/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 2;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 4;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 5;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 6;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern24 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 306
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode)
          || GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x4, 0, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 0;

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3
          || XINT (x3, 1) != 306
          || GET_MODE (x3) != E_SImode)
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode)
        return -1;
      x9 = XVECEXP (x3, 0, 0);
      operands[3] = x9;
      x10 = XVECEXP (x3, 0, 2);
      operands[2] = x10;
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 1;

    case SUBREG:
    case TRUNCATE:
      operands[3] = x3;
      if (!subreg_lowpart_operator (operands[3], E_HImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || XINT (x4, 1) != 306
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode)
          || GET_MODE (x2) != E_VNx8HImode)
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[4] = x6;
      x7 = XVECEXP (x4, 0, 2);
      operands[2] = x7;
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  return pattern49 (x1); /* [-1, 1] */
}

int
pattern54 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    case E_HFmode:
      if (!register_operand (operands[0], E_HFmode)
          || GET_MODE (x3) != E_HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 5;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 6;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 7;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 8;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      return 0;

    case VEC_DUPLICATE:
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      return 1;

    case VEC_SELECT:
      x7 = XEXP (x5, 1);
      if (GET_CODE (x7) != PARALLEL
          || XVECLEN (x7, 0) != 1)
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x8 = XVECEXP (x7, 0, 0);
      operands[3] = x8;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          res = pattern72 (x3, 
E_V4HImode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case E_V8HImode:
          res = pattern72 (x3, 
E_V8HImode);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        case E_V2SImode:
          res = pattern73 (x3, 
E_V2SImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case E_V4SImode:
          res = pattern73 (x3, 
E_V4SImode);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case E_HImode:
          res = pattern72 (x3, 
E_HImode);
          if (res >= 0)
            return res + 10; /* [10, 11] */
          return -1;

        case E_SImode:
          res = pattern73 (x3, 
E_SImode);
          if (res >= 0)
            return res + 12; /* [12, 13] */
          return -1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 167)
        return -1;
      x9 = XVECEXP (x5, 0, 0);
      operands[2] = x9;
      x10 = XVECEXP (x5, 0, 1);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern74 (x3, 
E_VNx8HImode) != 0)
            return -1;
          return 14;

        case E_VNx4SImode:
          if (pattern74 (x3, 
E_VNx4SImode) != 0)
            return -1;
          return 15;

        case E_VNx2DImode:
          if (pattern74 (x3, 
E_VNx2DImode) != 0)
            return -1;
          return 16;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern100 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern99 (x1, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern99 (x1, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern99 (x1, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern107 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern99 (x3, 
E_VNx16QImode, 
E_VNx8HImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern99 (x3, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern99 (x3, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern114 (rtx x1, unsigned int i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern118 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern68 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern68 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    case E_V2DFmode:
      if (pattern68 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_V2DFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern130 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 6;

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      return 7;

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode))
        return -1;
      return 8;

    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !register_operand (operands[1], E_V4BFmode))
        return -1;
      return 9;

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !register_operand (operands[1], E_V8BFmode))
        return -1;
      return 10;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 11;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 12;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 13;

    default:
      return -1;
    }
}

int
pattern164 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 167)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 0);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x8 = XVECEXP (x2, 0, 2);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern162 (x2, 
E_VNx8HFmode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern162 (x2, 
E_VNx4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern179 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx32QImode:
      return pattern178 (x3, 
E_VNx32QImode); /* [-1, 0] */

    case E_VNx16HImode:
      if (pattern178 (x3, 
E_VNx16HImode) != 0)
        return -1;
      return 1;

    case E_VNx8SImode:
      if (pattern178 (x3, 
E_VNx8SImode) != 0)
        return -1;
      return 2;

    case E_VNx4DImode:
      if (pattern178 (x3, 
E_VNx4DImode) != 0)
        return -1;
      return 3;

    case E_VNx16BFmode:
      if (pattern178 (x3, 
E_VNx16BFmode) != 0)
        return -1;
      return 4;

    case E_VNx16HFmode:
      if (pattern178 (x3, 
E_VNx16HFmode) != 0)
        return -1;
      return 5;

    case E_VNx8SFmode:
      if (pattern178 (x3, 
E_VNx8SFmode) != 0)
        return -1;
      return 6;

    case E_VNx4DFmode:
      if (pattern178 (x3, 
E_VNx4DFmode) != 0)
        return -1;
      return 7;

    case E_VNx64QImode:
      if (pattern178 (x3, 
E_VNx64QImode) != 0)
        return -1;
      return 8;

    case E_VNx32HImode:
      if (pattern178 (x3, 
E_VNx32HImode) != 0)
        return -1;
      return 9;

    case E_VNx16SImode:
      if (pattern178 (x3, 
E_VNx16SImode) != 0)
        return -1;
      return 10;

    case E_VNx8DImode:
      if (pattern178 (x3, 
E_VNx8DImode) != 0)
        return -1;
      return 11;

    case E_VNx32BFmode:
      if (pattern178 (x3, 
E_VNx32BFmode) != 0)
        return -1;
      return 12;

    case E_VNx32HFmode:
      if (pattern178 (x3, 
E_VNx32HFmode) != 0)
        return -1;
      return 13;

    case E_VNx16SFmode:
      if (pattern178 (x3, 
E_VNx16SFmode) != 0)
        return -1;
      return 14;

    case E_VNx8DFmode:
      if (pattern178 (x3, 
E_VNx8DFmode) != 0)
        return -1;
      return 15;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern203 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  operands[2] = x2;
  x3 = XVECEXP (x1, 0, 3);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern202 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern202 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern202 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    case E_VNx8BFmode:
      if (pattern200 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  return 0;
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[2] = x7;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return pattern218 (x2); /* [-1, 15] */

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x9 = XEXP (x7, 1);
      operands[3] = x9;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      res = pattern218 (x2);
      if (res >= 0)
        return res + 16; /* [16, 31] */
      return -1;

    default:
      return -1;
    }
}

int
pattern229 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
      operands[1] = x7;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[2] = x8;
      switch (GET_MODE (x5))
        {
        case E_VNx32QImode:
          if (GET_MODE (x2) != E_VNx32QImode
              || GET_MODE (x3) != E_VNx32QImode
              || !aligned_register_operand (operands[2], E_VNx32QImode))
            return -1;
          return 0;

        case E_VNx16HImode:
          if (GET_MODE (x2) != E_VNx16HImode
              || GET_MODE (x3) != E_VNx16HImode
              || !aligned_register_operand (operands[2], E_VNx16HImode))
            return -1;
          return 1;

        case E_VNx8SImode:
          if (GET_MODE (x2) != E_VNx8SImode
              || GET_MODE (x3) != E_VNx8SImode
              || !aligned_register_operand (operands[2], E_VNx8SImode))
            return -1;
          return 2;

        case E_VNx4DImode:
          if (GET_MODE (x2) != E_VNx4DImode
              || GET_MODE (x3) != E_VNx4DImode
              || !aligned_register_operand (operands[2], E_VNx4DImode))
            return -1;
          return 3;

        case E_VNx16BFmode:
          if (GET_MODE (x2) != E_VNx16BFmode
              || GET_MODE (x3) != E_VNx16BFmode
              || !aligned_register_operand (operands[2], E_VNx16BFmode))
            return -1;
          return 4;

        case E_VNx16HFmode:
          if (GET_MODE (x2) != E_VNx16HFmode
              || GET_MODE (x3) != E_VNx16HFmode
              || !aligned_register_operand (operands[2], E_VNx16HFmode))
            return -1;
          return 5;

        case E_VNx8SFmode:
          if (GET_MODE (x2) != E_VNx8SFmode
              || GET_MODE (x3) != E_VNx8SFmode
              || !aligned_register_operand (operands[2], E_VNx8SFmode))
            return -1;
          return 6;

        case E_VNx4DFmode:
          if (GET_MODE (x2) != E_VNx4DFmode
              || GET_MODE (x3) != E_VNx4DFmode
              || !aligned_register_operand (operands[2], E_VNx4DFmode))
            return -1;
          return 7;

        case E_VNx64QImode:
          if (GET_MODE (x2) != E_VNx64QImode
              || GET_MODE (x3) != E_VNx64QImode
              || !aligned_register_operand (operands[2], E_VNx64QImode))
            return -1;
          return 8;

        case E_VNx32HImode:
          if (GET_MODE (x2) != E_VNx32HImode
              || GET_MODE (x3) != E_VNx32HImode
              || !aligned_register_operand (operands[2], E_VNx32HImode))
            return -1;
          return 9;

        case E_VNx16SImode:
          if (GET_MODE (x2) != E_VNx16SImode
              || GET_MODE (x3) != E_VNx16SImode
              || !aligned_register_operand (operands[2], E_VNx16SImode))
            return -1;
          return 10;

        case E_VNx8DImode:
          if (GET_MODE (x2) != E_VNx8DImode
              || GET_MODE (x3) != E_VNx8DImode
              || !aligned_register_operand (operands[2], E_VNx8DImode))
            return -1;
          return 11;

        case E_VNx32BFmode:
          if (GET_MODE (x2) != E_VNx32BFmode
              || GET_MODE (x3) != E_VNx32BFmode
              || !aligned_register_operand (operands[2], E_VNx32BFmode))
            return -1;
          return 12;

        case E_VNx32HFmode:
          if (GET_MODE (x2) != E_VNx32HFmode
              || GET_MODE (x3) != E_VNx32HFmode
              || !aligned_register_operand (operands[2], E_VNx32HFmode))
            return -1;
          return 13;

        case E_VNx16SFmode:
          if (GET_MODE (x2) != E_VNx16SFmode
              || GET_MODE (x3) != E_VNx16SFmode
              || !aligned_register_operand (operands[2], E_VNx16SFmode))
            return -1;
          return 14;

        case E_VNx8DFmode:
          if (GET_MODE (x2) != E_VNx8DFmode
              || GET_MODE (x3) != E_VNx8DFmode
              || !aligned_register_operand (operands[2], E_VNx8DFmode))
            return -1;
          return 15;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x7) != E_SImode)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x7, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XVECEXP (x2, 0, 4);
      operands[3] = x8;
      switch (GET_MODE (x5))
        {
        case E_VNx32QImode:
          if (GET_MODE (x2) != E_VNx32QImode
              || GET_MODE (x3) != E_VNx32QImode
              || !aligned_register_operand (operands[3], E_VNx32QImode))
            return -1;
          return 16;

        case E_VNx16HImode:
          if (GET_MODE (x2) != E_VNx16HImode
              || GET_MODE (x3) != E_VNx16HImode
              || !aligned_register_operand (operands[3], E_VNx16HImode))
            return -1;
          return 17;

        case E_VNx8SImode:
          if (GET_MODE (x2) != E_VNx8SImode
              || GET_MODE (x3) != E_VNx8SImode
              || !aligned_register_operand (operands[3], E_VNx8SImode))
            return -1;
          return 18;

        case E_VNx4DImode:
          if (GET_MODE (x2) != E_VNx4DImode
              || GET_MODE (x3) != E_VNx4DImode
              || !aligned_register_operand (operands[3], E_VNx4DImode))
            return -1;
          return 19;

        case E_VNx16BFmode:
          if (GET_MODE (x2) != E_VNx16BFmode
              || GET_MODE (x3) != E_VNx16BFmode
              || !aligned_register_operand (operands[3], E_VNx16BFmode))
            return -1;
          return 20;

        case E_VNx16HFmode:
          if (GET_MODE (x2) != E_VNx16HFmode
              || GET_MODE (x3) != E_VNx16HFmode
              || !aligned_register_operand (operands[3], E_VNx16HFmode))
            return -1;
          return 21;

        case E_VNx8SFmode:
          if (GET_MODE (x2) != E_VNx8SFmode
              || GET_MODE (x3) != E_VNx8SFmode
              || !aligned_register_operand (operands[3], E_VNx8SFmode))
            return -1;
          return 22;

        case E_VNx4DFmode:
          if (GET_MODE (x2) != E_VNx4DFmode
              || GET_MODE (x3) != E_VNx4DFmode
              || !aligned_register_operand (operands[3], E_VNx4DFmode))
            return -1;
          return 23;

        case E_VNx64QImode:
          if (GET_MODE (x2) != E_VNx64QImode
              || GET_MODE (x3) != E_VNx64QImode
              || !aligned_register_operand (operands[3], E_VNx64QImode))
            return -1;
          return 24;

        case E_VNx32HImode:
          if (GET_MODE (x2) != E_VNx32HImode
              || GET_MODE (x3) != E_VNx32HImode
              || !aligned_register_operand (operands[3], E_VNx32HImode))
            return -1;
          return 25;

        case E_VNx16SImode:
          if (GET_MODE (x2) != E_VNx16SImode
              || GET_MODE (x3) != E_VNx16SImode
              || !aligned_register_operand (operands[3], E_VNx16SImode))
            return -1;
          return 26;

        case E_VNx8DImode:
          if (GET_MODE (x2) != E_VNx8DImode
              || GET_MODE (x3) != E_VNx8DImode
              || !aligned_register_operand (operands[3], E_VNx8DImode))
            return -1;
          return 27;

        case E_VNx32BFmode:
          if (GET_MODE (x2) != E_VNx32BFmode
              || GET_MODE (x3) != E_VNx32BFmode
              || !aligned_register_operand (operands[3], E_VNx32BFmode))
            return -1;
          return 28;

        case E_VNx32HFmode:
          if (GET_MODE (x2) != E_VNx32HFmode
              || GET_MODE (x3) != E_VNx32HFmode
              || !aligned_register_operand (operands[3], E_VNx32HFmode))
            return -1;
          return 29;

        case E_VNx16SFmode:
          if (GET_MODE (x2) != E_VNx16SFmode
              || GET_MODE (x3) != E_VNx16SFmode
              || !aligned_register_operand (operands[3], E_VNx16SFmode))
            return -1;
          return 30;

        case E_VNx8DFmode:
          if (GET_MODE (x2) != E_VNx8DFmode
              || GET_MODE (x3) != E_VNx8DFmode
              || !aligned_register_operand (operands[3], E_VNx8DFmode))
            return -1;
          return 31;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern291 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern290 (x1, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern290 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern290 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern297 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x3;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      if (!cc_register (operands[2], E_VOIDmode))
        return -1;
      x6 = XEXP (x1, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern296 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern296 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern306 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      return 0;

    case CONST_VECTOR:
    case CONST:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern305 (x1, 
E_VNx16QImode) != 0)
            return -1;
          return 1;

        case E_VNx8QImode:
          if (pattern305 (x1, 
E_VNx8QImode) != 0)
            return -1;
          return 2;

        case E_VNx4QImode:
          if (pattern305 (x1, 
E_VNx4QImode) != 0)
            return -1;
          return 3;

        case E_VNx2QImode:
          if (pattern305 (x1, 
E_VNx2QImode) != 0)
            return -1;
          return 4;

        case E_VNx8HImode:
          if (pattern305 (x1, 
E_VNx8HImode) != 0)
            return -1;
          return 5;

        case E_VNx4HImode:
          if (pattern305 (x1, 
E_VNx4HImode) != 0)
            return -1;
          return 6;

        case E_VNx2HImode:
          if (pattern305 (x1, 
E_VNx2HImode) != 0)
            return -1;
          return 7;

        case E_VNx4SImode:
          if (pattern305 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 8;

        case E_VNx2SImode:
          if (pattern305 (x1, 
E_VNx2SImode) != 0)
            return -1;
          return 9;

        case E_VNx2DImode:
          if (pattern305 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 10;

        case E_V2DImode:
          if (pattern305 (x1, 
E_V2DImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern35 (x1);
      if (res >= 0)
        return res + 12; /* [12, 19] */
      return -1;

    default:
      return -1;
    }
}

int
pattern323 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern318 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern318 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern318 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern318 (x1, 
E_DImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern331 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x1) != E_V8QImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x1) != E_V4HImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 4;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x1) != E_V2SImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern346 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XVECEXP (x6, 0, 2);
  operands[3] = x7;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  return pattern345 (x1); /* [-1, 3] */
}

int
pattern351 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_plus_operand (operands[2], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern357 (rtx x1, machine_mode i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 1
      || XINT (x1, 1) != i2
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  return 0;
}

int
pattern359 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern358 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern358 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern358 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern364 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 1;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x1) != E_V2DImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern373 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode
      || GET_MODE (x2) != E_SImode)
    return -1;
  return 0;
}

int
pattern374 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern378 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern377 (x1, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern377 (x1, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern377 (x1, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern383 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern382 (x1); /* [-1, 1] */
}

int
pattern386 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != VEC_SELECT)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != VEC_SELECT)
    return -1;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  x9 = XEXP (x6, 0);
  operands[2] = x9;
  x10 = XEXP (x6, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern385 (x1, 
E_V16QImode, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern385 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern385 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern392 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern362 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern362 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern362 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern362 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern362 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern362 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern362 (x1, 
E_V2DImode) != 0)
        return -1;
      return 6;

    case E_DImode:
      if (pattern387 (x1, 
E_DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern398 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern404 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern412 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern411 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern411 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern411 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern418 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern318 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern318 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern318 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V8HFmode:
      if (pattern318 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 3;

    case E_V4SFmode:
      if (pattern318 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern427 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V8HImode)
      || GET_MODE (x1) != E_V8HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_hi (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V4HImode))
    return -1;
  return 0;
}

int
pattern431 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_int_rnd_operand (operands[4], i2)
      || !aarch64_simd_shift_imm_vec_si (operands[3], i1)
      || !register_operand (operands[1], E_V2SImode))
    return -1;
  return 0;
}

int
pattern439 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode)
    return -1;
  switch (XINT (x1, 1))
    {
    case 168:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 306:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern22 (x1);
      if (res >= 0)
        return res + 1; /* [1, 4] */
      return -1;

    default:
      return -1;
    }
}

int
pattern448 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !vect_par_cnst_even_or_odd_half (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern451 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern450 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern450 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern450 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern450 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern450 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern450 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern450 (x1, 
E_V2DImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern462 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern461 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern461 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern461 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern461 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern461 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern461 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern461 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern461 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern461 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern461 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    case E_V2DImode:
      if (pattern461 (x1, 
E_V2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern473 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern477 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V4HImode:
          return pattern476 (x2, 
E_V8HImode, 
E_V4HImode, 
E_V8QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern476 (x2, 
E_V16HImode, 
E_V8HImode, 
E_V16QImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V2SImode:
          if (pattern476 (x2, 
E_V4SImode, 
E_V2SImode, 
E_V4HImode) != 0)
            return -1;
          return 2;

        case E_V4SImode:
          if (pattern476 (x2, 
E_V8SImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_V2DImode:
          if (pattern476 (x2, 
E_V4DImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 4;

        case E_DImode:
          if (pattern476 (x2, 
E_V2DImode, 
E_DImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern501 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x4, 1);
  operands[4] = x7;
  x8 = XEXP (x3, 1);
  operands[3] = x8;
  switch (GET_CODE (operands[3]))
    {
    case CONST_VECTOR:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x1) != E_V8QImode
              || pattern429 (x2, 
E_V8QImode, 
E_V8HImode) != 0)
            return -1;
          return 0;

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x1) != E_V16QImode
              || GET_MODE (x2) != E_V16QImode
              || GET_MODE (x3) != E_V16HImode
              || GET_MODE (x4) != E_V16HImode
              || GET_MODE (x5) != E_V16HImode
              || !register_operand (operands[2], E_V16QImode)
              || !aarch64_int_rnd_operand (operands[4], E_V16HImode)
              || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V16QImode)
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x1) != E_V4HImode
              || pattern430 (x2, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || GET_MODE (x2) != E_V8HImode
              || GET_MODE (x3) != E_V8SImode
              || GET_MODE (x4) != E_V8SImode
              || GET_MODE (x5) != E_V8SImode
              || !register_operand (operands[2], E_V8HImode)
              || !aarch64_int_rnd_operand (operands[4], E_V8SImode)
              || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V8HImode)
              || !register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x1) != E_V2SImode
              || pattern431 (x2, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_V4DImode
              || GET_MODE (x4) != E_V4DImode
              || GET_MODE (x5) != E_V4DImode
              || !register_operand (operands[2], E_V4SImode)
              || !aarch64_int_rnd_operand (operands[4], E_V4DImode)
              || !aarch64_simd_shift_imm_vec_si (operands[3], E_V4SImode)
              || !register_operand (operands[1], E_V4SImode))
            return -1;
          return 5;

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x2) != E_V2DImode
              || GET_MODE (x3) != E_V2TImode
              || GET_MODE (x4) != E_V2TImode
              || GET_MODE (x5) != E_V2TImode
              || !register_operand (operands[2], E_V2DImode)
              || !aarch64_int_rnd_operand (operands[4], E_V2TImode)
              || !aarch64_simd_shift_imm_vec_di (operands[3], E_V2DImode)
              || !register_operand (operands[1], E_V2DImode))
            return -1;
          return 6;

        default:
          return -1;
        }

    case CONST_INT:
      if (!aarch64_simd_shift_imm_offset_di (operands[3], E_DImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || GET_MODE (x3) != E_TImode
          || GET_MODE (x4) != E_TImode
          || GET_MODE (x5) != E_TImode
          || !register_operand (operands[2], E_DImode)
          || !aarch64_int_rnd_operand (operands[4], E_TImode)
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern550 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CC_NZCmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_CC_NZCmode)
    return -1;
  return 0;
}

int
pattern557 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !aarch64_plus_operand (operands[2], i1)
      || !aarch64_reg_or_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern563 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !aarch64_logical_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern569 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 31)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 66
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  x8 = XEXP (x6, 1);
  x9 = XEXP (x8, 0);
  operands[1] = x9;
  x10 = XEXP (x8, 1);
  operands[2] = x10;
  x11 = XVECEXP (x3, 0, 2);
  operands[3] = x11;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  x13 = XEXP (x12, 0);
  operands[4] = x13;
  return pattern345 (x1); /* [-1, 3] */
}

int
pattern584 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  switch (GET_MODE (x3))
    {
    case E_VNx2QImode:
      if (!aarch64_gather_scale_operand_b (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[8], E_VNx2QImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (!aarch64_gather_scale_operand_h (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[8], E_VNx2HImode))
        return -1;
      return 1;

    case E_VNx2SImode:
      if (!aarch64_gather_scale_operand_w (operands[4], E_DImode)
          || !aarch64_maskload_else_operand (operands[8], E_VNx2SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern588 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      x4 = XVECEXP (x1, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[1] = x6;
      switch (XINT (x3, 1))
        {
        case 115:
          x7 = XVECEXP (x3, 0, 2);
          operands[4] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              return pattern578 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 5] */

            case E_VNx4HImode:
              res = pattern578 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 6; /* [6, 11] */
              return -1;

            case E_VNx2HImode:
              res = pattern578 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 12; /* [12, 17] */
              return -1;

            case E_VNx4SImode:
              res = pattern578 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 18; /* [18, 23] */
              return -1;

            case E_VNx2SImode:
              res = pattern578 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 24; /* [24, 29] */
              return -1;

            case E_VNx2DImode:
              res = pattern578 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 30; /* [30, 35] */
              return -1;

            default:
              return -1;
            }

        case 402:
          x7 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 86
              || GET_MODE (x7) != E_VNx16BImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              res = pattern579 (x1, 
E_VNx8HImode, 
E_VNx8BImode);
              if (res >= 0)
                return res + 36; /* [36, 41] */
              return -1;

            case E_VNx4HImode:
              res = pattern579 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 42; /* [42, 47] */
              return -1;

            case E_VNx2HImode:
              res = pattern579 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 48; /* [48, 53] */
              return -1;

            case E_VNx4SImode:
              res = pattern579 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 54; /* [54, 59] */
              return -1;

            case E_VNx2SImode:
              res = pattern579 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 60; /* [60, 65] */
              return -1;

            case E_VNx2DImode:
              res = pattern579 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 66; /* [66, 71] */
              return -1;

            default:
              return -1;
            }

        case 403:
          x7 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 86
              || GET_MODE (x7) != E_VNx16BImode)
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HImode:
              res = pattern580 (x1, 
E_VNx8HImode, 
E_VNx8BImode);
              if (res >= 0)
                return res + 72; /* [72, 77] */
              return -1;

            case E_VNx4HImode:
              res = pattern580 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 78; /* [78, 83] */
              return -1;

            case E_VNx2HImode:
              res = pattern580 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 84; /* [84, 89] */
              return -1;

            case E_VNx4SImode:
              res = pattern580 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
              if (res >= 0)
                return res + 90; /* [90, 95] */
              return -1;

            case E_VNx2SImode:
              res = pattern580 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 96; /* [96, 101] */
              return -1;

            case E_VNx2DImode:
              res = pattern580 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
              if (res >= 0)
                return res + 102; /* [102, 107] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x3, 1) != 125)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          res = pattern581 (x1, 
E_VNx8HImode, 
E_VNx8BImode);
          if (res >= 0)
            return res + 108; /* [108, 113] */
          return -1;

        case E_VNx4HImode:
          res = pattern581 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
          if (res >= 0)
            return res + 114; /* [114, 119] */
          return -1;

        case E_VNx2HImode:
          res = pattern581 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
          if (res >= 0)
            return res + 120; /* [120, 125] */
          return -1;

        case E_VNx4SImode:
          res = pattern581 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
          if (res >= 0)
            return res + 126; /* [126, 131] */
          return -1;

        case E_VNx2SImode:
          res = pattern581 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
          if (res >= 0)
            return res + 132; /* [132, 137] */
          return -1;

        case E_VNx2DImode:
          res = pattern581 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
          if (res >= 0)
            return res + 138; /* [138, 143] */
          return -1;

        default:
          return -1;
        }

    case 7:
      x5 = XVECEXP (x3, 0, 0);
      operands[5] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[1] = x6;
      x8 = XVECEXP (x3, 0, 3);
      operands[3] = x8;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x9 = XVECEXP (x3, 0, 4);
      operands[4] = x9;
      switch (XINT (x3, 1))
        {
        case 120:
          x10 = XVECEXP (x3, 0, 6);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SCRATCH)
            return -1;
          x7 = XVECEXP (x3, 0, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[2] = x7;
              x4 = XVECEXP (x1, 0, 0);
              operands[6] = x4;
              x12 = XVECEXP (x3, 0, 5);
              operands[7] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4HImode:
                  res = pattern582 (x1, 
E_VNx4HImode);
                  if (res >= 0)
                    return res + 144; /* [144, 145] */
                  return -1;

                case E_VNx4SImode:
                  res = pattern582 (x1, 
E_VNx4SImode);
                  if (res >= 0)
                    return res + 146; /* [146, 147] */
                  return -1;

                case E_VNx2HImode:
                  res = pattern583 (x1, 
E_VNx2HImode);
                  if (res >= 0)
                    return res + 148; /* [148, 150] */
                  return -1;

                case E_VNx2SImode:
                  res = pattern583 (x1, 
E_VNx2SImode);
                  if (res >= 0)
                    return res + 151; /* [151, 153] */
                  return -1;

                case E_VNx2DImode:
                  res = pattern583 (x1, 
E_VNx2DImode);
                  if (res >= 0)
                    return res + 154; /* [154, 156] */
                  return -1;

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x7, 0) != 2
                  || XINT (x7, 1) != 125
                  || GET_MODE (x7) != E_VNx2DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 0);
              operands[6] = x4;
              if (!register_operand (operands[5], E_VNx2BImode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              x13 = XVECEXP (x7, 0, 0);
              operands[7] = x13;
              x14 = XVECEXP (x7, 0, 1);
              if (GET_MODE (x14) != E_VNx2DImode)
                return -1;
              x12 = XVECEXP (x3, 0, 5);
              operands[8] = x12;
              switch (GET_CODE (x14))
                {
                case SIGN_EXTEND:
                  x15 = XEXP (x14, 0);
                  switch (GET_CODE (x15))
                    {
                    case REG:
                    case SUBREG:
                      res = pattern585 (x1);
                      if (res >= 0)
                        return res + 157; /* [157, 165] */
                      return -1;

                    case TRUNCATE:
                      if (GET_MODE (x15) != E_VNx2SImode)
                        return -1;
                      x16 = XEXP (x15, 0);
                      operands[2] = x16;
                      if (!register_operand (operands[2], E_VNx2DImode))
                        return -1;
                      switch (GET_MODE (operands[0]))
                        {
                        case E_VNx2HImode:
                          res = pattern584 (x1, 
E_VNx2HImode);
                          if (res >= 0)
                            return res + 166; /* [166, 168] */
                          return -1;

                        case E_VNx2SImode:
                          res = pattern584 (x1, 
E_VNx2SImode);
                          if (res >= 0)
                            return res + 169; /* [169, 171] */
                          return -1;

                        case E_VNx2DImode:
                          res = pattern584 (x1, 
E_VNx2DImode);
                          if (res >= 0)
                            return res + 172; /* [172, 174] */
                          return -1;

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  res = pattern585 (x1);
                  if (res >= 0)
                    return res + 175; /* [175, 183] */
                  return -1;

                default:
                  return -1;
                }

            case AND:
              if (GET_MODE (x7) != E_VNx2DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 0);
              operands[7] = x4;
              if (!register_operand (operands[5], E_VNx2BImode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              x17 = XEXP (x7, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              x18 = XEXP (x7, 1);
              operands[6] = x18;
              if (!aarch64_sve_uxtw_immediate (operands[6], E_VNx2DImode))
                return -1;
              x12 = XVECEXP (x3, 0, 5);
              operands[8] = x12;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx2HImode:
                  res = pattern584 (x1, 
E_VNx2HImode);
                  if (res >= 0)
                    return res + 184; /* [184, 186] */
                  return -1;

                case E_VNx2SImode:
                  res = pattern584 (x1, 
E_VNx2SImode);
                  if (res >= 0)
                    return res + 187; /* [187, 189] */
                  return -1;

                case E_VNx2DImode:
                  res = pattern584 (x1, 
E_VNx2DImode);
                  if (res >= 0)
                    return res + 190; /* [190, 192] */
                  return -1;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 121:
          x12 = XVECEXP (x3, 0, 5);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return -1;
          x19 = XEXP (x12, 0);
          if (GET_CODE (x19) != SCRATCH)
            return -1;
          x10 = XVECEXP (x3, 0, 6);
          if (GET_CODE (x10) != REG
              || REGNO (x10) != 86
              || GET_MODE (x10) != E_VNx16BImode)
            return -1;
          x7 = XVECEXP (x3, 0, 2);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[2] = x7;
              x4 = XVECEXP (x1, 0, 0);
              operands[6] = x4;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4SImode:
                  if (!register_operand (operands[0], E_VNx4SImode)
                      || GET_MODE (x1) != E_VNx4SImode
                      || !general_operand (operands[6], E_VNx4BImode)
                      || GET_MODE (x2) != E_VNx4SImode
                      || !register_operand (operands[5], E_VNx4BImode)
                      || !register_operand (operands[2], E_VNx4SImode))
                    return -1;
                  switch (GET_MODE (x3))
                    {
                    case E_VNx4QImode:
                      if (!aarch64_sve_gather_offset_b (operands[1], E_DImode)
                          || !aarch64_gather_scale_operand_b (operands[4], E_DImode))
                        return -1;
                      return 193;

                    case E_VNx4HImode:
                      if (!aarch64_sve_gather_offset_h (operands[1], E_DImode)
                          || !aarch64_gather_scale_operand_h (operands[4], E_DImode))
                        return -1;
                      return 194;

                    default:
                      return -1;
                    }

                case E_VNx2DImode:
                  if (!register_operand (operands[0], E_VNx2DImode)
                      || GET_MODE (x1) != E_VNx2DImode
                      || !general_operand (operands[6], E_VNx2BImode)
                      || GET_MODE (x2) != E_VNx2DImode
                      || !register_operand (operands[5], E_VNx2BImode)
                      || !register_operand (operands[2], E_VNx2DImode))
                    return -1;
                  switch (GET_MODE (x3))
                    {
                    case E_VNx2QImode:
                      if (!aarch64_sve_gather_offset_b (operands[1], E_DImode)
                          || !aarch64_gather_scale_operand_b (operands[4], E_DImode))
                        return -1;
                      return 195;

                    case E_VNx2HImode:
                      if (!aarch64_sve_gather_offset_h (operands[1], E_DImode)
                          || !aarch64_gather_scale_operand_h (operands[4], E_DImode))
                        return -1;
                      return 196;

                    case E_VNx2SImode:
                      if (!aarch64_sve_gather_offset_w (operands[1], E_DImode)
                          || !aarch64_gather_scale_operand_w (operands[4], E_DImode))
                        return -1;
                      return 197;

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case UNSPEC:
              if (XVECLEN (x7, 0) != 2
                  || XINT (x7, 1) != 125
                  || GET_MODE (x7) != E_VNx2DImode)
                return -1;
              x14 = XVECEXP (x7, 0, 1);
              if (GET_CODE (x14) != SIGN_EXTEND
                  || GET_MODE (x14) != E_VNx2DImode)
                return -1;
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != TRUNCATE
                  || GET_MODE (x15) != E_VNx2SImode
                  || !register_operand (operands[0], E_VNx2DImode)
                  || GET_MODE (x1) != E_VNx2DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 0);
              operands[6] = x4;
              if (GET_MODE (x2) != E_VNx2DImode
                  || !register_operand (operands[5], E_VNx2BImode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              x13 = XVECEXP (x7, 0, 0);
              operands[7] = x13;
              x16 = XEXP (x15, 0);
              operands[2] = x16;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              res = pattern586 (x3);
              if (res >= 0)
                return res + 198; /* [198, 200] */
              return -1;

            case AND:
              if (GET_MODE (x7) != E_VNx2DImode
                  || !register_operand (operands[0], E_VNx2DImode)
                  || GET_MODE (x1) != E_VNx2DImode)
                return -1;
              x4 = XVECEXP (x1, 0, 0);
              operands[7] = x4;
              if (GET_MODE (x2) != E_VNx2DImode
                  || !register_operand (operands[5], E_VNx2BImode)
                  || !aarch64_reg_or_zero (operands[1], E_DImode))
                return -1;
              x17 = XEXP (x7, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              x18 = XEXP (x7, 1);
              operands[6] = x18;
              if (!aarch64_sve_uxtw_immediate (operands[6], E_VNx2DImode))
                return -1;
              res = pattern586 (x3);
              if (res >= 0)
                return res + 201; /* [201, 203] */
              return -1;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      if (XINT (x3, 1) != 122)
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_BLKmode)
        return -1;
      x20 = XEXP (x8, 0);
      if (GET_CODE (x20) != SCRATCH)
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[2] = x6;
      if (!aarch64_reg_or_zero (operands[2], E_DImode))
        return -1;
      x7 = XVECEXP (x3, 0, 2);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          res = pattern587 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
          if (res >= 0)
            return res + 204; /* [204, 209] */
          return -1;

        case E_VNx2DImode:
          res = pattern587 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
          if (res >= 0)
            return res + 210; /* [210, 215] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern781 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 56]
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern790 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[3], i3)
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern799 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 0);
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx2QImode:
          return pattern798 (x1, 
E_VNx2QImode); /* [-1, 0] */

        case E_VNx2HImode:
          if (pattern798 (x1, 
E_VNx2HImode) != 0)
            return -1;
          return 1;

        case E_VNx2SImode:
          if (pattern798 (x1, 
E_VNx2SImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern798 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 3;

        case E_VNx4QImode:
          if (pattern798 (x1, 
E_VNx4QImode) != 0)
            return -1;
          return 4;

        case E_VNx4HImode:
          if (pattern798 (x1, 
E_VNx4HImode) != 0)
            return -1;
          return 5;

        case E_VNx4SImode:
          if (pattern798 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 125
          || GET_MODE (x4) != E_VNx2DImode)
        return -1;
      x6 = XVECEXP (x4, 0, 1);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_VNx2DImode)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != TRUNCATE
          || GET_MODE (x7) != E_VNx2SImode
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode
          || GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[4] = x5;
      if (GET_MODE (x3) != E_VNx2DImode)
        return -1;
      x8 = XVECEXP (x4, 0, 0);
      operands[5] = x8;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_VNx2DImode)
          || !const_1_to_3_operand (operands[3], E_VNx2DImode)
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      return 7;

    case AND:
      if (GET_MODE (x4) != E_VNx2DImode
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode
          || GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x5 = XVECEXP (x2, 0, 0);
      operands[5] = x5;
      if (GET_MODE (x3) != E_VNx2DImode)
        return -1;
      x10 = XEXP (x4, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_VNx2DImode))
        return -1;
      x11 = XEXP (x4, 1);
      operands[4] = x11;
      if (!aarch64_sve_uxtw_immediate (operands[4], E_VNx2DImode)
          || !const_1_to_3_operand (operands[3], E_VNx2DImode)
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern842 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      operands[4] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          return pattern840 (x1, 
E_VNx16QImode, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx4SImode:
          if (pattern840 (x1, 
E_VNx8HImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 1;

        case E_VNx2DImode:
          if (pattern840 (x1, 
E_VNx4SImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      operands[4] = x5;
      x6 = XVECEXP (x2, 0, 0);
      operands[5] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern841 (x1, 
E_VNx8HImode, 
E_VNx16QImode, 
E_VNx8BImode) != 0)
            return -1;
          return 3;

        case E_VNx4SImode:
          if (pattern841 (x1, 
E_VNx4SImode, 
E_VNx8HImode, 
E_VNx4BImode) != 0)
            return -1;
          return 4;

        case E_VNx2DImode:
          if (pattern841 (x1, 
E_VNx2DImode, 
E_VNx4SImode, 
E_VNx2BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern863 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern868 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern873 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x4, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern872 (x1, 
E_V4HImode, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern872 (x1, 
E_V8HImode, 
E_V16HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern872 (x1, 
E_V2SImode, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern872 (x1, 
E_V4SImode, 
E_V8SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2DImode:
      if (pattern872 (x1, 
E_V2DImode, 
E_V4DImode, 
E_V4SImode) != 0)
        return -1;
      return 4;

    case E_DImode:
      if (pattern872 (x1, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern884 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  if (!aarch64_imm3 (operands[1], E_VOIDmode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_SImode:
      return pattern883 (x2, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern883 (x2, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern889 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_raddsubhn_imm_vec (operands[3], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[4], i1))
    return -1;
  return 0;
}

int
pattern895 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern901 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_imm_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern911 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != NEG)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CC_NZmode
      || GET_MODE (x3) != E_CC_NZmode)
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  x13 = XEXP (x7, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  x14 = XEXP (x7, 1);
  if (!rtx_equal_p (x14, operands[2]))
    return -1;
  switch (GET_MODE (x9))
    {
    case E_SImode:
      if (GET_MODE (x10) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x6) != E_SImode
          || GET_MODE (x7) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (GET_MODE (x10) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x6) != E_DImode
          || GET_MODE (x7) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern927 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !const_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[3], E_SImode)
          || !aarch64_simd_shift_imm_si (operands[4], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[3], E_DImode)
          || !aarch64_simd_shift_imm_di (operands[4], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern942 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern949 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 2);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[0], E_VNx16BImode)
          || GET_MODE (x1) != E_VNx16BImode
          || GET_MODE (x2) != E_VNx16BImode
          || GET_MODE (x3) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx16QImode)
          || !register_operand (operands[1], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[0], E_VNx8BImode)
          || GET_MODE (x1) != E_VNx8BImode
          || GET_MODE (x2) != E_VNx8BImode
          || GET_MODE (x3) != E_VNx8BImode
          || !register_operand (operands[1], E_VNx8BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (!register_operand (operands[0], E_VNx4BImode)
          || GET_MODE (x1) != E_VNx4BImode
          || GET_MODE (x2) != E_VNx4BImode
          || GET_MODE (x3) != E_VNx4BImode
          || !register_operand (operands[1], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (!register_operand (operands[0], E_VNx2BImode)
          || GET_MODE (x1) != E_VNx2BImode
          || GET_MODE (x2) != E_VNx2BImode
          || GET_MODE (x3) != E_VNx2BImode
          || !register_operand (operands[1], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern989 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_QImode:
      if (!register_operand (operands[3], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[3], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern997 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_V2SImode:
      if (!register_operand (operands[2], E_V2SImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!register_operand (operands[2], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1007 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1012 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern1011 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern1011 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern1011 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1021 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1029 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x1, 1);
  x5 = XVECEXP (x4, 0, 0);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern1028 (x1, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern1028 (x1, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern1028 (x1, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern1028 (x1, 
E_VNx2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1039 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1045 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_reg_or_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1050 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1058 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1066 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4HFmode
          || !register_operand (operands[2], E_V4HFmode)
          || !register_operand (operands[1], E_V4HFmode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_V4HFmode:
          if (!register_operand (operands[3], E_V4HFmode))
            return -1;
          return 0;

        case E_V8HFmode:
          if (!register_operand (operands[3], E_V8HFmode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (pattern814 (x2, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1085 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != UNSPEC
          || XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != i1
          || GET_MODE (x2) != E_VNx16BImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx16BImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      if (!rtx_equal_p (x6, operands[3]))
        return -1;
      return 0;

    case CLOBBER:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!scratch_operand (operands[0], E_VNx16BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1095 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (operands[2]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1030 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1030 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1030 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1030 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1094 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4SFmode:
          if (pattern1094 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        case E_VNx2DFmode:
          if (pattern1094 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 6;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1110 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], E_VNx2BImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  operands[4] = x3;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  return 0;
}

int
pattern1118 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1126 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1134 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1141 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != UNSPEC
      || XVECLEN (x2, 0) != 1
      || XINT (x2, 1) != 689
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 89
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern1151 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1162 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_VNx8QImode:
      return 0;

    case E_VNx4QImode:
      return 1;

    case E_VNx2QImode:
      return 2;

    case E_VNx4HImode:
      return 3;

    case E_VNx2HImode:
      return 4;

    case E_VNx2SImode:
      return 5;

    default:
      return -1;
    }
}

int
pattern1169 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1177 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MINUS)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  x10 = XEXP (x3, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x4, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (x7))
    {
    case E_SImode:
      return pattern1176 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern1176 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1183 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_logical_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1190 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_one (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1197 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1205 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != AND)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != i1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XEXP (x4, 0);
      if (!rtx_equal_p (x6, operands[2]))
        return -1;
      x7 = XEXP (x4, 1);
      if (!rtx_equal_p (x7, operands[3]))
        return -1;
      x8 = XEXP (x3, 1);
      if (!rtx_equal_p (x8, operands[4]))
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 1);
      x11 = XVECEXP (x10, 0, 3);
      switch (GET_MODE (x11))
        {
        case E_VNx16BImode:
          return pattern1204 (x1, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8BImode:
          if (pattern1204 (x1, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4BImode:
          if (pattern1204 (x1, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2BImode:
          if (pattern1204 (x1, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      if (!scratch_operand (operands[0], E_VNx16BImode))
        return -1;
      x9 = XVECEXP (x1, 0, 0);
      x10 = XEXP (x9, 1);
      x11 = XVECEXP (x10, 0, 3);
      switch (GET_MODE (x11))
        {
        case E_VNx16BImode:
          x12 = XEXP (x11, 0);
          if (GET_MODE (x12) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16BImode)
              || !register_operand (operands[3], E_VNx16BImode))
            return -1;
          return 4;

        case E_VNx8BImode:
          x12 = XEXP (x11, 0);
          if (GET_MODE (x12) != E_VNx8BImode
              || !register_operand (operands[2], E_VNx8BImode)
              || !register_operand (operands[3], E_VNx8BImode))
            return -1;
          return 5;

        case E_VNx4BImode:
          x12 = XEXP (x11, 0);
          if (GET_MODE (x12) != E_VNx4BImode
              || !register_operand (operands[2], E_VNx4BImode)
              || !register_operand (operands[3], E_VNx4BImode))
            return -1;
          return 6;

        case E_VNx2BImode:
          x12 = XEXP (x11, 0);
          if (GET_MODE (x12) != E_VNx2BImode
              || !register_operand (operands[2], E_VNx2BImode)
              || !register_operand (operands[3], E_VNx2BImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1240 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  x5 = XEXP (x3, 1);
  if (!rtx_equal_p (x5, operands[2]))
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  switch (GET_MODE (x8))
    {
    case E_SImode:
      return pattern1239 (x3, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern1239 (x3, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1247 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !aarch64_sve_float_arith_immediate (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1254 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1261 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1269 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!const_int_operand (operands[3], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[4], i1)
      || !const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1274 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_hi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1281 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || pattern1280 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern1289 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 1);
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  if (!aarch64_imm3 (operands[2], E_VOIDmode))
    return -1;
  x12 = XEXP (x5, 0);
  if (!rtx_equal_p (x12, operands[1]))
    return -1;
  switch (GET_MODE (x8))
    {
    case E_SImode:
      return pattern1288 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern1288 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1302 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1314 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[3], E_VNx16QImode))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!register_operand (operands[2], E_VNx32QImode)
          || GET_MODE (x1) != E_VNx32QImode)
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!register_operand (operands[2], E_VNx64QImode)
          || GET_MODE (x1) != E_VNx64QImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1322 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx4QImode:
      if (!register_operand (operands[2], E_VNx4QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4QImode))
        return -1;
      return 0;

    case E_VNx4HImode:
      if (!register_operand (operands[2], E_VNx4HImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4HImode))
        return -1;
      return 1;

    case E_VNx4SImode:
      if (!register_operand (operands[2], E_VNx4SImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1329 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_borrow_operation (operands[2], i2))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !aarch64_borrow_operation (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !register_operand (operands[3], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx8BImode
          || !register_operand (operands[2], E_VNx8HImode)
          || !register_operand (operands[3], E_VNx8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1345 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8BFmode:
      if (!register_operand (operands[2], E_VNx8BFmode)
          || GET_MODE (x1) != E_VNx8BFmode
          || !register_operand (operands[3], E_VNx8BFmode))
        return -1;
      return 0;

    case E_VNx8HFmode:
      if (!register_operand (operands[2], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode
          || !register_operand (operands[3], E_VNx8HFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1352 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[2], E_VNx32QImode)
          || GET_MODE (x1) != E_VNx32QImode)
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[2], E_VNx64QImode)
          || GET_MODE (x1) != E_VNx64QImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1358 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 1);
  if (XINT (x5, 1) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 1);
  if (XINT (x7, 1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern1357 (x1, 
E_VNx16QImode, 
E_VNx64QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern1357 (x1, 
E_VNx8HImode, 
E_VNx32HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern1357 (x1, 
E_VNx4SImode, 
E_VNx16SImode) != 0)
        return -1;
      return 2;

    case E_VNx2DImode:
      if (pattern1357 (x1, 
E_VNx2DImode, 
E_VNx8DImode) != 0)
        return -1;
      return 3;

    case E_VNx8BFmode:
      if (pattern1357 (x1, 
E_VNx8BFmode, 
E_VNx32BFmode) != 0)
        return -1;
      return 4;

    case E_VNx8HFmode:
      if (pattern1357 (x1, 
E_VNx8HFmode, 
E_VNx32HFmode) != 0)
        return -1;
      return 5;

    case E_VNx4SFmode:
      if (pattern1357 (x1, 
E_VNx4SFmode, 
E_VNx16SFmode) != 0)
        return -1;
      return 6;

    case E_VNx2DFmode:
      if (pattern1357 (x1, 
E_VNx2DFmode, 
E_VNx8DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern588 (x2))
    {
    case 0:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
        return -1;
      return 5766; /* aarch64_load_extendvnx8hivnx8qi */

    case 1:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
        return -1;
      return 5768; /* aarch64_load_extendvnx8hivnx4qi */

    case 2:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
        return -1;
      return 5770; /* aarch64_load_extendvnx8hivnx2qi */

    case 3:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
        return -1;
      return 5772; /* aarch64_load_extendvnx8hivnx4hi */

    case 4:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
        return -1;
      return 5774; /* aarch64_load_extendvnx8hivnx2hi */

    case 5:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
        return -1;
      return 5776; /* aarch64_load_extendvnx8hivnx2si */

    case 6:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
        return -1;
      return 5778; /* aarch64_load_extendvnx4hivnx8qi */

    case 7:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
        return -1;
      return 5780; /* aarch64_load_extendvnx4hivnx4qi */

    case 8:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
        return -1;
      return 5782; /* aarch64_load_extendvnx4hivnx2qi */

    case 9:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
        return -1;
      return 5784; /* aarch64_load_extendvnx4hivnx4hi */

    case 10:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
        return -1;
      return 5786; /* aarch64_load_extendvnx4hivnx2hi */

    case 11:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
        return -1;
      return 5788; /* aarch64_load_extendvnx4hivnx2si */

    case 12:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
        return -1;
      return 5790; /* aarch64_load_extendvnx2hivnx8qi */

    case 13:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
        return -1;
      return 5792; /* aarch64_load_extendvnx2hivnx4qi */

    case 14:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
        return -1;
      return 5794; /* aarch64_load_extendvnx2hivnx2qi */

    case 15:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
        return -1;
      return 5796; /* aarch64_load_extendvnx2hivnx4hi */

    case 16:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
        return -1;
      return 5798; /* aarch64_load_extendvnx2hivnx2hi */

    case 17:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
        return -1;
      return 5800; /* aarch64_load_extendvnx2hivnx2si */

    case 18:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
        return -1;
      return 5802; /* aarch64_load_extendvnx4sivnx8qi */

    case 19:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
        return -1;
      return 5804; /* aarch64_load_extendvnx4sivnx4qi */

    case 20:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
        return -1;
      return 5806; /* aarch64_load_extendvnx4sivnx2qi */

    case 21:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
        return -1;
      return 5808; /* aarch64_load_extendvnx4sivnx4hi */

    case 22:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
        return -1;
      return 5810; /* aarch64_load_extendvnx4sivnx2hi */

    case 23:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
        return -1;
      return 5812; /* aarch64_load_extendvnx4sivnx2si */

    case 24:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
        return -1;
      return 5814; /* aarch64_load_extendvnx2sivnx8qi */

    case 25:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
        return -1;
      return 5816; /* aarch64_load_extendvnx2sivnx4qi */

    case 26:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
        return -1;
      return 5818; /* aarch64_load_extendvnx2sivnx2qi */

    case 27:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
        return -1;
      return 5820; /* aarch64_load_extendvnx2sivnx4hi */

    case 28:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
        return -1;
      return 5822; /* aarch64_load_extendvnx2sivnx2hi */

    case 29:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
        return -1;
      return 5824; /* aarch64_load_extendvnx2sivnx2si */

    case 30:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
        return -1;
      return 5826; /* aarch64_load_extendvnx2divnx8qi */

    case 31:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
        return -1;
      return 5828; /* aarch64_load_extendvnx2divnx4qi */

    case 32:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
        return -1;
      return 5830; /* aarch64_load_extendvnx2divnx2qi */

    case 33:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
        return -1;
      return 5832; /* aarch64_load_extendvnx2divnx4hi */

    case 34:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
        return -1;
      return 5834; /* aarch64_load_extendvnx2divnx2hi */

    case 35:
      if (!
#line 1351 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
        return -1;
      return 5836; /* aarch64_load_extendvnx2divnx2si */

    case 36:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0))
        return -1;
      return 5926; /* aarch64_ldff1_extendvnx8hivnx8qi */

    case 37:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0))
        return -1;
      return 5930; /* aarch64_ldff1_extendvnx8hivnx4qi */

    case 38:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0))
        return -1;
      return 5934; /* aarch64_ldff1_extendvnx8hivnx2qi */

    case 39:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0))
        return -1;
      return 5938; /* aarch64_ldff1_extendvnx8hivnx4hi */

    case 40:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0))
        return -1;
      return 5942; /* aarch64_ldff1_extendvnx8hivnx2hi */

    case 41:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0))
        return -1;
      return 5946; /* aarch64_ldff1_extendvnx8hivnx2si */

    case 42:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0))
        return -1;
      return 5950; /* aarch64_ldff1_extendvnx4hivnx8qi */

    case 43:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 5954; /* aarch64_ldff1_extendvnx4hivnx4qi */

    case 44:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0))
        return -1;
      return 5958; /* aarch64_ldff1_extendvnx4hivnx2qi */

    case 45:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 5962; /* aarch64_ldff1_extendvnx4hivnx4hi */

    case 46:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0))
        return -1;
      return 5966; /* aarch64_ldff1_extendvnx4hivnx2hi */

    case 47:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0))
        return -1;
      return 5970; /* aarch64_ldff1_extendvnx4hivnx2si */

    case 48:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0))
        return -1;
      return 5974; /* aarch64_ldff1_extendvnx2hivnx8qi */

    case 49:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0))
        return -1;
      return 5978; /* aarch64_ldff1_extendvnx2hivnx4qi */

    case 50:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 5982; /* aarch64_ldff1_extendvnx2hivnx2qi */

    case 51:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0))
        return -1;
      return 5986; /* aarch64_ldff1_extendvnx2hivnx4hi */

    case 52:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 5990; /* aarch64_ldff1_extendvnx2hivnx2hi */

    case 53:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 5994; /* aarch64_ldff1_extendvnx2hivnx2si */

    case 54:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 5998; /* aarch64_ldff1_extendvnx4sivnx8qi */

    case 55:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6002; /* aarch64_ldff1_extendvnx4sivnx4qi */

    case 56:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 6006; /* aarch64_ldff1_extendvnx4sivnx2qi */

    case 57:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6010; /* aarch64_ldff1_extendvnx4sivnx4hi */

    case 58:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 6014; /* aarch64_ldff1_extendvnx4sivnx2hi */

    case 59:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 6018; /* aarch64_ldff1_extendvnx4sivnx2si */

    case 60:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0))
        return -1;
      return 6022; /* aarch64_ldff1_extendvnx2sivnx8qi */

    case 61:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0))
        return -1;
      return 6026; /* aarch64_ldff1_extendvnx2sivnx4qi */

    case 62:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6030; /* aarch64_ldff1_extendvnx2sivnx2qi */

    case 63:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0))
        return -1;
      return 6034; /* aarch64_ldff1_extendvnx2sivnx4hi */

    case 64:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6038; /* aarch64_ldff1_extendvnx2sivnx2hi */

    case 65:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6042; /* aarch64_ldff1_extendvnx2sivnx2si */

    case 66:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 6046; /* aarch64_ldff1_extendvnx2divnx8qi */

    case 67:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 6050; /* aarch64_ldff1_extendvnx2divnx4qi */

    case 68:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6054; /* aarch64_ldff1_extendvnx2divnx2qi */

    case 69:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 6058; /* aarch64_ldff1_extendvnx2divnx4hi */

    case 70:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6062; /* aarch64_ldff1_extendvnx2divnx2hi */

    case 71:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6066; /* aarch64_ldff1_extendvnx2divnx2si */

    case 72:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x81) == 0))
        return -1;
      return 5927; /* aarch64_ldnf1_extendvnx8hivnx8qi */

    case 73:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x41) == 0))
        return -1;
      return 5931; /* aarch64_ldnf1_extendvnx8hivnx4qi */

    case 74:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x21) == 0))
        return -1;
      return 5935; /* aarch64_ldnf1_extendvnx8hivnx2qi */

    case 75:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x42) == 0))
        return -1;
      return 5939; /* aarch64_ldnf1_extendvnx8hivnx4hi */

    case 76:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x22) == 0))
        return -1;
      return 5943; /* aarch64_ldnf1_extendvnx8hivnx2hi */

    case 77:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x81 & 0x24) == 0))
        return -1;
      return 5947; /* aarch64_ldnf1_extendvnx8hivnx2si */

    case 78:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x81) == 0))
        return -1;
      return 5951; /* aarch64_ldnf1_extendvnx4hivnx8qi */

    case 79:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 5955; /* aarch64_ldnf1_extendvnx4hivnx4qi */

    case 80:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x21) == 0))
        return -1;
      return 5959; /* aarch64_ldnf1_extendvnx4hivnx2qi */

    case 81:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 5963; /* aarch64_ldnf1_extendvnx4hivnx4hi */

    case 82:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x22) == 0))
        return -1;
      return 5967; /* aarch64_ldnf1_extendvnx4hivnx2hi */

    case 83:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x24) == 0))
        return -1;
      return 5971; /* aarch64_ldnf1_extendvnx4hivnx2si */

    case 84:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x81) == 0))
        return -1;
      return 5975; /* aarch64_ldnf1_extendvnx2hivnx8qi */

    case 85:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x41) == 0))
        return -1;
      return 5979; /* aarch64_ldnf1_extendvnx2hivnx4qi */

    case 86:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 5983; /* aarch64_ldnf1_extendvnx2hivnx2qi */

    case 87:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x42) == 0))
        return -1;
      return 5987; /* aarch64_ldnf1_extendvnx2hivnx4hi */

    case 88:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 5991; /* aarch64_ldnf1_extendvnx2hivnx2hi */

    case 89:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 5995; /* aarch64_ldnf1_extendvnx2hivnx2si */

    case 90:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 5999; /* aarch64_ldnf1_extendvnx4sivnx8qi */

    case 91:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6003; /* aarch64_ldnf1_extendvnx4sivnx4qi */

    case 92:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 6007; /* aarch64_ldnf1_extendvnx4sivnx2qi */

    case 93:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6011; /* aarch64_ldnf1_extendvnx4sivnx4hi */

    case 94:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 6015; /* aarch64_ldnf1_extendvnx4sivnx2hi */

    case 95:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 6019; /* aarch64_ldnf1_extendvnx4sivnx2si */

    case 96:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x81) == 0))
        return -1;
      return 6023; /* aarch64_ldnf1_extendvnx2sivnx8qi */

    case 97:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x41) == 0))
        return -1;
      return 6027; /* aarch64_ldnf1_extendvnx2sivnx4qi */

    case 98:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6031; /* aarch64_ldnf1_extendvnx2sivnx2qi */

    case 99:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x42) == 0))
        return -1;
      return 6035; /* aarch64_ldnf1_extendvnx2sivnx4hi */

    case 100:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6039; /* aarch64_ldnf1_extendvnx2sivnx2hi */

    case 101:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6043; /* aarch64_ldnf1_extendvnx2sivnx2si */

    case 102:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 6047; /* aarch64_ldnf1_extendvnx2divnx8qi */

    case 103:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 6051; /* aarch64_ldnf1_extendvnx2divnx4qi */

    case 104:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6055; /* aarch64_ldnf1_extendvnx2divnx2qi */

    case 105:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 6059; /* aarch64_ldnf1_extendvnx2divnx4hi */

    case 106:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6063; /* aarch64_ldnf1_extendvnx2divnx2hi */

    case 107:
      if (!
#line 1435 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6067; /* aarch64_ldnf1_extendvnx2divnx2si */

    case 108:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x81) == 0))
        return -1;
      return 5838; /* *aarch64_load_extend_movvnx8hivnx8qi */

    case 109:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x41) == 0))
        return -1;
      return 5840; /* *aarch64_load_extend_movvnx8hivnx4qi */

    case 110:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x21) == 0))
        return -1;
      return 5842; /* *aarch64_load_extend_movvnx8hivnx2qi */

    case 111:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x42) == 0))
        return -1;
      return 5844; /* *aarch64_load_extend_movvnx8hivnx4hi */

    case 112:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x22) == 0))
        return -1;
      return 5846; /* *aarch64_load_extend_movvnx8hivnx2hi */

    case 113:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x81 & 0x24) == 0))
        return -1;
      return 5848; /* *aarch64_load_extend_movvnx8hivnx2si */

    case 114:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x81) == 0))
        return -1;
      return 5850; /* *aarch64_load_extend_movvnx4hivnx8qi */

    case 115:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x41) == 0))
        return -1;
      return 5852; /* *aarch64_load_extend_movvnx4hivnx4qi */

    case 116:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x21) == 0))
        return -1;
      return 5854; /* *aarch64_load_extend_movvnx4hivnx2qi */

    case 117:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x42) == 0))
        return -1;
      return 5856; /* *aarch64_load_extend_movvnx4hivnx4hi */

    case 118:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x22) == 0))
        return -1;
      return 5858; /* *aarch64_load_extend_movvnx4hivnx2hi */

    case 119:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x41 & 0x24) == 0))
        return -1;
      return 5860; /* *aarch64_load_extend_movvnx4hivnx2si */

    case 120:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x81) == 0))
        return -1;
      return 5862; /* *aarch64_load_extend_movvnx2hivnx8qi */

    case 121:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x41) == 0))
        return -1;
      return 5864; /* *aarch64_load_extend_movvnx2hivnx4qi */

    case 122:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x21) == 0))
        return -1;
      return 5866; /* *aarch64_load_extend_movvnx2hivnx2qi */

    case 123:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x42) == 0))
        return -1;
      return 5868; /* *aarch64_load_extend_movvnx2hivnx4hi */

    case 124:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x22) == 0))
        return -1;
      return 5870; /* *aarch64_load_extend_movvnx2hivnx2hi */

    case 125:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x21 & 0x24) == 0))
        return -1;
      return 5872; /* *aarch64_load_extend_movvnx2hivnx2si */

    case 126:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x81) == 0))
        return -1;
      return 5874; /* *aarch64_load_extend_movvnx4sivnx8qi */

    case 127:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x41) == 0))
        return -1;
      return 5876; /* *aarch64_load_extend_movvnx4sivnx4qi */

    case 128:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x21) == 0))
        return -1;
      return 5878; /* *aarch64_load_extend_movvnx4sivnx2qi */

    case 129:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x42) == 0))
        return -1;
      return 5880; /* *aarch64_load_extend_movvnx4sivnx4hi */

    case 130:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x22) == 0))
        return -1;
      return 5882; /* *aarch64_load_extend_movvnx4sivnx2hi */

    case 131:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x43 & 0x24) == 0))
        return -1;
      return 5884; /* *aarch64_load_extend_movvnx4sivnx2si */

    case 132:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x81) == 0))
        return -1;
      return 5886; /* *aarch64_load_extend_movvnx2sivnx8qi */

    case 133:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x41) == 0))
        return -1;
      return 5888; /* *aarch64_load_extend_movvnx2sivnx4qi */

    case 134:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x21) == 0))
        return -1;
      return 5890; /* *aarch64_load_extend_movvnx2sivnx2qi */

    case 135:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x42) == 0))
        return -1;
      return 5892; /* *aarch64_load_extend_movvnx2sivnx4hi */

    case 136:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x22) == 0))
        return -1;
      return 5894; /* *aarch64_load_extend_movvnx2sivnx2hi */

    case 137:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x23 & 0x24) == 0))
        return -1;
      return 5896; /* *aarch64_load_extend_movvnx2sivnx2si */

    case 138:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x81) == 0))
        return -1;
      return 5898; /* *aarch64_load_extend_movvnx2divnx8qi */

    case 139:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x41) == 0))
        return -1;
      return 5900; /* *aarch64_load_extend_movvnx2divnx4qi */

    case 140:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x21) == 0))
        return -1;
      return 5902; /* *aarch64_load_extend_movvnx2divnx2qi */

    case 141:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x42) == 0))
        return -1;
      return 5904; /* *aarch64_load_extend_movvnx2divnx4hi */

    case 142:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x22) == 0))
        return -1;
      return 5906; /* *aarch64_load_extend_movvnx2divnx2hi */

    case 143:
      if (!
#line 1371 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (~0x27 & 0x24) == 0))
        return -1;
      return 5908; /* *aarch64_load_extend_movvnx2divnx2si */

    case 144:
      if (!
#line 1663 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x41) == 0))
        return -1;
      return 6124; /* aarch64_gather_load_extendvnx4hivnx4qi */

    case 145:
      if (!
#line 1663 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x41 & 0x42) == 0))
        return -1;
      return 6128; /* aarch64_gather_load_extendvnx4hivnx4hi */

    case 146:
      if (!
#line 1663 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 6126; /* aarch64_gather_load_extendvnx4sivnx4qi */

    case 147:
      if (!
#line 1663 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 6130; /* aarch64_gather_load_extendvnx4sivnx4hi */

    case 148:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6132; /* aarch64_gather_load_extendvnx2hivnx2qi */

    case 149:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6138; /* aarch64_gather_load_extendvnx2hivnx2hi */

    case 150:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6144; /* aarch64_gather_load_extendvnx2hivnx2si */

    case 151:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6134; /* aarch64_gather_load_extendvnx2sivnx2qi */

    case 152:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6140; /* aarch64_gather_load_extendvnx2sivnx2hi */

    case 153:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6146; /* aarch64_gather_load_extendvnx2sivnx2si */

    case 154:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6136; /* aarch64_gather_load_extendvnx2divnx2qi */

    case 155:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6142; /* aarch64_gather_load_extendvnx2divnx2hi */

    case 156:
      if (!
#line 1703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6148; /* aarch64_gather_load_extendvnx2divnx2si */

    case 157:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6150; /* *aarch64_gather_load_extendvnx2hivnx2qi_sxtw_unpacked */

    case 158:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6162; /* *aarch64_gather_load_extendvnx2hivnx2hi_sxtw_unpacked */

    case 159:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6174; /* *aarch64_gather_load_extendvnx2hivnx2si_sxtw_unpacked */

    case 160:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6154; /* *aarch64_gather_load_extendvnx2sivnx2qi_sxtw_unpacked */

    case 161:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6166; /* *aarch64_gather_load_extendvnx2sivnx2hi_sxtw_unpacked */

    case 162:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6178; /* *aarch64_gather_load_extendvnx2sivnx2si_sxtw_unpacked */

    case 163:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6158; /* *aarch64_gather_load_extendvnx2divnx2qi_sxtw_unpacked */

    case 164:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6170; /* *aarch64_gather_load_extendvnx2divnx2hi_sxtw_unpacked */

    case 165:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6182; /* *aarch64_gather_load_extendvnx2divnx2si_sxtw_unpacked */

    case 166:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6186; /* *aarch64_gather_load_extendvnx2hivnx2qi_sxtw */

    case 167:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6192; /* *aarch64_gather_load_extendvnx2hivnx2hi_sxtw */

    case 168:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6198; /* *aarch64_gather_load_extendvnx2hivnx2si_sxtw */

    case 169:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6188; /* *aarch64_gather_load_extendvnx2sivnx2qi_sxtw */

    case 170:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6194; /* *aarch64_gather_load_extendvnx2sivnx2hi_sxtw */

    case 171:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6200; /* *aarch64_gather_load_extendvnx2sivnx2si_sxtw */

    case 172:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6190; /* *aarch64_gather_load_extendvnx2divnx2qi_sxtw */

    case 173:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6196; /* *aarch64_gather_load_extendvnx2divnx2hi_sxtw */

    case 174:
      if (!
#line 1780 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6202; /* *aarch64_gather_load_extendvnx2divnx2si_sxtw */

    case 175:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6152; /* *aarch64_gather_load_extendvnx2hivnx2qi_uxtw_unpacked */

    case 176:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6164; /* *aarch64_gather_load_extendvnx2hivnx2hi_uxtw_unpacked */

    case 177:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6176; /* *aarch64_gather_load_extendvnx2hivnx2si_uxtw_unpacked */

    case 178:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6156; /* *aarch64_gather_load_extendvnx2sivnx2qi_uxtw_unpacked */

    case 179:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6168; /* *aarch64_gather_load_extendvnx2sivnx2hi_uxtw_unpacked */

    case 180:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6180; /* *aarch64_gather_load_extendvnx2sivnx2si_uxtw_unpacked */

    case 181:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6160; /* *aarch64_gather_load_extendvnx2divnx2qi_uxtw_unpacked */

    case 182:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6172; /* *aarch64_gather_load_extendvnx2divnx2hi_uxtw_unpacked */

    case 183:
      if (!
#line 1742 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6184; /* *aarch64_gather_load_extendvnx2divnx2si_uxtw_unpacked */

    case 184:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x21) == 0))
        return -1;
      return 6204; /* *aarch64_gather_load_extendvnx2hivnx2qi_uxtw */

    case 185:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x22) == 0))
        return -1;
      return 6210; /* *aarch64_gather_load_extendvnx2hivnx2hi_uxtw */

    case 186:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x21 & 0x24) == 0))
        return -1;
      return 6216; /* *aarch64_gather_load_extendvnx2hivnx2si_uxtw */

    case 187:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x21) == 0))
        return -1;
      return 6206; /* *aarch64_gather_load_extendvnx2sivnx2qi_uxtw */

    case 188:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x22) == 0))
        return -1;
      return 6212; /* *aarch64_gather_load_extendvnx2sivnx2hi_uxtw */

    case 189:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x23 & 0x24) == 0))
        return -1;
      return 6218; /* *aarch64_gather_load_extendvnx2sivnx2si_uxtw */

    case 190:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 6208; /* *aarch64_gather_load_extendvnx2divnx2qi_uxtw */

    case 191:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 6214; /* *aarch64_gather_load_extendvnx2divnx2hi_uxtw */

    case 192:
      if (!
#line 1815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 6220; /* *aarch64_gather_load_extendvnx2divnx2si_uxtw */

    case 193:
      if (!
#line 1976 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6230; /* aarch64_ldff1_gather_extendvnx4sivnx4qi */

    case 194:
      if (!
#line 1976 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6232; /* aarch64_ldff1_gather_extendvnx4sivnx4hi */

    case 195:
      if (!
#line 2014 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6234; /* aarch64_ldff1_gather_extendvnx2divnx2qi */

    case 196:
      if (!
#line 2014 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6236; /* aarch64_ldff1_gather_extendvnx2divnx2hi */

    case 197:
      if (!
#line 2014 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6238; /* aarch64_ldff1_gather_extendvnx2divnx2si */

    case 198:
      if (!
#line 2052 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6240; /* *aarch64_ldff1_gather_extendvnx2divnx2qi_sxtw */

    case 199:
      if (!
#line 2052 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6242; /* *aarch64_ldff1_gather_extendvnx2divnx2hi_sxtw */

    case 200:
      if (!
#line 2052 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6244; /* *aarch64_ldff1_gather_extendvnx2divnx2si_sxtw */

    case 201:
      if (!
#line 2084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6246; /* *aarch64_ldff1_gather_extendvnx2divnx2qi_uxtw */

    case 202:
      if (!
#line 2084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6248; /* *aarch64_ldff1_gather_extendvnx2divnx2hi_uxtw */

    case 203:
      if (!
#line 2084 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 6250; /* *aarch64_ldff1_gather_extendvnx2divnx2si_uxtw */

    case 204:
      if (!
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
        return -1;
      return 11178; /* aarch64_gather_ldnt_extendvnx4sivnx8qi */

    case 205:
      if (!
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
        return -1;
      return 11180; /* aarch64_gather_ldnt_extendvnx4sivnx4qi */

    case 206:
      if (!
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
        return -1;
      return 11182; /* aarch64_gather_ldnt_extendvnx4sivnx2qi */

    case 207:
      if (!
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
        return -1;
      return 11184; /* aarch64_gather_ldnt_extendvnx4sivnx4hi */

    case 208:
      if (!
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
        return -1;
      return 11186; /* aarch64_gather_ldnt_extendvnx4sivnx2hi */

    case 209:
      if (!
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
        return -1;
      return 11188; /* aarch64_gather_ldnt_extendvnx4sivnx2si */

    case 210:
      if (!
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
        return -1;
      return 11190; /* aarch64_gather_ldnt_extendvnx2divnx8qi */

    case 211:
      if (!
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
        return -1;
      return 11192; /* aarch64_gather_ldnt_extendvnx2divnx4qi */

    case 212:
      if (!
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
        return -1;
      return 11194; /* aarch64_gather_ldnt_extendvnx2divnx2qi */

    case 213:
      if (!
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
        return -1;
      return 11196; /* aarch64_gather_ldnt_extendvnx2divnx4hi */

    case 214:
      if (!
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
        return -1;
      return 11198; /* aarch64_gather_ldnt_extendvnx2divnx2hi */

    case 215:
      if (!
#line 397 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
        return -1;
      return 11200; /* aarch64_gather_ldnt_extendvnx2divnx2si */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern99 (x3, 
E_VNx16QImode, 
E_VNx8HImode) != 0
          || !
#line 9321 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10739; /* vec_pack_trunc_vnx8hi */

    case E_VNx8HImode:
      if (pattern99 (x3, 
E_VNx8HImode, 
E_VNx4SImode) != 0
          || !
#line 9321 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10740; /* vec_pack_trunc_vnx4si */

    case E_VNx4SImode:
      if (pattern99 (x3, 
E_VNx4SImode, 
E_VNx2DImode) != 0
          || !
#line 9321 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10741; /* vec_pack_trunc_vnx2di */

    case E_VNx16BImode:
      if (pattern99 (x3, 
E_VNx16BImode, 
E_VNx8BImode) != 0
          || !
#line 10003 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10900; /* vec_pack_trunc_vnx8bi */

    case E_VNx8BImode:
      if (pattern99 (x3, 
E_VNx8BImode, 
E_VNx4BImode) != 0
          || !
#line 10003 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10901; /* vec_pack_trunc_vnx4bi */

    case E_VNx4BImode:
      if (pattern99 (x3, 
E_VNx4BImode, 
E_VNx2BImode) != 0
          || !
#line 10003 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10902; /* vec_pack_trunc_vnx2bi */

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      if (pattern91 (x3, 
E_V4HImode, 
E_V4HFmode) != 0
          || !(
#line 10141 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5315; /* aarch64_fscalev4hf */

    case E_V8HFmode:
      if (pattern91 (x3, 
E_V8HImode, 
E_V8HFmode) != 0
          || !(
#line 10141 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5316; /* aarch64_fscalev8hf */

    case E_V2SFmode:
      if (pattern91 (x3, 
E_V2SImode, 
E_V2SFmode) != 0
          || !
#line 10141 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5317; /* aarch64_fscalev2sf */

    case E_V4SFmode:
      if (pattern91 (x3, 
E_V4SImode, 
E_V4SFmode) != 0
          || !
#line 10141 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5318; /* aarch64_fscalev4sf */

    case E_V2DFmode:
      if (pattern91 (x3, 
E_V2DImode, 
E_V2DFmode) != 0
          || !
#line 10141 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8))
        return -1;
      return 5319; /* aarch64_fscalev2df */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern120 (x1))
    {
    case 0:
      if (!
#line 3884 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12810; /* aarch64_sve_uzpqvnx32qi */

    case 1:
      if (!
#line 3884 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12812; /* aarch64_sve_uzpqvnx16hi */

    case 2:
      if (!
#line 3884 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12814; /* aarch64_sve_uzpqvnx8si */

    case 3:
      if (!
#line 3884 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12816; /* aarch64_sve_uzpqvnx4di */

    case 4:
      if (!
#line 3884 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12818; /* aarch64_sve_uzpqvnx16bf */

    case 5:
      if (!
#line 3884 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12820; /* aarch64_sve_uzpqvnx16hf */

    case 6:
      if (!
#line 3884 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12822; /* aarch64_sve_uzpqvnx8sf */

    case 7:
      if (!
#line 3884 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12824; /* aarch64_sve_uzpqvnx4df */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern97 (x1))
    {
    case 0:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10640; /* aarch64_sve_zip1qvnx16qi */

    case 1:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10646; /* aarch64_sve_zip1qvnx8hi */

    case 2:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10652; /* aarch64_sve_zip1qvnx4si */

    case 3:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10658; /* aarch64_sve_zip1qvnx2di */

    case 4:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10664; /* aarch64_sve_zip1qvnx8bf */

    case 5:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10670; /* aarch64_sve_zip1qvnx8hf */

    case 6:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10676; /* aarch64_sve_zip1qvnx4sf */

    case 7:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10682; /* aarch64_sve_zip1qvnx2df */

    default:
      return -1;
    }
}

 int
recog_98 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern70 (x1))
    {
    case 0:
      if (!(
#line 1811 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2153; /* aarch64_smax_nanpv4hf */

    case 1:
      if (!(
#line 1811 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2165; /* aarch64_smax_nanpv8hf */

    case 2:
      if (!
#line 1811 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2169; /* aarch64_smax_nanpv2sf */

    case 3:
      if (!
#line 1811 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2181; /* aarch64_smax_nanpv4sf */

    case 4:
      if (!
#line 1811 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2185; /* aarch64_smax_nanpv2df */

    case 5:
      if (!
#line 9027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10359; /* aarch64_pred_reduc_smax_nan_vnx8hf */

    case 6:
      if (!
#line 9027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10364; /* aarch64_pred_reduc_smax_nan_vnx4sf */

    case 7:
      if (!
#line 9027 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10369; /* aarch64_pred_reduc_smax_nan_vnx2df */

    default:
      return -1;
    }
}

 int
recog_110 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern55 (x3, 
E_V8QImode) != 0
          || !
#line 5036 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3202; /* aarch64_pmulv8qi */

    case E_V16QImode:
      if (pattern55 (x3, 
E_V16QImode) != 0
          || !
#line 5036 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3203; /* aarch64_pmulv16qi */

    case E_VNx16QImode:
      if (pattern55 (x3, 
E_VNx16QImode) != 0
          || !
#line 3609 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12599; /* aarch64_sve2_pmulvnx16qi */

    default:
      return -1;
    }
}

 int
recog_121 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern65 (x1))
    {
    case 0:
      if (!(
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1385; /* aarch64_fcadd90v4hf */

    case 1:
      if (!(
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 1391; /* aarch64_fcadd90v8hf */

    case 2:
      if (!
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
        return -1;
      return 1393; /* aarch64_fcadd90v2sf */

    case 3:
      if (!
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
        return -1;
      return 1399; /* aarch64_fcadd90v4sf */

    case 4:
      if (!
#line 439 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
        return -1;
      return 1401; /* aarch64_fcadd90v2df */

    default:
      return -1;
    }
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (!
#line 2983 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12471; /* aarch64_sve_sqcadd270vnx16qi */

    case 1:
      if (!
#line 2983 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12475; /* aarch64_sve_sqcadd270vnx8hi */

    case 2:
      if (!
#line 2983 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12479; /* aarch64_sve_sqcadd270vnx4si */

    case 3:
      if (!
#line 2983 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12483; /* aarch64_sve_sqcadd270vnx2di */

    default:
      return -1;
    }
}

 int
recog_141 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern94 (x1))
    {
    case 0:
      if (!
#line 8961 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 8))
        return -1;
      return 10322; /* aarch64_pred_reduc_sadd_vnx16qi */

    case 1:
      if (!
#line 8961 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
        return -1;
      return 10324; /* aarch64_pred_reduc_sadd_vnx8hi */

    case 2:
      if (!
#line 8961 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
        return -1;
      return 10326; /* aarch64_pred_reduc_sadd_vnx4si */

    case 3:
      if (!
#line 8961 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
        return -1;
      return 10328; /* aarch64_pred_reduc_sadd_vnx2di */

    default:
      return -1;
    }
}

 int
recog_153 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x8QImode:
      if (!register_operand (operands[0], E_V3x8QImode)
          || GET_MODE (x3) != E_V3x8QImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4450; /* aarch64_simd_ld3rv8qi */

    case E_V3x4HImode:
      if (!register_operand (operands[0], E_V3x4HImode)
          || GET_MODE (x3) != E_V3x4HImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4451; /* aarch64_simd_ld3rv4hi */

    case E_V3x2SImode:
      if (!register_operand (operands[0], E_V3x2SImode)
          || GET_MODE (x3) != E_V3x2SImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4452; /* aarch64_simd_ld3rv2si */

    case E_V3x1DImode:
      if (!register_operand (operands[0], E_V3x1DImode)
          || GET_MODE (x3) != E_V3x1DImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4453; /* aarch64_simd_ld3rdi */

    case E_V3x4HFmode:
      if (!register_operand (operands[0], E_V3x4HFmode)
          || GET_MODE (x3) != E_V3x4HFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4454; /* aarch64_simd_ld3rv4hf */

    case E_V3x2SFmode:
      if (!register_operand (operands[0], E_V3x2SFmode)
          || GET_MODE (x3) != E_V3x2SFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4455; /* aarch64_simd_ld3rv2sf */

    case E_V3x1DFmode:
      if (!register_operand (operands[0], E_V3x1DFmode)
          || GET_MODE (x3) != E_V3x1DFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4456; /* aarch64_simd_ld3rdf */

    case E_V3x4BFmode:
      if (!register_operand (operands[0], E_V3x4BFmode)
          || GET_MODE (x3) != E_V3x4BFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4457; /* aarch64_simd_ld3rv4bf */

    case E_V3x16QImode:
      if (!register_operand (operands[0], E_V3x16QImode)
          || GET_MODE (x3) != E_V3x16QImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4458; /* aarch64_simd_ld3rv16qi */

    case E_V3x8HImode:
      if (!register_operand (operands[0], E_V3x8HImode)
          || GET_MODE (x3) != E_V3x8HImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4459; /* aarch64_simd_ld3rv8hi */

    case E_V3x4SImode:
      if (!register_operand (operands[0], E_V3x4SImode)
          || GET_MODE (x3) != E_V3x4SImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4460; /* aarch64_simd_ld3rv4si */

    case E_V3x2DImode:
      if (!register_operand (operands[0], E_V3x2DImode)
          || GET_MODE (x3) != E_V3x2DImode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4461; /* aarch64_simd_ld3rv2di */

    case E_V3x8HFmode:
      if (!register_operand (operands[0], E_V3x8HFmode)
          || GET_MODE (x3) != E_V3x8HFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4462; /* aarch64_simd_ld3rv8hf */

    case E_V3x4SFmode:
      if (!register_operand (operands[0], E_V3x4SFmode)
          || GET_MODE (x3) != E_V3x4SFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4463; /* aarch64_simd_ld3rv4sf */

    case E_V3x2DFmode:
      if (!register_operand (operands[0], E_V3x2DFmode)
          || GET_MODE (x3) != E_V3x2DFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4464; /* aarch64_simd_ld3rv2df */

    case E_V3x8BFmode:
      if (!register_operand (operands[0], E_V3x8BFmode)
          || GET_MODE (x3) != E_V3x8BFmode
          || !
#line 7672 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4465; /* aarch64_simd_ld3rv8bf */

    default:
      return -1;
    }
}

 int
recog_156 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern372 (x3))
    {
    case 0:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5584; /* *aarch64_sve_reinterpretvnx16qi */

    case 1:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5585; /* *aarch64_sve_reinterpretvnx8qi */

    case 2:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5586; /* *aarch64_sve_reinterpretvnx4qi */

    case 3:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5587; /* *aarch64_sve_reinterpretvnx2qi */

    case 4:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5588; /* *aarch64_sve_reinterpretvnx8hi */

    case 5:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5589; /* *aarch64_sve_reinterpretvnx4hi */

    case 6:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5590; /* *aarch64_sve_reinterpretvnx2hi */

    case 7:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5591; /* *aarch64_sve_reinterpretvnx4si */

    case 8:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5592; /* *aarch64_sve_reinterpretvnx2si */

    case 9:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5593; /* *aarch64_sve_reinterpretvnx2di */

    case 10:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5594; /* *aarch64_sve_reinterpretvnx8hf */

    case 11:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5595; /* *aarch64_sve_reinterpretvnx4hf */

    case 12:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5596; /* *aarch64_sve_reinterpretvnx2hf */

    case 13:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5597; /* *aarch64_sve_reinterpretvnx8bf */

    case 14:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5598; /* *aarch64_sve_reinterpretvnx4bf */

    case 15:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5599; /* *aarch64_sve_reinterpretvnx2bf */

    case 16:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5600; /* *aarch64_sve_reinterpretvnx4sf */

    case 17:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5601; /* *aarch64_sve_reinterpretvnx2sf */

    case 18:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5602; /* *aarch64_sve_reinterpretvnx2df */

    case 19:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5603; /* *aarch64_sve_reinterpretvnx32qi */

    case 20:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5604; /* *aarch64_sve_reinterpretvnx16hi */

    case 21:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5605; /* *aarch64_sve_reinterpretvnx8si */

    case 22:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5606; /* *aarch64_sve_reinterpretvnx4di */

    case 23:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5607; /* *aarch64_sve_reinterpretvnx16bf */

    case 24:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5608; /* *aarch64_sve_reinterpretvnx16hf */

    case 25:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5609; /* *aarch64_sve_reinterpretvnx8sf */

    case 26:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5610; /* *aarch64_sve_reinterpretvnx4df */

    case 27:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5611; /* *aarch64_sve_reinterpretvnx48qi */

    case 28:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5612; /* *aarch64_sve_reinterpretvnx24hi */

    case 29:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5613; /* *aarch64_sve_reinterpretvnx12si */

    case 30:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5614; /* *aarch64_sve_reinterpretvnx6di */

    case 31:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5615; /* *aarch64_sve_reinterpretvnx24bf */

    case 32:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5616; /* *aarch64_sve_reinterpretvnx24hf */

    case 33:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5617; /* *aarch64_sve_reinterpretvnx12sf */

    case 34:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5618; /* *aarch64_sve_reinterpretvnx6df */

    case 35:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5619; /* *aarch64_sve_reinterpretvnx64qi */

    case 36:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5620; /* *aarch64_sve_reinterpretvnx32hi */

    case 37:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5621; /* *aarch64_sve_reinterpretvnx16si */

    case 38:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5622; /* *aarch64_sve_reinterpretvnx8di */

    case 39:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5623; /* *aarch64_sve_reinterpretvnx32bf */

    case 40:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5624; /* *aarch64_sve_reinterpretvnx32hf */

    case 41:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5625; /* *aarch64_sve_reinterpretvnx16sf */

    case 42:
      if (!
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5626; /* *aarch64_sve_reinterpretvnx8df */

    default:
      return -1;
    }
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern124 (x1))
    {
    case 0:
      if (!(
#line 6798 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 883; /* floorhf2 */

    case 1:
      if (!
#line 6798 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 890; /* floorsf2 */

    case 2:
      if (!
#line 6798 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 897; /* floordf2 */

    case 3:
      if (!(
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2478; /* floorv4hf2 */

    case 4:
      if (!(
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2495; /* floorv8hf2 */

    case 5:
      if (!
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2506; /* floorv2sf2 */

    case 6:
      if (!
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2523; /* floorv4sf2 */

    case 7:
      if (!
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2530; /* floorv2df2 */

    case 8:
      if (!
#line 699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11368; /* floorvnx8sf2 */

    case 9:
      if (!
#line 699 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11372; /* floorvnx16sf2 */

    default:
      return -1;
    }
}

 int
recog_182 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 3411 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2725; /* reduc_plus_scal_v2sf */

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x3) != E_DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 3411 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2726; /* reduc_plus_scal_v2df */

    default:
      return -1;
    }
}

 int
recog_190 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern136 (x1))
    {
    case 0:
      if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10756; /* aarch64_sve_uunpklo_vnx16qi */

    case 1:
      if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10760; /* aarch64_sve_uunpklo_vnx8hi */

    case 2:
      if (!
#line 9370 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10764; /* aarch64_sve_uunpklo_vnx4si */

    case 3:
      if (!
#line 10036 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10903; /* aarch64_sve_punpklo_vnx16bi */

    case 4:
      if (!
#line 10036 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10905; /* aarch64_sve_punpklo_vnx8bi */

    case 5:
      if (!
#line 10036 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10907; /* aarch64_sve_punpklo_vnx4bi */

    default:
      return -1;
    }
}

 int
recog_198 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1111 (x2))
        {
        case 0:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10844; /* *cond_floatuns_nonextendvnx8hivnx8hf_relaxed */
          break;

        case 1:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10850; /* *cond_floatuns_nonextendvnx4sivnx8hf_relaxed */
          break;

        case 2:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10856; /* *cond_floatuns_nonextendvnx2divnx8hf_relaxed */
          break;

        case 3:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10846; /* *cond_floatuns_nonextendvnx8hivnx4sf_relaxed */
          break;

        case 4:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10852; /* *cond_floatuns_nonextendvnx4sivnx4sf_relaxed */
          break;

        case 5:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10858; /* *cond_floatuns_nonextendvnx2divnx4sf_relaxed */
          break;

        case 6:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10848; /* *cond_floatuns_nonextendvnx8hivnx2df_relaxed */
          break;

        case 7:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10854; /* *cond_floatuns_nonextendvnx4sivnx2df_relaxed */
          break;

        case 8:
          if (
#line 9646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10860; /* *cond_floatuns_nonextendvnx2divnx2df_relaxed */
          break;

        default:
          break;
        }
      break;

    case 1L:
      switch (pattern1112 (x2))
        {
        case 0:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
            return 10862; /* *cond_floatuns_nonextendvnx8hivnx8hf_strict */
          break;

        case 1:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
            return 10868; /* *cond_floatuns_nonextendvnx4sivnx8hf_strict */
          break;

        case 2:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
            return 10874; /* *cond_floatuns_nonextendvnx2divnx8hf_strict */
          break;

        case 3:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
            return 10864; /* *cond_floatuns_nonextendvnx8hivnx4sf_strict */
          break;

        case 4:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
            return 10870; /* *cond_floatuns_nonextendvnx4sivnx4sf_strict */
          break;

        case 5:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
            return 10876; /* *cond_floatuns_nonextendvnx2divnx4sf_strict */
          break;

        case 6:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
            return 10866; /* *cond_floatuns_nonextendvnx8hivnx2df_strict */
          break;

        case 7:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
            return 10872; /* *cond_floatuns_nonextendvnx4sivnx2df_strict */
          break;

        case 8:
          if (
#line 9669 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
            return 10878; /* *cond_floatuns_nonextendvnx2divnx2df_strict */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
      || pattern1110 (x2, 
E_VNx4SImode, 
E_VNx2DFmode) != 0
      || !
#line 9703 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
    return -1;
  return 10880; /* *cond_floatuns_extendvnx4sivnx2df */
}

 int
recog_204 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern859 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7199; /* *cond_rintvnx8hf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7265; /* *cond_rintvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7210; /* *cond_rintvnx4sf_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7276; /* *cond_rintvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7221; /* *cond_rintvnx2df_2_relaxed */
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7287; /* *cond_rintvnx2df_any_relaxed */

    case 3:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7232; /* *cond_rintvnx8hf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !
#line 3781 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7298; /* *cond_rintvnx8hf_any_strict */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7243; /* *cond_rintvnx4sf_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !
#line 3781 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7309; /* *cond_rintvnx4sf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 3732 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7254; /* *cond_rintvnx2df_2_strict */
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !
#line 3781 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 7320; /* *cond_rintvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_221 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11607; /* *cond_urhaddvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11652; /* *cond_urhaddvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11692; /* *cond_urhaddvnx8hi_any */
}

 int
recog_231 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11628; /* *cond_uhaddvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11669; /* *cond_uhaddvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11709; /* *cond_uhaddvnx2di_any */
}

 int
recog_241 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11601; /* *cond_srhaddvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11647; /* *cond_srhaddvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11687; /* *cond_srhaddvnx8hi_any */
}

 int
recog_251 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11622; /* *cond_shaddvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11664; /* *cond_shaddvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11704; /* *cond_shaddvnx2di_any */
}

 int
recog_261 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1047 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8496; /* *cond_fmax_nanvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8642; /* *cond_fmax_nanvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8746; /* *cond_fmax_nanvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8509; /* *cond_fmax_nanvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8655; /* *cond_fmax_nanvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8759; /* *cond_fmax_nanvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8522; /* *cond_fmax_nanvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8668; /* *cond_fmax_nanvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8772; /* *cond_fmax_nanvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8535; /* *cond_fmax_nanvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8681; /* *cond_fmax_nanvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8785; /* *cond_fmax_nanvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8596; /* *cond_fmax_nanvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8846; /* *cond_fmax_nanvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8603; /* *cond_fmax_nanvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8853; /* *cond_fmax_nanvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8610; /* *cond_fmax_nanvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8860; /* *cond_fmax_nanvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8548; /* *cond_fmax_nanvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8694; /* *cond_fmax_nanvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8798; /* *cond_fmax_nanvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8561; /* *cond_fmax_nanvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8707; /* *cond_fmax_nanvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8811; /* *cond_fmax_nanvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8574; /* *cond_fmax_nanvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8720; /* *cond_fmax_nanvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8824; /* *cond_fmax_nanvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8587; /* *cond_fmax_nanvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8733; /* *cond_fmax_nanvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8837; /* *cond_fmax_nanvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8617; /* *cond_fmax_nanvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8867; /* *cond_fmax_nanvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8624; /* *cond_fmax_nanvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8874; /* *cond_fmax_nanvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8631; /* *cond_fmax_nanvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8881; /* *cond_fmax_nanvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_270 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern698 (x2))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern469 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x4 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x4, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7438; /* *cond_subvnx16qi_2 */
          if (rtx_equal_p (x4, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7608; /* *cond_subvnx16qi_3 */
          operands[4] = x4;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7778; /* *cond_subvnx16qi_any */

        case E_VNx8QImode:
          if (pattern469 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x4 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x4, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7455; /* *cond_subvnx8qi_2 */
          if (rtx_equal_p (x4, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7625; /* *cond_subvnx8qi_3 */
          operands[4] = x4;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7795; /* *cond_subvnx8qi_any */

        case E_VNx4QImode:
          if (pattern469 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x4 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x4, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7472; /* *cond_subvnx4qi_2 */
          if (rtx_equal_p (x4, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7642; /* *cond_subvnx4qi_3 */
          operands[4] = x4;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7812; /* *cond_subvnx4qi_any */

        case E_VNx2QImode:
          if (pattern469 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x4 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x4, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7489; /* *cond_subvnx2qi_2 */
          if (rtx_equal_p (x4, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7659; /* *cond_subvnx2qi_3 */
          operands[4] = x4;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7829; /* *cond_subvnx2qi_any */

        case E_VNx8HImode:
          if (pattern469 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x4 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x4, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7506; /* *cond_subvnx8hi_2 */
          if (rtx_equal_p (x4, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7676; /* *cond_subvnx8hi_3 */
          operands[4] = x4;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7846; /* *cond_subvnx8hi_any */

        case E_VNx4HImode:
          if (pattern469 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x4 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x4, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7523; /* *cond_subvnx4hi_2 */
          if (rtx_equal_p (x4, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7693; /* *cond_subvnx4hi_3 */
          operands[4] = x4;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7863; /* *cond_subvnx4hi_any */

        case E_VNx2HImode:
          if (pattern469 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x4 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x4, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7540; /* *cond_subvnx2hi_2 */
          if (rtx_equal_p (x4, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7710; /* *cond_subvnx2hi_3 */
          operands[4] = x4;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7880; /* *cond_subvnx2hi_any */

        case E_VNx4SImode:
          if (pattern469 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x4 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x4, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7557; /* *cond_subvnx4si_2 */
          if (rtx_equal_p (x4, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7727; /* *cond_subvnx4si_3 */
          operands[4] = x4;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7897; /* *cond_subvnx4si_any */

        case E_VNx2SImode:
          if (pattern469 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x4 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x4, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7574; /* *cond_subvnx2si_2 */
          if (rtx_equal_p (x4, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7744; /* *cond_subvnx2si_3 */
          operands[4] = x4;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7914; /* *cond_subvnx2si_any */

        case E_VNx2DImode:
          if (pattern469 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x4 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x4, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7591; /* *cond_subvnx2di_2 */
          if (rtx_equal_p (x4, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7761; /* *cond_subvnx2di_3 */
          operands[4] = x4;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7931; /* *cond_subvnx2di_any */

        default:
          return -1;
        }

    case 1:
      return recog_269 (x1, insn, pnum_clobbers);

    case 2:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8001; /* *aarch64_cond_sabdvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8021; /* *aarch64_cond_sabdvnx16qi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8041; /* *aarch64_cond_sabdvnx16qi_any */

    case 3:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8003; /* *aarch64_cond_sabdvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8023; /* *aarch64_cond_sabdvnx8qi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8043; /* *aarch64_cond_sabdvnx8qi_any */

    case 4:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8005; /* *aarch64_cond_sabdvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8025; /* *aarch64_cond_sabdvnx4qi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8045; /* *aarch64_cond_sabdvnx4qi_any */

    case 5:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8007; /* *aarch64_cond_sabdvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8027; /* *aarch64_cond_sabdvnx2qi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8047; /* *aarch64_cond_sabdvnx2qi_any */

    case 6:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8009; /* *aarch64_cond_sabdvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8029; /* *aarch64_cond_sabdvnx8hi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8049; /* *aarch64_cond_sabdvnx8hi_any */

    case 7:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8011; /* *aarch64_cond_sabdvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8031; /* *aarch64_cond_sabdvnx4hi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8051; /* *aarch64_cond_sabdvnx4hi_any */

    case 8:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8013; /* *aarch64_cond_sabdvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8033; /* *aarch64_cond_sabdvnx2hi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8053; /* *aarch64_cond_sabdvnx2hi_any */

    case 9:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8015; /* *aarch64_cond_sabdvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8035; /* *aarch64_cond_sabdvnx4si_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8055; /* *aarch64_cond_sabdvnx4si_any */

    case 10:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8017; /* *aarch64_cond_sabdvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8037; /* *aarch64_cond_sabdvnx2si_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8057; /* *aarch64_cond_sabdvnx2si_any */

    case 11:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8019; /* *aarch64_cond_sabdvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8039; /* *aarch64_cond_sabdvnx2di_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8059; /* *aarch64_cond_sabdvnx2di_any */

    case 12:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8002; /* *aarch64_cond_uabdvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8022; /* *aarch64_cond_uabdvnx16qi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8042; /* *aarch64_cond_uabdvnx16qi_any */

    case 13:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8004; /* *aarch64_cond_uabdvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8024; /* *aarch64_cond_uabdvnx8qi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8044; /* *aarch64_cond_uabdvnx8qi_any */

    case 14:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8006; /* *aarch64_cond_uabdvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8026; /* *aarch64_cond_uabdvnx4qi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8046; /* *aarch64_cond_uabdvnx4qi_any */

    case 15:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8008; /* *aarch64_cond_uabdvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8028; /* *aarch64_cond_uabdvnx2qi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8048; /* *aarch64_cond_uabdvnx2qi_any */

    case 16:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8010; /* *aarch64_cond_uabdvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8030; /* *aarch64_cond_uabdvnx8hi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8050; /* *aarch64_cond_uabdvnx8hi_any */

    case 17:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8012; /* *aarch64_cond_uabdvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8032; /* *aarch64_cond_uabdvnx4hi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8052; /* *aarch64_cond_uabdvnx4hi_any */

    case 18:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8014; /* *aarch64_cond_uabdvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8034; /* *aarch64_cond_uabdvnx2hi_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8054; /* *aarch64_cond_uabdvnx2hi_any */

    case 19:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8016; /* *aarch64_cond_uabdvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8036; /* *aarch64_cond_uabdvnx4si_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8056; /* *aarch64_cond_uabdvnx4si_any */

    case 20:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8018; /* *aarch64_cond_uabdvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8038; /* *aarch64_cond_uabdvnx2si_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8058; /* *aarch64_cond_uabdvnx2si_any */

    case 21:
      x5 = XVECEXP (x2, 0, 1);
      x6 = XEXP (x5, 0);
      x7 = XVECEXP (x6, 0, 0);
      operands[4] = x7;
      x8 = XEXP (x5, 1);
      x9 = XVECEXP (x8, 0, 0);
      operands[5] = x9;
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4352 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8020; /* *aarch64_cond_uabdvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4383 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8040; /* *aarch64_cond_uabdvnx2di_3 */
      operands[5] = x7;
      operands[6] = x9;
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 8060; /* *aarch64_cond_uabdvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_282 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern723 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7450; /* *cond_ssaddvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7620; /* *cond_ssaddvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7790; /* *cond_ssaddvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7467; /* *cond_ssaddvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7637; /* *cond_ssaddvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7807; /* *cond_ssaddvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7484; /* *cond_ssaddvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7654; /* *cond_ssaddvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7824; /* *cond_ssaddvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7501; /* *cond_ssaddvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7671; /* *cond_ssaddvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7841; /* *cond_ssaddvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7518; /* *cond_ssaddvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7688; /* *cond_ssaddvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7858; /* *cond_ssaddvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7535; /* *cond_ssaddvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7705; /* *cond_ssaddvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7875; /* *cond_ssaddvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7552; /* *cond_ssaddvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7722; /* *cond_ssaddvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7892; /* *cond_ssaddvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7569; /* *cond_ssaddvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7739; /* *cond_ssaddvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7909; /* *cond_ssaddvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7586; /* *cond_ssaddvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7756; /* *cond_ssaddvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7926; /* *cond_ssaddvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && (
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7603; /* *cond_ssaddvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && (
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 7773; /* *cond_ssaddvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 2754 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 7943; /* *cond_ssaddvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_294 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern598 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6698; /* *cond_clzvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6788; /* *cond_clzvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6707; /* *cond_clzvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6797; /* *cond_clzvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6716; /* *cond_clzvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6806; /* *cond_clzvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6725; /* *cond_clzvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6815; /* *cond_clzvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6734; /* *cond_clzvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6824; /* *cond_clzvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6743; /* *cond_clzvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6833; /* *cond_clzvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6752; /* *cond_clzvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6842; /* *cond_clzvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6761; /* *cond_clzvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6851; /* *cond_clzvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6770; /* *cond_clzvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6860; /* *cond_clzvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && 
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 6779; /* *cond_clzvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])))
        return -1;
      return 6869; /* *cond_clzvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_302 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx2TImode:
      switch (pattern791 (x3, 
E_VNx32QImode, 
E_VNx2TImode))
        {
        case 0:
          if (!
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 11206; /* aarch64_sve_stnqvnx32qi */

        case 1:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16HImode:
              if (!register_operand (operands[1], E_VNx16HImode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11207; /* aarch64_sve_stnqvnx16hi */

            case E_VNx16BFmode:
              if (!register_operand (operands[1], E_VNx16BFmode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11210; /* aarch64_sve_stnqvnx16bf */

            case E_VNx16HFmode:
              if (!register_operand (operands[1], E_VNx16HFmode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11211; /* aarch64_sve_stnqvnx16hf */

            default:
              return -1;
            }

        case 2:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx8SImode:
              if (!register_operand (operands[1], E_VNx8SImode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11208; /* aarch64_sve_stnqvnx8si */

            case E_VNx8SFmode:
              if (!register_operand (operands[1], E_VNx8SFmode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11212; /* aarch64_sve_stnqvnx8sf */

            default:
              return -1;
            }

        case 3:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx4DImode:
              if (!register_operand (operands[1], E_VNx4DImode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11209; /* aarch64_sve_stnqvnx4di */

            case E_VNx4DFmode:
              if (!register_operand (operands[1], E_VNx4DFmode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11213; /* aarch64_sve_stnqvnx4df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_VNx3TImode:
      switch (pattern791 (x3, 
E_VNx48QImode, 
E_VNx3TImode))
        {
        case 0:
          if (!
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 11214; /* aarch64_sve_stnqvnx48qi */

        case 1:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx24HImode:
              if (!register_operand (operands[1], E_VNx24HImode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11215; /* aarch64_sve_stnqvnx24hi */

            case E_VNx24BFmode:
              if (!register_operand (operands[1], E_VNx24BFmode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11218; /* aarch64_sve_stnqvnx24bf */

            case E_VNx24HFmode:
              if (!register_operand (operands[1], E_VNx24HFmode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11219; /* aarch64_sve_stnqvnx24hf */

            default:
              return -1;
            }

        case 2:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx12SImode:
              if (!register_operand (operands[1], E_VNx12SImode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11216; /* aarch64_sve_stnqvnx12si */

            case E_VNx12SFmode:
              if (!register_operand (operands[1], E_VNx12SFmode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11220; /* aarch64_sve_stnqvnx12sf */

            default:
              return -1;
            }

        case 3:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx6DImode:
              if (!register_operand (operands[1], E_VNx6DImode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11217; /* aarch64_sve_stnqvnx6di */

            case E_VNx6DFmode:
              if (!register_operand (operands[1], E_VNx6DFmode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11221; /* aarch64_sve_stnqvnx6df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case E_VNx4TImode:
      switch (pattern791 (x3, 
E_VNx64QImode, 
E_VNx4TImode))
        {
        case 0:
          if (!
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 11222; /* aarch64_sve_stnqvnx64qi */

        case 1:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx32HImode:
              if (!register_operand (operands[1], E_VNx32HImode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11223; /* aarch64_sve_stnqvnx32hi */

            case E_VNx32BFmode:
              if (!register_operand (operands[1], E_VNx32BFmode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11226; /* aarch64_sve_stnqvnx32bf */

            case E_VNx32HFmode:
              if (!register_operand (operands[1], E_VNx32HFmode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11227; /* aarch64_sve_stnqvnx32hf */

            default:
              return -1;
            }

        case 2:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16SImode:
              if (!register_operand (operands[1], E_VNx16SImode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11224; /* aarch64_sve_stnqvnx16si */

            case E_VNx16SFmode:
              if (!register_operand (operands[1], E_VNx16SFmode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11228; /* aarch64_sve_stnqvnx16sf */

            default:
              return -1;
            }

        case 3:
          switch (GET_MODE (operands[1]))
            {
            case E_VNx8DImode:
              if (!register_operand (operands[1], E_VNx8DImode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11225; /* aarch64_sve_stnqvnx8di */

            case E_VNx8DFmode:
              if (!register_operand (operands[1], E_VNx8DFmode)
                  || !
#line 454 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
                return -1;
              return 11229; /* aarch64_sve_stnqvnx8df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_312 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern166 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9943; /* while_wrsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9953; /* while_wrdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9963; /* while_wrsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9973; /* while_wrdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9983; /* while_wrsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9993; /* while_wrdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10003; /* while_wrsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10013; /* while_wrdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_318 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern166 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9937; /* while_ltsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9947; /* while_ltdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9957; /* while_ltsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9967; /* while_ltdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9977; /* while_ltsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9987; /* while_ltdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9997; /* while_ltsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10007; /* while_ltdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_326 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern191 (x3, 
E_VNx16QImode) != 0
          || !(
#line 3856 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3179 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12778; /* aarch64_sve_tbxqvnx16qi */

    case E_VNx8HImode:
      if (pattern191 (x3, 
E_VNx8HImode) != 0
          || !(
#line 3856 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3179 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12780; /* aarch64_sve_tbxqvnx8hi */

    case E_VNx4SImode:
      if (pattern191 (x3, 
E_VNx4SImode) != 0
          || !(
#line 3856 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3179 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12782; /* aarch64_sve_tbxqvnx4si */

    case E_VNx2DImode:
      if (pattern191 (x3, 
E_VNx2DImode) != 0
          || !(
#line 3856 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3179 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12784; /* aarch64_sve_tbxqvnx2di */

    case E_VNx8BFmode:
      if (pattern784 (x3, 
E_VNx8HImode, 
E_VNx8BFmode) != 0
          || !(
#line 3856 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3179 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12786; /* aarch64_sve_tbxqvnx8bf */

    case E_VNx8HFmode:
      if (pattern784 (x3, 
E_VNx8HImode, 
E_VNx8HFmode) != 0
          || !(
#line 3856 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3179 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12788; /* aarch64_sve_tbxqvnx8hf */

    case E_VNx4SFmode:
      if (pattern784 (x3, 
E_VNx4SImode, 
E_VNx4SFmode) != 0
          || !(
#line 3856 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3179 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12790; /* aarch64_sve_tbxqvnx4sf */

    case E_VNx2DFmode:
      if (pattern784 (x3, 
E_VNx2DImode, 
E_VNx2DFmode) != 0
          || !(
#line 3856 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 3179 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 12792; /* aarch64_sve_tbxqvnx2df */

    default:
      return -1;
    }
}

 int
recog_335 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern788 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 1463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6070; /* aarch64_ldnt1vnx16qi */

    case E_VNx8HImode:
      if (pattern788 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 1463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6071; /* aarch64_ldnt1vnx8hi */

    case E_VNx4SImode:
      if (pattern788 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 1463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6072; /* aarch64_ldnt1vnx4si */

    case E_VNx2DImode:
      if (pattern788 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 1463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6073; /* aarch64_ldnt1vnx2di */

    case E_VNx8BFmode:
      if (pattern788 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6074; /* aarch64_ldnt1vnx8bf */

    case E_VNx8HFmode:
      if (pattern788 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 1463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6075; /* aarch64_ldnt1vnx8hf */

    case E_VNx4SFmode:
      if (pattern788 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 1463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6076; /* aarch64_ldnt1vnx4sf */

    case E_VNx2DFmode:
      if (pattern788 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 1463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 6077; /* aarch64_ldnt1vnx2df */

    default:
      return -1;
    }
}

 int
recog_343 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern172 (x1))
    {
    case 0:
      if (!
#line 9405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
        return -1;
      return 10766; /* aarch64_sve_fixuns_trunc_nontruncvnx8hfvnx8hi */

    case 1:
      if (!
#line 9405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
        return -1;
      return 10768; /* aarch64_sve_fixuns_trunc_nontruncvnx4sfvnx8hi */

    case 2:
      if (!
#line 9405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
        return -1;
      return 10770; /* aarch64_sve_fixuns_trunc_nontruncvnx2dfvnx8hi */

    case 3:
      if (!
#line 9405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
        return -1;
      return 10772; /* aarch64_sve_fixuns_trunc_nontruncvnx8hfvnx4si */

    case 4:
      if (!
#line 9405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
        return -1;
      return 10774; /* aarch64_sve_fixuns_trunc_nontruncvnx4sfvnx4si */

    case 5:
      if (!
#line 9405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
        return -1;
      return 10776; /* aarch64_sve_fixuns_trunc_nontruncvnx2dfvnx4si */

    case 6:
      if (!
#line 9420 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10784; /* aarch64_sve_fixuns_trunc_truncvnx2dfvnx4si */

    case 7:
      if (!
#line 9405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
        return -1;
      return 10778; /* aarch64_sve_fixuns_trunc_nontruncvnx8hfvnx2di */

    case 8:
      if (!
#line 9405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
        return -1;
      return 10780; /* aarch64_sve_fixuns_trunc_nontruncvnx4sfvnx2di */

    case 9:
      if (!
#line 9405 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
        return -1;
      return 10782; /* aarch64_sve_fixuns_trunc_nontruncvnx2dfvnx2di */

    default:
      return -1;
    }
}

 int
recog_355 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern193 (x1))
    {
    case 0:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12491; /* aarch64_sve_sqrdcmlah270vnx16qi */

    case 1:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12499; /* aarch64_sve_sqrdcmlah270vnx8hi */

    case 2:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12507; /* aarch64_sve_sqrdcmlah270vnx4si */

    case 3:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12515; /* aarch64_sve_sqrdcmlah270vnx2di */

    case 4:
      if (!
#line 3032 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12523; /* aarch64_sqrdcmlah270_lane_vnx8hi */

    case 5:
      if (!
#line 3032 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12531; /* aarch64_sqrdcmlah270_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_363 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[3] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      if (pattern790 (x3, 
E_VNx8HFmode, 
E_HFmode, 
E_VNx8BImode) != 0
          || !
#line 9058 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10373; /* mask_fold_left_plus_vnx8hf */

    case E_SFmode:
      if (pattern790 (x3, 
E_VNx4SFmode, 
E_SFmode, 
E_VNx4BImode) != 0
          || !
#line 9058 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10374; /* mask_fold_left_plus_vnx4sf */

    case E_DFmode:
      if (pattern790 (x3, 
E_VNx2DFmode, 
E_DFmode, 
E_VNx2BImode) != 0
          || !
#line 9058 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 10375; /* mask_fold_left_plus_vnx2df */

    default:
      return -1;
    }
}

 int
recog_372 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern189 (x1))
    {
    case 0:
      if (!
#line 2820 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12419; /* aarch64_pred_uminpvnx16qi */

    case 1:
      if (!
#line 2820 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12424; /* aarch64_pred_uminpvnx8hi */

    case 2:
      if (!
#line 2820 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12429; /* aarch64_pred_uminpvnx4si */

    case 3:
      if (!
#line 2820 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12434; /* aarch64_pred_uminpvnx2di */

    default:
      return -1;
    }
}

 int
recog_380 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern183 (x1))
    {
    case 0:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11796; /* aarch64_sve_eorbtvnx16qi */

    case 1:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11804; /* aarch64_sve_eorbtvnx8hi */

    case 2:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11812; /* aarch64_sve_eorbtvnx4si */

    case 3:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11820; /* aarch64_sve_eorbtvnx2di */

    default:
      return -1;
    }
}

 int
recog_388 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SFmode:
      if (pattern182 (x3, 
E_VNx4SFmode) != 0
          || !(
#line 7999 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 553 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_F32MM)))
        return -1;
      return 9404; /* aarch64_sve_fmmlavnx4sf */

    case E_VNx2DFmode:
      if (pattern182 (x3, 
E_VNx2DFmode) != 0
          || !(
#line 7999 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 554 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_F64MM)))
        return -1;
      return 9405; /* aarch64_sve_fmmlavnx2df */

    default:
      return -1;
    }
}

 int
recog_396 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_CC_NZCmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  if (pnum_clobbers != NULL)
    {
      res = recog_394 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (!aarch64_sve_ptrue_flag (x3, E_SImode))
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_CC_NZCmode)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  if (!register_operand (x5, E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x6))
    {
    case AND:
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x5;
      x7 = XEXP (x6, 0);
      switch (GET_CODE (x7))
        {
        case REG:
          if (REGNO (x7) != 86
              || GET_MODE (x7) != E_VNx16BImode)
            return -1;
          operands[2] = x3;
          if (GET_MODE (x6) != E_VNx16BImode)
            return -1;
          x8 = XVECEXP (x2, 0, 1);
          if (!rtx_equal_p (x8, operands[1]))
            return -1;
          x9 = XEXP (x6, 1);
          if (!rtx_equal_p (x9, operands[1])
              || !
#line 1182 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          *pnum_clobbers = 1;
          return 5718; /* *aarch64_rdffr_z_ptest */

        case AND:
          switch (pattern1161 (x2))
            {
            case 0:
              if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9052; /* *andvnx16bi3_ptest */

            case 1:
              if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9055; /* *andvnx8bi3_ptest */

            case 2:
              if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9058; /* *andvnx4bi3_ptest */

            case 3:
              if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9061; /* *andvnx2bi3_ptest */

            case 4:
              if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9080; /* *bicvnx16bi3_ptest */

            case 5:
              if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9082; /* *bicvnx8bi3_ptest */

            case 6:
              if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9084; /* *bicvnx4bi3_ptest */

            case 7:
              if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9086; /* *bicvnx2bi3_ptest */

            case 8:
              if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9104; /* *norvnx16bi3_ptest */

            case 9:
              if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9106; /* *norvnx8bi3_ptest */

            case 10:
              if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9108; /* *norvnx4bi3_ptest */

            case 11:
              if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9110; /* *norvnx2bi3_ptest */

            default:
              return -1;
            }

        case IOR:
          switch (pattern1161 (x2))
            {
            case 0:
              if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9053; /* *iorvnx16bi3_ptest */

            case 1:
              if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9056; /* *iorvnx8bi3_ptest */

            case 2:
              if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9059; /* *iorvnx4bi3_ptest */

            case 3:
              if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9062; /* *iorvnx2bi3_ptest */

            case 4:
              if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9081; /* *ornvnx16bi3_ptest */

            case 5:
              if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9083; /* *ornvnx8bi3_ptest */

            case 6:
              if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9085; /* *ornvnx4bi3_ptest */

            case 7:
              if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9087; /* *ornvnx2bi3_ptest */

            case 8:
              if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9105; /* *nandvnx16bi3_ptest */

            case 9:
              if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9107; /* *nandvnx8bi3_ptest */

            case 10:
              if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9109; /* *nandvnx4bi3_ptest */

            case 11:
              if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9111; /* *nandvnx2bi3_ptest */

            default:
              return -1;
            }

        case XOR:
          x8 = XVECEXP (x2, 0, 1);
          operands[4] = x8;
          operands[5] = x3;
          x10 = XEXP (x7, 0);
          operands[2] = x10;
          x11 = XEXP (x7, 1);
          operands[3] = x11;
          x9 = XEXP (x6, 1);
          if (!rtx_equal_p (x9, operands[4]))
            return -1;
          switch (pattern1158 (x6))
            {
            case 0:
              if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9054; /* *xorvnx16bi3_ptest */

            case 1:
              if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9057; /* *xorvnx8bi3_ptest */

            case 2:
              if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9060; /* *xorvnx4bi3_ptest */

            case 3:
              if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9063; /* *xorvnx2bi3_ptest */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      return recog_395 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
      operands[3] = x6;
      operands[0] = x5;
      x8 = XVECEXP (x2, 0, 1);
      operands[1] = x8;
      operands[2] = x3;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx16BImode:
          if (!register_operand (operands[3], E_VNx16BImode)
              || !
#line 8879 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10286; /* aarch64_ptestvnx16bi */

        case E_VNx8BImode:
          if (!register_operand (operands[3], E_VNx8BImode)
              || !
#line 8879 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10287; /* aarch64_ptestvnx8bi */

        case E_VNx4BImode:
          if (!register_operand (operands[3], E_VNx4BImode)
              || !
#line 8879 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10288; /* aarch64_ptestvnx4bi */

        case E_VNx2BImode:
          if (!register_operand (operands[3], E_VNx2BImode)
              || !
#line 8879 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10289; /* aarch64_ptestvnx2bi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_411 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern934 (x3, 
E_VNx8HImode, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 5198 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8444; /* aarch64_pred_fscalevnx8hf */

    case E_VNx4SFmode:
      if (pattern934 (x3, 
E_VNx4SImode, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 5198 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8445; /* aarch64_pred_fscalevnx4sf */

    case E_VNx2DFmode:
      if (pattern934 (x3, 
E_VNx2DImode, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 5198 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8446; /* aarch64_pred_fscalevnx2df */

    case E_HFmode:
      if (pattern934 (x3, 
E_HImode, 
E_HFmode, 
E_VNx8BImode) != 0
          || !
#line 5198 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8447; /* aarch64_pred_fscalehf */

    case E_SFmode:
      if (pattern934 (x3, 
E_SImode, 
E_SFmode, 
E_VNx4BImode) != 0
          || !
#line 5198 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8448; /* aarch64_pred_fscalesf */

    case E_DFmode:
      if (pattern934 (x3, 
E_DImode, 
E_DFmode, 
E_VNx2BImode) != 0
          || !
#line 5198 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8449; /* aarch64_pred_fscaledf */

    default:
      return -1;
    }
}

 int
recog_417 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 89
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 90
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 92
      || GET_MODE (x5) != E_DImode
      || pattern720 (x1, 
92) != 0)
    return -1;
  *pnum_clobbers = 8;
  return 12908; /* aarch64_restore_za */
}

 int
recog_421 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern936 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 6071 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8933; /* aarch64_pred_subvnx8hf */

    case E_VNx4SFmode:
      if (pattern936 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 6071 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8934; /* aarch64_pred_subvnx4sf */

    case E_VNx2DFmode:
      if (pattern936 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 6071 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8935; /* aarch64_pred_subvnx2df */

    case E_VNx8BFmode:
      if (pattern200 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1346 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
        return -1;
      return 11775; /* aarch64_pred_subvnx8bf */

    default:
      return -1;
    }
}

 int
recog_429 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern246 (x1))
    {
    case 0:
      if (!
#line 1429 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13645; /* aarch64_sme_smlsvnx4sivnx16qi */

    case 1:
      if (!
#line 1429 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13649; /* aarch64_sme_smlsvnx4sivnx8hi */

    case 2:
      if (!
#line 1459 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13661; /* aarch64_sme_smlsvnx4sivnx32qi */

    case 3:
      if (!
#line 1459 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13665; /* aarch64_sme_smlsvnx4sivnx64qi */

    case 4:
      if (!
#line 1459 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13669; /* aarch64_sme_smlsvnx4sivnx16hi */

    case 5:
      if (!
#line 1459 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13673; /* aarch64_sme_smlsvnx4sivnx32hi */

    case 6:
      if (!
#line 1557 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13773; /* aarch64_sme_smlsvnx2divnx8hi */

    case 7:
      if (!
#line 1587 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13781; /* aarch64_sme_smlsvnx2divnx16hi */

    case 8:
      if (!
#line 1587 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13785; /* aarch64_sme_smlsvnx2divnx32hi */

    case 9:
      if (!
#line 1490 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13693; /* aarch64_sme_single_smlsvnx4sivnx32qi */

    case 10:
      if (!
#line 1490 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13697; /* aarch64_sme_single_smlsvnx4sivnx64qi */

    case 11:
      if (!
#line 1490 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13701; /* aarch64_sme_single_smlsvnx4sivnx16hi */

    case 12:
      if (!
#line 1490 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13705; /* aarch64_sme_single_smlsvnx4sivnx32hi */

    case 13:
      if (!
#line 1618 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13797; /* aarch64_sme_single_smlsvnx2divnx16hi */

    case 14:
      if (!
#line 1618 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13801; /* aarch64_sme_single_smlsvnx2divnx32hi */

    case 15:
      if (!
#line 1524 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13725; /* aarch64_sme_lane_smlsvnx4sivnx16qi */

    case 16:
      if (!
#line 1524 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13729; /* aarch64_sme_lane_smlsvnx4sivnx32qi */

    case 17:
      if (!
#line 1524 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13733; /* aarch64_sme_lane_smlsvnx4sivnx64qi */

    case 18:
      if (!
#line 1524 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13737; /* aarch64_sme_lane_smlsvnx4sivnx8hi */

    case 19:
      if (!
#line 1524 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13741; /* aarch64_sme_lane_smlsvnx4sivnx16hi */

    case 20:
      if (!
#line 1524 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13745; /* aarch64_sme_lane_smlsvnx4sivnx32hi */

    case 21:
      if (!
#line 1652 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13813; /* aarch64_sme_lane_smlsvnx2divnx8hi */

    case 22:
      if (!
#line 1652 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13817; /* aarch64_sme_lane_smlsvnx2divnx16hi */

    case 23:
      if (!
#line 1652 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13821; /* aarch64_sme_lane_smlsvnx2divnx32hi */

    case 24:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx16QImode)
          && register_operand (operands[3], E_VNx16QImode)
          && 
#line 1443 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13653; /* *aarch64_sme_smlsvnx4sivnx16qi_plus */
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1443 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return 13657; /* *aarch64_sme_smlsvnx4sivnx8hi_plus */
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          switch (pattern1312 ())
            {
            case 0:
              if (
#line 1473 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13677; /* *aarch64_sme_smlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1473 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13681; /* *aarch64_sme_smlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1313 ())
        {
        case 0:
          if (!
#line 1473 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13685; /* *aarch64_sme_smlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1473 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13689; /* *aarch64_sme_smlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 25:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode)
          && register_operand (operands[3], E_VNx8HImode)
          && 
#line 1571 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return 13777; /* *aarch64_sme_smlsvnx2divnx8hi_plus */
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      switch (pattern1313 ())
        {
        case 0:
          if (!
#line 1601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13789; /* *aarch64_sme_smlsvnx2divnx16hi_plus */

        case 1:
          if (!
#line 1601 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13793; /* *aarch64_sme_smlsvnx2divnx32hi_plus */

        default:
          return -1;
        }

    case 26:
      if (const_0_to_4_step_4_operand (operands[1], E_SImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          switch (pattern1314 (x3))
            {
            case 0:
              if (
#line 1505 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13709; /* *aarch64_sme_single_smlsvnx4sivnx32qi_plus */
              break;

            case 1:
              if (
#line 1505 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13713; /* *aarch64_sme_single_smlsvnx4sivnx64qi_plus */
              break;

            default:
              break;
            }
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern245 (x3))
        {
        case 0:
          if (!
#line 1505 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13717; /* *aarch64_sme_single_smlsvnx4sivnx16hi_plus */

        case 1:
          if (!
#line 1505 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13721; /* *aarch64_sme_single_smlsvnx4sivnx32hi_plus */

        default:
          return -1;
        }

    case 27:
      if (!
#line 1633 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13805; /* *aarch64_sme_single_smlsvnx2divnx16hi_plus */

    case 28:
      if (!
#line 1633 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
        return -1;
      return 13809; /* *aarch64_sme_single_smlsvnx2divnx32hi_plus */

    case 29:
      if (register_operand (operands[3], E_VNx16QImode))
        {
          if (const_0_to_12_step_4_operand (operands[1], E_SImode)
              && register_operand (operands[2], E_VNx16QImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              if (GET_MODE (x3) == E_VNx16QImode
                  && 
#line 1541 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return 13749; /* *aarch64_sme_lane_smlsvnx4sivnx16qi */
            }
          if (const_0_to_4_step_4_operand (operands[1], E_SImode))
            {
              x2 = XEXP (x1, 1);
              x3 = XVECEXP (x2, 0, 4);
              switch (pattern1352 (x3))
                {
                case 0:
                  if (
#line 1541 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13753; /* *aarch64_sme_lane_smlsvnx4sivnx32qi */
                  break;

                case 1:
                  if (
#line 1541 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                    return 13757; /* *aarch64_sme_lane_smlsvnx4sivnx64qi */
                  break;

                default:
                  break;
                }
            }
        }
      if (!register_operand (operands[3], E_VNx8HImode))
        return -1;
      if (const_0_to_14_step_2_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1541 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return 13761; /* *aarch64_sme_lane_smlsvnx4sivnx8hi */
        }
      if (!const_0_to_6_step_2_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1353 (x3))
        {
        case 0:
          if (!
#line 1541 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13765; /* *aarch64_sme_lane_smlsvnx4sivnx16hi */

        case 1:
          if (!
#line 1541 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 13769; /* *aarch64_sme_lane_smlsvnx4sivnx32hi */

        default:
          return -1;
        }

    case 30:
      if (const_0_to_12_step_4_operand (operands[1], E_SImode)
          && register_operand (operands[2], E_VNx8HImode))
        {
          x2 = XEXP (x1, 1);
          x3 = XVECEXP (x2, 0, 4);
          if (GET_MODE (x3) == E_VNx8HImode
              && 
#line 1669 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return 13825; /* *aarch64_sme_lane_smlsvnx2divnx8hi */
        }
      if (!const_0_to_4_step_4_operand (operands[1], E_SImode))
        return -1;
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 4);
      switch (pattern1353 (x3))
        {
        case 0:
          if (!
#line 1669 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13829; /* *aarch64_sme_lane_smlsvnx2divnx16hi */

        case 1:
          if (!
#line 1669 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2 && TARGET_SME_I16I64))
            return -1;
          return 13833; /* *aarch64_sme_lane_smlsvnx2divnx32hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_437 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern229 (x1))
    {
    case 0:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13242; /* aarch64_sme_write_horvnx32qivnx32qi */

    case 1:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13244; /* aarch64_sme_write_horvnx16hivnx16hi */

    case 2:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13246; /* aarch64_sme_write_horvnx8sivnx8si */

    case 3:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13248; /* aarch64_sme_write_horvnx4divnx4di */

    case 4:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13250; /* aarch64_sme_write_horvnx16bfvnx16bf */

    case 5:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13252; /* aarch64_sme_write_horvnx16hfvnx16hf */

    case 6:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13254; /* aarch64_sme_write_horvnx8sfvnx8sf */

    case 7:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13256; /* aarch64_sme_write_horvnx4dfvnx4df */

    case 8:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13258; /* aarch64_sme_write_horvnx64qivnx64qi */

    case 9:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13260; /* aarch64_sme_write_horvnx32hivnx32hi */

    case 10:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13262; /* aarch64_sme_write_horvnx16sivnx16si */

    case 11:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13264; /* aarch64_sme_write_horvnx8divnx8di */

    case 12:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13266; /* aarch64_sme_write_horvnx32bfvnx32bf */

    case 13:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13268; /* aarch64_sme_write_horvnx32hfvnx32hf */

    case 14:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13270; /* aarch64_sme_write_horvnx16sfvnx16sf */

    case 15:
      if (!
#line 979 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13272; /* aarch64_sme_write_horvnx8dfvnx8df */

    case 16:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 8))
        return -1;
      return 13274; /* *aarch64_sme_write_horvnx32qivnx32qi_plus */

    case 17:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13276; /* *aarch64_sme_write_horvnx16hivnx16hi_plus */

    case 18:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13278; /* *aarch64_sme_write_horvnx8sivnx8si_plus */

    case 19:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13280; /* *aarch64_sme_write_horvnx4divnx4di_plus */

    case 20:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13282; /* *aarch64_sme_write_horvnx16bfvnx16bf_plus */

    case 21:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13284; /* *aarch64_sme_write_horvnx16hfvnx16hf_plus */

    case 22:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13286; /* *aarch64_sme_write_horvnx8sfvnx8sf_plus */

    case 23:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 2 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13288; /* *aarch64_sme_write_horvnx4dfvnx4df_plus */

    case 24:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 8))
        return -1;
      return 13290; /* *aarch64_sme_write_horvnx64qivnx64qi_plus */

    case 25:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13292; /* *aarch64_sme_write_horvnx32hivnx32hi_plus */

    case 26:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13294; /* *aarch64_sme_write_horvnx16sivnx16si_plus */

    case 27:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13296; /* *aarch64_sme_write_horvnx8divnx8di_plus */

    case 28:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13298; /* *aarch64_sme_write_horvnx32bfvnx32bf_plus */

    case 29:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 16))
        return -1;
      return 13300; /* *aarch64_sme_write_horvnx32hfvnx32hf_plus */

    case 30:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 32))
        return -1;
      return 13302; /* *aarch64_sme_write_horvnx16sfvnx16sf_plus */

    case 31:
      if (!
#line 997 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && UINTVAL (operands[2]) % 4 == 0
   && UINTVAL (operands[2]) < 128 / 64))
        return -1;
      return 13304; /* *aarch64_sme_write_horvnx8dfvnx8df_plus */

    default:
      return -1;
    }
}

 int
recog_444 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 281:
      if (pattern196 (x1) != 0
          || !
#line 9206 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5193; /* aarch64_sm3tt1aqv4si */

    case 282:
      if (pattern196 (x1) != 0
          || !
#line 9206 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5194; /* aarch64_sm3tt1bqv4si */

    case 283:
      if (pattern196 (x1) != 0
          || !
#line 9206 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5195; /* aarch64_sm3tt2aqv4si */

    case 284:
      if (pattern196 (x1) != 0
          || !
#line 9206 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SM4))
        return -1;
      return 5196; /* aarch64_sm3tt2bqv4si */

    case 590:
      return recog_398 (x1, insn, pnum_clobbers);

    case 193:
      return recog_418 (x1, insn, pnum_clobbers);

    case 458:
      switch (pattern198 (x1))
        {
        case 0:
          if (!
#line 10181 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5332; /* aarch64_fmlalbv8hf */

        case 1:
          if (!
#line 2090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 11993; /* aarch64_sve_add_fmlalbvnx8hf */

        case 2:
          if (!
#line 10196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5334; /* aarch64_fmlalb_lanev8hfv8qi */

        case 3:
          if (!
#line 10196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5336; /* aarch64_fmlalb_lanev8hfv16qi */

        default:
          return -1;
        }

    case 464:
      switch (pattern198 (x1))
        {
        case 0:
          if (!
#line 10181 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5333; /* aarch64_fmlaltv8hf */

        case 1:
          if (!
#line 2090 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 11994; /* aarch64_sve_add_fmlaltvnx8hf */

        case 2:
          if (!
#line 10196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5335; /* aarch64_fmlalt_lanev8hfv8qi */

        case 3:
          if (!
#line 10196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5337; /* aarch64_fmlalt_lanev8hfv16qi */

        default:
          return -1;
        }

    case 459:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 10212 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5338; /* aarch64_fmlallbbv4sf */

        case 1:
          if (!
#line 2105 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 11995; /* aarch64_sve_add_fmlallbbvnx4sf */

        case 2:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5342; /* aarch64_fmlallbb_lanev4sfv8qi */

        case 3:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5346; /* aarch64_fmlallbb_lanev4sfv16qi */

        default:
          return -1;
        }

    case 460:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 10212 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5339; /* aarch64_fmlallbtv4sf */

        case 1:
          if (!
#line 2105 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 11996; /* aarch64_sve_add_fmlallbtvnx4sf */

        case 2:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5343; /* aarch64_fmlallbt_lanev4sfv8qi */

        case 3:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5347; /* aarch64_fmlallbt_lanev4sfv16qi */

        default:
          return -1;
        }

    case 461:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 10212 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5340; /* aarch64_fmlalltbv4sf */

        case 1:
          if (!
#line 2105 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 11997; /* aarch64_sve_add_fmlalltbvnx4sf */

        case 2:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5344; /* aarch64_fmlalltb_lanev4sfv8qi */

        case 3:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5348; /* aarch64_fmlalltb_lanev4sfv16qi */

        default:
          return -1;
        }

    case 462:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 10212 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5341; /* aarch64_fmlallttv4sf */

        case 1:
          if (!
#line 2105 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8FMA))
            return -1;
          return 11998; /* aarch64_sve_add_fmlallttvnx4sf */

        case 2:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5345; /* aarch64_fmlalltt_lanev4sfv8qi */

        case 3:
          if (!
#line 10227 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8FMA))
            return -1;
          return 5349; /* aarch64_fmlalltt_lanev4sfv16qi */

        default:
          return -1;
        }

    case 127:
      return recog_396 (x1, insn, pnum_clobbers);

    case 390:
      return recog_411 (x1, insn, pnum_clobbers);

    case 352:
      switch (pattern201 (x1))
        {
        case 0:
          if (!(
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3377 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_FAMINMAX)))
            return -1;
          return 8480; /* aarch64_pred_famaxvnx8hf */

        case 1:
          if (!(
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3377 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_FAMINMAX)))
            return -1;
          return 8484; /* aarch64_pred_famaxvnx4sf */

        case 2:
          if (!(
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3377 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_FAMINMAX)))
            return -1;
          return 8488; /* aarch64_pred_famaxvnx2df */

        default:
          return -1;
        }

    case 353:
      switch (pattern201 (x1))
        {
        case 0:
          if (!(
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3378 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_FAMINMAX)))
            return -1;
          return 8481; /* aarch64_pred_faminvnx8hf */

        case 1:
          if (!(
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3378 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_FAMINMAX)))
            return -1;
          return 8485; /* aarch64_pred_faminvnx4sf */

        case 2:
          if (!(
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3378 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_FAMINMAX)))
            return -1;
          return 8489; /* aarch64_pred_faminvnx2df */

        default:
          return -1;
        }

    case 370:
      switch (pattern201 (x1))
        {
        case 0:
          if (!
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8482; /* aarch64_pred_divvnx8hf */

        case 1:
          if (!
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8486; /* aarch64_pred_divvnx4sf */

        case 2:
          if (!
#line 5437 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8490; /* aarch64_pred_divvnx2df */

        default:
          return -1;
        }

    case 378:
      return recog_422 (x1, insn, pnum_clobbers);

    case 351:
      return recog_420 (x1, insn, pnum_clobbers);

    case 354:
      switch (pattern201 (x1))
        {
        case 0:
          if (!
#line 5906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8903; /* aarch64_pred_cadd90vnx8hf */

        case 1:
          if (!
#line 5906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8905; /* aarch64_pred_cadd90vnx4sf */

        case 2:
          if (!
#line 5906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8907; /* aarch64_pred_cadd90vnx2df */

        default:
          return -1;
        }

    case 355:
      switch (pattern201 (x1))
        {
        case 0:
          if (!
#line 5906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8904; /* aarch64_pred_cadd270vnx8hf */

        case 1:
          if (!
#line 5906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8906; /* aarch64_pred_cadd270vnx4sf */

        case 2:
          if (!
#line 5906 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8908; /* aarch64_pred_cadd270vnx2df */

        default:
          return -1;
        }

    case 392:
      return recog_421 (x1, insn, pnum_clobbers);

    case 377:
      return recog_419 (x1, insn, pnum_clobbers);

    case 371:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9006; /* aarch64_pred_fmax_nanvnx8hf */

        case 1:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9012; /* aarch64_pred_fmax_nanvnx4sf */

        case 2:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9018; /* aarch64_pred_fmax_nanvnx2df */

        case 3:
          if (!
#line 1346 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11769; /* aarch64_pred_fmax_nanvnx8bf */

        default:
          return -1;
        }

    case 372:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9007; /* aarch64_pred_fmaxvnx8hf */

        case 1:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9013; /* aarch64_pred_fmaxvnx4sf */

        case 2:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9019; /* aarch64_pred_fmaxvnx2df */

        case 3:
          if (!
#line 1346 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11770; /* aarch64_pred_fmaxvnx8bf */

        default:
          return -1;
        }

    case 373:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9008; /* aarch64_pred_fmin_nanvnx8hf */

        case 1:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9014; /* aarch64_pred_fmin_nanvnx4sf */

        case 2:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9020; /* aarch64_pred_fmin_nanvnx2df */

        case 3:
          if (!
#line 1346 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11771; /* aarch64_pred_fmin_nanvnx8bf */

        default:
          return -1;
        }

    case 374:
      return recog_410 (x1, insn, pnum_clobbers);

    case 394:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9010; /* aarch64_pred_smaxvnx8hf */

        case 1:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9016; /* aarch64_pred_smaxvnx4sf */

        case 2:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9022; /* aarch64_pred_smaxvnx2df */

        case 3:
          if (!
#line 1346 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11776; /* aarch64_pred_smaxvnx8bf */

        case 4:
          if (!
#line 2952 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX))
            return -1;
          return 12462; /* *aarch64_pred_faminmax_fused */

        case 5:
          if (!
#line 2952 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX))
            return -1;
          return 12464; /* *aarch64_pred_faminmax_fused */

        case 6:
          if (!
#line 2952 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX))
            return -1;
          return 12466; /* *aarch64_pred_faminmax_fused */

        default:
          return -1;
        }

    case 395:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9011; /* aarch64_pred_sminvnx8hf */

        case 1:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9017; /* aarch64_pred_sminvnx4sf */

        case 2:
          if (!
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9023; /* aarch64_pred_sminvnx2df */

        case 3:
          if (!
#line 1346 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return -1;
          return 11777; /* aarch64_pred_sminvnx8bf */

        case 4:
          if (!
#line 2952 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX))
            return -1;
          return 12463; /* *aarch64_pred_faminmax_fused */

        case 5:
          if (!
#line 2952 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX))
            return -1;
          return 12465; /* *aarch64_pred_faminmax_fused */

        case 6:
          if (!
#line 2952 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX))
            return -1;
          return 12467; /* *aarch64_pred_faminmax_fused */

        default:
          return -1;
        }

    case 578:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern226 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3270 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9399; /* aarch64_sve_bfdot_lanevnx4sf */

    case 579:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern226 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3271 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9400; /* aarch64_sve_bfmlalb_lanevnx4sf */

    case 580:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern226 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3272 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE_BF16))
        return -1;
      return 9401; /* aarch64_sve_bfmlalt_lanevnx4sf */

    case 581:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern226 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3273 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 9402; /* aarch64_sve_bfmlslb_lanevnx4sf */

    case 582:
      if (GET_MODE (x2) != E_VNx4SFmode
          || pattern226 (x1, 
E_VNx4SFmode, 
E_VNx8BFmode) != 0
          || !
#line 3274 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 9403; /* aarch64_sve_bfmlslt_lanevnx4sf */

    case 356:
      switch (pattern211 (x1))
        {
        case 0:
          if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10174; /* aarch64_pred_fcmeqvnx8hf */

        case 1:
          if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10180; /* aarch64_pred_fcmeqvnx4sf */

        case 2:
          if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10186; /* aarch64_pred_fcmeqvnx2df */

        default:
          return -1;
        }

    case 357:
      return recog_416 (x1, insn, pnum_clobbers);

    case 358:
      return recog_415 (x1, insn, pnum_clobbers);

    case 363:
      return recog_414 (x1, insn, pnum_clobbers);

    case 364:
      return recog_413 (x1, insn, pnum_clobbers);

    case 365:
      switch (pattern211 (x1))
        {
        case 0:
          if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10179; /* aarch64_pred_fcmnevnx8hf */

        case 1:
          if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10185; /* aarch64_pred_fcmnevnx4sf */

        case 2:
          if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10191; /* aarch64_pred_fcmnevnx2df */

        default:
          return -1;
        }

    case 366:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[4] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern938 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !
#line 8528 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10192; /* aarch64_pred_fcmuovnx8hf */

        case E_VNx4BImode:
          if (pattern938 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !
#line 8528 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10193; /* aarch64_pred_fcmuovnx4sf */

        case E_VNx2BImode:
          if (pattern938 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !
#line 8528 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10194; /* aarch64_pred_fcmuovnx2df */

        default:
          return -1;
        }

    case 438:
      x5 = XVECEXP (x2, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      x6 = XVECEXP (x2, 0, 2);
      operands[1] = x6;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          if (pattern869 (x2, 
E_VNx4SFmode, 
E_VNx8BFmode, 
E_VNx4BImode) != 0
              || !
#line 9901 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_BF16))
            return -1;
          return 10891; /* aarch64_sve_cvtntvnx8bf */

        case E_VNx8HFmode:
          if (pattern869 (x2, 
E_VNx4SFmode, 
E_VNx8HFmode, 
E_VNx4BImode) != 0
              || !
#line 3232 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12562; /* aarch64_sve_cvtntvnx8hf */

        case E_VNx4SFmode:
          if (pattern869 (x2, 
E_VNx2DFmode, 
E_VNx4SFmode, 
E_VNx2BImode) != 0
              || !
#line 3232 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12563; /* aarch64_sve_cvtntvnx4sf */

        default:
          return -1;
        }

    case 120:
      if (GET_MODE (x2) != E_VNx2DImode)
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != SCRATCH)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx2DImode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx2BImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!aarch64_reg_or_zero (operands[2], E_DImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_VNx2DImode)
          || !
#line 347 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11173; /* aarch64_gather_ld1q */

    case 122:
      return recog_412 (x1, insn, pnum_clobbers);

    case 540:
      return recog_409 (x1, insn, pnum_clobbers);

    case 541:
      return recog_408 (x1, insn, pnum_clobbers);

    case 621:
      if (pattern215 (x1) != 0)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_VNx2BImode))
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      operands[1] = x5;
      if (!aarch64_reg_or_zero (operands[1], E_DImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[2] = x6;
      if (!register_operand (operands[2], E_VNx2DImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      if (!register_operand (operands[3], E_VNx2DImode)
          || !
#line 529 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11326; /* aarch64_scatter_st1q */

    case 124:
      return recog_401 (x1, insn, pnum_clobbers);

    case 480:
      return recog_404 (x1, insn, pnum_clobbers);

    case 442:
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 84
          || GET_MODE (x7) != E_DImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_VNx16QImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      if (!register_operand (operands[3], E_VNx16QImode))
        return -1;
      switch (pattern1054 (x2))
        {
        case 0:
          if (!
#line 2161 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8DOT4 && !(VNx8HFmode == VNx8HFmode && !TARGET_SSVE_FP8DOT2)))
            return -1;
          return 12005; /* aarch64_sve_dotvnx8hf */

        case 1:
          if (!
#line 2161 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_FP8DOT4 && !(VNx4SFmode == VNx8HFmode && !TARGET_SSVE_FP8DOT2)))
            return -1;
          return 12006; /* aarch64_sve_dotvnx4sf */

        default:
          return -1;
        }

    case 440:
      if (GET_MODE (x2) != E_VNx4SFmode)
        return -1;
      x5 = XVECEXP (x2, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_VNx4SFmode))
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      x6 = XVECEXP (x2, 0, 2);
      operands[1] = x6;
      if (!register_operand (operands[1], E_VNx4SFmode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[3] = x7;
      if (!register_operand (operands[3], E_VNx2DFmode)
          || !
#line 3322 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12567; /* aarch64_sve2_cvtxntvnx2df */

    case 136:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12626; /* aarch64_sve_whilege_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12634; /* aarch64_sve_whilege_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12642; /* aarch64_sve_whilege_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12650; /* aarch64_sve_whilege_b64_x2 */

        default:
          return -1;
        }

    case 137:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12627; /* aarch64_sve_whilegt_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12635; /* aarch64_sve_whilegt_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12643; /* aarch64_sve_whilegt_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12651; /* aarch64_sve_whilegt_b64_x2 */

        default:
          return -1;
        }

    case 138:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12628; /* aarch64_sve_whileugt_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12636; /* aarch64_sve_whileugt_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12644; /* aarch64_sve_whileugt_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12652; /* aarch64_sve_whileugt_b64_x2 */

        default:
          return -1;
        }

    case 139:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12629; /* aarch64_sve_whileuge_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12637; /* aarch64_sve_whileuge_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12645; /* aarch64_sve_whileuge_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12653; /* aarch64_sve_whileuge_b64_x2 */

        default:
          return -1;
        }

    case 140:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12630; /* aarch64_sve_whilele_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12638; /* aarch64_sve_whilele_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12646; /* aarch64_sve_whilele_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12654; /* aarch64_sve_whilele_b64_x2 */

        default:
          return -1;
        }

    case 141:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12631; /* aarch64_sve_whileult_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12639; /* aarch64_sve_whileult_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12647; /* aarch64_sve_whileult_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12655; /* aarch64_sve_whileult_b64_x2 */

        default:
          return -1;
        }

    case 142:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12632; /* aarch64_sve_whileule_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12640; /* aarch64_sve_whileule_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12648; /* aarch64_sve_whileule_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12656; /* aarch64_sve_whileule_b64_x2 */

        default:
          return -1;
        }

    case 143:
      switch (pattern216 (x1, pnum_clobbers))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12633; /* aarch64_sve_whilelt_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12641; /* aarch64_sve_whilelt_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12649; /* aarch64_sve_whilelt_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          *pnum_clobbers = 1;
          return 12657; /* aarch64_sve_whilelt_b64_x2 */

        default:
          return -1;
        }

    case 693:
      return recog_417 (x1, insn, pnum_clobbers);

    case 697:
      return recog_403 (x1, insn, pnum_clobbers);

    case 699:
      return recog_402 (x1, insn, pnum_clobbers);

    case 648:
      return recog_400 (x1, insn, pnum_clobbers);

    case 649:
      return recog_399 (x1, insn, pnum_clobbers);

    case 677:
      return recog_405 (x1, insn, pnum_clobbers);

    case 701:
      return recog_397 (x1, insn, pnum_clobbers);

    case 631:
      return recog_424 (x1, insn, pnum_clobbers);

    case 661:
      return recog_423 (x1, insn, pnum_clobbers);

    case 637:
      return recog_407 (x1, insn, pnum_clobbers);

    case 644:
      return recog_406 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_461 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              switch (pattern609 (x2, 
E_SImode))
                {
                case 0:
                  return 215; /* *add_zero_extendqi_si */

                case 1:
                  return 219; /* *add_zero_extendhi_si */

                case 2:
                  return 223; /* *add_zero_extendsi_si */

                default:
                  return -1;
                }

            case E_DImode:
              switch (pattern609 (x2, 
E_DImode))
                {
                case 0:
                  return 217; /* *add_zero_extendqi_di */

                case 1:
                  return 221; /* *add_zero_extendhi_di */

                case 2:
                  return 225; /* *add_zero_extendsi_di */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern610 (x2, 
E_V8HImode, 
E_V8QImode) != 0
                  || !
#line 4703 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3050; /* aarch64_uaddwv8qi */

            case E_V4SImode:
              if (pattern610 (x2, 
E_V4SImode, 
E_V4HImode) != 0
                  || !
#line 4703 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3052; /* aarch64_uaddwv4hi */

            case E_V2DImode:
              if (pattern610 (x2, 
E_V2DImode, 
E_V2SImode) != 0
                  || !
#line 4703 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3054; /* aarch64_uaddwv2si */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern291 (x2))
            {
            case 0:
              if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3021; /* aarch64_uaddlv8qi */

            case 1:
              if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3025; /* aarch64_uaddlv4hi */

            case 2:
              if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3029; /* aarch64_uaddlv2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x2, 1);
      operands[1] = x5;
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case SMAX:
          switch (pattern616 (x2, 
SMIN))
            {
            case 0:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1674; /* aarch64_sabalv8qi */

            case 1:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1676; /* aarch64_sabalv4hi */

            case 2:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1678; /* aarch64_sabalv2si */

            case 3:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1680; /* aarch64_sabal2v16qi_insn */

            case 4:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1682; /* aarch64_sabal2v8hi_insn */

            case 5:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1684; /* aarch64_sabal2v4si_insn */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern616 (x2, 
UMIN))
            {
            case 0:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1675; /* aarch64_uabalv8qi */

            case 1:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1677; /* aarch64_uabalv4hi */

            case 2:
              if (!
#line 964 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1679; /* aarch64_uabalv2si */

            case 3:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1681; /* aarch64_uabal2v16qi_insn */

            case 4:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1683; /* aarch64_uabal2v8hi_insn */

            case 5:
              if (!
#line 989 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1685; /* aarch64_uabal2v4si_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case ZERO_EXTEND:
          switch (pattern611 (x2))
            {
            case 0:
              if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 2997; /* aarch64_uaddlv16qi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3009; /* aarch64_uaddlv16qi_lo_internal */

            case 1:
              if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3001; /* aarch64_uaddlv8hi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3013; /* aarch64_uaddlv8hi_lo_internal */

            case 2:
              if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3005; /* aarch64_uaddlv4si_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3017; /* aarch64_uaddlv4si_lo_internal */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern613 (x2))
            {
            case 0:
              if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  && 
#line 4716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3056; /* aarch64_uaddwv16qi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  || !
#line 4729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3062; /* aarch64_uaddw2v16qi_internal */

            case 1:
              if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  && 
#line 4716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3058; /* aarch64_uaddwv8hi_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  || !
#line 4729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3064; /* aarch64_uaddw2v8hi_internal */

            case 2:
              if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  && 
#line 4716 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 3060; /* aarch64_uaddwv4si_internal */
              if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  || !
#line 4729 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3066; /* aarch64_uaddw2v4si_internal */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern379 (x2, 
E_DImode) != 0)
        return -1;
      switch (pattern325 (x2))
        {
        case 0:
          if (!
#line 10381 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10949; /* aarch64_sve_incdi_pat */

        case 1:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10983; /* *aarch64_sve_incdivnx16bi_cntp */

        case 2:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10986; /* *aarch64_sve_incdivnx8bi_cntp */

        case 3:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10989; /* *aarch64_sve_incdivnx4bi_cntp */

        case 4:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10992; /* *aarch64_sve_incdivnx2bi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_470 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 2:
      switch (pattern400 (x3))
        {
        case 0:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8163; /* *bicvnx16qi3 */

        case 1:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8164; /* *bicvnx8qi3 */

        case 2:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8165; /* *bicvnx4qi3 */

        case 3:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8166; /* *bicvnx2qi3 */

        case 4:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8167; /* *bicvnx8hi3 */

        case 5:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8168; /* *bicvnx4hi3 */

        case 6:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8169; /* *bicvnx2hi3 */

        case 7:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8170; /* *bicvnx4si3 */

        case 8:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8171; /* *bicvnx2si3 */

        case 9:
          if (!
#line 4757 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8172; /* *bicvnx2di3 */

        default:
          return -1;
        }

    case 3:
      if (pnum_clobbers == NULL
          || XINT (x4, 1) != 126)
        return -1;
      x5 = XVECEXP (x4, 0, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XVECEXP (x4, 0, 0);
      operands[4] = x6;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      x8 = XVECEXP (x4, 0, 2);
      switch (GET_CODE (x8))
        {
        case LT:
          switch (pattern948 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9744; /* *cmpltvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9754; /* *cmpltvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9784; /* *cmpltvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9764; /* *cmpltvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9794; /* *cmpltvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9814; /* *cmpltvnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9774; /* *cmpltvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9804; /* *cmpltvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9824; /* *cmpltvnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9834; /* *cmpltvnx2di_and */

            default:
              return -1;
            }

        case LE:
          switch (pattern948 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9745; /* *cmplevnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9755; /* *cmplevnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9785; /* *cmplevnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9765; /* *cmplevnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9795; /* *cmplevnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9815; /* *cmplevnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9775; /* *cmplevnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9805; /* *cmplevnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9825; /* *cmplevnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9835; /* *cmplevnx2di_and */

            default:
              return -1;
            }

        case EQ:
          switch (pattern948 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9746; /* *cmpeqvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9756; /* *cmpeqvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9786; /* *cmpeqvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9766; /* *cmpeqvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9796; /* *cmpeqvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9816; /* *cmpeqvnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9776; /* *cmpeqvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9806; /* *cmpeqvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9826; /* *cmpeqvnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9836; /* *cmpeqvnx2di_and */

            default:
              return -1;
            }

        case NE:
          switch (pattern948 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9747; /* *cmpnevnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9757; /* *cmpnevnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9787; /* *cmpnevnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9767; /* *cmpnevnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9797; /* *cmpnevnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9817; /* *cmpnevnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9777; /* *cmpnevnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9807; /* *cmpnevnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9827; /* *cmpnevnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9837; /* *cmpnevnx2di_and */

            default:
              return -1;
            }

        case GE:
          switch (pattern948 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9748; /* *cmpgevnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9758; /* *cmpgevnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9788; /* *cmpgevnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9768; /* *cmpgevnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9798; /* *cmpgevnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9818; /* *cmpgevnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9778; /* *cmpgevnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9808; /* *cmpgevnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9828; /* *cmpgevnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9838; /* *cmpgevnx2di_and */

            default:
              return -1;
            }

        case GT:
          switch (pattern948 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9749; /* *cmpgtvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9759; /* *cmpgtvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9789; /* *cmpgtvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9769; /* *cmpgtvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9799; /* *cmpgtvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9819; /* *cmpgtvnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9779; /* *cmpgtvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9809; /* *cmpgtvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9829; /* *cmpgtvnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9839; /* *cmpgtvnx2di_and */

            default:
              return -1;
            }

        case LTU:
          switch (pattern949 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9750; /* *cmplovnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9760; /* *cmplovnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9790; /* *cmplovnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9770; /* *cmplovnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9800; /* *cmplovnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9820; /* *cmplovnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9780; /* *cmplovnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9810; /* *cmplovnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9830; /* *cmplovnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9840; /* *cmplovnx2di_and */

            default:
              return -1;
            }

        case LEU:
          switch (pattern949 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9751; /* *cmplsvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9761; /* *cmplsvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9791; /* *cmplsvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9771; /* *cmplsvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9801; /* *cmplsvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9821; /* *cmplsvnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9781; /* *cmplsvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9811; /* *cmplsvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9831; /* *cmplsvnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9841; /* *cmplsvnx2di_and */

            default:
              return -1;
            }

        case GEU:
          switch (pattern949 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9752; /* *cmphsvnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9762; /* *cmphsvnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9792; /* *cmphsvnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9772; /* *cmphsvnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9802; /* *cmphsvnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9822; /* *cmphsvnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9782; /* *cmphsvnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9812; /* *cmphsvnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9832; /* *cmphsvnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9842; /* *cmphsvnx2di_and */

            default:
              return -1;
            }

        case GTU:
          switch (pattern949 (x3))
            {
            case 0:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9753; /* *cmphivnx16qi_and */

            case 1:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9763; /* *cmphivnx8qi_and */

            case 2:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9793; /* *cmphivnx8hi_and */

            case 3:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9773; /* *cmphivnx4qi_and */

            case 4:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9803; /* *cmphivnx4hi_and */

            case 5:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9823; /* *cmphivnx4si_and */

            case 6:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9783; /* *cmphivnx2qi_and */

            case 7:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9813; /* *cmphivnx2hi_and */

            case 8:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9833; /* *cmphivnx2si_and */

            case 9:
              if (!
#line 8286 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              *pnum_clobbers = 1;
              return 9843; /* *cmphivnx2di_and */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 4:
      switch (pattern403 (x3))
        {
        case 0:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10195; /* *fcmeqvnx8hf_and_combine */

        case 1:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10201; /* *fcmeqvnx4sf_and_combine */

        case 2:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10207; /* *fcmeqvnx2df_and_combine */

        case 3:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10196; /* *fcmgevnx8hf_and_combine */

        case 4:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10202; /* *fcmgevnx4sf_and_combine */

        case 5:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10208; /* *fcmgevnx2df_and_combine */

        case 6:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10197; /* *fcmgtvnx8hf_and_combine */

        case 7:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10203; /* *fcmgtvnx4sf_and_combine */

        case 8:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10209; /* *fcmgtvnx2df_and_combine */

        case 9:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10198; /* *fcmlevnx8hf_and_combine */

        case 10:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10204; /* *fcmlevnx4sf_and_combine */

        case 11:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10210; /* *fcmlevnx2df_and_combine */

        case 12:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10199; /* *fcmltvnx8hf_and_combine */

        case 13:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10205; /* *fcmltvnx4sf_and_combine */

        case 14:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10211; /* *fcmltvnx2df_and_combine */

        case 15:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10200; /* *fcmnevnx8hf_and_combine */

        case 16:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10206; /* *fcmnevnx4sf_and_combine */

        case 17:
          if (!
#line 8550 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10212; /* *fcmnevnx2df_and_combine */

        case 18:
          if (!
#line 8573 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10213; /* *fcmuovnx8hf_and_combine */

        case 19:
          if (!
#line 8573 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10214; /* *fcmuovnx4sf_and_combine */

        case 20:
          if (!
#line 8573 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10215; /* *fcmuovnx2df_and_combine */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_486 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern520 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1586; /* negv8qi2_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1590; /* negv4hi2_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1594; /* negv2si2_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 2682 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 2383; /* negv4hf2_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 2682 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2387; /* negv2sf2_vec_concatz_be */

        default:
          return -1;
        }

    case LT:
      switch (pattern523 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4063; /* aarch64_cmltv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4083; /* aarch64_cmltv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4228; /* aarch64_cmltv4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4103; /* aarch64_cmltv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4248; /* aarch64_cmltv2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4283; /* aarch64_cmltdf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4298; /* aarch64_facltv4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4314; /* aarch64_facltv2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4342; /* aarch64_facltdf_vec_concatz_be */

        default:
          return -1;
        }

    case LE:
      switch (pattern523 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4066; /* aarch64_cmlev8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4086; /* aarch64_cmlev4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4231; /* aarch64_cmlev4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4106; /* aarch64_cmlev2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4251; /* aarch64_cmlev2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4286; /* aarch64_cmledf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4301; /* aarch64_faclev4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4317; /* aarch64_faclev2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4345; /* aarch64_facledf_vec_concatz_be */

        default:
          return -1;
        }

    case EQ:
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      switch (pattern521 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4069; /* aarch64_cmeqv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4089; /* aarch64_cmeqv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4234; /* aarch64_cmeqv4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4109; /* aarch64_cmeqv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4254; /* aarch64_cmeqv2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4289; /* aarch64_cmeqdf_vec_concatz_be */

        default:
          return -1;
        }

    case GE:
      switch (pattern523 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4072; /* aarch64_cmgev8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4092; /* aarch64_cmgev4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4237; /* aarch64_cmgev4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4112; /* aarch64_cmgev2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4257; /* aarch64_cmgev2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4292; /* aarch64_cmgedf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4304; /* aarch64_facgev4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4320; /* aarch64_facgev2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4348; /* aarch64_facgedf_vec_concatz_be */

        default:
          return -1;
        }

    case GT:
      switch (pattern523 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4075; /* aarch64_cmgtv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4095; /* aarch64_cmgtv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4240; /* aarch64_cmgtv4hf_vec_concatz_be */

        case 3:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7196 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4115; /* aarch64_cmgtv2si_vec_concatz_be */

        case 4:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4260; /* aarch64_cmgtv2sf_vec_concatz_be */

        case 5:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7413 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4295; /* aarch64_cmgtdf_vec_concatz_be */

        case 6:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && (
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
            return -1;
          return 4307; /* aarch64_facgtv4hf_vec_concatz_be */

        case 7:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4323; /* aarch64_facgtv2sf_vec_concatz_be */

        case 8:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7434 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4351; /* aarch64_facgtdf_vec_concatz_be */

        default:
          return -1;
        }

    case LTU:
      switch (pattern525 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4138; /* aarch64_cmltuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4154; /* aarch64_cmltuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4170; /* aarch64_cmltuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case LEU:
      switch (pattern525 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4141; /* aarch64_cmleuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4157; /* aarch64_cmleuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4173; /* aarch64_cmleuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case GEU:
      switch (pattern525 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4144; /* aarch64_cmgeuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4160; /* aarch64_cmgeuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4176; /* aarch64_cmgeuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case GTU:
      switch (pattern525 (x2))
        {
        case 0:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4147; /* aarch64_cmgtuv8qi_vec_concatz_be */

        case 1:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4163; /* aarch64_cmgtuv4hi_vec_concatz_be */

        case 2:
          if (!(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7261 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 4179; /* aarch64_cmgtuv2si_vec_concatz_be */

        default:
          return -1;
        }

    case NE:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != AND
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      if (!aarch64_simd_or_scalar_imm_zero (operands[3], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode)
          || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 7399 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
        return -1;
      return 4225; /* *aarch64_cmtstdi_vec_concatz_be */

    default:
      return -1;
    }
}

 int
recog_495 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (pattern544 (x2))
            {
            case 0:
              if (!
#line 1839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2192; /* aarch64_xtn2v8hi_insn_be */

            case 1:
              if (!
#line 1839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2193; /* aarch64_xtn2v4si_insn_be */

            case 2:
              if (!
#line 1839 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2194; /* aarch64_xtn2v2di_insn_be */

            default:
              return -1;
            }

        case TRUNCATE:
          operands[1] = x4;
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern830 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                  || !
#line 1867 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2195; /* *aarch64_narrow_truncv8hi */

            case E_V8HImode:
              if (pattern830 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                  || !
#line 1867 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2196; /* *aarch64_narrow_truncv4si */

            case E_V4SImode:
              if (pattern830 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                  || !
#line 1867 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2197; /* *aarch64_narrow_truncv2di */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
          switch (pattern546 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 9874 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5234; /* truncv8hiv8qi2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 9874 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5237; /* truncv4siv4hi2_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 9874 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5240; /* truncv2div2si2_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern548 (x2, 
ASHIFTRT))
            {
            case 0:
              x5 = XEXP (x2, 1);
              x6 = XEXP (x5, 0);
              x8 = XEXP (x6, 0);
              operands[3] = x8;
              operands[1] = x7;
              if (
#line 1941 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return 2201; /* *aarch64_rtopbits_shufflev8hi_le */
              operands[1] = x8;
              operands[3] = x7;
              if (!
#line 1955 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2207; /* *aarch64_rtopbits_shufflev8hi_be */

            case 1:
              x5 = XEXP (x2, 1);
              x6 = XEXP (x5, 0);
              x8 = XEXP (x6, 0);
              operands[3] = x8;
              operands[1] = x7;
              if (
#line 1941 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return 2203; /* *aarch64_rtopbits_shufflev4si_le */
              operands[1] = x8;
              operands[3] = x7;
              if (!
#line 1955 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2209; /* *aarch64_rtopbits_shufflev4si_be */

            case 2:
              x5 = XEXP (x2, 1);
              x6 = XEXP (x5, 0);
              x8 = XEXP (x6, 0);
              operands[3] = x8;
              operands[1] = x7;
              if (
#line 1941 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return 2205; /* *aarch64_rtopbits_shufflev2di_le */
              operands[1] = x8;
              operands[3] = x7;
              if (!
#line 1955 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2211; /* *aarch64_rtopbits_shufflev2di_be */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT))))
                return -1;
              return 3897; /* *aarch64_sshrn_nv8hi_insn_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT))))
                return -1;
              return 3915; /* *aarch64_sshrn_nv4si_insn_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT))))
                return -1;
              return 3933; /* *aarch64_sshrn_nv2di_insn_vec_concatz_le */

            case 6:
              if (!
#line 6956 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
                return -1;
              return 4017; /* aarch64_sshrn2_nv8hi_insn_be */

            case 7:
              if (!
#line 6956 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
                return -1;
              return 4023; /* aarch64_sshrn2_nv4si_insn_be */

            case 8:
              if (!
#line 6956 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, ASHIFTRT)))
                return -1;
              return 4029; /* aarch64_sshrn2_nv2di_insn_be */

            default:
              return -1;
            }

        case PLUS:
          x9 = XEXP (x7, 0);
          switch (GET_CODE (x9))
            {
            case SIGN_EXTEND:
              x10 = XEXP (x9, 0);
              operands[1] = x10;
              x5 = XEXP (x2, 1);
              operands[4] = x5;
              x11 = XEXP (x7, 1);
              switch (GET_CODE (x11))
                {
                case SIGN_EXTEND:
                  x12 = XEXP (x11, 0);
                  operands[2] = x12;
                  x13 = XEXP (x4, 1);
                  operands[3] = x13;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16QImode:
                      if (pattern670 (x2, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3068; /* *aarch64_shaddv8qi_vec_concatz_le_insn */

                    case E_V8HImode:
                      if (pattern670 (x2, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3084; /* *aarch64_shaddv4hi_vec_concatz_le_insn */

                    case E_V4SImode:
                      if (pattern670 (x2, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3100; /* *aarch64_shaddv2si_vec_concatz_le_insn */

                    default:
                      return -1;
                    }

                case CONST_INT:
                case CONST_WIDE_INT:
                case CONST_VECTOR:
                  operands[3] = x11;
                  x13 = XEXP (x4, 1);
                  operands[2] = x13;
                  switch (GET_CODE (operands[2]))
                    {
                    case CONST_VECTOR:
                      switch (GET_MODE (operands[0]))
                        {
                        case E_V16QImode:
                          if (pattern426 (x2, 
E_V8QImode, 
E_V8HImode) != 0
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                            return -1;
                          return 3780; /* aarch64_srshr_nv8qi_vec_concatz_le_insn */

                        case E_V8HImode:
                          if (pattern427 (x2, 
E_V4HImode, 
E_V4SImode) != 0
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                            return -1;
                          return 3788; /* aarch64_srshr_nv4hi_vec_concatz_le_insn */

                        case E_V4SImode:
                          if (pattern428 (x2, 
E_V2SImode, 
E_V2DImode) != 0
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                            return -1;
                          return 3796; /* aarch64_srshr_nv2si_vec_concatz_le_insn */

                        default:
                          return -1;
                        }

                    case CONST_INT:
                      if (!aarch64_simd_shift_imm_offset_di (operands[2], E_DImode)
                          || !register_operand (operands[0], E_V2DImode)
                          || GET_MODE (x2) != E_V2DImode
                          || GET_MODE (x3) != E_DImode
                          || pattern1064 (x4, 
E_TImode, 
E_DImode) != 0
                          || !aarch64_simd_or_scalar_imm_zero (operands[4], E_DImode)
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                        return -1;
                      return 3806; /* aarch64_srshr_ndi_vec_concatz_le_insn */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern671 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3074; /* *aarch64_uhaddv8qi_vec_concatz_le_insn */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3090; /* *aarch64_uhaddv4hi_vec_concatz_le_insn */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3106; /* *aarch64_uhaddv2si_vec_concatz_le_insn */

                default:
                  return -1;
                }

            case PLUS:
              x10 = XEXP (x9, 0);
              switch (GET_CODE (x10))
                {
                case SIGN_EXTEND:
                  switch (pattern768 (x2, 
SIGN_EXTEND))
                    {
                    case 0:
                      if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3116; /* *aarch64_srhaddv8qi_vec_concatz_le_insn */

                    case 1:
                      if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3124; /* *aarch64_srhaddv4hi_vec_concatz_le_insn */

                    case 2:
                      if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3132; /* *aarch64_srhaddv2si_vec_concatz_le_insn */

                    default:
                      return -1;
                    }

                case ZERO_EXTEND:
                  switch (pattern768 (x2, 
ZERO_EXTEND))
                    {
                    case 0:
                      if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3119; /* *aarch64_urhaddv8qi_vec_concatz_le_insn */

                    case 1:
                      if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3127; /* *aarch64_urhaddv4hi_vec_concatz_le_insn */

                    case 2:
                      if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4836 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3135; /* *aarch64_urhaddv2si_vec_concatz_le_insn */

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  switch (pattern677 (x2))
                    {
                    case 0:
                      if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3158; /* aarch64_raddhnv8hi_insn_vec_concatz_le */

                    case 1:
                      if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3164; /* aarch64_raddhnv4si_insn_vec_concatz_le */

                    case 2:
                      if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 3170; /* aarch64_raddhnv2di_insn_vec_concatz_le */

                    case 3:
                      if (!
#line 4957 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                        return -1;
                      return 3193; /* aarch64_raddhn2v8hi_insn_be */

                    case 4:
                      if (!
#line 4957 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                        return -1;
                      return 3195; /* aarch64_raddhn2v4si_insn_be */

                    case 5:
                      if (!
#line 4957 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                        return -1;
                      return 3197; /* aarch64_raddhn2v2di_insn_be */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern674 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3140; /* aarch64_addhnv8hi_insn_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3146; /* aarch64_addhnv4si_insn_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3152; /* aarch64_addhnv2di_insn_vec_concatz_le */

                case 3:
                  if (!
#line 4941 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3187; /* aarch64_addhn2v8hi_insn_be */

                case 4:
                  if (!
#line 4941 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3189; /* aarch64_addhn2v4si_insn_be */

                case 5:
                  if (!
#line 4941 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3191; /* aarch64_addhn2v2di_insn_be */

                default:
                  return -1;
                }

            case MINUS:
              switch (pattern677 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3161; /* aarch64_rsubhnv8hi_insn_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3167; /* aarch64_rsubhnv4si_insn_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4864 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3173; /* aarch64_rsubhnv2di_insn_vec_concatz_le */

                case 3:
                  if (!
#line 4957 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3194; /* aarch64_rsubhn2v8hi_insn_be */

                case 4:
                  if (!
#line 4957 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3196; /* aarch64_rsubhn2v4si_insn_be */

                case 5:
                  if (!
#line 4957 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3198; /* aarch64_rsubhn2v2di_insn_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case MINUS:
          x9 = XEXP (x7, 0);
          switch (GET_CODE (x9))
            {
            case SIGN_EXTEND:
              switch (pattern671 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3071; /* *aarch64_shsubv8qi_vec_concatz_le_insn */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3087; /* *aarch64_shsubv4hi_vec_concatz_le_insn */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3103; /* *aarch64_shsubv2si_vec_concatz_le_insn */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern671 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3077; /* *aarch64_uhsubv8qi_vec_concatz_le_insn */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3093; /* *aarch64_uhsubv4hi_vec_concatz_le_insn */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4819 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3109; /* *aarch64_uhsubv2si_vec_concatz_le_insn */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              switch (pattern674 (x2))
                {
                case 0:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3143; /* aarch64_subhnv8hi_insn_vec_concatz_le */

                case 1:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3149; /* aarch64_subhnv4si_insn_vec_concatz_le */

                case 2:
                  if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 4850 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3155; /* aarch64_subhnv2di_insn_vec_concatz_le */

                case 3:
                  if (!
#line 4941 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3188; /* aarch64_subhn2v8hi_insn_be */

                case 4:
                  if (!
#line 4941 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3190; /* aarch64_subhn2v4si_insn_be */

                case 5:
                  if (!
#line 4941 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 3192; /* aarch64_subhn2v2di_insn_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case LSHIFTRT:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern548 (x2, 
LSHIFTRT))
            {
            case 0:
              x5 = XEXP (x2, 1);
              x6 = XEXP (x5, 0);
              x8 = XEXP (x6, 0);
              operands[3] = x8;
              operands[1] = x7;
              if (
#line 1941 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return 2202; /* *aarch64_topbits_shufflev8hi_le */
              operands[1] = x8;
              operands[3] = x7;
              if (!
#line 1955 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2208; /* *aarch64_topbits_shufflev8hi_be */

            case 1:
              x5 = XEXP (x2, 1);
              x6 = XEXP (x5, 0);
              x8 = XEXP (x6, 0);
              operands[3] = x8;
              operands[1] = x7;
              if (
#line 1941 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return 2204; /* *aarch64_topbits_shufflev4si_le */
              operands[1] = x8;
              operands[3] = x7;
              if (!
#line 1955 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2210; /* *aarch64_topbits_shufflev4si_be */

            case 2:
              x5 = XEXP (x2, 1);
              x6 = XEXP (x5, 0);
              x8 = XEXP (x6, 0);
              operands[3] = x8;
              operands[1] = x7;
              if (
#line 1941 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !BYTES_BIG_ENDIAN))
                return 2206; /* *aarch64_topbits_shufflev2di_le */
              operands[1] = x8;
              operands[3] = x7;
              if (!
#line 1955 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 2212; /* *aarch64_topbits_shufflev2di_be */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT))))
                return -1;
              return 3900; /* *aarch64_shrn_nv8hi_insn_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT))))
                return -1;
              return 3918; /* *aarch64_shrn_nv4si_insn_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6693 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT))))
                return -1;
              return 3936; /* *aarch64_shrn_nv2di_insn_vec_concatz_le */

            case 6:
              if (!
#line 6956 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 4018; /* aarch64_ushrn2_nv8hi_insn_be */

            case 7:
              if (!
#line 6956 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 4024; /* aarch64_ushrn2_nv4si_insn_be */

            case 8:
              if (!
#line 6956 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && AARCH64_VALID_SHRN_OP (TRUNCATE, LSHIFTRT)))
                return -1;
              return 4030; /* aarch64_ushrn2_nv2di_insn_be */

            default:
              return -1;
            }

        case PLUS:
          x9 = XEXP (x7, 0);
          if (GET_CODE (x9) != ZERO_EXTEND)
            return -1;
          x13 = XEXP (x4, 1);
          switch (GET_CODE (x13))
            {
            case CONST_VECTOR:
              x5 = XEXP (x2, 1);
              switch (GET_CODE (x5))
                {
                case CONST_INT:
                case CONST_DOUBLE:
                case CONST_VECTOR:
                case CONST:
                  operands[4] = x5;
                  x10 = XEXP (x9, 0);
                  operands[1] = x10;
                  x11 = XEXP (x7, 1);
                  operands[3] = x11;
                  operands[2] = x13;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V16QImode:
                      if (pattern1134 (x2, 
E_V8QImode, 
E_V16QImode) != 0)
                        return -1;
                      switch (GET_MODE (x4))
                        {
                        case E_V8HImode:
                          if (pattern1273 (x7, 
E_V8QImode, 
E_V8HImode) != 0
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                            return -1;
                          return 3783; /* aarch64_urshr_nv8qi_vec_concatz_le_insn */

                        case E_V8SImode:
                          if (pattern1273 (x7, 
E_V8HImode, 
E_V8SImode) != 0
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6720 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                            return -1;
                          return 3945; /* *aarch64_rshrn_nv8hi_insn_vec_concatz_le */

                        default:
                          return -1;
                        }

                    case E_V8HImode:
                      if (pattern1134 (x2, 
E_V4HImode, 
E_V8HImode) != 0)
                        return -1;
                      switch (GET_MODE (x4))
                        {
                        case E_V4SImode:
                          if (pattern1274 (x7, 
E_V4HImode, 
E_V4SImode) != 0
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                            return -1;
                          return 3791; /* aarch64_urshr_nv4hi_vec_concatz_le_insn */

                        case E_V4DImode:
                          if (pattern1274 (x7, 
E_V4SImode, 
E_V4DImode) != 0
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6720 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                            return -1;
                          return 3954; /* *aarch64_rshrn_nv4si_insn_vec_concatz_le */

                        default:
                          return -1;
                        }

                    case E_V4SImode:
                      if (pattern1134 (x2, 
E_V2SImode, 
E_V4SImode) != 0)
                        return -1;
                      switch (GET_MODE (x4))
                        {
                        case E_V2DImode:
                          if (pattern1275 (x7, 
E_V2SImode, 
E_V2DImode) != 0
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                            return -1;
                          return 3799; /* aarch64_urshr_nv2si_vec_concatz_le_insn */

                        case E_V2TImode:
                          if (pattern1275 (x7, 
E_V2DImode, 
E_V2TImode) != 0
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6720 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                            return -1;
                          return 3963; /* *aarch64_rshrn_nv2di_insn_vec_concatz_le */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  switch (pattern432 (x2))
                    {
                    case 0:
                      if (!
#line 7011 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                        return -1;
                      return 4042; /* aarch64_rshrn2_nv8hi_insn_be */

                    case 1:
                      if (!
#line 7011 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                        return -1;
                      return 4045; /* aarch64_rshrn2_nv4si_insn_be */

                    case 2:
                      if (!
#line 7011 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                        return -1;
                      return 4048; /* aarch64_rshrn2_nv2di_insn_be */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case CONST_INT:
              operands[2] = x13;
              if (!aarch64_simd_shift_imm_offset_di (operands[2], E_DImode)
                  || !register_operand (operands[0], E_V2DImode)
                  || GET_MODE (x2) != E_V2DImode
                  || GET_MODE (x3) != E_DImode
                  || GET_MODE (x4) != E_TImode
                  || GET_MODE (x7) != E_TImode
                  || GET_MODE (x9) != E_TImode)
                return -1;
              x10 = XEXP (x9, 0);
              operands[1] = x10;
              if (!register_operand (operands[1], E_DImode))
                return -1;
              x11 = XEXP (x7, 1);
              operands[3] = x11;
              if (!aarch64_int_rnd_operand (operands[3], E_TImode))
                return -1;
              x5 = XEXP (x2, 1);
              operands[4] = x5;
              if (!aarch64_simd_or_scalar_imm_zero (operands[4], E_DImode)
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6600 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                return -1;
              return 3809; /* aarch64_urshr_ndi_vec_concatz_le_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMIN:
      return recog_492 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_510 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 2);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_HFmode:
              if (pattern516 (x3, 
E_HFmode) != 0
                  || !(
#line 6852 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
                return -1;
              return 970; /* *aarch64_fmahf4 */

            case E_SFmode:
              if (pattern516 (x3, 
E_SFmode) != 0
                  || !
#line 6852 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 971; /* *aarch64_fmasf4 */

            case E_DFmode:
              if (pattern516 (x3, 
E_DFmode) != 0
                  || !
#line 6852 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 972; /* *aarch64_fmadf4 */

            case E_V4HFmode:
              if (pattern517 (x3, 
E_V4HFmode) != 0
                  || !(
#line 2855 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2400; /* fmav4hf4 */

            case E_V8HFmode:
              if (pattern517 (x3, 
E_V8HFmode) != 0
                  || !(
#line 2855 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2403; /* fmav8hf4 */

            case E_V2SFmode:
              if (pattern517 (x3, 
E_V2SFmode) != 0
                  || !
#line 2855 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2404; /* fmav2sf4 */

            case E_V4SFmode:
              if (pattern517 (x3, 
E_V4SFmode) != 0
                  || !
#line 2855 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2407; /* fmav4sf4 */

            case E_V2DFmode:
              if (pattern517 (x3, 
E_V2DFmode) != 0
                  || !
#line 2855 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2408; /* fmav2df4 */

            default:
              return -1;
            }

        case NEG:
          operands[2] = x4;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern807 (x3, 
E_SFmode) != 0
                  || !
#line 6891 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 976; /* *aarch64_fmssf4 */

            case E_DFmode:
              if (pattern807 (x3, 
E_DFmode) != 0
                  || !
#line 6891 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                return -1;
              return 977; /* *aarch64_fmsdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          x5 = XEXP (x3, 2);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_HFmode:
                  if (pattern652 (x3, 
E_HFmode) != 0
                      || !(
#line 6872 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
                    return -1;
                  return 973; /* *aarch64_fnmahf4 */

                case E_SFmode:
                  if (pattern652 (x3, 
E_SFmode) != 0
                      || !
#line 6872 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                    return -1;
                  return 974; /* *aarch64_fnmasf4 */

                case E_DFmode:
                  if (pattern652 (x3, 
E_DFmode) != 0
                      || !
#line 6872 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                    return -1;
                  return 975; /* *aarch64_fnmadf4 */

                case E_V4HFmode:
                  if (pattern653 (x3, 
E_V4HFmode) != 0
                      || !(
#line 2928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                    return -1;
                  return 2436; /* fnmav4hf4 */

                case E_V8HFmode:
                  if (pattern653 (x3, 
E_V8HFmode) != 0
                      || !(
#line 2928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                    return -1;
                  return 2439; /* fnmav8hf4 */

                case E_V2SFmode:
                  if (pattern653 (x3, 
E_V2SFmode) != 0
                      || !
#line 2928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2440; /* fnmav2sf4 */

                case E_V4SFmode:
                  if (pattern653 (x3, 
E_V4SFmode) != 0
                      || !
#line 2928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2443; /* fnmav4sf4 */

                case E_V2DFmode:
                  if (pattern653 (x3, 
E_V2DFmode) != 0
                      || !
#line 2928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2444; /* fnmav2df4 */

                default:
                  return -1;
                }

            case NEG:
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              operands[3] = x6;
              x7 = XEXP (x5, 0);
              operands[1] = x7;
              switch (GET_MODE (operands[0]))
                {
                case E_SFmode:
                  if (pattern891 (x3, 
E_SFmode) != 0
                      || !
#line 6909 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                    return -1;
                  return 978; /* *aarch64_fnmssf4 */

                case E_DFmode:
                  if (pattern891 (x3, 
E_DFmode) != 0
                      || !
#line 6909 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
                    return -1;
                  return 979; /* *aarch64_fnmsdf4 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x9 = XEXP (x6, 0);
          switch (GET_CODE (x9))
            {
            case VEC_SELECT:
              x10 = XEXP (x9, 1);
              if (GET_CODE (x10) != PARALLEL
                  || XVECLEN (x10, 0) != 1)
                return -1;
              x8 = XEXP (x4, 0);
              operands[3] = x8;
              x11 = XEXP (x9, 0);
              operands[1] = x11;
              x12 = XVECEXP (x10, 0, 0);
              operands[2] = x12;
              if (!immediate_operand (operands[2], E_SImode))
                return -1;
              x5 = XEXP (x3, 2);
              operands[4] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V2SFmode:
                  if (pattern1130 (x3, 
E_V2SFmode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V2SFmode:
                      if (!register_operand (operands[1], E_V2SFmode)
                          || !
#line 2943 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2445; /* *aarch64_fnma4_eltv2sf */

                    case E_V4SFmode:
                      if (!register_operand (operands[1], E_V4SFmode)
                          || !
#line 2961 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2450; /* *aarch64_fnma4_elt_to_128v2sf */

                    default:
                      return -1;
                    }

                case E_V4SFmode:
                  if (pattern1130 (x3, 
E_V4SFmode) != 0)
                    return -1;
                  switch (GET_MODE (operands[1]))
                    {
                    case E_V4SFmode:
                      if (!register_operand (operands[1], E_V4SFmode)
                          || !
#line 2943 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2448; /* *aarch64_fnma4_eltv4sf */

                    case E_V2SFmode:
                      if (!register_operand (operands[1], E_V2SFmode)
                          || !
#line 2961 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2453; /* *aarch64_fnma4_elt_to_64v4sf */

                    default:
                      return -1;
                    }

                case E_V2DFmode:
                  if (!register_operand (operands[0], E_V2DFmode)
                      || GET_MODE (x3) != E_V2DFmode
                      || GET_MODE (x4) != E_V2DFmode
                      || !register_operand (operands[3], E_V2DFmode)
                      || GET_MODE (x6) != E_V2DFmode
                      || GET_MODE (x9) != E_DFmode
                      || !register_operand (operands[1], E_V2DFmode)
                      || !register_operand (operands[4], E_V2DFmode)
                      || !
#line 2943 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2449; /* *aarch64_fnma4_eltv2df */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x9;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              x5 = XEXP (x3, 2);
              operands[3] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V4HImode:
                  if (pattern892 (x3, 
E_V4HImode, 
E_HImode) != 0
                      || !
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2454; /* *aarch64_fnma4_elt_from_dupv4hi */

                case E_V8HImode:
                  if (pattern892 (x3, 
E_V8HImode, 
E_HImode) != 0
                      || !
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2457; /* *aarch64_fnma4_elt_from_dupv8hi */

                case E_V2SImode:
                  if (pattern892 (x3, 
E_V2SImode, 
E_SImode) != 0
                      || !
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2458; /* *aarch64_fnma4_elt_from_dupv2si */

                case E_V4SImode:
                  if (pattern892 (x3, 
E_V4SImode, 
E_SImode) != 0
                      || !
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2461; /* *aarch64_fnma4_elt_from_dupv4si */

                case E_V4HFmode:
                  if (pattern892 (x3, 
E_V4HFmode, 
E_HFmode) != 0
                      || !(
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                    return -1;
                  return 2462; /* *aarch64_fnma4_elt_from_dupv4hf */

                case E_V8HFmode:
                  if (pattern892 (x3, 
E_V8HFmode, 
E_HFmode) != 0
                      || !(
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                    return -1;
                  return 2465; /* *aarch64_fnma4_elt_from_dupv8hf */

                case E_V2SFmode:
                  if (pattern892 (x3, 
E_V2SFmode, 
E_SFmode) != 0
                      || !
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2466; /* *aarch64_fnma4_elt_from_dupv2sf */

                case E_V4SFmode:
                  if (pattern892 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                      || !
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2469; /* *aarch64_fnma4_elt_from_dupv4sf */

                case E_V2DFmode:
                  if (pattern892 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                      || !
#line 2977 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2470; /* *aarch64_fnma4_elt_from_dupv2df */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x8 = XEXP (x4, 0);
      switch (GET_CODE (x8))
        {
        case VEC_SELECT:
          x13 = XEXP (x8, 1);
          if (GET_CODE (x13) != PARALLEL
              || XVECLEN (x13, 0) != 1)
            return -1;
          x14 = XEXP (x8, 0);
          operands[1] = x14;
          x15 = XVECEXP (x13, 0, 0);
          operands[2] = x15;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          x5 = XEXP (x3, 2);
          operands[4] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SFmode:
              if (pattern1061 (x3, 
E_V2SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (!register_operand (operands[1], E_V2SFmode)
                      || !
#line 2869 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2409; /* *aarch64_fma4_eltv2sf */

                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !
#line 2886 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2414; /* *aarch64_fma4_elt_to_128v2sf */

                default:
                  return -1;
                }

            case E_V4SFmode:
              if (pattern1061 (x3, 
E_V4SFmode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SFmode:
                  if (!register_operand (operands[1], E_V4SFmode)
                      || !
#line 2869 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2412; /* *aarch64_fma4_eltv4sf */

                case E_V2SFmode:
                  if (!register_operand (operands[1], E_V2SFmode)
                      || !
#line 2886 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2417; /* *aarch64_fma4_elt_to_64v4sf */

                default:
                  return -1;
                }

            case E_V2DFmode:
              if (!register_operand (operands[0], E_V2DFmode)
                  || GET_MODE (x3) != E_V2DFmode
                  || GET_MODE (x4) != E_V2DFmode
                  || GET_MODE (x8) != E_DFmode
                  || !register_operand (operands[1], E_V2DFmode)
                  || !register_operand (operands[3], E_V2DFmode)
                  || !register_operand (operands[4], E_V2DFmode)
                  || !
#line 2869 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2413; /* *aarch64_fma4_eltv2df */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x8;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          x5 = XEXP (x3, 2);
          operands[3] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern808 (x3, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2418; /* *aarch64_fma4_elt_from_dupv4hi */

            case E_V8HImode:
              if (pattern808 (x3, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2421; /* *aarch64_fma4_elt_from_dupv8hi */

            case E_V2SImode:
              if (pattern808 (x3, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2422; /* *aarch64_fma4_elt_from_dupv2si */

            case E_V4SImode:
              if (pattern808 (x3, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2425; /* *aarch64_fma4_elt_from_dupv4si */

            case E_V4HFmode:
              if (pattern808 (x3, 
E_V4HFmode, 
E_HFmode) != 0
                  || !(
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2426; /* *aarch64_fma4_elt_from_dupv4hf */

            case E_V8HFmode:
              if (pattern808 (x3, 
E_V8HFmode, 
E_HFmode) != 0
                  || !(
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 2429; /* *aarch64_fma4_elt_from_dupv8hf */

            case E_V2SFmode:
              if (pattern808 (x3, 
E_V2SFmode, 
E_SFmode) != 0
                  || !
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2430; /* *aarch64_fma4_elt_from_dupv2sf */

            case E_V4SFmode:
              if (pattern808 (x3, 
E_V4SFmode, 
E_SFmode) != 0
                  || !
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2433; /* *aarch64_fma4_elt_from_dupv4sf */

            case E_V2DFmode:
              if (pattern808 (x3, 
E_V2DFmode, 
E_DFmode) != 0
                  || !
#line 2901 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2434; /* *aarch64_fma4_elt_from_dupv2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      if (pattern295 (x3) != 0)
        return -1;
      x5 = XEXP (x3, 2);
      operands[4] = x5;
      if (!register_operand (operands[4], E_DFmode))
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[3] = x6;
          if (!register_operand (operands[3], E_DFmode)
              || !
#line 2914 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2435; /* *aarch64_fma4_elt_to_64v2df */

        case NEG:
          if (GET_MODE (x6) != E_DFmode)
            return -1;
          x9 = XEXP (x6, 0);
          operands[3] = x9;
          if (!register_operand (operands[3], E_DFmode)
              || !
#line 2991 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2471; /* *aarch64_fnma4_elt_to_64v2df */

        default:
          return -1;
        }

    case FLOAT_EXTEND:
      return recog_478 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_516 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      switch (pattern436 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3233; /* sssubv8qi3 */

        case 1:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3241; /* sssubv16qi3 */

        case 2:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3249; /* sssubv4hi3 */

        case 3:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3257; /* sssubv8hi3 */

        case 4:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3265; /* sssubv2si3 */

        case 5:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3273; /* sssubv4si3 */

        case 6:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3277; /* sssubv2di3 */

        case 7:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3281; /* sssubhi3 */

        case 8:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3285; /* sssubqi3 */

        case 9:
          *pnum_clobbers = 2;
          return 3288; /* aarch64_sssubsi3 */

        case 10:
          *pnum_clobbers = 2;
          return 3290; /* aarch64_sssubdi3 */

        case 11:
          if (!
#line 4457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8062; /* sssubvnx16qi3 */

        case 12:
          if (!
#line 4457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8064; /* sssubvnx8hi3 */

        case 13:
          if (!
#line 4457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8066; /* sssubvnx4si3 */

        case 14:
          if (!
#line 4457 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8068; /* sssubvnx2di3 */

        default:
          return -1;
        }

    case SS_ASHIFT:
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != MULT)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != SIGN_EXTEND)
        return -1;
      x8 = XEXP (x5, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x7, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[2] = x9;
          x10 = XEXP (x6, 1);
          switch (GET_CODE (x10))
            {
            case SIGN_EXTEND:
              x11 = XEXP (x10, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  operands[3] = x11;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1138 (x3, 
E_V4HImode, 
E_V4SImode) != 0
                          || !
#line 5753 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3565; /* aarch64_sqdmlslv4hi */

                    case E_V2DImode:
                      if (pattern1138 (x3, 
E_V2SImode, 
E_V2DImode) != 0
                          || !
#line 5753 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3566; /* aarch64_sqdmlslv2si */

                    case E_SImode:
                      if (pattern1138 (x3, 
E_HImode, 
E_SImode) != 0
                          || !
#line 5753 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3567; /* aarch64_sqdmlslhi */

                    case E_DImode:
                      if (pattern1138 (x3, 
E_SImode, 
E_DImode) != 0
                          || !
#line 5753 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3568; /* aarch64_sqdmlslsi */

                    default:
                      return -1;
                    }

                case VEC_SELECT:
                  x12 = XEXP (x11, 1);
                  if (GET_CODE (x12) != PARALLEL
                      || XVECLEN (x12, 0) != 1)
                    return -1;
                  x13 = XEXP (x11, 0);
                  operands[3] = x13;
                  x14 = XVECEXP (x12, 0, 0);
                  operands[4] = x14;
                  if (!immediate_operand (operands[4], E_SImode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_SImode:
                      if (pattern1255 (x3, 
E_HImode, 
E_SImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[3]))
                        {
                        case E_V4HImode:
                          if (!register_operand (operands[3], E_V4HImode)
                              || !
#line 5895 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3579; /* aarch64_sqdmlsl_lanehi */

                        case E_V8HImode:
                          if (!register_operand (operands[3], E_V8HImode)
                              || !
#line 5942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3583; /* aarch64_sqdmlsl_laneqhi */

                        default:
                          return -1;
                        }

                    case E_DImode:
                      if (pattern1255 (x3, 
E_SImode, 
E_DImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[3]))
                        {
                        case E_V2SImode:
                          if (!register_operand (operands[3], E_V2SImode)
                              || !
#line 5895 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3580; /* aarch64_sqdmlsl_lanesi */

                        case E_V4SImode:
                          if (!register_operand (operands[3], E_V4SImode)
                              || !
#line 5942 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3584; /* aarch64_sqdmlsl_laneqsi */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              x11 = XEXP (x10, 0);
              switch (pattern963 (x11))
                {
                case 0:
                  x13 = XEXP (x11, 0);
                  x15 = XEXP (x13, 0);
                  operands[3] = x15;
                  x16 = XEXP (x13, 1);
                  x17 = XVECEXP (x16, 0, 0);
                  operands[4] = x17;
                  if (!immediate_operand (operands[4], E_SImode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1277 (x3, 
E_V4HImode, 
E_V4SImode) != 0)
                        return -1;
                      switch (pattern1341 (x10))
                        {
                        case 0:
                          if (!
#line 5799 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3571; /* aarch64_sqdmlsl_lanev4hi */

                        case 1:
                          if (!
#line 5824 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3573; /* aarch64_sqdmlsl_laneqv4hi */

                        default:
                          return -1;
                        }

                    case E_V2DImode:
                      if (pattern1277 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
                        return -1;
                      switch (pattern1342 (x10))
                        {
                        case 0:
                          if (!
#line 5799 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3572; /* aarch64_sqdmlsl_lanev2si */

                        case 1:
                          if (!
#line 5824 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3574; /* aarch64_sqdmlsl_laneqv2si */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 1:
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1171 (x3, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V4HImode) != 0
                          || !
#line 5965 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3585; /* aarch64_sqdmlsl_nv4hi */

                    case E_V2DImode:
                      if (pattern1171 (x3, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0
                          || !
#line 5965 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3586; /* aarch64_sqdmlsl_nv2si */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x18 = XEXP (x9, 0);
          operands[2] = x18;
          x10 = XEXP (x6, 1);
          switch (GET_CODE (x10))
            {
            case SIGN_EXTEND:
              x11 = XEXP (x10, 0);
              if (GET_CODE (x11) != VEC_SELECT)
                return -1;
              x19 = XEXP (x9, 1);
              operands[4] = x19;
              x13 = XEXP (x11, 0);
              operands[3] = x13;
              x12 = XEXP (x11, 1);
              if (!rtx_equal_p (x12, operands[4]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V4SImode:
                  if (pattern1201 (x3, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0
                      || !
#line 6025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3591; /* aarch64_sqdmlsl2v8hi_internal */

                case E_V2DImode:
                  if (pattern1201 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0
                      || !
#line 6025 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 3592; /* aarch64_sqdmlsl2v4si_internal */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              x11 = XEXP (x10, 0);
              switch (pattern963 (x11))
                {
                case 0:
                  x19 = XEXP (x9, 1);
                  operands[5] = x19;
                  x13 = XEXP (x11, 0);
                  x15 = XEXP (x13, 0);
                  operands[3] = x15;
                  x16 = XEXP (x13, 1);
                  x17 = XVECEXP (x16, 0, 0);
                  operands[4] = x17;
                  if (!immediate_operand (operands[4], E_SImode))
                    return -1;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1286 (x3, 
E_V8HImode, 
E_V4HImode, 
E_V4SImode) != 0)
                        return -1;
                      switch (pattern1341 (x10))
                        {
                        case 0:
                          if (!
#line 6065 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3593; /* aarch64_sqdmlsl2_lanev8hi_internal */

                        case 1:
                          if (!
#line 6117 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3597; /* aarch64_sqdmlsl2_laneqv8hi_internal */

                        default:
                          return -1;
                        }

                    case E_V2DImode:
                      if (pattern1286 (x3, 
E_V4SImode, 
E_V2SImode, 
E_V2DImode) != 0)
                        return -1;
                      switch (pattern1342 (x10))
                        {
                        case 0:
                          if (!
#line 6065 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3594; /* aarch64_sqdmlsl2_lanev4si_internal */

                        case 1:
                          if (!
#line 6117 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                            return -1;
                          return 3598; /* aarch64_sqdmlsl2_laneqv4si_internal */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case 1:
                  x19 = XEXP (x9, 1);
                  operands[4] = x19;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V4SImode:
                      if (pattern1202 (x3, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode) != 0
                          || !
#line 6200 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3601; /* aarch64_sqdmlsl2_nv8hi_internal */

                    case E_V2DImode:
                      if (pattern1202 (x3, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0
                          || !
#line 6200 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 3602; /* aarch64_sqdmlsl2_nv4si_internal */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern440 (x3))
        {
        case 0:
          if (!
#line 10531 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10965; /* aarch64_sve_sqdecdi_pat */

        case 1:
          if (!
#line 10949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11017; /* *aarch64_sve_sqdecdivnx16bi_cntp */

        case 2:
          if (!
#line 10949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11020; /* *aarch64_sve_sqdecdivnx8bi_cntp */

        case 3:
          if (!
#line 10949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11023; /* *aarch64_sve_sqdecdivnx4bi_cntp */

        case 4:
          if (!
#line 10949 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11026; /* *aarch64_sve_sqdecdivnx2bi_cntp */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern441 (x3))
        {
        case 0:
          if (!
#line 10596 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10971; /* aarch64_sve_sqdecvnx2di_pat */

        case 1:
          if (!
#line 11056 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11041; /* *aarch64_sve_sqdecvnx2di_cntp */

        case 2:
          if (!
#line 10617 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10974; /* aarch64_sve_sqdecvnx4si_pat */

        case 3:
          if (!
#line 11095 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11044; /* *aarch64_sve_sqdecvnx4si_cntp */

        case 4:
          if (!
#line 10652 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10977; /* *aarch64_sve_sqdecvnx8hi_pat */

        case 5:
          if (!
#line 11136 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11047; /* *aarch64_sve_sqdecvnx8hi_cntp */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x5, 0) != 2)
        return -1;
      x20 = XVECEXP (x5, 0, 0);
      operands[2] = x20;
      switch (XINT (x5, 1))
        {
        case 508:
          switch (pattern637 (x3))
            {
            case 0:
              if (!
#line 2447 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12197; /* aarch64_sve_qsub_sqdmullbvnx8hi */

            case 1:
              if (!
#line 2447 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12200; /* aarch64_sve_qsub_sqdmullbvnx4si */

            case 2:
              if (!
#line 2447 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12203; /* aarch64_sve_qsub_sqdmullbvnx2di */

            case 3:
              if (!
#line 2466 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12206; /* aarch64_sve_qsub_sqdmullb_lane_vnx4si */

            case 4:
              if (!
#line 2466 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12208; /* aarch64_sve_qsub_sqdmullb_lane_vnx2di */

            default:
              return -1;
            }

        case 509:
          switch (pattern635 (x3))
            {
            case 0:
              if (!
#line 2447 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12198; /* aarch64_sve_qsub_sqdmullbtvnx8hi */

            case 1:
              if (!
#line 2447 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12201; /* aarch64_sve_qsub_sqdmullbtvnx4si */

            case 2:
              if (!
#line 2447 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12204; /* aarch64_sve_qsub_sqdmullbtvnx2di */

            default:
              return -1;
            }

        case 510:
          switch (pattern637 (x3))
            {
            case 0:
              if (!
#line 2447 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12199; /* aarch64_sve_qsub_sqdmulltvnx8hi */

            case 1:
              if (!
#line 2447 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12202; /* aarch64_sve_qsub_sqdmulltvnx4si */

            case 2:
              if (!
#line 2447 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12205; /* aarch64_sve_qsub_sqdmulltvnx2di */

            case 3:
              if (!
#line 2466 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12207; /* aarch64_sve_qsub_sqdmullt_lane_vnx4si */

            case 4:
              if (!
#line 2466 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 12209; /* aarch64_sve_qsub_sqdmullt_lane_vnx2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_530 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case TRUNCATE:
      operands[1] = x4;
      res = recog_471 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (!subreg_lowpart_operator (x4, E_SImode))
        return -1;
      operands[4] = x4;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SIGN_EXTRACT
          || GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 2);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x8 = XEXP (x5, 1);
      operands[2] = x8;
      if (!aarch64_simd_shift_imm_offset_si (operands[2], E_VOIDmode))
        return -1;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      if (!aarch64_simd_shift_imm_si (operands[3], E_VOIDmode)
          || !
#line 6629 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (SImode) - 1)))
        return -1;
      return 868; /* *ashiftsi_extvdi_bfiz */

    case SIGN_EXTEND:
      switch (pattern304 (x3))
        {
        case 0:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 852; /* *extendqi_shft_si */

        case 1:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 856; /* *extendhi_shft_si */

        case 2:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 860; /* *extendsi_shft_si */

        case 3:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 854; /* *extendqi_shft_di */

        case 4:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 858; /* *extendhi_shft_di */

        case 5:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 862; /* *extendsi_shft_di */

        case 6:
          if (!
#line 6534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3767; /* aarch64_sshllv8qi */

        case 7:
          if (!
#line 6534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3769; /* aarch64_sshllv4hi */

        case 8:
          if (!
#line 6534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3771; /* aarch64_sshllv2si */

        case 9:
          if (!
#line 6566 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3773; /* aarch64_sshll2v16qi */

        case 10:
          if (!
#line 6566 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3775; /* aarch64_sshll2v8hi */

        case 11:
          if (!
#line 6566 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3777; /* aarch64_sshll2v4si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern304 (x3))
        {
        case 0:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 853; /* *zero_extendqi_shft_si */

        case 1:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 857; /* *zero_extendhi_shft_si */

        case 2:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 32))
            return -1;
          return 861; /* *zero_extendsi_shft_si */

        case 3:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 855; /* *zero_extendqi_shft_di */

        case 4:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 859; /* *zero_extendhi_shft_di */

        case 5:
          if (!
#line 6584 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < 64))
            return -1;
          return 863; /* *zero_extendsi_shft_di */

        case 6:
          if (!
#line 6534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3768; /* aarch64_ushllv8qi */

        case 7:
          if (!
#line 6534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3770; /* aarch64_ushllv4hi */

        case 8:
          if (!
#line 6534 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3772; /* aarch64_ushllv2si */

        case 9:
          if (!
#line 6566 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3774; /* aarch64_ushll2v16qi */

        case 10:
          if (!
#line 6566 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3776; /* aarch64_ushll2v8hi */

        case 11:
          if (!
#line 6566 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3778; /* aarch64_ushll2v4si */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x10 = XEXP (x4, 2);
      if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x11 = XEXP (x4, 1);
      operands[2] = x11;
      x9 = XEXP (x3, 1);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern332 (x3, 
E_VOIDmode, 
E_SImode) != 0
              || !aarch64_simd_shift_imm_si (operands[3], E_VOIDmode)
              || !
#line 6614 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (SImode) - 1)))
            return -1;
          return 866; /* *ashiftsi_extv_bfiz */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !aarch64_simd_shift_imm_offset_di (operands[2], E_VOIDmode)
              || !aarch64_simd_shift_imm_di (operands[3], E_VOIDmode)
              || !
#line 6614 "../../gcc/config/aarch64/aarch64.md"
(IN_RANGE (INTVAL (operands[2]) + INTVAL (operands[3]),
	     1, GET_MODE_BITSIZE (DImode) - 1)))
            return -1;
          return 867; /* *ashiftdi_extv_bfiz */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_539 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern438 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3230; /* usaddv8qi3 */

        case 1:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3240; /* usaddv16qi3 */

        case 2:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3246; /* usaddv4hi3 */

        case 3:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3256; /* usaddv8hi3 */

        case 4:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3262; /* usaddv2si3 */

        case 5:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3272; /* usaddv4si3 */

        case 6:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3276; /* usaddv2di3 */

        case 7:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3280; /* usaddhi3 */

        case 8:
          if (!
#line 5170 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3284; /* usaddqi3 */

        case 9:
          *pnum_clobbers = 1;
          return 3291; /* usaddsi3 */

        case 10:
          *pnum_clobbers = 1;
          return 3293; /* usadddi3 */

        case 11:
          if (!
#line 4473 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8069; /* usaddvnx16qi3 */

        case 12:
          if (!
#line 4473 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8071; /* usaddvnx8hi3 */

        case 13:
          if (!
#line 4473 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8073; /* usaddvnx4si3 */

        case 14:
          if (!
#line 4473 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8075; /* usaddvnx2di3 */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern326 (x3))
        {
        case 0:
          if (!
#line 10381 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10951; /* aarch64_sve_uqincdi_pat */

        case 1:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10985; /* *aarch64_sve_uqincdivnx16bi_cntp */

        case 2:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10988; /* *aarch64_sve_uqincdivnx8bi_cntp */

        case 3:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10991; /* *aarch64_sve_uqincdivnx4bi_cntp */

        case 4:
          if (!
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10994; /* *aarch64_sve_uqincdivnx2bi_cntp */

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern330 (x3))
        {
        case 0:
          if (!
#line 10446 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10957; /* aarch64_sve_uqincvnx2di_pat */

        case 1:
          if (!
#line 10823 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11009; /* *aarch64_sve_uqincvnx2di_cntp */

        case 2:
          if (!
#line 10467 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10960; /* aarch64_sve_uqincvnx4si_pat */

        case 3:
          if (!
#line 10862 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11012; /* *aarch64_sve_uqincvnx4si_cntp */

        case 4:
          if (!
#line 10502 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10963; /* *aarch64_sve_uqincvnx8hi_pat */

        case 5:
          if (!
#line 10903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 11015; /* *aarch64_sve_uqincvnx8hi_cntp */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_559 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10022; /* *while_rwsivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10032; /* *while_rwdivnx16bi_cc */
}

 int
recog_568 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10160; /* while_ugtsivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10170; /* while_ugtdivnx2bi_ptest */
}

 int
recog_578 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10119; /* while_gtsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10129; /* while_gtdivnx8bi_ptest */
}

 int
recog_588 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10078; /* *while_gesivnx2bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10088; /* *while_gedivnx2bi_cc */
}

 int
recog_598 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern678 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9943; /* while_wrsivnx16bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9953; /* while_wrdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9963; /* while_wrsivnx8bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9973; /* while_wrdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9983; /* while_wrsivnx4bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9993; /* while_wrdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10003; /* while_wrsivnx2bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10013; /* while_wrdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_602 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XINT (x3, 1))
    {
    case 127:
      if (pattern550 (x2) != 0)
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      if (XWINT (x4, 0) == 1L)
        {
          res = recog_593 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x5 = XVECEXP (x3, 0, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_VNx16BImode)
          || !aarch64_sve_ptrue_flag (x4, E_SImode))
        return -1;
      x6 = XVECEXP (x3, 0, 3);
      switch (GET_CODE (x6))
        {
        case AND:
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case REG:
              if (REGNO (x7) != 86
                  || GET_MODE (x7) != E_VNx16BImode)
                return -1;
              operands[2] = x4;
              if (GET_MODE (x6) != E_VNx16BImode)
                return -1;
              x8 = XVECEXP (x3, 0, 1);
              if (!rtx_equal_p (x8, operands[1]))
                return -1;
              x9 = XEXP (x6, 1);
              if (!rtx_equal_p (x9, operands[1]))
                return -1;
              x10 = XVECEXP (x1, 0, 1);
              switch (GET_CODE (x10))
                {
                case CLOBBER:
                  x11 = XEXP (x10, 0);
                  operands[0] = x11;
                  if (!scratch_operand (operands[0], E_VNx16BImode)
                      || !
#line 1182 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 5718; /* *aarch64_rdffr_z_ptest */

                case SET:
                  x12 = XEXP (x10, 1);
                  if (GET_CODE (x12) != AND
                      || GET_MODE (x12) != E_VNx16BImode)
                    return -1;
                  x13 = XEXP (x12, 0);
                  if (GET_CODE (x13) != REG
                      || REGNO (x13) != 86
                      || GET_MODE (x13) != E_VNx16BImode)
                    return -1;
                  x11 = XEXP (x10, 0);
                  operands[0] = x11;
                  if (!register_operand (operands[0], E_VNx16BImode))
                    return -1;
                  x14 = XEXP (x12, 1);
                  if (!rtx_equal_p (x14, operands[1])
                      || !
#line 1223 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 5720; /* *aarch64_rdffr_z_cc */

                default:
                  return -1;
                }

            case AND:
              switch (pattern1210 (x1, 
AND))
                {
                case 0:
                  if (!
#line 6815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9040; /* *andvnx16bi3_cc */

                case 1:
                  if (!
#line 6815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9043; /* *andvnx8bi3_cc */

                case 2:
                  if (!
#line 6815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9046; /* *andvnx4bi3_cc */

                case 3:
                  if (!
#line 6815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9049; /* *andvnx2bi3_cc */

                case 4:
                  if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9052; /* *andvnx16bi3_ptest */

                case 5:
                  if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9055; /* *andvnx8bi3_ptest */

                case 6:
                  if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9058; /* *andvnx4bi3_ptest */

                case 7:
                  if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9061; /* *andvnx2bi3_ptest */

                case 8:
                  if (!
#line 6888 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9072; /* *bicvnx16bi3_cc */

                case 9:
                  if (!
#line 6888 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9074; /* *bicvnx8bi3_cc */

                case 10:
                  if (!
#line 6888 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9076; /* *bicvnx4bi3_cc */

                case 11:
                  if (!
#line 6888 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9078; /* *bicvnx2bi3_cc */

                case 12:
                  if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9080; /* *bicvnx16bi3_ptest */

                case 13:
                  if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9082; /* *bicvnx8bi3_ptest */

                case 14:
                  if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9084; /* *bicvnx4bi3_ptest */

                case 15:
                  if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9086; /* *bicvnx2bi3_ptest */

                case 16:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9096; /* *norvnx16bi3_cc */

                case 17:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9098; /* *norvnx8bi3_cc */

                case 18:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9100; /* *norvnx4bi3_cc */

                case 19:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9102; /* *norvnx2bi3_cc */

                case 20:
                  if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9104; /* *norvnx16bi3_ptest */

                case 21:
                  if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9106; /* *norvnx8bi3_ptest */

                case 22:
                  if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9108; /* *norvnx4bi3_ptest */

                case 23:
                  if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9110; /* *norvnx2bi3_ptest */

                default:
                  return -1;
                }

            case IOR:
              switch (pattern1210 (x1, 
IOR))
                {
                case 0:
                  if (!
#line 6815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9041; /* *iorvnx16bi3_cc */

                case 1:
                  if (!
#line 6815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9044; /* *iorvnx8bi3_cc */

                case 2:
                  if (!
#line 6815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9047; /* *iorvnx4bi3_cc */

                case 3:
                  if (!
#line 6815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9050; /* *iorvnx2bi3_cc */

                case 4:
                  if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9053; /* *iorvnx16bi3_ptest */

                case 5:
                  if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9056; /* *iorvnx8bi3_ptest */

                case 6:
                  if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9059; /* *iorvnx4bi3_ptest */

                case 7:
                  if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9062; /* *iorvnx2bi3_ptest */

                case 8:
                  if (!
#line 6888 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9073; /* *ornvnx16bi3_cc */

                case 9:
                  if (!
#line 6888 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9075; /* *ornvnx8bi3_cc */

                case 10:
                  if (!
#line 6888 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9077; /* *ornvnx4bi3_cc */

                case 11:
                  if (!
#line 6888 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9079; /* *ornvnx2bi3_cc */

                case 12:
                  if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9081; /* *ornvnx16bi3_ptest */

                case 13:
                  if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9083; /* *ornvnx8bi3_ptest */

                case 14:
                  if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9085; /* *ornvnx4bi3_ptest */

                case 15:
                  if (!
#line 6911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9087; /* *ornvnx2bi3_ptest */

                case 16:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9097; /* *nandvnx16bi3_cc */

                case 17:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9099; /* *nandvnx8bi3_cc */

                case 18:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9101; /* *nandvnx4bi3_cc */

                case 19:
                  if (!
#line 6963 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9103; /* *nandvnx2bi3_cc */

                case 20:
                  if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9105; /* *nandvnx16bi3_ptest */

                case 21:
                  if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9107; /* *nandvnx8bi3_ptest */

                case 22:
                  if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9109; /* *nandvnx4bi3_ptest */

                case 23:
                  if (!
#line 6987 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9111; /* *nandvnx2bi3_ptest */

                default:
                  return -1;
                }

            case XOR:
              x8 = XVECEXP (x3, 0, 1);
              operands[4] = x8;
              operands[5] = x4;
              x15 = XEXP (x7, 0);
              operands[2] = x15;
              x16 = XEXP (x7, 1);
              operands[3] = x16;
              x9 = XEXP (x6, 1);
              if (!rtx_equal_p (x9, operands[4]))
                return -1;
              switch (pattern1205 (x1, 
XOR))
                {
                case 0:
                  if (!
#line 6815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9042; /* *xorvnx16bi3_cc */

                case 1:
                  if (!
#line 6815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9045; /* *xorvnx8bi3_cc */

                case 2:
                  if (!
#line 6815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9048; /* *xorvnx4bi3_cc */

                case 3:
                  if (!
#line 6815 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9051; /* *xorvnx2bi3_cc */

                case 4:
                  if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9054; /* *xorvnx16bi3_ptest */

                case 5:
                  if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9057; /* *xorvnx8bi3_ptest */

                case 6:
                  if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9060; /* *xorvnx4bi3_ptest */

                case 7:
                  if (!
#line 6837 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 9063; /* *xorvnx2bi3_ptest */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x6, 0) != 3)
            return -1;
          switch (XINT (x6, 1))
            {
            case 126:
              return recog_596 (x1, insn, pnum_clobbers);

            case 299:
              switch (pattern1235 (x1, 
299))
                {
                case 0:
                  if (!
#line 10094 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 10911; /* *aarch64_brka_cc */

                case 1:
                  if (!
#line 10116 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 10913; /* *aarch64_brka_ptest */

                default:
                  return -1;
                }

            case 300:
              switch (pattern1235 (x1, 
300))
                {
                case 0:
                  if (!
#line 10094 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 10912; /* *aarch64_brkb_cc */

                case 1:
                  if (!
#line 10116 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 10914; /* *aarch64_brkb_ptest */

                default:
                  return -1;
                }

            case 302:
              switch (pattern1236 (x1, 
302))
                {
                case 0:
                  if (!
#line 10225 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 10920; /* *aarch64_brkpa_cc */

                case 1:
                  if (!
#line 10247 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 10922; /* *aarch64_brkpa_ptest */

                default:
                  return -1;
                }

            case 303:
              switch (pattern1236 (x1, 
303))
                {
                case 0:
                  if (!
#line 10225 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 10921; /* *aarch64_brkpb_cc */

                case 1:
                  if (!
#line 10247 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                    return -1;
                  return 10923; /* *aarch64_brkpb_ptest */

                default:
                  return -1;
                }

            case 304:
              switch (pattern1238 (x1, 
304))
                {
                case 0:
                  if (!
#line 10294 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10932; /* *aarch64_sve_pfirstvnx16bi_cc */

                case 1:
                  if (!
#line 10294 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10934; /* *aarch64_sve_pfirstvnx8bi_cc */

                case 2:
                  if (!
#line 10294 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10936; /* *aarch64_sve_pfirstvnx4bi_cc */

                case 3:
                  if (!
#line 10294 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10938; /* *aarch64_sve_pfirstvnx2bi_cc */

                case 4:
                  if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10940; /* *aarch64_sve_pfirstvnx16bi_ptest */

                case 5:
                  if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10942; /* *aarch64_sve_pfirstvnx8bi_ptest */

                case 6:
                  if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10944; /* *aarch64_sve_pfirstvnx4bi_ptest */

                case 7:
                  if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10946; /* *aarch64_sve_pfirstvnx2bi_ptest */

                default:
                  return -1;
                }

            case 305:
              switch (pattern1238 (x1, 
305))
                {
                case 0:
                  if (!
#line 10294 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10933; /* *aarch64_sve_pnextvnx16bi_cc */

                case 1:
                  if (!
#line 10294 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10935; /* *aarch64_sve_pnextvnx8bi_cc */

                case 2:
                  if (!
#line 10294 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10937; /* *aarch64_sve_pnextvnx4bi_cc */

                case 3:
                  if (!
#line 10294 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10939; /* *aarch64_sve_pnextvnx2bi_cc */

                case 4:
                  if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10941; /* *aarch64_sve_pnextvnx16bi_ptest */

                case 5:
                  if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10943; /* *aarch64_sve_pnextvnx8bi_ptest */

                case 6:
                  if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10945; /* *aarch64_sve_pnextvnx4bi_ptest */

                case 7:
                  if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
                    return -1;
                  return 10947; /* *aarch64_sve_pnextvnx2bi_ptest */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 136:
      switch (pattern551 (x1))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12626; /* aarch64_sve_whilege_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12634; /* aarch64_sve_whilege_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12642; /* aarch64_sve_whilege_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12650; /* aarch64_sve_whilege_b64_x2 */

        default:
          return -1;
        }

    case 137:
      switch (pattern551 (x1))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12627; /* aarch64_sve_whilegt_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12635; /* aarch64_sve_whilegt_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12643; /* aarch64_sve_whilegt_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12651; /* aarch64_sve_whilegt_b64_x2 */

        default:
          return -1;
        }

    case 138:
      switch (pattern551 (x1))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12628; /* aarch64_sve_whileugt_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12636; /* aarch64_sve_whileugt_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12644; /* aarch64_sve_whileugt_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12652; /* aarch64_sve_whileugt_b64_x2 */

        default:
          return -1;
        }

    case 139:
      switch (pattern551 (x1))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12629; /* aarch64_sve_whileuge_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12637; /* aarch64_sve_whileuge_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12645; /* aarch64_sve_whileuge_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12653; /* aarch64_sve_whileuge_b64_x2 */

        default:
          return -1;
        }

    case 140:
      switch (pattern551 (x1))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12630; /* aarch64_sve_whilele_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12638; /* aarch64_sve_whilele_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12646; /* aarch64_sve_whilele_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12654; /* aarch64_sve_whilele_b64_x2 */

        default:
          return -1;
        }

    case 141:
      switch (pattern551 (x1))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12631; /* aarch64_sve_whileult_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12639; /* aarch64_sve_whileult_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12647; /* aarch64_sve_whileult_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12655; /* aarch64_sve_whileult_b64_x2 */

        default:
          return -1;
        }

    case 142:
      switch (pattern551 (x1))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12632; /* aarch64_sve_whileule_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12640; /* aarch64_sve_whileule_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12648; /* aarch64_sve_whileule_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12656; /* aarch64_sve_whileule_b64_x2 */

        default:
          return -1;
        }

    case 143:
      switch (pattern551 (x1))
        {
        case 0:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12633; /* aarch64_sve_whilelt_b8_x2 */

        case 1:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12641; /* aarch64_sve_whilelt_b16_x2 */

        case 2:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12649; /* aarch64_sve_whilelt_b32_x2 */

        case 3:
          if (!
#line 3680 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12657; /* aarch64_sve_whilelt_b64_x2 */

        default:
          return -1;
        }

    case 650:
      x5 = XVECEXP (x3, 0, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 93)
        return -1;
      x8 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 89
          || GET_MODE (x8) != E_DImode)
        return -1;
      x6 = XVECEXP (x3, 0, 3);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      if (pattern442 (x10, 
650, 
4, 
UNSPEC) != 0)
        return -1;
      x12 = XEXP (x10, 1);
      x17 = XVECEXP (x12, 0, 0);
      if (GET_CODE (x17) != REG
          || REGNO (x17) != 93)
        return -1;
      x18 = XVECEXP (x12, 0, 1);
      if (GET_CODE (x18) != REG
          || REGNO (x18) != 89
          || GET_MODE (x18) != E_DImode)
        return -1;
      x19 = XVECEXP (x12, 0, 3);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 93)
        return -1;
      x20 = XEXP (x2, 0);
      operands[0] = x20;
      x4 = XVECEXP (x3, 0, 2);
      switch (GET_CODE (x4))
        {
        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x21 = XVECEXP (x12, 0, 2);
          if (!rtx_equal_p (x21, operands[1]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx4DImode:
              if (!aligned_register_operand (operands[0], E_VNx4DImode)
                  || GET_MODE (x3) != E_VNx4DImode
                  || pattern684 (x1, 
E_VNx4DImode) != 0
                  || !
#line 945 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
                return -1;
              return 13238; /* aarch64_sme_readzvnx4di */

            case E_VNx8DImode:
              if (!aligned_register_operand (operands[0], E_VNx8DImode)
                  || GET_MODE (x3) != E_VNx8DImode
                  || pattern684 (x1, 
E_VNx8DImode) != 0
                  || !
#line 945 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
                return -1;
              return 13239; /* aarch64_sme_readzvnx8di */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x21 = XVECEXP (x12, 0, 2);
          if (GET_CODE (x21) != PLUS
              || GET_MODE (x21) != E_SImode)
            return -1;
          x22 = XEXP (x4, 0);
          operands[1] = x22;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x23 = XEXP (x4, 1);
          operands[2] = x23;
          if (!const_0_to_7_operand (operands[2], E_SImode))
            return -1;
          x24 = XEXP (x21, 0);
          if (!rtx_equal_p (x24, operands[1]))
            return -1;
          x25 = XEXP (x21, 1);
          if (!rtx_equal_p (x25, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx4DImode:
              if (!aligned_register_operand (operands[0], E_VNx4DImode)
                  || GET_MODE (x3) != E_VNx4DImode
                  || pattern684 (x1, 
E_VNx4DImode) != 0
                  || !
#line 966 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
                return -1;
              return 13240; /* *aarch64_sme_readzvnx4di_plus */

            case E_VNx8DImode:
              if (!aligned_register_operand (operands[0], E_VNx8DImode)
                  || GET_MODE (x3) != E_VNx8DImode
                  || pattern684 (x1, 
E_VNx8DImode) != 0
                  || !
#line 966 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2p1))
                return -1;
              return 13241; /* *aarch64_sme_readzvnx8di_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19;
  int res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return recog_620 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          switch (XINT (x1, 1))
            {
            case 164:
              if (GET_MODE (x1) != E_DImode
                  || !aarch64_sysreg_string (operands[0], E_VOIDmode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              return 3; /* aarch64_write_sysregdi */

            case 165:
              if (GET_MODE (x1) != E_TImode
                  || !aarch64_sysreg_string (operands[0], E_VOIDmode)
                  || !register_operand (operands[1], E_TImode)
                  || !
#line 672 "../../gcc/config/aarch64/aarch64.md"
(TARGET_D128))
                return -1;
              return 4; /* aarch64_write_sysregti */

            case 180:
              if (!const_int_operand (operands[0], E_VOIDmode)
                  || !const_int_operand (operands[1], E_VOIDmode))
                return -1;
              return 1221; /* patchable_area */

            default:
              return -1;
            }

        case 1:
          switch (XINT (x1, 1))
            {
            case 5:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1150; /* blockage */

            case 4:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  return 1160; /* aarch64_set_fpsrsi */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  return 1162; /* aarch64_set_fpsrdi */

                default:
                  return -1;
                }

            case 2:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  if (!register_operand (operands[0], E_SImode))
                    return -1;
                  return 1161; /* aarch64_set_fpcrsi */

                case E_DImode:
                  if (!register_operand (operands[0], E_DImode))
                    return -1;
                  return 1163; /* aarch64_set_fpcrdi */

                default:
                  return -1;
                }

            case 8:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1170; /* bti_noarg */

            case 9:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1171; /* bti_c */

            case 10:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1172; /* bti_j */

            case 11:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1173; /* bti_jc */

            case 7:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1174; /* speculation_barrier */

            case 14:
              x2 = XVECEXP (x1, 0, 0);
              if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              return 1227; /* aarch64_gcspopm_xzr */

            case 15:
              x2 = XVECEXP (x1, 0, 0);
              operands[0] = x2;
              if (!register_operand (operands[0], E_DImode))
                return -1;
              return 1228; /* aarch64_gcsss1 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PARALLEL:
      return recog_621 (x1, insn, pnum_clobbers);

    case UNSPEC:
      switch (XVECLEN (x1, 0))
        {
        case 1:
          if (XINT (x1, 1) != 71)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 29; /* nop */

        case 2:
          if (XINT (x1, 1) != 166)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          x3 = XVECEXP (x1, 0, 1);
          operands[1] = x3;
          if (!aarch64_prefetch_operand (operands[1], E_DImode))
            return -1;
          return 31; /* aarch64_pldx */

        default:
          return -1;
        }

    case PREFETCH:
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (aarch64_prefetch_operand (operands[0], E_DImode))
        {
          x5 = XEXP (x1, 1);
          operands[1] = x5;
          if (const_int_operand (operands[1], E_QImode))
            {
              x6 = XEXP (x1, 2);
              operands[2] = x6;
              if (const_int_operand (operands[2], E_QImode))
                return 30; /* prefetch */
            }
        }
      if (GET_CODE (x4) != UNSPEC
          || GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x1, 1);
      if (!const_int_operand (x5, E_DImode))
        return -1;
      x6 = XEXP (x1, 2);
      if (!const_int_operand (x6, E_DImode))
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 3:
          if (XINT (x4, 1) != 169)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[0] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[1] = x8;
          x9 = XVECEXP (x4, 0, 2);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          operands[3] = x5;
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16BImode:
              if (!register_operand (operands[0], E_VNx16BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx16QImode)
                  || !
#line 2122 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6252; /* aarch64_sve_prefetchvnx16qi */

            case E_VNx8BImode:
              if (!register_operand (operands[0], E_VNx8BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx8HImode)
                  || !
#line 2122 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6253; /* aarch64_sve_prefetchvnx8hi */

            case E_VNx4BImode:
              if (!register_operand (operands[0], E_VNx4BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx4SImode)
                  || !
#line 2122 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6254; /* aarch64_sve_prefetchvnx4si */

            case E_VNx2BImode:
              if (!register_operand (operands[0], E_VNx2BImode)
                  || !aarch64_sve_prefetch_operand (operands[1], E_VNx2DImode)
                  || !
#line 2122 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 6255; /* aarch64_sve_prefetchvnx2di */

            default:
              return -1;
            }

        case 7:
          if (XINT (x4, 1) != 170)
            return -1;
          x7 = XVECEXP (x4, 0, 0);
          operands[0] = x7;
          x8 = XVECEXP (x4, 0, 1);
          operands[1] = x8;
          x10 = XVECEXP (x4, 0, 3);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x11 = XVECEXP (x4, 0, 4);
          operands[4] = x11;
          x12 = XVECEXP (x4, 0, 5);
          operands[5] = x12;
          x13 = XVECEXP (x4, 0, 6);
          operands[6] = x13;
          if (!const_int_operand (operands[6], E_DImode))
            return -1;
          operands[7] = x5;
          operands[8] = x6;
          x9 = XVECEXP (x4, 0, 2);
          switch (GET_CODE (x9))
            {
            case REG:
            case SUBREG:
              operands[2] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_VNx4BImode:
                  if (!register_operand (operands[0], E_VNx4BImode)
                      || !register_operand (operands[2], E_VNx4SImode))
                    return -1;
                  if (aarch64_sve_gather_offset_b (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_b (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                      && 
#line 2162 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6256; /* aarch64_sve_gather_prefetchvnx16qivnx4si */
                  if (aarch64_sve_gather_offset_h (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_h (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                      && 
#line 2162 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6257; /* aarch64_sve_gather_prefetchvnx8hivnx4si */
                  if (aarch64_sve_gather_offset_w (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_w (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                      && 
#line 2162 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6258; /* aarch64_sve_gather_prefetchvnx4sivnx4si */
                  if (!aarch64_sve_gather_offset_d (operands[1], E_DImode)
                      || !aarch64_gather_scale_operand_d (operands[4], E_DImode)
                      || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                      || !
#line 2162 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6259; /* aarch64_sve_gather_prefetchvnx2divnx4si */

                case E_VNx2BImode:
                  if (!register_operand (operands[0], E_VNx2BImode)
                      || !register_operand (operands[2], E_VNx2DImode))
                    return -1;
                  if (aarch64_sve_gather_offset_b (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_b (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                      && 
#line 2191 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6260; /* aarch64_sve_gather_prefetchvnx16qivnx2di */
                  if (aarch64_sve_gather_offset_h (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_h (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                      && 
#line 2191 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6261; /* aarch64_sve_gather_prefetchvnx8hivnx2di */
                  if (aarch64_sve_gather_offset_w (operands[1], E_DImode)
                      && aarch64_gather_scale_operand_w (operands[4], E_DImode)
                      && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                      && 
#line 2191 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return 6262; /* aarch64_sve_gather_prefetchvnx4sivnx2di */
                  if (!aarch64_sve_gather_offset_d (operands[1], E_DImode)
                      || !aarch64_gather_scale_operand_d (operands[4], E_DImode)
                      || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                      || !
#line 2191 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                    return -1;
                  return 6263; /* aarch64_sve_gather_prefetchvnx2divnx2di */

                default:
                  return -1;
                }

            case UNSPEC:
              if (pattern570 (x9) != 0
                  || !register_operand (operands[0], E_VNx2BImode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x14 = XVECEXP (x9, 0, 0);
              operands[9] = x14;
              x15 = XVECEXP (x9, 0, 1);
              x16 = XEXP (x15, 0);
              x17 = XEXP (x16, 0);
              operands[2] = x17;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              if (aarch64_gather_scale_operand_b (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                  && 
#line 2222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6264; /* *aarch64_sve_gather_prefetchvnx16qivnx2di_sxtw */
              if (aarch64_gather_scale_operand_h (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                  && 
#line 2222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6265; /* *aarch64_sve_gather_prefetchvnx8hivnx2di_sxtw */
              if (aarch64_gather_scale_operand_w (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                  && 
#line 2222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6266; /* *aarch64_sve_gather_prefetchvnx4sivnx2di_sxtw */
              if (!aarch64_gather_scale_operand_d (operands[4], E_DImode)
                  || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                  || !
#line 2222 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6267; /* *aarch64_sve_gather_prefetchvnx2divnx2di_sxtw */

            case AND:
              if (GET_MODE (x9) != E_VNx2DImode
                  || !register_operand (operands[0], E_VNx2BImode)
                  || !register_operand (operands[1], E_DImode))
                return -1;
              x18 = XEXP (x9, 0);
              operands[2] = x18;
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              x19 = XEXP (x9, 1);
              operands[9] = x19;
              if (!aarch64_sve_uxtw_immediate (operands[9], E_VNx2DImode))
                return -1;
              if (aarch64_gather_scale_operand_b (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx16QImode)
                  && 
#line 2252 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6268; /* *aarch64_sve_gather_prefetchvnx16qivnx2di_uxtw */
              if (aarch64_gather_scale_operand_h (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx8HImode)
                  && 
#line 2252 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6269; /* *aarch64_sve_gather_prefetchvnx8hivnx2di_uxtw */
              if (aarch64_gather_scale_operand_w (operands[4], E_DImode)
                  && aarch64_simd_imm_zero (operands[5], E_VNx4SImode)
                  && 
#line 2252 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 6270; /* *aarch64_sve_gather_prefetchvnx4sivnx2di_uxtw */
              if (!aarch64_gather_scale_operand_d (operands[4], E_DImode)
                  || !aarch64_simd_imm_zero (operands[5], E_VNx2DImode)
                  || !
#line 2252 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 6271; /* *aarch64_sve_gather_prefetchvnx2divnx2di_uxtw */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRAP_IF:
      x4 = XEXP (x1, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      return 32; /* trap */

    case RETURN:
      return 33; /* *do_return */

    case SIMPLE_RETURN:
      return 34; /* simple_return */

    default:
      return -1;
    }
}

 rtx_insn *
split_12 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1241 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1248 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2945 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx2DImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1268 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1273 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2953 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx2DImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1293 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1307 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2961 (insn, operands);
}

 rtx_insn *
split_15 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1241 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1248 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2939 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1268 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1273 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2947 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1293 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1307 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2955 (insn, operands);
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2848 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2889 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2929 (insn, operands);
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2812 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2859 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2899 (insn, operands);
}

 rtx_insn *
split_28 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2846 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2887 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2927 (insn, operands);
}

 rtx_insn *
split_33 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2833 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2876 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2916 (insn, operands);
}

 rtx_insn *
split_38 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2820 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2865 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2905 (insn, operands);
}

 rtx_insn *
split_43 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2806 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2854 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2894 (insn, operands);
}

 rtx_insn *
split_48 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2840 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2882 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2922 (insn, operands);
}

 rtx_insn *
split_54 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2815 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2861 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2901 (insn, operands);
}

 rtx_insn *
split_60 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1036 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1681 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1754 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1806 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1694 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1767 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1819 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1707 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1780 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1832 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1720 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1793 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1845 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1727 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1904 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1734 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1911 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1741 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1918 (insn, operands);

    case 7:
      if (!((
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1858 (insn, operands);

    case 8:
      if (!(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1871 (insn, operands);

    case 9:
      if (!(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1884 (insn, operands);

    case 10:
      if (!(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1897 (insn, operands);

    case 11:
      if (!(
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1925 (insn, operands);

    case 12:
      if (!(
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1932 (insn, operands);

    case 13:
      if (!(
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1939 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_64 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1036 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && ((
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1674 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && ((
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1747 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !((
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1799 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1687 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1760 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1812 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1700 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1773 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1825 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1713 (insn, operands);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1786 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1838 (insn, operands);

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1722 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !(
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1899 (insn, operands);

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1729 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !(
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1906 (insn, operands);

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 5522 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return gen_split_1736 (insn, operands);
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !(
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5691 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
        return NULL;
      return gen_split_1913 (insn, operands);

    case 7:
      if (!((
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1851 (insn, operands);

    case 8:
      if (!(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1864 (insn, operands);

    case 9:
      if (!(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1877 (insn, operands);

    case 10:
      if (!(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1890 (insn, operands);

    case 11:
      if (!(
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1920 (insn, operands);

    case 12:
      if (!(
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1927 (insn, operands);

    case 13:
      if (!(
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 5727 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
        return NULL;
      return gen_split_1934 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_71 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  operands[4] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern699 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1254 (insn, operands);

        case E_VNx8QImode:
          if (pattern699 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1271 (insn, operands);

        case E_VNx4QImode:
          if (pattern699 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1288 (insn, operands);

        case E_VNx2QImode:
          if (pattern699 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1305 (insn, operands);

        case E_VNx8HImode:
          if (pattern699 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1322 (insn, operands);

        case E_VNx4HImode:
          if (pattern699 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1339 (insn, operands);

        case E_VNx2HImode:
          if (pattern699 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1356 (insn, operands);

        case E_VNx4SImode:
          if (pattern699 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1373 (insn, operands);

        case E_VNx2SImode:
          if (pattern699 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1390 (insn, operands);

        case E_VNx2DImode:
          if (pattern699 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1407 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1039 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 4807 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1498 (insn, operands);

        case E_VNx8QImode:
          if (pattern1039 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 4807 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1499 (insn, operands);

        case E_VNx4QImode:
          if (pattern1039 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 4807 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1500 (insn, operands);

        case E_VNx2QImode:
          if (pattern1039 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 4807 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1501 (insn, operands);

        case E_VNx8HImode:
          if (pattern1039 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 4807 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1502 (insn, operands);

        case E_VNx4HImode:
          if (pattern1039 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 4807 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1503 (insn, operands);

        case E_VNx2HImode:
          if (pattern1039 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 4807 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1504 (insn, operands);

        case E_VNx4SImode:
          if (pattern1039 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 4807 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1505 (insn, operands);

        case E_VNx2SImode:
          if (pattern1039 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 4807 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1506 (insn, operands);

        case E_VNx2DImode:
          if (pattern1039 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 4807 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])) && 
#line 4814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1507 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_75 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (XINT (x2, 1) != 123
      || GET_MODE (x2) != E_BLKmode)
    return NULL;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 2
      || XINT (x3, 1) != 125
      || GET_MODE (x3) != E_VNx2DImode)
    return NULL;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return NULL;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return NULL;
  x6 = XVECEXP (x2, 0, 0);
  operands[5] = x6;
  if (!register_operand (operands[5], E_VNx2BImode))
    return NULL;
  x7 = XVECEXP (x2, 0, 1);
  operands[0] = x7;
  if (!register_operand (operands[0], E_DImode))
    return NULL;
  x8 = XVECEXP (x3, 0, 0);
  operands[6] = x8;
  x9 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x9) != E_VNx2DImode)
    return NULL;
  x10 = XVECEXP (x2, 0, 3);
  operands[2] = x10;
  if (!const_int_operand (operands[2], E_DImode))
    return NULL;
  x11 = XVECEXP (x2, 0, 4);
  operands[3] = x11;
  switch (pattern1300 (x2))
    {
    case 0:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_1005 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1307 ())
            {
            case 0:
              if ((
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1007 (insn, operands);
              break;

            case 1:
              if ((
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1009 (insn, operands);
              break;

            case 2:
              if ((
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1011 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1013 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1015 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1017 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1019 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_1021 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1307 ())
            {
            case 0:
              if ((
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1022 (insn, operands);
              break;

            case 1:
              if ((
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1023 (insn, operands);
              break;

            case 2:
              if ((
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1024 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1025 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1026 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1027 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2517 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1028 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      x12 = XVECEXP (x2, 0, 5);
      if (GET_MODE (x12) == E_VNx2QImode
          && aarch64_gather_scale_operand_b (operands[3], E_DImode))
        {
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          if (register_operand (operands[4], E_VNx2DImode)
              && (
#line 2616 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2621 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
            return gen_split_1029 (insn, operands);
        }
      if (GET_MODE (x12) == E_VNx2HImode
          && aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          x13 = XEXP (x12, 0);
          operands[4] = x13;
          if (register_operand (operands[4], E_VNx2DImode)
              && (
#line 2616 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2621 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
            return gen_split_1030 (insn, operands);
        }
      if (GET_MODE (x12) != E_VNx2SImode
          || !aarch64_gather_scale_operand_w (operands[3], E_DImode))
        return NULL;
      x13 = XEXP (x12, 0);
      operands[4] = x13;
      if (!register_operand (operands[4], E_VNx2DImode)
          || !(
#line 2616 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2621 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[5], operands[6]))))
        return NULL;
      return gen_split_1031 (insn, operands);

    case 3:
      if (register_operand (operands[4], E_VNx2QImode)
          && aarch64_gather_scale_operand_b (operands[3], E_DImode)
          && (
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
        return gen_split_1006 (insn, operands);
      if (aarch64_gather_scale_operand_h (operands[3], E_DImode))
        {
          switch (pattern1307 ())
            {
            case 0:
              if ((
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1008 (insn, operands);
              break;

            case 1:
              if ((
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1010 (insn, operands);
              break;

            case 2:
              if ((
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1012 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (aarch64_gather_scale_operand_w (operands[3], E_DImode))
        {
          switch (GET_MODE (operands[4]))
            {
            case E_VNx2SImode:
              if (register_operand (operands[4], E_VNx2SImode)
                  && (
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1014 (insn, operands);
              break;

            case E_VNx2SFmode:
              if (register_operand (operands[4], E_VNx2SFmode)
                  && (
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return gen_split_1016 (insn, operands);
              break;

            default:
              break;
            }
        }
      if (!aarch64_gather_scale_operand_d (operands[3], E_DImode))
        return NULL;
      switch (GET_MODE (operands[4]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[4], E_VNx2DImode)
              || !(
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1018 (insn, operands);

        case E_VNx2DFmode:
          if (!register_operand (operands[4], E_VNx2DFmode)
              || !(
#line 2484 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 2489 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
            return NULL;
          return gen_split_1020 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_79 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (pattern2 (x3))
        {
        case 0:
          if (aarch64_pluslong_strict_immedate (operands[2], E_SImode)
              && 
#line 2511 "../../gcc/config/aarch64/aarch64.md"
(epilogue_completed))
            return gen_split_14 (insn, operands);
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_SImode)
              || !(
#line 2543 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx) && 
#line 2553 "../../gcc/config/aarch64/aarch64.md"
( epilogue_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && aarch64_split_add_offset_immediate (operands[2], SImode))))
            return NULL;
          return gen_split_16 (insn, operands);

        case 1:
          if (aarch64_pluslong_strict_immedate (operands[2], E_DImode)
              && 
#line 2511 "../../gcc/config/aarch64/aarch64.md"
(epilogue_completed))
            return gen_split_15 (insn, operands);
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_DImode)
              || !(
#line 2543 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx) && 
#line 2553 "../../gcc/config/aarch64/aarch64.md"
( epilogue_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])
   && aarch64_split_add_offset_immediate (operands[2], DImode))))
            return NULL;
          return gen_split_17 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x6 = XEXP (x4, 0);
      switch (GET_CODE (x6))
        {
        case LSHIFTRT:
          switch (pattern446 (x3))
            {
            case 0:
              if (!
#line 5125 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   SImode)))
                return NULL;
              return gen_split_41 (insn, operands);

            case 1:
              if (!
#line 5125 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && aarch64_bitmask_imm (UINTVAL (operands[3]) << UINTVAL (operands[2]),
			   DImode)))
                return NULL;
              return gen_split_45 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern447 (x3))
            {
            case 0:
              if (!
#line 5147 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[3]))
   && (PLUS != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_49 (insn, operands);

            case 1:
              if (!
#line 5147 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && ((paradoxical_subreg_p (operands[1])
	&& rtx_equal_p (SUBREG_REG (operands[1]), operands[4]))
       || (REG_P (operands[1])
	   && REG_P (operands[4])
	   && REGNO (operands[1]) == REGNO (operands[4])))
   && (trunc_int_for_mode (GET_MODE_MASK (GET_MODE (operands[4]))
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[3]))
   && (PLUS != PLUS
       || (GET_MODE_MASK (GET_MODE (operands[4]))
	   & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_53 (insn, operands);

            case 2:
              if (!
#line 5176 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), SImode)
       == INTVAL (operands[4]))
   && (PLUS != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_57 (insn, operands);

            case 3:
              if (!
#line 5176 "../../gcc/config/aarch64/aarch64.md"
(can_create_pseudo_p ()
   && pow2_or_zerop (UINTVAL (operands[3]) + 1)
   && (trunc_int_for_mode (UINTVAL (operands[3])
			   << INTVAL (operands[2]), DImode)
       == INTVAL (operands[4]))
   && (PLUS != PLUS
       || (INTVAL (operands[4]) & INTVAL (operands[3])) == 0)))
                return NULL;
              return gen_split_61 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case LSHIFTRT:
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != PLUS)
        return NULL;
      switch (pattern378 (x3))
        {
        case 0:
          if (!(
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 5016 "../../gcc/config/aarch64/aarch64-simd.md"
( true)))
            return NULL;
          return gen_split_191 (insn, operands);

        case 1:
          if (!(
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 5016 "../../gcc/config/aarch64/aarch64-simd.md"
( true)))
            return NULL;
          return gen_split_192 (insn, operands);

        case 2:
          if (!(
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 5016 "../../gcc/config/aarch64/aarch64-simd.md"
( true)))
            return NULL;
          return gen_split_193 (insn, operands);

        default:
          return NULL;
        }

    case VEC_SELECT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != VEC_SELECT)
        return NULL;
      switch (pattern449 (x3))
        {
        case 0:
          if (!(
#line 7501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7503 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_236 (insn, operands);

        case 1:
          if (!(
#line 7501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7503 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_237 (insn, operands);

        case 2:
          if (!(
#line 7501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7503 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_238 (insn, operands);

        case 3:
          if (!(
#line 7501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])) && 
#line 7503 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
            return NULL;
          return gen_split_239 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (XVECLEN (x4, 0))
        {
        case 2:
          if (XINT (x4, 1) != 125)
            return NULL;
          x7 = XVECEXP (x4, 0, 1);
          switch (GET_CODE (x7))
            {
            case ASHIFT:
              x8 = XEXP (x7, 1);
              operands[3] = x8;
              switch (pattern799 (x3))
                {
                case 0:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1415 (insn, operands);

                case 1:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1416 (insn, operands);

                case 2:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1417 (insn, operands);

                case 3:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1418 (insn, operands);

                case 4:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1419 (insn, operands);

                case 5:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1420 (insn, operands);

                case 6:
                  if (!(
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4210 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_1421 (insn, operands);

                case 7:
                  if (!(
#line 4232 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4234 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[4]) || !CONSTANT_P (operands[5])))))
                    return NULL;
                  return gen_split_1422 (insn, operands);

                case 8:
                  if (!(
#line 4253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 4255 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[5]))))
                    return NULL;
                  return gen_split_1423 (insn, operands);

                default:
                  return NULL;
                }

            case ASHIFTRT:
              switch (pattern773 (x3))
                {
                case 0:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3010 (insn, operands);

                case 1:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3012 (insn, operands);

                case 2:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3014 (insn, operands);

                case 3:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3016 (insn, operands);

                default:
                  return NULL;
                }

            case LSHIFTRT:
              switch (pattern773 (x3))
                {
                case 0:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3011 (insn, operands);

                case 1:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3013 (insn, operands);

                case 2:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3015 (insn, operands);

                case 3:
                  if (!(
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1964 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
                    return NULL;
                  return gen_split_3017 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 3:
          if (XINT (x4, 1) != 306)
            return NULL;
          switch (pattern626 (x3))
            {
            case 0:
              if (!(
#line 10735 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10737 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2708 (insn, operands);

            case 1:
              if (!(
#line 10735 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10737 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2709 (insn, operands);

            case 2:
              if (!(
#line 10735 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10737 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2710 (insn, operands);

            case 3:
              if (!(
#line 10735 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10737 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
                return NULL;
              return gen_split_2711 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (pattern38 (x4, 
E_DImode) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return NULL;
      x6 = XEXP (x4, 0);
      x9 = XVECEXP (x6, 0, 0);
      operands[3] = x9;
      x10 = XVECEXP (x6, 0, 2);
      operands[2] = x10;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      switch (pattern19 ())
        {
        case 0:
          if (!(
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2696 (insn, operands);

        case 1:
          if (!(
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2699 (insn, operands);

        case 2:
          if (!(
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2702 (insn, operands);

        case 3:
          if (!(
#line 10716 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10718 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2705 (insn, operands);

        default:
          return NULL;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      switch (pattern20 (x3))
        {
        case 0:
          if (!(
#line 10823 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10828 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2720 (insn, operands);

        case 1:
          if (!(
#line 10862 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10867 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2723 (insn, operands);

        case 2:
          if (!(
#line 10903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10908 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2726 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_98 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2435 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2445 (insn, operands);
}

 rtx_insn *
split_102 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3439 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2514 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3439 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2524 (insn, operands);
}

 rtx_insn *
split_106 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3439 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2434 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3439 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2444 (insn, operands);
}

 rtx_insn *
split_112 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2473 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2483 (insn, operands);
}

 rtx_insn *
split_119 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2492 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2502 (insn, operands);
}

 rtx_insn *
split_126 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2511 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2521 (insn, operands);
}

 rtx_insn *
split_134 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern1324 (x1, 
GEU))
    {
    case 0:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2115 (insn, operands);

    case 1:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2125 (insn, operands);

    case 2:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2155 (insn, operands);

    case 3:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2135 (insn, operands);

    case 4:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2165 (insn, operands);

    case 5:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2185 (insn, operands);

    case 6:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2145 (insn, operands);

    case 7:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2175 (insn, operands);

    case 8:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2195 (insn, operands);

    case 9:
      if (!(
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8229 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2205 (insn, operands);

    case 10:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2215 (insn, operands);

    case 11:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2225 (insn, operands);

    case 12:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2255 (insn, operands);

    case 13:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2235 (insn, operands);

    case 14:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2265 (insn, operands);

    case 15:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2285 (insn, operands);

    case 16:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2245 (insn, operands);

    case 17:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2275 (insn, operands);

    case 18:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2295 (insn, operands);

    case 19:
      if (!(
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])) && 
#line 8263 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[4], operands[6]))))
        return NULL;
      return gen_split_2305 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_2 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V2DFmode))
    {
      switch (pattern924 (
E_V2DFmode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_140 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_141 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_142 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_143 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_144 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_145 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_146 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_147 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (memory_operand (operands[0], E_V2DFmode))
    {
      if (register_operand (operands[1], E_V2DFmode))
        {
          switch (pattern979 ())
            {
            case 0:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_204 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_205 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_206 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_207 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_208 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_209 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 6:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_210 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 7:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_211 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (peep2_current_count >= 3)
        {
          x2 = PATTERN (peep2_next_insn (2));
          if (pattern978 (x2, 
E_V2DFmode) == 0
              && 
#line 304 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, false, V2DFmode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_239 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (peep2_current_count < 3)
    return NULL;
  x2 = PATTERN (peep2_next_insn (2));
  if (pattern923 (x2, 
E_V2DFmode) != 0
      || !
#line 325 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, true, V2DFmode)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_243 (insn, operands);
}

 rtx_insn *
peephole2_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V4SFmode))
    {
      switch (pattern924 (
E_V4SFmode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_132 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_133 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_134 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_135 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_136 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_137 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_138 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_139 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V4SFmode)
      || !register_operand (operands[1], E_V4SFmode))
    return NULL;
  switch (pattern979 ())
    {
    case 0:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_196 (insn, operands);

    case 1:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_197 (insn, operands);

    case 2:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_198 (insn, operands);

    case 3:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_199 (insn, operands);

    case 4:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_200 (insn, operands);

    case 5:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_201 (insn, operands);

    case 6:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_202 (insn, operands);

    case 7:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_203 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_7 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V4SImode))
    {
      switch (pattern924 (
E_V4SImode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_108 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_109 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_110 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_111 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_112 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_113 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_114 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_115 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V4SImode)
      || !register_operand (operands[1], E_V4SImode))
    return NULL;
  switch (pattern979 ())
    {
    case 0:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_172 (insn, operands);

    case 1:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_173 (insn, operands);

    case 2:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_174 (insn, operands);

    case 3:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_175 (insn, operands);

    case 4:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_176 (insn, operands);

    case 5:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_177 (insn, operands);

    case 6:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_178 (insn, operands);

    case 7:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_179 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V2SImode))
    {
      switch (pattern921 (
E_V2SImode))
        {
        case 0:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_23 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_29 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_35 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_41 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_47 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_53 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (memory_operand (operands[0], E_V2SImode))
    {
      if (register_operand (operands[1], E_V2SImode))
        {
          switch (pattern976 ())
            {
            case 0:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_59 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_65 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_71 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_77 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_83 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_89 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (peep2_current_count >= 3)
        {
          x2 = PATTERN (peep2_next_insn (2));
          if (pattern978 (x2, 
E_V2SImode) == 0
              && 
#line 304 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, false, V2SImode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_236 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (peep2_current_count < 3)
    return NULL;
  x2 = PATTERN (peep2_next_insn (2));
  if (pattern923 (x2, 
E_V2SImode) != 0
      || !
#line 325 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, true, V2SImode)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_240 (insn, operands);
}
