/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern7 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern7 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V4HImode:
      if (pattern8 (x1, 
E_V4HFmode, 
E_V4HImode) != 0)
        return -1;
      return 6;

    case E_V8HImode:
      if (pattern8 (x1, 
E_V8HFmode, 
E_V8HImode) != 0)
        return -1;
      return 7;

    case E_V2SImode:
      if (pattern8 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      return 8;

    case E_V4SImode:
      if (pattern8 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 9;

    case E_V2DImode:
      if (pattern8 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 10;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HFmode
          || !register_operand (operands[1], E_HFmode))
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x3, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 3
          || XINT (x6, 1) != 306
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XVECEXP (x6, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XVECEXP (x6, 0, 0);
      operands[3] = x8;
      x9 = XVECEXP (x6, 0, 2);
      operands[2] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      return pattern19 (); /* [-1, 3] */

    case VEC_DUPLICATE:
      res = pattern20 (x3);
      if (res >= 0)
        return res + 4; /* [4, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern28 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern33 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_vsb_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  switch (GET_CODE (x3))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          return pattern30 (x1, 
E_SImode); /* [-1, 0] */

        case E_DImode:
          if (pattern30 (x1, 
E_DImode) != 0)
            return -1;
          return 1;

        case E_V8QImode:
          if (pattern31 (x1, 
E_V8QImode) != 0)
            return -1;
          return 2;

        case E_V16QImode:
          if (pattern31 (x1, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V4HImode:
          if (pattern31 (x1, 
E_V4HImode) != 0)
            return -1;
          return 4;

        case E_V8HImode:
          if (pattern31 (x1, 
E_V8HImode) != 0)
            return -1;
          return 5;

        case E_V2SImode:
          if (pattern31 (x1, 
E_V2SImode) != 0)
            return -1;
          return 6;

        case E_V4SImode:
          if (pattern31 (x1, 
E_V4SImode) != 0)
            return -1;
          return 7;

        case E_VNx32QImode:
          if (pattern32 (x1, 
E_VNx32QImode) != 0)
            return -1;
          return 8;

        case E_VNx16HImode:
          if (pattern32 (x1, 
E_VNx16HImode) != 0)
            return -1;
          return 9;

        case E_VNx8SImode:
          if (pattern32 (x1, 
E_VNx8SImode) != 0)
            return -1;
          return 10;

        case E_VNx4DImode:
          if (pattern32 (x1, 
E_VNx4DImode) != 0)
            return -1;
          return 11;

        case E_VNx64QImode:
          if (pattern32 (x1, 
E_VNx64QImode) != 0)
            return -1;
          return 12;

        case E_VNx32HImode:
          if (pattern32 (x1, 
E_VNx32HImode) != 0)
            return -1;
          return 13;

        case E_VNx16SImode:
          if (pattern32 (x1, 
E_VNx16SImode) != 0)
            return -1;
          return 14;

        case E_VNx8DImode:
          if (pattern32 (x1, 
E_VNx8DImode) != 0)
            return -1;
          return 15;

        default:
          return -1;
        }

    case CONST_VECTOR:
      operands[2] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern33 (x1, 
E_VNx16QImode) != 0)
            return -1;
          return 16;

        case E_VNx8QImode:
          if (pattern33 (x1, 
E_VNx8QImode) != 0)
            return -1;
          return 17;

        case E_VNx4QImode:
          if (pattern33 (x1, 
E_VNx4QImode) != 0)
            return -1;
          return 18;

        case E_VNx2QImode:
          if (pattern33 (x1, 
E_VNx2QImode) != 0)
            return -1;
          return 19;

        case E_VNx8HImode:
          if (pattern33 (x1, 
E_VNx8HImode) != 0)
            return -1;
          return 20;

        case E_VNx4HImode:
          if (pattern33 (x1, 
E_VNx4HImode) != 0)
            return -1;
          return 21;

        case E_VNx2HImode:
          if (pattern33 (x1, 
E_VNx2HImode) != 0)
            return -1;
          return 22;

        case E_VNx4SImode:
          if (pattern33 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 23;

        case E_VNx2SImode:
          if (pattern33 (x1, 
E_VNx2SImode) != 0)
            return -1;
          return 24;

        case E_VNx2DImode:
          if (pattern33 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 25;

        case E_V2DImode:
          if (pattern33 (x1, 
E_V2DImode) != 0)
            return -1;
          return 26;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      res = pattern35 (x1);
      if (res >= 0)
        return res + 27; /* [27, 34] */
      return -1;

    default:
      return -1;
    }
}

int
pattern74 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern80 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_shift_imm_si (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern87 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_V8QImode))
        return -1;
      return pattern86 (x2); /* [-1, 1] */

    case VEC_SELECT:
      if (GET_MODE (x5) != E_V8QImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_V16QImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      if (!vect_par_cnst_hi_half (operands[2], E_V16QImode))
        return -1;
      res = pattern86 (x2);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern68 (x3, 
E_VNx16QImode, 
E_VNx16BImode, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern68 (x3, 
E_VNx8HImode, 
E_VNx8BImode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern68 (x3, 
E_VNx4SImode, 
E_VNx4BImode, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern68 (x3, 
E_VNx2DImode, 
E_VNx2BImode, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  return pattern100 (x3); /* [-1, 2] */
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return pattern100 (x3); /* [-1, 2] */

    case UNSPEC:
      if (XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 167)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[2] = x6;
      x7 = XVECEXP (x5, 0, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern102 (x3, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
            return -1;
          return 3;

        case E_VNx2DImode:
          if (pattern102 (x3, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern116 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern55 (x3, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern55 (x3, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern55 (x3, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern125 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_tls_le_symref (operands[1], E_VOIDmode))
    return -1;
  return pattern42 (x3); /* [-1, 1] */
}

int
pattern131 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern134 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode))
            return -1;
          return 0;

        case E_VNx16QImode:
          if (!register_operand (operands[0], E_VNx16QImode)
              || GET_MODE (x3) != E_VNx16QImode
              || !register_operand (operands[1], E_VNx16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 1
          || XINT (x4, 1) != i1)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      if (GET_CODE (x5) != XOR)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern133 (x3, 
E_V16QImode) != 0)
            return -1;
          return 2;

        case E_VNx16QImode:
          if (pattern133 (x3, 
E_VNx16QImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern146 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_DImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!aarch64_simd_shift_imm_offset_di (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern157 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern165 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx4SFmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx4SFmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_VNx4SFmode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx8BFmode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_VNx8BFmode))
    return -1;
  return 0;
}

int
pattern174 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern173 (x3, 
E_VNx8HFmode); /* [-1, 2] */

    case E_VNx4SFmode:
      res = pattern173 (x3, 
E_VNx4SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x3) != E_VNx2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx8BImode:
          if (!register_operand (operands[1], E_VNx8BImode)
              || !register_operand (operands[2], E_VNx8HImode))
            return -1;
          return 6;

        case E_VNx4BImode:
          if (!register_operand (operands[1], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SImode))
            return -1;
          return 7;

        case E_VNx2BImode:
          if (!register_operand (operands[1], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[2], E_VNx2DImode))
                return -1;
              return 8;

            case E_VNx4SImode:
              if (!register_operand (operands[2], E_VNx4SImode))
                return -1;
              return 9;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern188 (x3, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern188 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern188 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern201 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern200 (x3, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern200 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern200 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern208 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      return pattern203 (x3); /* [-1, 3] */

    case UNSPEC:
      if (XVECLEN (x6, 0) != 3
          || XINT (x6, 1) != 350)
        return -1;
      x7 = XVECEXP (x6, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x8 = XVECEXP (x3, 0, 3);
      if (GET_CODE (x8) != UNSPEC
          || XVECLEN (x8, 0) != 3
          || XINT (x8, 1) != 350)
        return -1;
      x9 = XVECEXP (x8, 0, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      res = pattern207 (x3);
      if (res >= 0)
        return res + 4; /* [4, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern224 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[5] = x5;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  x8 = XVECEXP (x3, 0, 4);
  operands[4] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BFmode:
      return pattern223 (x3, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx8HFmode:
      if (pattern223 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4SFmode:
      if (pattern223 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2DFmode:
      if (pattern223 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern233 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 4);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern237 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx32QImode:
      if (!aligned_register_operand (operands[1], E_VNx32QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx64QImode:
      if (!aligned_register_operand (operands[1], E_VNx64QImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx64QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 1;

    case E_VNx16HImode:
      if (!aligned_register_operand (operands[1], E_VNx16HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx16HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 2;

    case E_VNx32HImode:
      if (!aligned_register_operand (operands[1], E_VNx32HImode))
        return -1;
      x3 = XVECEXP (x1, 0, 4);
      if (GET_MODE (x3) != E_VNx32HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern244 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x5) != UNSPEC
      || XVECLEN (x5, 0) != 2
      || XINT (x5, 1) != 167)
    return -1;
  x6 = XEXP (x1, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 93)
    return -1;
  x7 = XVECEXP (x5, 0, 1);
  if (!const_int_operand (x7, E_SImode))
    return -1;
  x8 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[1] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[2] = x10;
      operands[3] = x7;
      switch (GET_MODE (x6))
        {
        case E_VNx4SImode:
          return pattern237 (x2, 
E_VNx4SImode); /* [-1, 3] */

        case E_VNx2DImode:
          res = pattern237 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 4; /* [4, 7] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x11 = XEXP (x8, 0);
      operands[0] = x11;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x12 = XEXP (x8, 1);
      operands[1] = x12;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x9 = XVECEXP (x2, 0, 3);
      operands[2] = x9;
      x10 = XVECEXP (x5, 0, 0);
      operands[3] = x10;
      operands[4] = x7;
      switch (GET_MODE (x6))
        {
        case E_VNx4SImode:
          res = pattern241 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        case E_VNx2DImode:
          res = pattern241 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 12; /* [12, 15] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern258 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  switch (GET_MODE (x5))
    {
    case E_VNx4SImode:
      if (GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4BImode)
          || !register_operand (operands[2], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_VNx16QImode:
          if (!register_operand (operands[3], E_VNx16QImode)
              || !register_operand (operands[4], E_VNx16QImode))
            return -1;
          return 0;

        case E_VNx8HImode:
          if (!register_operand (operands[3], E_VNx8HImode)
              || !register_operand (operands[4], E_VNx8HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_VNx2DImode:
      if (pattern257 (x2, 
E_VNx8HImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern273 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], E_VNx2BImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_VNx2DImode:
      return 0;

    case E_VNx1TImode:
      return 1;

    default:
      return -1;
    }
}

int
pattern276 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 3);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[3] = x8;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  x9 = XVECEXP (x2, 0, 5);
  switch (GET_CODE (x9))
    {
    case REG:
    case SUBREG:
      operands[4] = x9;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (!register_operand (operands[0], E_VNx16QImode)
              || GET_MODE (x2) != E_VNx16QImode
              || !register_operand (operands[1], E_VNx16QImode))
            return -1;
          switch (GET_MODE (x3))
            {
            case E_VNx16QImode:
              if (!register_operand (operands[2], E_VNx16BImode))
                return -1;
              return 0;

            case E_VNx1TImode:
              if (!register_operand (operands[2], E_VNx2BImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_VNx8HImode:
          res = pattern271 (x2, 
E_VNx8HImode);
          if (res >= 0)
            return res + 2; /* [2, 3] */
          return -1;

        case E_VNx4SImode:
          res = pattern272 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 4; /* [4, 5] */
          return -1;

        case E_VNx2DImode:
          res = pattern273 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 6; /* [6, 7] */
          return -1;

        case E_VNx8BFmode:
          res = pattern271 (x2, 
E_VNx8BFmode);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case E_VNx8HFmode:
          res = pattern271 (x2, 
E_VNx8HFmode);
          if (res >= 0)
            return res + 10; /* [10, 11] */
          return -1;

        case E_VNx4SFmode:
          res = pattern272 (x2, 
E_VNx4SFmode);
          if (res >= 0)
            return res + 12; /* [12, 13] */
          return -1;

        case E_VNx2DFmode:
          res = pattern273 (x2, 
E_VNx2DFmode);
          if (res >= 0)
            return res + 14; /* [14, 15] */
          return -1;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      operands[4] = x10;
      if (!register_operand (operands[4], E_SImode))
        return -1;
      x11 = XEXP (x9, 1);
      operands[5] = x11;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern274 (x2, 
E_VNx16BImode, 
E_VNx16QImode) != 0)
            return -1;
          return 16;

        case E_VNx8HImode:
          if (pattern274 (x2, 
E_VNx8BImode, 
E_VNx8HImode) != 0)
            return -1;
          return 17;

        case E_VNx4SImode:
          if (pattern274 (x2, 
E_VNx4BImode, 
E_VNx4SImode) != 0)
            return -1;
          return 18;

        case E_VNx2DImode:
          if (pattern274 (x2, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
            return -1;
          return 19;

        case E_VNx8BFmode:
          if (pattern275 (x2, 
E_VNx8BImode, 
E_VNx8BFmode, 
E_VNx8HImode) != 0)
            return -1;
          return 20;

        case E_VNx8HFmode:
          if (pattern275 (x2, 
E_VNx8BImode, 
E_VNx8HFmode, 
E_VNx8HImode) != 0)
            return -1;
          return 21;

        case E_VNx4SFmode:
          if (pattern275 (x2, 
E_VNx4BImode, 
E_VNx4SFmode, 
E_VNx4SImode) != 0)
            return -1;
          return 22;

        case E_VNx2DFmode:
          if (pattern275 (x2, 
E_VNx2BImode, 
E_VNx2DFmode, 
E_VNx2DImode) != 0)
            return -1;
          return 23;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern311 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[2] = x4;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern309 (x1, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern309 (x1, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern309 (x1, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        case E_VNx2DImode:
          if (pattern309 (x1, 
E_VNx2DImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x1, 1);
      if (GET_CODE (x5) != VEC_DUPLICATE)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx32QImode:
          if (pattern310 (x1, 
E_VNx16QImode, 
E_VNx32QImode) != 0)
            return -1;
          return 4;

        case E_VNx16HImode:
          if (pattern310 (x1, 
E_VNx8HImode, 
E_VNx16HImode) != 0)
            return -1;
          return 5;

        case E_VNx8SImode:
          if (pattern310 (x1, 
E_VNx4SImode, 
E_VNx8SImode) != 0)
            return -1;
          return 6;

        case E_VNx4DImode:
          if (pattern310 (x1, 
E_VNx2DImode, 
E_VNx4DImode) != 0)
            return -1;
          return 7;

        case E_VNx64QImode:
          if (pattern310 (x1, 
E_VNx16QImode, 
E_VNx64QImode) != 0)
            return -1;
          return 8;

        case E_VNx32HImode:
          if (pattern310 (x1, 
E_VNx8HImode, 
E_VNx32HImode) != 0)
            return -1;
          return 9;

        case E_VNx16SImode:
          if (pattern310 (x1, 
E_VNx4SImode, 
E_VNx16SImode) != 0)
            return -1;
          return 10;

        case E_VNx8DImode:
          if (pattern310 (x1, 
E_VNx2DImode, 
E_VNx8DImode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern330 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode
          || GET_MODE (x3) != E_VNx2DImode
          || GET_MODE (x5) != E_SImode)
        return -1;
      return pattern327 (x5); /* [-1, 1] */

    case UNSPEC:
      if (XVECLEN (x4, 0) != 3
          || !register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode
          || GET_MODE (x3) != E_VNx4SImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      res = pattern328 (x4);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    case SUBREG:
    case TRUNCATE:
      if (!subreg_lowpart_operator (x4, E_HImode))
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 3
          || !register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode
          || GET_MODE (x3) != E_VNx8HImode
          || GET_MODE (x5) != E_SImode)
        return -1;
      res = pattern329 (x4);
      if (res >= 0)
        return res + 4; /* [4, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern347 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 31)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  return pattern346 (x1); /* [-1, 3] */
}

int
pattern355 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 31)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 66
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XVECEXP (x1, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x9, 1);
  operands[2] = x11;
  x12 = XVECEXP (x3, 0, 2);
  operands[3] = x12;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x13 = XEXP (x6, 0);
  operands[4] = x13;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return pattern354 (x1); /* [-1, 3] */
}

int
pattern363 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern362 (x1, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern362 (x1, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern368 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || !register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || !register_operand (operands[3], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern376 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 0);
      if (!rtx_equal_p (x7, operands[1]))
        return -1;
      x8 = XEXP (x3, 1);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern374 (x1, 
E_V8QImode, 
E_V8HImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern374 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
            return -1;
          return 1;

        case E_V2DImode:
          if (pattern374 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x7 = XEXP (x3, 0);
      if (GET_CODE (x7) != VEC_SELECT)
        return -1;
      x8 = XEXP (x3, 1);
      if (GET_CODE (x8) != VEC_SELECT)
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      x10 = XEXP (x5, 1);
      operands[3] = x10;
      x11 = XEXP (x6, 0);
      operands[2] = x11;
      x12 = XEXP (x6, 1);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      x13 = XEXP (x7, 0);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      x14 = XEXP (x7, 1);
      if (!rtx_equal_p (x14, operands[3]))
        return -1;
      x15 = XEXP (x8, 0);
      if (!rtx_equal_p (x15, operands[2]))
        return -1;
      x16 = XEXP (x8, 1);
      if (!rtx_equal_p (x16, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern375 (x1, 
E_V8QImode, 
E_V16QImode, 
E_V8HImode) != 0)
            return -1;
          return 3;

        case E_V4SImode:
          if (pattern375 (x1, 
E_V4HImode, 
E_V8HImode, 
E_V4SImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern375 (x1, 
E_V2SImode, 
E_V4SImode, 
E_V2DImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern394 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern397 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  if (!register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern401 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_reg_or_zero (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern405 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_reg_or_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_reg_or_shift_imm_di (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern409 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern414 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern413 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern413 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern413 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern420 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i2)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern426 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_V8QImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V8QImode))
    return -1;
  return 0;
}

int
pattern432 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[1] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x5, 1);
  operands[4] = x8;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || pattern429 (x3, 
E_V8HImode, 
E_V8SImode) != 0)
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || pattern430 (x3, 
E_V4SImode, 
E_V4DImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || pattern431 (x3, 
E_V2DImode, 
E_V2TImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern443 (rtx x1, unsigned int i1, machine_mode i2, rtx_code i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != i2)
    return -1;
  return 0;
}

int
pattern447 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x1, 1);
  switch (GET_CODE (x6))
    {
    case ZERO_EXTEND:
      x7 = XEXP (x2, 1);
      operands[3] = x7;
      x8 = XEXP (x6, 0);
      operands[4] = x8;
      if (!register_operand (operands[4], E_VOIDmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !aarch64_shift_imm_si (operands[2], E_QImode)
              || !const_int_operand (operands[3], E_SImode)
              || GET_MODE (x6) != E_SImode)
            return -1;
          return 0;

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !aarch64_shift_imm_di (operands[2], E_QImode)
              || !const_int_operand (operands[3], E_DImode)
              || GET_MODE (x6) != E_DImode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case AND:
      x7 = XEXP (x2, 1);
      operands[4] = x7;
      x9 = XEXP (x6, 1);
      operands[3] = x9;
      x8 = XEXP (x6, 0);
      if (!rtx_equal_p (x8, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x1) != E_SImode
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || !register_operand (operands[1], E_SImode)
              || !aarch64_shift_imm_si (operands[2], E_QImode)
              || !const_int_operand (operands[4], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !const_int_operand (operands[3], E_SImode))
            return -1;
          return 2;

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x1) != E_DImode
              || GET_MODE (x2) != E_DImode
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !aarch64_shift_imm_di (operands[2], E_QImode)
              || !const_int_operand (operands[4], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !const_int_operand (operands[3], E_DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern472 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern471 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern471 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern471 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern471 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern471 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern471 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern471 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern471 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern471 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern471 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern487 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  x5 = XEXP (x1, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern486 (x1, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern486 (x1, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern486 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern486 (x1, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern486 (x1, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern496 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[3], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern503 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  x8 = XEXP (x2, 1);
  operands[3] = x8;
  x9 = XEXP (x3, 0);
  if (!rtx_equal_p (x9, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern502 (x1, 
E_V8HImode, 
E_V4HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern502 (x1, 
E_V16HImode, 
E_V8HImode, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V2SImode:
      if (pattern502 (x1, 
E_V4SImode, 
E_V2SImode, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern502 (x1, 
E_V8SImode, 
E_V4SImode, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2DImode:
      if (pattern502 (x1, 
E_V4DImode, 
E_V2DImode, 
E_V4SImode) != 0)
        return -1;
      return 4;

    case E_DImode:
      if (pattern502 (x1, 
E_V2DImode, 
E_DImode, 
E_V2SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern518 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern524 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern528 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x1) != E_V16QImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !aarch64_simd_or_scalar_imm_zero (operands[3], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode)
        return -1;
      x3 = XEXP (x2, 0);
      if (GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern553 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  x9 = XEXP (x5, 1);
  operands[3] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern552 (x5, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern552 (x5, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern564 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (XVECLEN (x3, 0))
    {
    case 1:
      if (XINT (x3, 1) != 27
          || GET_MODE (x3) != E_CCmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 66
          || GET_MODE (x5) != E_CCmode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != UNSPEC_VOLATILE
          || XVECLEN (x8, 0) != 5
          || XINT (x8, 1) != 27)
        return -1;
      x9 = XEXP (x6, 0);
      operands[0] = x9;
      x10 = XVECEXP (x8, 0, 0);
      operands[2] = x10;
      x11 = XVECEXP (x8, 0, 1);
      operands[3] = x11;
      x12 = XVECEXP (x8, 0, 2);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x13 = XVECEXP (x8, 0, 3);
      operands[5] = x13;
      if (!const_int_operand (operands[5], E_SImode))
        return -1;
      x14 = XVECEXP (x8, 0, 4);
      operands[6] = x14;
      if (!const_int_operand (operands[6], E_SImode))
        return -1;
      x15 = XVECEXP (x1, 0, 3);
      x16 = XEXP (x15, 0);
      operands[7] = x16;
      return pattern558 (x1); /* [-1, 4] */

    case 2:
      if (XINT (x3, 1) != 31)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x9 = XEXP (x6, 0);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 66
          || GET_MODE (x9) != E_CCmode)
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x17 = XVECEXP (x3, 0, 1);
      operands[2] = x17;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x18 = XEXP (x7, 0);
      operands[3] = x18;
      x15 = XVECEXP (x1, 0, 3);
      x16 = XEXP (x15, 0);
      operands[4] = x16;
      x4 = XVECEXP (x3, 0, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          res = pattern560 (x3);
          if (res >= 0)
            return res + 5; /* [5, 8] */
          return -1;

        case MINUS:
          res = pattern560 (x3);
          if (res >= 0)
            return res + 9; /* [9, 12] */
          return -1;

        case IOR:
          res = pattern562 (x3);
          if (res >= 0)
            return res + 13; /* [13, 16] */
          return -1;

        case XOR:
          res = pattern562 (x3);
          if (res >= 0)
            return res + 17; /* [17, 20] */
          return -1;

        case AND:
          res = pattern562 (x3);
          if (res >= 0)
            return res + 21; /* [21, 24] */
          return -1;

        case NOT:
          x19 = XEXP (x4, 0);
          if (GET_CODE (x19) != AND)
            return -1;
          x20 = XEXP (x19, 1);
          operands[1] = x20;
          x21 = XEXP (x19, 0);
          if (!rtx_equal_p (x21, operands[0]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern563 (x3, 
E_QImode) != 0)
                return -1;
              return 25;

            case E_HImode:
              if (pattern563 (x3, 
E_HImode) != 0)
                return -1;
              return 26;

            case E_SImode:
              if (pattern563 (x3, 
E_SImode) != 0)
                return -1;
              return 27;

            case E_DImode:
              if (pattern563 (x3, 
E_DImode) != 0)
                return -1;
              return 28;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern605 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_HImode:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8QImode))
            return -1;
          return 0;

        case E_V16HImode:
          if (!register_operand (operands[1], E_V16QImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case E_SImode:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        case E_V8SImode:
          if (!register_operand (operands[1], E_V8HImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case E_DImode:
      x3 = XVECEXP (x2, 0, 0);
      switch (GET_MODE (x3))
        {
        case E_V4DImode:
          if (!register_operand (operands[1], E_V4SImode))
            return -1;
          return 4;

        case E_V2DImode:
          if (!register_operand (operands[1], E_V2SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern620 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x1, 1);
  operands[1] = x7;
  x8 = XEXP (x4, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          return pattern619 (x1, 
E_V4SImode, 
E_HImode, 
E_SImode, 
E_V4HImode); /* [-1, 0] */

        case E_V2DImode:
          if (pattern619 (x1, 
E_V2DImode, 
E_SImode, 
E_DImode, 
E_V2SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_SELECT:
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != PARALLEL
          || XVECLEN (x9, 0) != 1)
        return -1;
      x10 = XEXP (x8, 0);
      operands[3] = x10;
      x11 = XVECEXP (x9, 0, 0);
      operands[4] = x11;
      if (!immediate_operand (operands[4], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x5) != E_V4SImode
              || !register_operand (operands[2], E_V4HImode)
              || GET_MODE (x3) != E_V4SImode
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x8) != E_HImode
              || !register_operand (operands[1], E_V4SImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V4HImode:
              if (!register_operand (operands[3], E_V4HImode))
                return -1;
              return 2;

            case E_V8HImode:
              if (!register_operand (operands[3], E_V8HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || GET_MODE (x2) != E_V2DImode
              || GET_MODE (x5) != E_V2DImode
              || !register_operand (operands[2], E_V2SImode)
              || GET_MODE (x3) != E_V2DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x8) != E_SImode
              || !register_operand (operands[1], E_V2DImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_V2SImode:
              if (!register_operand (operands[3], E_V2SImode))
                return -1;
              return 4;

            case E_V4SImode:
              if (!register_operand (operands[3], E_V4SImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern650 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern658 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  return 0;
}

int
pattern663 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[2] = x3;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          return pattern658 (x1, 
E_V4HImode, 
E_V8HImode); /* [-1, 0] */

        case E_V4SImode:
          if (pattern658 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x4 = XEXP (x1, 1);
      operands[3] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern662 (x1, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
            return -1;
          return 2;

        case E_V4SImode:
          if (pattern662 (x1, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != PARALLEL
          || XVECLEN (x6, 0) != 1)
        return -1;
      x5 = XEXP (x3, 0);
      operands[2] = x5;
      x7 = XVECEXP (x6, 0, 0);
      operands[3] = x7;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x4 = XEXP (x1, 1);
      operands[4] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x1) != E_V8HImode
              || GET_MODE (x2) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || GET_MODE (x3) != E_HImode
              || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V4HImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V4HImode:
              if (!register_operand (operands[2], E_V4HImode))
                return -1;
              return 4;

            case E_V8HImode:
              if (!register_operand (operands[2], E_V8HImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || GET_MODE (x2) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || GET_MODE (x3) != E_SImode
              || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V2SImode))
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V2SImode:
              if (!register_operand (operands[2], E_V2SImode))
                return -1;
              return 6;

            case E_V4SImode:
              if (!register_operand (operands[2], E_V4SImode))
                return -1;
              return 7;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern690 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 14
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 15
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 16
      || GET_MODE (x7) != E_DImode)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != 17
      || GET_MODE (x9) != E_DImode)
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 18
      || GET_MODE (x11) != E_DImode)
    return -1;
  x12 = XVECEXP (x1, 0, 7);
  if (GET_CODE (x12) != CLOBBER)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_CODE (x13) != REG
      || REGNO (x13) != 30
      || GET_MODE (x13) != E_DImode)
    return -1;
  x14 = XVECEXP (x1, 0, 8);
  return pattern689 (x14, 
E_CCmode, 
66); /* [-1, 0] */
}

int
pattern703 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  x5 = XVECEXP (x1, 0, 2);
  operands[4] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      return pattern699 (x1, 
E_VNx4SImode, 
E_VNx4BImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern699 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern705 (rtx x1, int i1, int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != i2
      || XINT (x3, 1) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern366 (x4, 
66, 
CLOBBER, 
E_CCmode); /* [-1, 0] */
}

int
pattern711 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_mem_pair_lanes_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_stp_reg_operand (operands[1], i1)
      || !aarch64_stp_reg_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern714 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], E_VNx8BImode)
      || !aarch64_sve_ld1ro_operand_h (operands[1], E_OImode))
    return -1;
  return 0;
}

int
pattern716 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], E_VNx2BImode)
      || !aarch64_sve_ld1ro_operand_d (operands[1], E_OImode))
    return -1;
  return 0;
}

int
pattern722 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (!register_operand (x2, i2))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern727 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (!register_operand (x3, E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      operands[2] = x3;
      return 0;

    case ASHIFT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 1;

    case ASHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 2;

    case LSHIFTRT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 3;

    case ROTATERT:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 4;

    case ROTATE:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      if (!aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      operands[3] = x3;
      return 5;

    default:
      return -1;
    }
}

int
pattern754 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern751 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern751 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern751 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern751 (x1, 
E_DImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern762 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern770 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_CC_Zmode)
    return -1;
  x6 = XVECEXP (x5, 0, 0);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 66
      || GET_MODE (x7) != E_CC_Zmode
      || !register_operand (operands[0], E_DImode))
    return -1;
  return 0;
}

int
pattern779 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[1] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern778 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern778 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern778 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern778 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern793 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern801 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_reg_or_zero (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_borrow_operation (operands[3], i1))
    return -1;
  return 0;
}

int
pattern808 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern814 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern820 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern826 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  x7 = XEXP (x5, 1);
  operands[3] = x7;
  x8 = XEXP (x4, 1);
  operands[4] = x8;
  x9 = XEXP (x3, 1);
  operands[5] = x9;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern825 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern825 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern825 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern839 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern838 (x1, 
E_VNx8HFmode); /* [-1, 2] */

    case E_VNx4SFmode:
      res = pattern838 (x1, 
E_VNx4SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DFmode:
      res = pattern838 (x1, 
E_VNx2DFmode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern849 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC)
    return -1;
  switch (XVECLEN (x3, 0))
    {
    case 2:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[3] = x5;
      switch (XINT (x3, 1))
        {
        case 414:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              return pattern843 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

            case E_VNx8QImode:
              if (pattern843 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              return 1;

            case E_VNx4QImode:
              if (pattern843 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              return 2;

            case E_VNx2QImode:
              if (pattern843 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              return 3;

            case E_VNx8HImode:
              if (pattern843 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 4;

            case E_VNx4HImode:
              if (pattern843 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              return 5;

            case E_VNx2HImode:
              if (pattern843 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              return 6;

            case E_VNx4SImode:
              if (pattern843 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 7;

            case E_VNx2SImode:
              if (pattern843 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              return 8;

            case E_VNx2DImode:
              if (pattern843 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 9;

            default:
              return -1;
            }

        case 225:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern844 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 10;

            case E_VNx8QImode:
              if (pattern844 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              return 11;

            case E_VNx4QImode:
              if (pattern844 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              return 12;

            case E_VNx2QImode:
              if (pattern844 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              return 13;

            case E_VNx8HImode:
              if (pattern844 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 14;

            case E_VNx4HImode:
              if (pattern844 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              return 15;

            case E_VNx2HImode:
              if (pattern844 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              return 16;

            case E_VNx4SImode:
              if (pattern844 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 17;

            case E_VNx2SImode:
              if (pattern844 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              return 18;

            case E_VNx2DImode:
              if (pattern844 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 19;

            default:
              return -1;
            }

        case 223:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern843 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 20;

            case E_VNx8QImode:
              if (pattern843 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              return 21;

            case E_VNx4QImode:
              if (pattern843 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              return 22;

            case E_VNx2QImode:
              if (pattern843 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              return 23;

            case E_VNx8HImode:
              if (pattern843 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 24;

            case E_VNx4HImode:
              if (pattern843 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              return 25;

            case E_VNx2HImode:
              if (pattern843 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              return 26;

            case E_VNx4SImode:
              if (pattern843 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 27;

            case E_VNx2SImode:
              if (pattern843 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              return 28;

            case E_VNx2DImode:
              if (pattern843 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 29;

            default:
              return -1;
            }

        case 224:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern843 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 30;

            case E_VNx8QImode:
              if (pattern843 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
                return -1;
              return 31;

            case E_VNx4QImode:
              if (pattern843 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
                return -1;
              return 32;

            case E_VNx2QImode:
              if (pattern843 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
                return -1;
              return 33;

            case E_VNx8HImode:
              if (pattern843 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 34;

            case E_VNx4HImode:
              if (pattern843 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
                return -1;
              return 35;

            case E_VNx2HImode:
              if (pattern843 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
                return -1;
              return 36;

            case E_VNx4SImode:
              if (pattern843 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 37;

            case E_VNx2SImode:
              if (pattern843 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
                return -1;
              return 38;

            case E_VNx2DImode:
              if (pattern843 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 39;

            default:
              return -1;
            }

        case 209:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern845 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 40;

            case E_VNx8HImode:
              if (pattern845 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 41;

            case E_VNx4SImode:
              if (pattern845 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 42;

            case E_VNx2DImode:
              if (pattern845 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 43;

            default:
              return -1;
            }

        case 213:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern845 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 44;

            case E_VNx8HImode:
              if (pattern845 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 45;

            case E_VNx4SImode:
              if (pattern845 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 46;

            case E_VNx2DImode:
              if (pattern845 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 47;

            default:
              return -1;
            }

        case 232:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern845 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 48;

            case E_VNx8HImode:
              if (pattern845 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 49;

            case E_VNx4SImode:
              if (pattern845 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 50;

            case E_VNx2DImode:
              if (pattern845 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 51;

            default:
              return -1;
            }

        case 211:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern845 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 52;

            case E_VNx8HImode:
              if (pattern845 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 53;

            case E_VNx4SImode:
              if (pattern845 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 54;

            case E_VNx2DImode:
              if (pattern845 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 55;

            default:
              return -1;
            }

        case 230:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern845 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 56;

            case E_VNx8HImode:
              if (pattern845 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 57;

            case E_VNx4SImode:
              if (pattern845 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 58;

            case E_VNx2DImode:
              if (pattern845 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 59;

            default:
              return -1;
            }

        case 220:
          res = pattern847 (x1);
          if (res >= 0)
            return res + 60; /* [60, 67] */
          return -1;

        case 210:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern845 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 68;

            case E_VNx8HImode:
              if (pattern845 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 69;

            case E_VNx4SImode:
              if (pattern845 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 70;

            case E_VNx2DImode:
              if (pattern845 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 71;

            default:
              return -1;
            }

        case 214:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern845 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 72;

            case E_VNx8HImode:
              if (pattern845 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 73;

            case E_VNx4SImode:
              if (pattern845 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 74;

            case E_VNx2DImode:
              if (pattern845 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 75;

            default:
              return -1;
            }

        case 233:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern845 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 76;

            case E_VNx8HImode:
              if (pattern845 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 77;

            case E_VNx4SImode:
              if (pattern845 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 78;

            case E_VNx2DImode:
              if (pattern845 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 79;

            default:
              return -1;
            }

        case 212:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern845 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 80;

            case E_VNx8HImode:
              if (pattern845 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 81;

            case E_VNx4SImode:
              if (pattern845 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 82;

            case E_VNx2DImode:
              if (pattern845 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 83;

            default:
              return -1;
            }

        case 231:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern845 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 84;

            case E_VNx8HImode:
              if (pattern845 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 85;

            case E_VNx4SImode:
              if (pattern845 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 86;

            case E_VNx2DImode:
              if (pattern845 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 87;

            default:
              return -1;
            }

        case 219:
          res = pattern847 (x1);
          if (res >= 0)
            return res + 88; /* [88, 95] */
          return -1;

        case 226:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern848 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 96;

            case E_VNx8HImode:
              if (pattern848 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 97;

            case E_VNx4SImode:
              if (pattern848 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 98;

            case E_VNx2DImode:
              if (pattern848 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 99;

            default:
              return -1;
            }

        case 227:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern848 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
                return -1;
              return 100;

            case E_VNx8HImode:
              if (pattern848 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
                return -1;
              return 101;

            case E_VNx4SImode:
              if (pattern848 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
                return -1;
              return 102;

            case E_VNx2DImode:
              if (pattern848 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
                return -1;
              return 103;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4BImode)
          || GET_MODE (x2) != E_VNx4SImode)
        return -1;
      x6 = XVECEXP (x2, 0, 0);
      operands[4] = x6;
      if (GET_MODE (x3) != E_VNx4SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx4SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 2);
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode))
        return -1;
      switch (XINT (x3, 1))
        {
        case 26:
          return 104;

        case 111:
          return 105;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1042 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_reg_zero_or_m1_or_1 (operands[3], i1)
      || !aarch64_reg_zero_or_m1_or_1 (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1046 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XWINT (x3, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          return pattern1030 (x1, 
E_VNx8BFmode, 
E_VNx8BImode); /* [-1, 0] */

        case E_VNx8HFmode:
          if (pattern1030 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SFmode:
          if (pattern1030 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        case E_VNx2DFmode:
          if (pattern1030 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 3;

        default:
          return -1;
        }

    case 1L:
      x4 = XVECEXP (x2, 0, 0);
      if (!rtx_equal_p (x4, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BFmode:
          if (pattern1030 (x1, 
E_VNx8BFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx8HFmode:
          if (pattern1030 (x1, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return -1;
          return 5;

        case E_VNx4SFmode:
          if (pattern1030 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return -1;
          return 6;

        case E_VNx2DFmode:
          if (pattern1030 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1072 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1076 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1086 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  if (XVECLEN (x4, 0) != 3)
    return -1;
  switch (XINT (x4, 1))
    {
    case 140:
      return pattern1084 (x1, 
140); /* [-1, 7] */

    case 141:
      res = pattern1084 (x1, 
141);
      if (res >= 0)
        return res + 8; /* [8, 15] */
      return -1;

    case 142:
      res = pattern1084 (x1, 
142);
      if (res >= 0)
        return res + 16; /* [16, 23] */
      return -1;

    case 143:
      res = pattern1084 (x1, 
143);
      if (res >= 0)
        return res + 24; /* [24, 31] */
      return -1;

    case 136:
      res = pattern1084 (x1, 
136);
      if (res >= 0)
        return res + 32; /* [32, 39] */
      return -1;

    case 137:
      res = pattern1084 (x1, 
137);
      if (res >= 0)
        return res + 40; /* [40, 47] */
      return -1;

    case 138:
      res = pattern1084 (x1, 
138);
      if (res >= 0)
        return res + 48; /* [48, 55] */
      return -1;

    case 139:
      res = pattern1084 (x1, 
139);
      if (res >= 0)
        return res + 56; /* [56, 63] */
      return -1;

    case 144:
      res = pattern1084 (x1, 
144);
      if (res >= 0)
        return res + 64; /* [64, 71] */
      return -1;

    case 145:
      res = pattern1084 (x1, 
145);
      if (res >= 0)
        return res + 72; /* [72, 79] */
      return -1;

    case 301:
      if (GET_MODE (x4) != E_VNx16BImode)
        return -1;
      x5 = XVECEXP (x3, 0, 0);
      operands[4] = x5;
      x6 = XVECEXP (x3, 0, 1);
      operands[5] = x6;
      x7 = XVECEXP (x4, 0, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_VNx16BImode))
        return -1;
      x8 = XVECEXP (x4, 0, 1);
      operands[2] = x8;
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      x9 = XVECEXP (x4, 0, 2);
      operands[3] = x9;
      if (!register_operand (operands[3], E_VNx16BImode))
        return -1;
      x10 = XVECEXP (x1, 0, 1);
      res = pattern1085 (x10, 
301);
      if (res >= 0)
        return res + 80; /* [80, 81] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1109 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern836 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 2] */

    case E_VNx4SImode:
      res = pattern836 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DImode:
      res = pattern836 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (XVECLEN (x1, 0) != 2
      || XINT (x1, 1) != 125
      || GET_MODE (x1) != E_VNx2DImode
      || !register_operand (operands[5], E_VNx2BImode))
    return -1;
  return 0;
}

int
pattern1125 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_even_or_odd_half (operands[3], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !vect_par_cnst_even_or_odd_half (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1133 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern1140 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i5
      || !register_operand (operands[1], i4)
      || !vect_par_cnst_hi_half (operands[3], i4))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i3)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1154 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], i1)
      || !aarch64_reg_or_fp_zero (operands[1], i1)
      || !memory_operand (operands[2], i1)
      || !aarch64_reg_or_fp_zero (operands[3], i1))
    return -1;
  operands[5] = x1;
  if (!aarch64_reg_or_fp_zero (operands[5], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!memory_operand (operands[6], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[7] = x4;
  if (!aarch64_reg_or_fp_zero (operands[7], i1))
    return -1;
  return 0;
}

int
pattern1164 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i2)
      || !aarch64_int_rnd_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1175 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != MINUS)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  x10 = XEXP (x8, 1);
  operands[3] = x10;
  x11 = XEXP (x3, 0);
  if (!rtx_equal_p (x11, operands[1]))
    return -1;
  x12 = XEXP (x4, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XEXP (x4, 1);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  return pattern1174 (x1); /* [-1, 1] */
}

int
pattern1180 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !aarch64_reg_or_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1185 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !aarch64_sync_memory_operand (operands[1], i1)
      || !aarch64_logical_operand (operands[2], i1))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern1195 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i1))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

int
pattern1200 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4, machine_mode i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i5
      || !register_operand (operands[2], i4)
      || !vect_par_cnst_hi_half (operands[4], i4))
    return -1;
  x6 = XEXP (x3, 1);
  return pattern1169 (x6, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1215 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1222 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1229 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i4)
      || GET_MODE (x1) != i4
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_int_rnd_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1237 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  x5 = XVECEXP (x4, 0, 2);
  operands[6] = x5;
  x6 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x6))
    {
    case SET:
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 3
          || XINT (x7, 1) != i1)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      x9 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x9, operands[4]))
        return -1;
      x10 = XVECEXP (x7, 0, 1);
      if (!rtx_equal_p (x10, operands[5]))
        return -1;
      x11 = XVECEXP (x7, 0, 2);
      if (!rtx_equal_p (x11, operands[6]))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (!register_operand (operands[6], E_VNx16BImode)
              || !register_operand (operands[0], E_VNx16BImode)
              || GET_MODE (x7) != E_VNx16BImode)
            return -1;
          return 0;

        case E_VNx8BImode:
          if (!register_operand (operands[6], E_VNx8BImode)
              || !register_operand (operands[0], E_VNx8BImode)
              || GET_MODE (x7) != E_VNx8BImode)
            return -1;
          return 1;

        case E_VNx4BImode:
          if (!register_operand (operands[6], E_VNx4BImode)
              || !register_operand (operands[0], E_VNx4BImode)
              || GET_MODE (x7) != E_VNx4BImode)
            return -1;
          return 2;

        case E_VNx2BImode:
          if (!register_operand (operands[6], E_VNx2BImode)
              || !register_operand (operands[0], E_VNx2BImode)
              || GET_MODE (x7) != E_VNx2BImode)
            return -1;
          return 3;

        default:
          return -1;
        }

    case CLOBBER:
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      switch (GET_MODE (x4))
        {
        case E_VNx16BImode:
          if (!register_operand (operands[6], E_VNx16BImode)
              || !scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 4;

        case E_VNx8BImode:
          if (!register_operand (operands[6], E_VNx8BImode)
              || !scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          return 5;

        case E_VNx4BImode:
          if (!register_operand (operands[6], E_VNx4BImode)
              || !scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          return 6;

        case E_VNx2BImode:
          if (!register_operand (operands[6], E_VNx2BImode)
              || !scratch_operand (operands[0], E_VNx2BImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1273 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_int_rnd_operand (operands[3], i2)
      || !aarch64_simd_shift_imm_vec_qi (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1280 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  return 0;
}

int
pattern1290 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern1293 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  x4 = XVECEXP (x2, 0, 2);
  x5 = XVECEXP (x4, 0, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern1292 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern1292 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern1292 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1307 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[4]))
    {
    case E_VNx2HImode:
      if (!register_operand (operands[4], E_VNx2HImode))
        return -1;
      return 0;

    case E_VNx2HFmode:
      if (!register_operand (operands[4], E_VNx2HFmode))
        return -1;
      return 1;

    case E_VNx2BFmode:
      if (!register_operand (operands[4], E_VNx2BFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1310 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1)
      || !aarch64_borrow_operation (operands[2], i2)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1
      || !aarch64_borrow_operation (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1319 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx2QImode:
      if (!register_operand (operands[2], E_VNx2QImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2QImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (!register_operand (operands[2], E_VNx2HImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2HImode))
        return -1;
      return 1;

    case E_VNx2SImode:
      if (!register_operand (operands[2], E_VNx2SImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2SImode))
        return -1;
      return 2;

    case E_VNx2DImode:
      if (!register_operand (operands[2], E_VNx2DImode)
          || !aarch64_sve_cmp_vsc_operand (operands[3], E_VNx2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1328 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_carry_operation (operands[2], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1
      || !aarch64_carry_operation (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  return 0;
}

int
pattern1337 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], E_VNx16BImode)
      || !register_operand (operands[3], E_VNx2DImode))
    return -1;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx8BImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      x2 = XVECEXP (x1, 0, 2);
      if (GET_MODE (x2) != E_VNx4BImode
          || !register_operand (operands[2], E_VNx4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1348 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[6], E_VNx16BImode)
      || !register_operand (operands[3], E_VNx2DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UNSPEC
          || XVECLEN (x3, 0) != 3
          || XINT (x3, 1) != 126)
        return -1;
      x4 = XVECEXP (x3, 0, 2);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != i1)
        return -1;
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x6 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x6, operands[6]))
        return -1;
      x7 = XVECEXP (x3, 0, 1);
      if (!rtx_equal_p (x7, operands[7]))
        return -1;
      x8 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x8, operands[2]))
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 1);
      x12 = XVECEXP (x11, 0, 3);
      switch (GET_MODE (x12))
        {
        case E_VNx16BImode:
          return pattern1347 (x1, 
E_VNx16BImode, 
E_VNx16QImode); /* [-1, 0] */

        case E_VNx8BImode:
          if (pattern1347 (x1, 
E_VNx8BImode, 
E_VNx8HImode) != 0)
            return -1;
          return 1;

        case E_VNx4BImode:
          if (pattern1347 (x1, 
E_VNx4BImode, 
E_VNx4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CLOBBER:
      x5 = XEXP (x2, 0);
      operands[0] = x5;
      x10 = XVECEXP (x1, 0, 0);
      x11 = XEXP (x10, 1);
      x12 = XVECEXP (x11, 0, 3);
      switch (GET_MODE (x12))
        {
        case E_VNx16BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (GET_MODE (x13) != E_VNx16BImode
              || !register_operand (operands[2], E_VNx16QImode)
              || !scratch_operand (operands[0], E_VNx16BImode))
            return -1;
          return 3;

        case E_VNx8BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (GET_MODE (x13) != E_VNx8BImode
              || !register_operand (operands[2], E_VNx8HImode)
              || !scratch_operand (operands[0], E_VNx8BImode))
            return -1;
          return 4;

        case E_VNx4BImode:
          x13 = XVECEXP (x12, 0, 2);
          if (GET_MODE (x13) != E_VNx4BImode
              || !register_operand (operands[2], E_VNx4SImode)
              || !scratch_operand (operands[0], E_VNx4BImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  switch (XINT (x3, 1))
    {
    case 320:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8077; /* aarch64_pred_smulhvnx16qi */

        case E_VNx8QImode:
          if (pattern860 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8079; /* aarch64_pred_smulhvnx8qi */

        case E_VNx4QImode:
          if (pattern860 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8081; /* aarch64_pred_smulhvnx4qi */

        case E_VNx2QImode:
          if (pattern860 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8083; /* aarch64_pred_smulhvnx2qi */

        case E_VNx8HImode:
          if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8085; /* aarch64_pred_smulhvnx8hi */

        case E_VNx4HImode:
          if (pattern860 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8087; /* aarch64_pred_smulhvnx4hi */

        case E_VNx2HImode:
          if (pattern860 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8089; /* aarch64_pred_smulhvnx2hi */

        case E_VNx4SImode:
          if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8091; /* aarch64_pred_smulhvnx4si */

        case E_VNx2SImode:
          if (pattern860 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8093; /* aarch64_pred_smulhvnx2si */

        case E_VNx2DImode:
          if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8095; /* aarch64_pred_smulhvnx2di */

        default:
          return -1;
        }

    case 321:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8078; /* aarch64_pred_umulhvnx16qi */

        case E_VNx8QImode:
          if (pattern860 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8080; /* aarch64_pred_umulhvnx8qi */

        case E_VNx4QImode:
          if (pattern860 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8082; /* aarch64_pred_umulhvnx4qi */

        case E_VNx2QImode:
          if (pattern860 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8084; /* aarch64_pred_umulhvnx2qi */

        case E_VNx8HImode:
          if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8086; /* aarch64_pred_umulhvnx8hi */

        case E_VNx4HImode:
          if (pattern860 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8088; /* aarch64_pred_umulhvnx4hi */

        case E_VNx2HImode:
          if (pattern860 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8090; /* aarch64_pred_umulhvnx2hi */

        case E_VNx4SImode:
          if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8092; /* aarch64_pred_umulhvnx4si */

        case E_VNx2SImode:
          if (pattern860 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8094; /* aarch64_pred_umulhvnx2si */

        case E_VNx2DImode:
          if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 4515 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8096; /* aarch64_pred_umulhvnx2di */

        default:
          return -1;
        }

    case 414:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern983 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8340; /* *sdiv_pow2vnx16qi3 */

        case E_VNx8QImode:
          if (pattern983 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8341; /* *sdiv_pow2vnx8qi3 */

        case E_VNx4QImode:
          if (pattern983 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8342; /* *sdiv_pow2vnx4qi3 */

        case E_VNx2QImode:
          if (pattern983 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8343; /* *sdiv_pow2vnx2qi3 */

        case E_VNx8HImode:
          if (pattern983 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8344; /* *sdiv_pow2vnx8hi3 */

        case E_VNx4HImode:
          if (pattern983 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8345; /* *sdiv_pow2vnx4hi3 */

        case E_VNx2HImode:
          if (pattern983 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8346; /* *sdiv_pow2vnx2hi3 */

        case E_VNx4SImode:
          if (pattern983 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8347; /* *sdiv_pow2vnx4si3 */

        case E_VNx2SImode:
          if (pattern983 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8348; /* *sdiv_pow2vnx2si3 */

        case E_VNx2DImode:
          if (pattern983 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8349; /* *sdiv_pow2vnx2di3 */

        case E_V8QImode:
          if (pattern983 (x2, 
E_V8QImode, 
E_VNx8BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8350; /* *sdiv_pow2v8qi3 */

        case E_V16QImode:
          if (pattern983 (x2, 
E_V16QImode, 
E_VNx16BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8351; /* *sdiv_pow2v16qi3 */

        case E_V4HImode:
          if (pattern983 (x2, 
E_V4HImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8352; /* *sdiv_pow2v4hi3 */

        case E_V8HImode:
          if (pattern983 (x2, 
E_V8HImode, 
E_VNx8BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8353; /* *sdiv_pow2v8hi3 */

        case E_V2SImode:
          if (pattern983 (x2, 
E_V2SImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8354; /* *sdiv_pow2v2si3 */

        case E_V4SImode:
          if (pattern983 (x2, 
E_V4SImode, 
E_VNx4BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8355; /* *sdiv_pow2v4si3 */

        case E_V2DImode:
          if (pattern983 (x2, 
E_V2DImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8356; /* *sdiv_pow2v2di3 */

        case E_V1DImode:
          if (pattern983 (x2, 
E_V1DImode, 
E_VNx2BImode) != 0
              || !
#line 5069 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 8357; /* *sdiv_pow2v1di3 */

        default:
          return -1;
        }

    case 209:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11546; /* aarch64_pred_shaddvnx16qi */

        case E_VNx8HImode:
          if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11556; /* aarch64_pred_shaddvnx8hi */

        case E_VNx4SImode:
          if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11566; /* aarch64_pred_shaddvnx4si */

        case E_VNx2DImode:
          if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11576; /* aarch64_pred_shaddvnx2di */

        default:
          return -1;
        }

    case 213:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11547; /* aarch64_pred_shsubvnx16qi */

        case E_VNx8HImode:
          if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11557; /* aarch64_pred_shsubvnx8hi */

        case E_VNx4SImode:
          if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11567; /* aarch64_pred_shsubvnx4si */

        case E_VNx2DImode:
          if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11577; /* aarch64_pred_shsubvnx2di */

        default:
          return -1;
        }

    case 232:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11548; /* aarch64_pred_sqrshlvnx16qi */

        case E_VNx8HImode:
          if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11558; /* aarch64_pred_sqrshlvnx8hi */

        case E_VNx4SImode:
          if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11568; /* aarch64_pred_sqrshlvnx4si */

        case E_VNx2DImode:
          if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11578; /* aarch64_pred_sqrshlvnx2di */

        default:
          return -1;
        }

    case 211:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11549; /* aarch64_pred_srhaddvnx16qi */

        case E_VNx8HImode:
          if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11559; /* aarch64_pred_srhaddvnx8hi */

        case E_VNx4SImode:
          if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11569; /* aarch64_pred_srhaddvnx4si */

        case E_VNx2DImode:
          if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11579; /* aarch64_pred_srhaddvnx2di */

        default:
          return -1;
        }

    case 230:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11550; /* aarch64_pred_srshlvnx16qi */

        case E_VNx8HImode:
          if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11560; /* aarch64_pred_srshlvnx8hi */

        case E_VNx4SImode:
          if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11570; /* aarch64_pred_srshlvnx4si */

        case E_VNx2DImode:
          if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11580; /* aarch64_pred_srshlvnx2di */

        default:
          return -1;
        }

    case 210:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11551; /* aarch64_pred_uhaddvnx16qi */

        case E_VNx8HImode:
          if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11561; /* aarch64_pred_uhaddvnx8hi */

        case E_VNx4SImode:
          if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11571; /* aarch64_pred_uhaddvnx4si */

        case E_VNx2DImode:
          if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11581; /* aarch64_pred_uhaddvnx2di */

        default:
          return -1;
        }

    case 214:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11552; /* aarch64_pred_uhsubvnx16qi */

        case E_VNx8HImode:
          if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11562; /* aarch64_pred_uhsubvnx8hi */

        case E_VNx4SImode:
          if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11572; /* aarch64_pred_uhsubvnx4si */

        case E_VNx2DImode:
          if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11582; /* aarch64_pred_uhsubvnx2di */

        default:
          return -1;
        }

    case 233:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11553; /* aarch64_pred_uqrshlvnx16qi */

        case E_VNx8HImode:
          if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11563; /* aarch64_pred_uqrshlvnx8hi */

        case E_VNx4SImode:
          if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11573; /* aarch64_pred_uqrshlvnx4si */

        case E_VNx2DImode:
          if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11583; /* aarch64_pred_uqrshlvnx2di */

        default:
          return -1;
        }

    case 212:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11554; /* aarch64_pred_urhaddvnx16qi */

        case E_VNx8HImode:
          if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11564; /* aarch64_pred_urhaddvnx8hi */

        case E_VNx4SImode:
          if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11574; /* aarch64_pred_urhaddvnx4si */

        case E_VNx2DImode:
          if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11584; /* aarch64_pred_urhaddvnx2di */

        default:
          return -1;
        }

    case 231:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern860 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11555; /* aarch64_pred_urshlvnx16qi */

        case E_VNx8HImode:
          if (pattern860 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11565; /* aarch64_pred_urshlvnx8hi */

        case E_VNx4SImode:
          if (pattern860 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11575; /* aarch64_pred_urshlvnx4si */

        case E_VNx2DImode:
          if (pattern860 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 997 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11585; /* aarch64_pred_urshlvnx2di */

        default:
          return -1;
        }

    case 226:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern984 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 1197 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11736; /* aarch64_pred_sqshlvnx16qi */

        case E_VNx8HImode:
          if (pattern984 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 1197 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11738; /* aarch64_pred_sqshlvnx8hi */

        case E_VNx4SImode:
          if (pattern984 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 1197 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11740; /* aarch64_pred_sqshlvnx4si */

        case E_VNx2DImode:
          if (pattern984 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 1197 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11742; /* aarch64_pred_sqshlvnx2di */

        default:
          return -1;
        }

    case 227:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern984 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 1197 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11737; /* aarch64_pred_uqshlvnx16qi */

        case E_VNx8HImode:
          if (pattern984 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 1197 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11739; /* aarch64_pred_uqshlvnx8hi */

        case E_VNx4SImode:
          if (pattern984 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 1197 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11741; /* aarch64_pred_uqshlvnx4si */

        case E_VNx2DImode:
          if (pattern984 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 1197 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11743; /* aarch64_pred_uqshlvnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_29 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (pattern75 (x1))
    {
    case 0:
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_V4HImode) != 0
              || !
#line 5555 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3428; /* aarch64_sqrdmulhv4hi */

        case E_V8HImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_V8HImode) != 0
              || !
#line 5555 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3432; /* aarch64_sqrdmulhv8hi */

        case E_V2SImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_V2SImode) != 0
              || !
#line 5555 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3436; /* aarch64_sqrdmulhv2si */

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_V4SImode) != 0
              || !
#line 5555 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3440; /* aarch64_sqrdmulhv4si */

        case E_HImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_HImode) != 0
              || !
#line 5555 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3442; /* aarch64_sqrdmulhhi */

        case E_SImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_SImode) != 0
              || !
#line 5555 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3444; /* aarch64_sqrdmulhsi */

        case E_VNx16QImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_VNx16QImode) != 0
              || !
#line 1160 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11723; /* aarch64_sve_sqrdmulhvnx16qi */

        case E_VNx8HImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_VNx8HImode) != 0
              || !
#line 1160 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11725; /* aarch64_sve_sqrdmulhvnx8hi */

        case E_VNx4SImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_VNx4SImode) != 0
              || !
#line 1160 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11727; /* aarch64_sve_sqrdmulhvnx4si */

        case E_VNx2DImode:
          x2 = XEXP (x1, 1);
          if (pattern55 (x2, 
E_VNx2DImode) != 0
              || !
#line 1160 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11729; /* aarch64_sve_sqrdmulhvnx2di */

        default:
          return -1;
        }

    case 1:
      switch (GET_MODE (operands[0]))
        {
        case E_V4HImode:
          x2 = XEXP (x1, 1);
          if (pattern783 (x2, 
E_HImode, 
E_V4HImode) != 0
              || !
#line 5567 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3448; /* aarch64_sqrdmulh_nv4hi */

        case E_V8HImode:
          x2 = XEXP (x1, 1);
          if (pattern783 (x2, 
E_HImode, 
E_V8HImode) != 0
              || !
#line 5567 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3452; /* aarch64_sqrdmulh_nv8hi */

        case E_V2SImode:
          x2 = XEXP (x1, 1);
          if (pattern783 (x2, 
E_SImode, 
E_V2SImode) != 0
              || !
#line 5567 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3456; /* aarch64_sqrdmulh_nv2si */

        case E_V4SImode:
          x2 = XEXP (x1, 1);
          if (pattern783 (x2, 
E_SImode, 
E_V4SImode) != 0
              || !
#line 5567 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3460; /* aarch64_sqrdmulh_nv4si */

        default:
          return -1;
        }

    case 2:
      if (!
#line 5582 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3464; /* aarch64_sqrdmulh_lanev4hi */

    case 3:
      if (!
#line 5597 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3480; /* aarch64_sqrdmulh_laneqv4hi */

    case 4:
      if (!
#line 5582 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3468; /* aarch64_sqrdmulh_lanev8hi */

    case 5:
      if (!
#line 5597 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3484; /* aarch64_sqrdmulh_laneqv8hi */

    case 6:
      if (!
#line 5582 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3472; /* aarch64_sqrdmulh_lanev2si */

    case 7:
      if (!
#line 5597 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3488; /* aarch64_sqrdmulh_laneqv2si */

    case 8:
      if (!
#line 5582 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3476; /* aarch64_sqrdmulh_lanev4si */

    case 9:
      if (!
#line 5597 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3492; /* aarch64_sqrdmulh_laneqv4si */

    case 10:
      if (!
#line 5612 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3494; /* aarch64_sqrdmulh_lanehi */

    case 11:
      if (!
#line 5627 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3498; /* aarch64_sqrdmulh_laneqhi */

    case 12:
      if (!
#line 5612 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3496; /* aarch64_sqrdmulh_lanesi */

    case 13:
      if (!
#line 5627 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3500; /* aarch64_sqrdmulh_laneqsi */

    case 14:
      if (!
#line 1173 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11731; /* aarch64_sve_sqrdmulh_lane_vnx8hi */

    case 15:
      if (!
#line 1173 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11733; /* aarch64_sve_sqrdmulh_lane_vnx4si */

    case 16:
      if (!
#line 1173 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11735; /* aarch64_sve_sqrdmulh_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_35 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!aarch64_simd_struct_operand (operands[0], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V4x8QImode:
      if (!register_operand (operands[1], E_V4x8QImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4554; /* aarch64_vec_store_lanesv4x8qi_lanev8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[1], E_V4x4HImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4555; /* aarch64_vec_store_lanesv4x4hi_lanev4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[1], E_V4x2SImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4556; /* aarch64_vec_store_lanesv4x2si_lanev2si */

    case E_V4x1DImode:
      if (!register_operand (operands[1], E_V4x1DImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4557; /* aarch64_vec_store_lanesv4x1di_lanedi */

    case E_V4x4HFmode:
      if (!register_operand (operands[1], E_V4x4HFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4558; /* aarch64_vec_store_lanesv4x4hf_lanev4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[1], E_V4x2SFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4559; /* aarch64_vec_store_lanesv4x2sf_lanev2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[1], E_V4x1DFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4560; /* aarch64_vec_store_lanesv4x1df_lanedf */

    case E_V4x4BFmode:
      if (!register_operand (operands[1], E_V4x4BFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4561; /* aarch64_vec_store_lanesv4x4bf_lanev4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[1], E_V4x16QImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4562; /* aarch64_vec_store_lanesv4x16qi_lanev16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[1], E_V4x8HImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4563; /* aarch64_vec_store_lanesv4x8hi_lanev8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[1], E_V4x4SImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4564; /* aarch64_vec_store_lanesv4x4si_lanev4si */

    case E_V4x2DImode:
      if (!register_operand (operands[1], E_V4x2DImode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4565; /* aarch64_vec_store_lanesv4x2di_lanev2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[1], E_V4x8HFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4566; /* aarch64_vec_store_lanesv4x8hf_lanev8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[1], E_V4x4SFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4567; /* aarch64_vec_store_lanesv4x4sf_lanev4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[1], E_V4x2DFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4568; /* aarch64_vec_store_lanesv4x2df_lanev2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[1], E_V4x8BFmode)
          || !
#line 7829 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4569; /* aarch64_vec_store_lanesv4x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern77 (x1))
    {
    case 0:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3636; /* aarch64_urshlv8qi */

    case 1:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3642; /* aarch64_urshlv16qi */

    case 2:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3652; /* aarch64_urshlv4hi */

    case 3:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3658; /* aarch64_urshlv8hi */

    case 4:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3668; /* aarch64_urshlv2si */

    case 5:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3674; /* aarch64_urshlv4si */

    case 6:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3678; /* aarch64_urshlv2di */

    case 7:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3688; /* aarch64_urshldi */

    case 8:
      if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11449; /* aarch64_sve_urshlvnx32qi */

    case 9:
      if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11452; /* aarch64_sve_urshlvnx16hi */

    case 10:
      if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11455; /* aarch64_sve_urshlvnx8si */

    case 11:
      if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11458; /* aarch64_sve_urshlvnx4di */

    case 12:
      if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11461; /* aarch64_sve_urshlvnx64qi */

    case 13:
      if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11464; /* aarch64_sve_urshlvnx32hi */

    case 14:
      if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11467; /* aarch64_sve_urshlvnx16si */

    case 15:
      if (!
#line 754 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11470; /* aarch64_sve_urshlvnx8di */

    case 16:
      if (!
#line 765 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11473; /* aarch64_sve_single_urshlvnx32qi */

    case 17:
      if (!
#line 765 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11476; /* aarch64_sve_single_urshlvnx16hi */

    case 18:
      if (!
#line 765 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11479; /* aarch64_sve_single_urshlvnx8si */

    case 19:
      if (!
#line 765 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11482; /* aarch64_sve_single_urshlvnx4di */

    case 20:
      if (!
#line 765 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11485; /* aarch64_sve_single_urshlvnx64qi */

    case 21:
      if (!
#line 765 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11488; /* aarch64_sve_single_urshlvnx32hi */

    case 22:
      if (!
#line 765 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11491; /* aarch64_sve_single_urshlvnx16si */

    case 23:
      if (!
#line 765 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 11494; /* aarch64_sve_single_urshlvnx8di */

    default:
      return -1;
    }
}

 int
recog_49 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern82 (x1))
    {
    case 0:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3691; /* aarch64_sqshlv8qi */

    case 1:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3703; /* aarch64_sqshlv16qi */

    case 2:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3707; /* aarch64_sqshlv4hi */

    case 3:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3719; /* aarch64_sqshlv8hi */

    case 4:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3723; /* aarch64_sqshlv2si */

    case 5:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3735; /* aarch64_sqshlv4si */

    case 6:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3739; /* aarch64_sqshlv2di */

    case 7:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3743; /* aarch64_sqshlqi */

    case 8:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3747; /* aarch64_sqshlhi */

    case 9:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3751; /* aarch64_sqshlsi */

    case 10:
      if (!
#line 6521 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3755; /* aarch64_sqshldi */

    case 11:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3846; /* aarch64_sqshl_nv8qi */

    case 12:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3849; /* aarch64_sqshl_nv16qi */

    case 13:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3852; /* aarch64_sqshl_nv4hi */

    case 14:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3855; /* aarch64_sqshl_nv8hi */

    case 15:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3858; /* aarch64_sqshl_nv2si */

    case 16:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3861; /* aarch64_sqshl_nv4si */

    case 17:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3864; /* aarch64_sqshl_nv2di */

    case 18:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3867; /* aarch64_sqshl_nqi */

    case 19:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3870; /* aarch64_sqshl_nhi */

    case 20:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3873; /* aarch64_sqshl_nsi */

    case 21:
      if (!
#line 6668 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3876; /* aarch64_sqshl_ndi */

    default:
      return -1;
    }
}

 int
recog_56 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4SImode:
          if (pattern55 (x3, 
E_VNx4SImode) != 0
              || !
#line 4132 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 7967; /* aarch64_adrvnx4si */

        case E_VNx2DImode:
          if (pattern55 (x3, 
E_VNx2DImode) != 0
              || !
#line 4132 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 7968; /* aarch64_adrvnx2di */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern595 (x5) != 0
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x5, 0, 1);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_VNx2DImode)
          || !
#line 4148 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 7969; /* *aarch64_adr_sxtw */

    case AND:
      if (GET_MODE (x5) != E_VNx2DImode
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x3) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode))
        return -1;
      x10 = XEXP (x5, 0);
      operands[2] = x10;
      if (!register_operand (operands[2], E_VNx2DImode))
        return -1;
      x11 = XEXP (x5, 1);
      operands[3] = x11;
      if (!aarch64_sve_uxtw_immediate (operands[3], E_VNx2DImode)
          || !
#line 4165 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
        return -1;
      return 7970; /* *aarch64_adr_uxtw_unspec */

    default:
      return -1;
    }
}

 int
recog_58 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern55 (x3, 
E_VNx16QImode) != 0
          || !(
#line 9093 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3175 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10377; /* aarch64_sve_tblqvnx16qi */

    case E_VNx8HImode:
      if (pattern55 (x3, 
E_VNx8HImode) != 0
          || !(
#line 9093 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3175 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10379; /* aarch64_sve_tblqvnx8hi */

    case E_VNx4SImode:
      if (pattern55 (x3, 
E_VNx4SImode) != 0
          || !(
#line 9093 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3175 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10381; /* aarch64_sve_tblqvnx4si */

    case E_VNx2DImode:
      if (pattern55 (x3, 
E_VNx2DImode) != 0
          || !(
#line 9093 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3175 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10383; /* aarch64_sve_tblqvnx2di */

    case E_VNx8BFmode:
      if (pattern91 (x3, 
E_VNx8HImode, 
E_VNx8BFmode) != 0
          || !(
#line 9093 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3175 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10385; /* aarch64_sve_tblqvnx8bf */

    case E_VNx8HFmode:
      if (pattern91 (x3, 
E_VNx8HImode, 
E_VNx8HFmode) != 0
          || !(
#line 9093 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3175 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10387; /* aarch64_sve_tblqvnx8hf */

    case E_VNx4SFmode:
      if (pattern91 (x3, 
E_VNx4SImode, 
E_VNx4SFmode) != 0
          || !(
#line 9093 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3175 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10389; /* aarch64_sve_tblqvnx4sf */

    case E_VNx2DFmode:
      if (pattern91 (x3, 
E_VNx2DImode, 
E_VNx2DFmode) != 0
          || !(
#line 9093 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3175 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10391; /* aarch64_sve_tblqvnx2df */

    default:
      return -1;
    }
}

 int
recog_72 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern69 (x1))
    {
    case 0:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2111; /* aarch64_smaxpv8qi */

    case 1:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2119; /* aarch64_smaxpv16qi */

    case 2:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2127; /* aarch64_smaxpv4hi */

    case 3:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2135; /* aarch64_smaxpv8hi */

    case 4:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2143; /* aarch64_smaxpv2si */

    case 5:
      if (!
#line 1800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2151; /* aarch64_smaxpv4si */

    case 6:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10332; /* aarch64_pred_reduc_smax_vnx16qi */

    case 7:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10339; /* aarch64_pred_reduc_smax_vnx8hi */

    case 8:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10346; /* aarch64_pred_reduc_smax_vnx4si */

    case 9:
      if (!
#line 8983 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10353; /* aarch64_pred_reduc_smax_vnx2di */

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern97 (x1))
    {
    case 0:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10644; /* aarch64_sve_uzp1qvnx16qi */

    case 1:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10650; /* aarch64_sve_uzp1qvnx8hi */

    case 2:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10656; /* aarch64_sve_uzp1qvnx4si */

    case 3:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10662; /* aarch64_sve_uzp1qvnx2di */

    case 4:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10668; /* aarch64_sve_uzp1qvnx8bf */

    case 5:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10674; /* aarch64_sve_uzp1qvnx8hf */

    case 6:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10680; /* aarch64_sve_uzp1qvnx4sf */

    case 7:
      if (!
#line 9227 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_F64MM))
        return -1;
      return 10686; /* aarch64_sve_uzp1qvnx2df */

    default:
      return -1;
    }
}

 int
recog_93 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3627; /* aarch64_sshlv8qi */

    case 1:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3639; /* aarch64_sshlv16qi */

    case 2:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3643; /* aarch64_sshlv4hi */

    case 3:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3655; /* aarch64_sshlv8hi */

    case 4:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3659; /* aarch64_sshlv2si */

    case 5:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3671; /* aarch64_sshlv4si */

    case 6:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3675; /* aarch64_sshlv2di */

    case 7:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3679; /* aarch64_sshldi */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern53 (x1))
    {
    case 0:
      return 1022; /* fcvtzssf3 */

    case 1:
      if (!
#line 7171 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1030; /* fcvtzshfsi3 */

    case 2:
      return 1024; /* fcvtzsdf3 */

    case 3:
      if (!
#line 7171 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1032; /* fcvtzshfdi3 */

    case 4:
      if (!
#line 7191 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1038; /* fcvtzshf3 */

    case 5:
      if (!(
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2617; /* fcvtzsv4hf3 */

    case 6:
      if (!(
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2619; /* fcvtzsv8hf3 */

    case 7:
      if (!
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2621; /* fcvtzsv2sf3 */

    case 8:
      if (!
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2623; /* fcvtzsv4sf3 */

    case 9:
      if (!
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2625; /* fcvtzsv2df3 */

    default:
      return -1;
    }
}

 int
recog_115 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern103 (x1))
    {
    case 0:
      if (!
#line 2269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12052; /* aarch64_sve_sqdmullbvnx8hi */

    case 1:
      if (!
#line 2269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12073; /* aarch64_sve_sqdmullbvnx4si */

    case 2:
      if (!
#line 2269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12094; /* aarch64_sve_sqdmullbvnx2di */

    case 3:
      if (!
#line 2282 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12110; /* aarch64_sve_sqdmullb_lane_vnx4si */

    case 4:
      if (!
#line 2282 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12116; /* aarch64_sve_sqdmullb_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_125 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern117 (x1))
    {
    case 0:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12697; /* aarch64_pred_reduc_uminqv_vnx16qi */

    case 1:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12705; /* aarch64_pred_reduc_uminqv_vnx8hi */

    case 2:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12713; /* aarch64_pred_reduc_uminqv_vnx4si */

    case 3:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12721; /* aarch64_pred_reduc_uminqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_135 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (!
#line 2983 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12470; /* aarch64_sve_sqcadd90vnx16qi */

    case 1:
      if (!
#line 2983 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12474; /* aarch64_sve_sqcadd90vnx8hi */

    case 2:
      if (!
#line 2983 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12478; /* aarch64_sve_sqcadd90vnx4si */

    case 3:
      if (!
#line 2983 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12482; /* aarch64_sve_sqcadd90vnx2di */

    default:
      return -1;
    }
}

 int
recog_145 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V2x8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8QImode
          || !register_operand (operands[1], E_V2x8QImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4658; /* aarch64_st1_x2_v8qi */

    case E_V2x4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HImode
          || !register_operand (operands[1], E_V2x4HImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4659; /* aarch64_st1_x2_v4hi */

    case E_V2x2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SImode
          || !register_operand (operands[1], E_V2x2SImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4660; /* aarch64_st1_x2_v2si */

    case E_V2x1DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DImode
          || !register_operand (operands[1], E_V2x1DImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4661; /* aarch64_st1_x2_di */

    case E_V2x4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HFmode
          || !register_operand (operands[1], E_V2x4HFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4662; /* aarch64_st1_x2_v4hf */

    case E_V2x2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SFmode
          || !register_operand (operands[1], E_V2x2SFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4663; /* aarch64_st1_x2_v2sf */

    case E_V2x1DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DFmode
          || !register_operand (operands[1], E_V2x1DFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4664; /* aarch64_st1_x2_df */

    case E_V2x4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4BFmode
          || !register_operand (operands[1], E_V2x4BFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4665; /* aarch64_st1_x2_v4bf */

    case E_V2x16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x16QImode
          || !register_operand (operands[1], E_V2x16QImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4666; /* aarch64_st1_x2_v16qi */

    case E_V2x8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HImode
          || !register_operand (operands[1], E_V2x8HImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4667; /* aarch64_st1_x2_v8hi */

    case E_V2x4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SImode
          || !register_operand (operands[1], E_V2x4SImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4668; /* aarch64_st1_x2_v4si */

    case E_V2x2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DImode
          || !register_operand (operands[1], E_V2x2DImode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4669; /* aarch64_st1_x2_v2di */

    case E_V2x8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HFmode
          || !register_operand (operands[1], E_V2x8HFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4670; /* aarch64_st1_x2_v8hf */

    case E_V2x4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SFmode
          || !register_operand (operands[1], E_V2x4SFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4671; /* aarch64_st1_x2_v4sf */

    case E_V2x2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DFmode
          || !register_operand (operands[1], E_V2x2DFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4672; /* aarch64_st1_x2_v2df */

    case E_V2x8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8BFmode
          || !register_operand (operands[1], E_V2x8BFmode)
          || !
#line 8046 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4673; /* aarch64_st1_x2_v8bf */

    case E_V3x8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8QImode
          || !register_operand (operands[1], E_V3x8QImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4674; /* aarch64_st1_x3_v8qi */

    case E_V3x4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HImode
          || !register_operand (operands[1], E_V3x4HImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4675; /* aarch64_st1_x3_v4hi */

    case E_V3x2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SImode
          || !register_operand (operands[1], E_V3x2SImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4676; /* aarch64_st1_x3_v2si */

    case E_V3x1DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DImode
          || !register_operand (operands[1], E_V3x1DImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4677; /* aarch64_st1_x3_di */

    case E_V3x4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HFmode
          || !register_operand (operands[1], E_V3x4HFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4678; /* aarch64_st1_x3_v4hf */

    case E_V3x2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SFmode
          || !register_operand (operands[1], E_V3x2SFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4679; /* aarch64_st1_x3_v2sf */

    case E_V3x1DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DFmode
          || !register_operand (operands[1], E_V3x1DFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4680; /* aarch64_st1_x3_df */

    case E_V3x4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4BFmode
          || !register_operand (operands[1], E_V3x4BFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4681; /* aarch64_st1_x3_v4bf */

    case E_V3x16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x16QImode
          || !register_operand (operands[1], E_V3x16QImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4682; /* aarch64_st1_x3_v16qi */

    case E_V3x8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HImode
          || !register_operand (operands[1], E_V3x8HImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4683; /* aarch64_st1_x3_v8hi */

    case E_V3x4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SImode
          || !register_operand (operands[1], E_V3x4SImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4684; /* aarch64_st1_x3_v4si */

    case E_V3x2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DImode
          || !register_operand (operands[1], E_V3x2DImode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4685; /* aarch64_st1_x3_v2di */

    case E_V3x8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HFmode
          || !register_operand (operands[1], E_V3x8HFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4686; /* aarch64_st1_x3_v8hf */

    case E_V3x4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SFmode
          || !register_operand (operands[1], E_V3x4SFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4687; /* aarch64_st1_x3_v4sf */

    case E_V3x2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DFmode
          || !register_operand (operands[1], E_V3x2DFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4688; /* aarch64_st1_x3_v2df */

    case E_V3x8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V3x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8BFmode
          || !register_operand (operands[1], E_V3x8BFmode)
          || !
#line 8066 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4689; /* aarch64_st1_x3_v8bf */

    case E_V4x8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8QImode
          || !register_operand (operands[1], E_V4x8QImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4690; /* aarch64_st1_x4_v8qi */

    case E_V4x4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HImode
          || !register_operand (operands[1], E_V4x4HImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4691; /* aarch64_st1_x4_v4hi */

    case E_V4x2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SImode
          || !register_operand (operands[1], E_V4x2SImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4692; /* aarch64_st1_x4_v2si */

    case E_V4x1DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DImode
          || !register_operand (operands[1], E_V4x1DImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4693; /* aarch64_st1_x4_di */

    case E_V4x4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HFmode
          || !register_operand (operands[1], E_V4x4HFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4694; /* aarch64_st1_x4_v4hf */

    case E_V4x2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SFmode
          || !register_operand (operands[1], E_V4x2SFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4695; /* aarch64_st1_x4_v2sf */

    case E_V4x1DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DFmode
          || !register_operand (operands[1], E_V4x1DFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4696; /* aarch64_st1_x4_df */

    case E_V4x4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4BFmode
          || !register_operand (operands[1], E_V4x4BFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4697; /* aarch64_st1_x4_v4bf */

    case E_V4x16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x16QImode
          || !register_operand (operands[1], E_V4x16QImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4698; /* aarch64_st1_x4_v16qi */

    case E_V4x8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HImode
          || !register_operand (operands[1], E_V4x8HImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4699; /* aarch64_st1_x4_v8hi */

    case E_V4x4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SImode
          || !register_operand (operands[1], E_V4x4SImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4700; /* aarch64_st1_x4_v4si */

    case E_V4x2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DImode
          || !register_operand (operands[1], E_V4x2DImode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4701; /* aarch64_st1_x4_v2di */

    case E_V4x8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HFmode
          || !register_operand (operands[1], E_V4x8HFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4702; /* aarch64_st1_x4_v8hf */

    case E_V4x4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SFmode
          || !register_operand (operands[1], E_V4x4SFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4703; /* aarch64_st1_x4_v4sf */

    case E_V4x2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DFmode
          || !register_operand (operands[1], E_V4x2DFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4704; /* aarch64_st1_x4_v2df */

    case E_V4x8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8BFmode
          || !register_operand (operands[1], E_V4x8BFmode)
          || !
#line 8086 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4705; /* aarch64_st1_x4_v8bf */

    case E_V8QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4722; /* aarch64_be_st1v8qi */

    case E_V16QImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4723; /* aarch64_be_st1v16qi */

    case E_V4HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4724; /* aarch64_be_st1v4hi */

    case E_V8HImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4725; /* aarch64_be_st1v8hi */

    case E_V2SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4726; /* aarch64_be_st1v2si */

    case E_V4SImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4727; /* aarch64_be_st1v4si */

    case E_V2DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4728; /* aarch64_be_st1v2di */

    case E_V4HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !register_operand (operands[1], E_V4HFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4729; /* aarch64_be_st1v4hf */

    case E_V8HFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !register_operand (operands[1], E_V8HFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4730; /* aarch64_be_st1v8hf */

    case E_V4BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BFmode
          || !register_operand (operands[1], E_V4BFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4731; /* aarch64_be_st1v4bf */

    case E_V8BFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BFmode
          || !register_operand (operands[1], E_V8BFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4732; /* aarch64_be_st1v8bf */

    case E_V2SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4733; /* aarch64_be_st1v2sf */

    case E_V4SFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4734; /* aarch64_be_st1v4sf */

    case E_V2DFmode:
      if (!aarch64_simd_struct_operand (operands[0], E_V2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4735; /* aarch64_be_st1v2df */

    case E_DImode:
      if (!aarch64_simd_struct_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !
#line 8115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4736; /* aarch64_be_st1di */

    default:
      return -1;
    }
}

 int
recog_212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1241 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11748; /* *cond_sqshlvnx4si_2 */
    }
  if (register_operand (operands[3], E_VNx4SImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1268 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11756; /* *cond_sqshlvnx4si_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !
#line 1293 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11764; /* *cond_sqshlvnx4si_any */
}

 int
recog_219 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11631; /* *cond_urhaddvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11672; /* *cond_urhaddvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11712; /* *cond_urhaddvnx2di_any */
}

 int
recog_229 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11605; /* *cond_uhsubvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11650; /* *cond_uhsubvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11690; /* *cond_uhsubvnx8hi_any */
}

 int
recog_239 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11625; /* *cond_srhaddvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11667; /* *cond_srhaddvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11707; /* *cond_srhaddvnx2di_any */
}

 int
recog_249 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11599; /* *cond_shsubvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11645; /* *cond_shsubvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11685; /* *cond_shsubvnx8hi_any */
}

 int
recog_259 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1047 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8498; /* *cond_fmin_nanvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8644; /* *cond_fmin_nanvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8748; /* *cond_fmin_nanvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8511; /* *cond_fmin_nanvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8657; /* *cond_fmin_nanvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8761; /* *cond_fmin_nanvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8524; /* *cond_fmin_nanvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8670; /* *cond_fmin_nanvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8774; /* *cond_fmin_nanvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8537; /* *cond_fmin_nanvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8683; /* *cond_fmin_nanvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8787; /* *cond_fmin_nanvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8598; /* *cond_fmin_nanvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8848; /* *cond_fmin_nanvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8605; /* *cond_fmin_nanvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8855; /* *cond_fmin_nanvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8612; /* *cond_fmin_nanvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8862; /* *cond_fmin_nanvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8550; /* *cond_fmin_nanvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8696; /* *cond_fmin_nanvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8800; /* *cond_fmin_nanvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8563; /* *cond_fmin_nanvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8709; /* *cond_fmin_nanvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8813; /* *cond_fmin_nanvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8576; /* *cond_fmin_nanvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8722; /* *cond_fmin_nanvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8826; /* *cond_fmin_nanvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8589; /* *cond_fmin_nanvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8735; /* *cond_fmin_nanvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8839; /* *cond_fmin_nanvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8619; /* *cond_fmin_nanvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8869; /* *cond_fmin_nanvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8626; /* *cond_fmin_nanvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8876; /* *cond_fmin_nanvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8633; /* *cond_fmin_nanvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8883; /* *cond_fmin_nanvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_265 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1113 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9228; /* *cond_fnmsvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9256; /* *cond_fnmsvnx8hf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9288; /* *cond_fnmsvnx8hf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9232; /* *cond_fnmsvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9260; /* *cond_fnmsvnx4sf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9292; /* *cond_fnmsvnx4sf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9236; /* *cond_fnmsvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9264; /* *cond_fnmsvnx2df_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9296; /* *cond_fnmsvnx2df_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[5] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9252; /* *cond_fnmsvnx8bf_4_relaxed */
      operands[6] = x4;
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9284; /* *cond_fnmsvnx8bf_any_relaxed */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9240; /* *cond_fnmsvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9272; /* *cond_fnmsvnx8hf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
          || !
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9304; /* *cond_fnmsvnx8hf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9244; /* *cond_fnmsvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9276; /* *cond_fnmsvnx4sf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
          || !
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9308; /* *cond_fnmsvnx4sf_any_strict */

    case 6:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 7532 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 9248; /* *cond_fnmsvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[4])
          && 
#line 7578 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 9280; /* *cond_fnmsvnx2df_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
          || !
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])))
        return -1;
      return 9312; /* *cond_fnmsvnx2df_any_strict */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[4])
          && (
#line 7578 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 9268; /* *cond_fnmsvnx8bf_4_strict */
      operands[5] = x5;
      if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
          || !(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 9300; /* *cond_fnmsvnx8bf_any_strict */

    default:
      return -1;
    }
}

 int
recog_273 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      switch (pattern723 (x2))
        {
        case 0:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7437; /* *cond_addvnx16qi_2 */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7607; /* *cond_addvnx16qi_3 */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7777; /* *cond_addvnx16qi_any */

        case 1:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7454; /* *cond_addvnx8qi_2 */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7624; /* *cond_addvnx8qi_3 */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7794; /* *cond_addvnx8qi_any */

        case 2:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7471; /* *cond_addvnx4qi_2 */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7641; /* *cond_addvnx4qi_3 */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7811; /* *cond_addvnx4qi_any */

        case 3:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7488; /* *cond_addvnx2qi_2 */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7658; /* *cond_addvnx2qi_3 */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7828; /* *cond_addvnx2qi_any */

        case 4:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7505; /* *cond_addvnx8hi_2 */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7675; /* *cond_addvnx8hi_3 */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7845; /* *cond_addvnx8hi_any */

        case 5:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7522; /* *cond_addvnx4hi_2 */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7692; /* *cond_addvnx4hi_3 */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7862; /* *cond_addvnx4hi_any */

        case 6:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7539; /* *cond_addvnx2hi_2 */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7709; /* *cond_addvnx2hi_3 */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7879; /* *cond_addvnx2hi_any */

        case 7:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7556; /* *cond_addvnx4si_2 */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7726; /* *cond_addvnx4si_3 */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7896; /* *cond_addvnx4si_any */

        case 8:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7573; /* *cond_addvnx2si_2 */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7743; /* *cond_addvnx2si_3 */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7913; /* *cond_addvnx2si_any */

        case 9:
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7590; /* *cond_addvnx2di_2 */
          if (rtx_equal_p (x6, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7760; /* *cond_addvnx2di_3 */
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7930; /* *cond_addvnx2di_any */

        default:
          return -1;
        }

    case MULT:
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      x8 = XEXP (x5, 1);
      operands[3] = x8;
      x9 = XEXP (x4, 1);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1050 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 7080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9122; /* *cond_fmavnx16qi_2 */
          if (rtx_equal_p (x6, operands[4])
              && 
#line 7099 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9132; /* *cond_fmavnx16qi_4 */
          operands[5] = x6;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx16QImode)
              || !
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9142; /* *cond_fmavnx16qi_any */

        case E_VNx8QImode:
          if (pattern1050 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 7080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9123; /* *cond_fmavnx8qi_2 */
          if (rtx_equal_p (x6, operands[4])
              && 
#line 7099 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9133; /* *cond_fmavnx8qi_4 */
          operands[5] = x6;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8QImode)
              || !
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9143; /* *cond_fmavnx8qi_any */

        case E_VNx4QImode:
          if (pattern1050 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 7080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9124; /* *cond_fmavnx4qi_2 */
          if (rtx_equal_p (x6, operands[4])
              && 
#line 7099 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9134; /* *cond_fmavnx4qi_4 */
          operands[5] = x6;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4QImode)
              || !
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9144; /* *cond_fmavnx4qi_any */

        case E_VNx2QImode:
          if (pattern1050 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 7080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9125; /* *cond_fmavnx2qi_2 */
          if (rtx_equal_p (x6, operands[4])
              && 
#line 7099 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9135; /* *cond_fmavnx2qi_4 */
          operands[5] = x6;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2QImode)
              || !
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9145; /* *cond_fmavnx2qi_any */

        case E_VNx8HImode:
          if (pattern1050 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 7080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9126; /* *cond_fmavnx8hi_2 */
          if (rtx_equal_p (x6, operands[4])
              && 
#line 7099 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9136; /* *cond_fmavnx8hi_4 */
          operands[5] = x6;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HImode)
              || !
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9146; /* *cond_fmavnx8hi_any */

        case E_VNx4HImode:
          if (pattern1050 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 7080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9127; /* *cond_fmavnx4hi_2 */
          if (rtx_equal_p (x6, operands[4])
              && 
#line 7099 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9137; /* *cond_fmavnx4hi_4 */
          operands[5] = x6;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4HImode)
              || !
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9147; /* *cond_fmavnx4hi_any */

        case E_VNx2HImode:
          if (pattern1050 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 7080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9128; /* *cond_fmavnx2hi_2 */
          if (rtx_equal_p (x6, operands[4])
              && 
#line 7099 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9138; /* *cond_fmavnx2hi_4 */
          operands[5] = x6;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2HImode)
              || !
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9148; /* *cond_fmavnx2hi_any */

        case E_VNx4SImode:
          if (pattern1050 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 7080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9129; /* *cond_fmavnx4si_2 */
          if (rtx_equal_p (x6, operands[4])
              && 
#line 7099 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9139; /* *cond_fmavnx4si_4 */
          operands[5] = x6;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SImode)
              || !
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9149; /* *cond_fmavnx4si_any */

        case E_VNx2SImode:
          if (pattern1050 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 7080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9130; /* *cond_fmavnx2si_2 */
          if (rtx_equal_p (x6, operands[4])
              && 
#line 7099 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9140; /* *cond_fmavnx2si_4 */
          operands[5] = x6;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2SImode)
              || !
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9150; /* *cond_fmavnx2si_any */

        case E_VNx2DImode:
          if (pattern1050 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && 
#line 7080 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9131; /* *cond_fmavnx2di_2 */
          if (rtx_equal_p (x6, operands[4])
              && 
#line 7099 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9141; /* *cond_fmavnx2di_4 */
          operands[5] = x6;
          if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DImode)
              || !
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])))
            return -1;
          return 9151; /* *cond_fmavnx2di_any */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_278 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 0);
  operands[3] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern932 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx16QImode)
       || register_operand (operands[2], VNx16QImode))))
        return -1;
      return 9406; /* *vcond_mask_vnx16qivnx16bi */

    case E_VNx8QImode:
      if (pattern932 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx8QImode)
       || register_operand (operands[2], VNx8QImode))))
        return -1;
      return 9407; /* *vcond_mask_vnx8qivnx8bi */

    case E_VNx4QImode:
      if (pattern932 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx4QImode)
       || register_operand (operands[2], VNx4QImode))))
        return -1;
      return 9408; /* *vcond_mask_vnx4qivnx4bi */

    case E_VNx2QImode:
      if (pattern932 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx2QImode)
       || register_operand (operands[2], VNx2QImode))))
        return -1;
      return 9409; /* *vcond_mask_vnx2qivnx2bi */

    case E_VNx8HImode:
      if (pattern932 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx8HImode)
       || register_operand (operands[2], VNx8HImode))))
        return -1;
      return 9410; /* *vcond_mask_vnx8hivnx8bi */

    case E_VNx4HImode:
      if (pattern932 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx4HImode)
       || register_operand (operands[2], VNx4HImode))))
        return -1;
      return 9411; /* *vcond_mask_vnx4hivnx4bi */

    case E_VNx2HImode:
      if (pattern932 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx2HImode)
       || register_operand (operands[2], VNx2HImode))))
        return -1;
      return 9412; /* *vcond_mask_vnx2hivnx2bi */

    case E_VNx4SImode:
      if (pattern932 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx4SImode)
       || register_operand (operands[2], VNx4SImode))))
        return -1;
      return 9413; /* *vcond_mask_vnx4sivnx4bi */

    case E_VNx2SImode:
      if (pattern932 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx2SImode)
       || register_operand (operands[2], VNx2SImode))))
        return -1;
      return 9414; /* *vcond_mask_vnx2sivnx2bi */

    case E_VNx2DImode:
      if (pattern932 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx2DImode)
       || register_operand (operands[2], VNx2DImode))))
        return -1;
      return 9415; /* *vcond_mask_vnx2divnx2bi */

    case E_VNx8HFmode:
      if (pattern932 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx8HFmode)
       || register_operand (operands[2], VNx8HFmode))))
        return -1;
      return 9416; /* *vcond_mask_vnx8hfvnx8bi */

    case E_VNx4HFmode:
      if (pattern932 (x2, 
E_VNx4HFmode, 
E_VNx4BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx4HFmode)
       || register_operand (operands[2], VNx4HFmode))))
        return -1;
      return 9417; /* *vcond_mask_vnx4hfvnx4bi */

    case E_VNx2HFmode:
      if (pattern932 (x2, 
E_VNx2HFmode, 
E_VNx2BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx2HFmode)
       || register_operand (operands[2], VNx2HFmode))))
        return -1;
      return 9418; /* *vcond_mask_vnx2hfvnx2bi */

    case E_VNx8BFmode:
      if (pattern932 (x2, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx8BFmode)
       || register_operand (operands[2], VNx8BFmode))))
        return -1;
      return 9419; /* *vcond_mask_vnx8bfvnx8bi */

    case E_VNx4BFmode:
      if (pattern932 (x2, 
E_VNx4BFmode, 
E_VNx4BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx4BFmode)
       || register_operand (operands[2], VNx4BFmode))))
        return -1;
      return 9420; /* *vcond_mask_vnx4bfvnx4bi */

    case E_VNx2BFmode:
      if (pattern932 (x2, 
E_VNx2BFmode, 
E_VNx2BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx2BFmode)
       || register_operand (operands[2], VNx2BFmode))))
        return -1;
      return 9421; /* *vcond_mask_vnx2bfvnx2bi */

    case E_VNx4SFmode:
      if (pattern932 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx4SFmode)
       || register_operand (operands[2], VNx4SFmode))))
        return -1;
      return 9422; /* *vcond_mask_vnx4sfvnx4bi */

    case E_VNx2SFmode:
      if (pattern932 (x2, 
E_VNx2SFmode, 
E_VNx2BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx2SFmode)
       || register_operand (operands[2], VNx2SFmode))))
        return -1;
      return 9423; /* *vcond_mask_vnx2sfvnx2bi */

    case E_VNx2DFmode:
      if (pattern932 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 8060 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (!register_operand (operands[1], VNx2DFmode)
       || register_operand (operands[2], VNx2DFmode))))
        return -1;
      return 9424; /* *vcond_mask_vnx2dfvnx2bi */

    case E_VNx32QImode:
      if (pattern933 (x2, 
E_VNx32QImode, 
E_VNx16BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12610; /* aarch64_sve_selvnx32qi */

    case E_VNx16HImode:
      if (pattern933 (x2, 
E_VNx16HImode, 
E_VNx8BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12611; /* aarch64_sve_selvnx16hi */

    case E_VNx8SImode:
      if (pattern933 (x2, 
E_VNx8SImode, 
E_VNx4BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12612; /* aarch64_sve_selvnx8si */

    case E_VNx4DImode:
      if (pattern933 (x2, 
E_VNx4DImode, 
E_VNx2BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12613; /* aarch64_sve_selvnx4di */

    case E_VNx16BFmode:
      if (pattern933 (x2, 
E_VNx16BFmode, 
E_VNx8BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12614; /* aarch64_sve_selvnx16bf */

    case E_VNx16HFmode:
      if (pattern933 (x2, 
E_VNx16HFmode, 
E_VNx8BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12615; /* aarch64_sve_selvnx16hf */

    case E_VNx8SFmode:
      if (pattern933 (x2, 
E_VNx8SFmode, 
E_VNx4BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12616; /* aarch64_sve_selvnx8sf */

    case E_VNx4DFmode:
      if (pattern933 (x2, 
E_VNx4DFmode, 
E_VNx2BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12617; /* aarch64_sve_selvnx4df */

    case E_VNx64QImode:
      if (pattern933 (x2, 
E_VNx64QImode, 
E_VNx16BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12618; /* aarch64_sve_selvnx64qi */

    case E_VNx32HImode:
      if (pattern933 (x2, 
E_VNx32HImode, 
E_VNx8BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12619; /* aarch64_sve_selvnx32hi */

    case E_VNx16SImode:
      if (pattern933 (x2, 
E_VNx16SImode, 
E_VNx4BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12620; /* aarch64_sve_selvnx16si */

    case E_VNx8DImode:
      if (pattern933 (x2, 
E_VNx8DImode, 
E_VNx2BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12621; /* aarch64_sve_selvnx8di */

    case E_VNx32BFmode:
      if (pattern933 (x2, 
E_VNx32BFmode, 
E_VNx8BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12622; /* aarch64_sve_selvnx32bf */

    case E_VNx32HFmode:
      if (pattern933 (x2, 
E_VNx32HFmode, 
E_VNx8BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12623; /* aarch64_sve_selvnx32hf */

    case E_VNx16SFmode:
      if (pattern933 (x2, 
E_VNx16SFmode, 
E_VNx4BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12624; /* aarch64_sve_selvnx16sf */

    case E_VNx8DFmode:
      if (pattern933 (x2, 
E_VNx8DFmode, 
E_VNx2BImode) != 0
          || !
#line 3653 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12625; /* aarch64_sve_selvnx8df */

    default:
      return -1;
    }
}

 int
recog_288 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (pattern723 (x2))
    {
    case 0:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7440; /* *cond_smaxvnx16qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7610; /* *cond_smaxvnx16qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7780; /* *cond_smaxvnx16qi_any */

    case 1:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7457; /* *cond_smaxvnx8qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7627; /* *cond_smaxvnx8qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7797; /* *cond_smaxvnx8qi_any */

    case 2:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7474; /* *cond_smaxvnx4qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7644; /* *cond_smaxvnx4qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7814; /* *cond_smaxvnx4qi_any */

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7491; /* *cond_smaxvnx2qi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7661; /* *cond_smaxvnx2qi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7831; /* *cond_smaxvnx2qi_any */

    case 4:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7508; /* *cond_smaxvnx8hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7678; /* *cond_smaxvnx8hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7848; /* *cond_smaxvnx8hi_any */

    case 5:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7525; /* *cond_smaxvnx4hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7695; /* *cond_smaxvnx4hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7865; /* *cond_smaxvnx4hi_any */

    case 6:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7542; /* *cond_smaxvnx2hi_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7712; /* *cond_smaxvnx2hi_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7882; /* *cond_smaxvnx2hi_any */

    case 7:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7559; /* *cond_smaxvnx4si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7729; /* *cond_smaxvnx4si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7899; /* *cond_smaxvnx4si_any */

    case 8:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7576; /* *cond_smaxvnx2si_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7746; /* *cond_smaxvnx2si_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7916; /* *cond_smaxvnx2si_any */

    case 9:
      x4 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x4, operands[2])
          && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7593; /* *cond_smaxvnx2di_2 */
      if (rtx_equal_p (x4, operands[3])
          && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 7763; /* *cond_smaxvnx2di_3 */
      operands[4] = x4;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
          || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
        return -1;
      return 7933; /* *cond_smaxvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_299 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!aarch64_simd_struct_operand (operands[1], E_BLKmode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4x8QImode:
      if (!register_operand (operands[0], E_V4x8QImode)
          || GET_MODE (x3) != E_V4x8QImode
          || !register_operand (operands[2], E_V4x8QImode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4530; /* aarch64_vec_load_lanesv4x8qi_lanev8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[0], E_V4x4HImode)
          || GET_MODE (x3) != E_V4x4HImode
          || !register_operand (operands[2], E_V4x4HImode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4531; /* aarch64_vec_load_lanesv4x4hi_lanev4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[0], E_V4x2SImode)
          || GET_MODE (x3) != E_V4x2SImode
          || !register_operand (operands[2], E_V4x2SImode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4532; /* aarch64_vec_load_lanesv4x2si_lanev2si */

    case E_V4x1DImode:
      if (!register_operand (operands[0], E_V4x1DImode)
          || GET_MODE (x3) != E_V4x1DImode
          || !register_operand (operands[2], E_V4x1DImode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4533; /* aarch64_vec_load_lanesv4x1di_lanedi */

    case E_V4x4HFmode:
      if (!register_operand (operands[0], E_V4x4HFmode)
          || GET_MODE (x3) != E_V4x4HFmode
          || !register_operand (operands[2], E_V4x4HFmode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4534; /* aarch64_vec_load_lanesv4x4hf_lanev4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[0], E_V4x2SFmode)
          || GET_MODE (x3) != E_V4x2SFmode
          || !register_operand (operands[2], E_V4x2SFmode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4535; /* aarch64_vec_load_lanesv4x2sf_lanev2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[0], E_V4x1DFmode)
          || GET_MODE (x3) != E_V4x1DFmode
          || !register_operand (operands[2], E_V4x1DFmode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4536; /* aarch64_vec_load_lanesv4x1df_lanedf */

    case E_V4x4BFmode:
      if (!register_operand (operands[0], E_V4x4BFmode)
          || GET_MODE (x3) != E_V4x4BFmode
          || !register_operand (operands[2], E_V4x4BFmode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4537; /* aarch64_vec_load_lanesv4x4bf_lanev4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[0], E_V4x16QImode)
          || GET_MODE (x3) != E_V4x16QImode
          || !register_operand (operands[2], E_V4x16QImode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4538; /* aarch64_vec_load_lanesv4x16qi_lanev16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[0], E_V4x8HImode)
          || GET_MODE (x3) != E_V4x8HImode
          || !register_operand (operands[2], E_V4x8HImode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4539; /* aarch64_vec_load_lanesv4x8hi_lanev8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[0], E_V4x4SImode)
          || GET_MODE (x3) != E_V4x4SImode
          || !register_operand (operands[2], E_V4x4SImode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4540; /* aarch64_vec_load_lanesv4x4si_lanev4si */

    case E_V4x2DImode:
      if (!register_operand (operands[0], E_V4x2DImode)
          || GET_MODE (x3) != E_V4x2DImode
          || !register_operand (operands[2], E_V4x2DImode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4541; /* aarch64_vec_load_lanesv4x2di_lanev2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[0], E_V4x8HFmode)
          || GET_MODE (x3) != E_V4x8HFmode
          || !register_operand (operands[2], E_V4x8HFmode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4542; /* aarch64_vec_load_lanesv4x8hf_lanev8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[0], E_V4x4SFmode)
          || GET_MODE (x3) != E_V4x4SFmode
          || !register_operand (operands[2], E_V4x4SFmode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4543; /* aarch64_vec_load_lanesv4x4sf_lanev4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[0], E_V4x2DFmode)
          || GET_MODE (x3) != E_V4x2DFmode
          || !register_operand (operands[2], E_V4x2DFmode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4544; /* aarch64_vec_load_lanesv4x2df_lanev2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[0], E_V4x8BFmode)
          || GET_MODE (x3) != E_V4x8BFmode
          || !register_operand (operands[2], E_V4x8BFmode)
          || !
#line 7784 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4545; /* aarch64_vec_load_lanesv4x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_306 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern788 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5723; /* maskloadvnx16qivnx16bi */

    case E_VNx8QImode:
      if (pattern788 (x3, 
E_VNx8QImode, 
E_VNx8BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5724; /* maskloadvnx8qivnx8bi */

    case E_VNx4QImode:
      if (pattern788 (x3, 
E_VNx4QImode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5725; /* maskloadvnx4qivnx4bi */

    case E_VNx2QImode:
      if (pattern788 (x3, 
E_VNx2QImode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5726; /* maskloadvnx2qivnx2bi */

    case E_VNx8HImode:
      if (pattern788 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5727; /* maskloadvnx8hivnx8bi */

    case E_VNx4HImode:
      if (pattern788 (x3, 
E_VNx4HImode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5728; /* maskloadvnx4hivnx4bi */

    case E_VNx2HImode:
      if (pattern788 (x3, 
E_VNx2HImode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5729; /* maskloadvnx2hivnx2bi */

    case E_VNx4SImode:
      if (pattern788 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5730; /* maskloadvnx4sivnx4bi */

    case E_VNx2SImode:
      if (pattern788 (x3, 
E_VNx2SImode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5731; /* maskloadvnx2sivnx2bi */

    case E_VNx2DImode:
      if (pattern788 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5732; /* maskloadvnx2divnx2bi */

    case E_VNx8HFmode:
      if (pattern788 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5733; /* maskloadvnx8hfvnx8bi */

    case E_VNx4HFmode:
      if (pattern788 (x3, 
E_VNx4HFmode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5734; /* maskloadvnx4hfvnx4bi */

    case E_VNx2HFmode:
      if (pattern788 (x3, 
E_VNx2HFmode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5735; /* maskloadvnx2hfvnx2bi */

    case E_VNx8BFmode:
      if (pattern788 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5736; /* maskloadvnx8bfvnx8bi */

    case E_VNx4BFmode:
      if (pattern788 (x3, 
E_VNx4BFmode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5737; /* maskloadvnx4bfvnx4bi */

    case E_VNx2BFmode:
      if (pattern788 (x3, 
E_VNx2BFmode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5738; /* maskloadvnx2bfvnx2bi */

    case E_VNx4SFmode:
      if (pattern788 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5739; /* maskloadvnx4sfvnx4bi */

    case E_VNx2SFmode:
      if (pattern788 (x3, 
E_VNx2SFmode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5740; /* maskloadvnx2sfvnx2bi */

    case E_VNx2DFmode:
      if (pattern788 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
          || !
#line 1296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 5741; /* maskloadvnx2dfvnx2bi */

    default:
      return -1;
    }
}

 int
recog_316 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern166 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9939; /* while_gtsivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9949; /* while_gtdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9959; /* while_gtsivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9969; /* while_gtdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9979; /* while_gtsivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 9989; /* while_gtdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 9999; /* while_gtsivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10009; /* while_gtdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_324 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x6, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx1SImode:
      if (!memory_operand (operands[0], E_VNx1SImode)
          || GET_MODE (x3) != E_VNx1SImode
          || !register_operand (operands[2], E_VNx4BImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx4SImode:
          if (!register_operand (operands[1], E_VNx4SImode)
              || !
#line 433 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 11202; /* aarch64_sve_st1_truncqvnx4si */

        case E_VNx4SFmode:
          if (!register_operand (operands[1], E_VNx4SFmode)
              || !
#line 433 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 11204; /* aarch64_sve_st1_truncqvnx4sf */

        default:
          return -1;
        }

    case E_VNx1DImode:
      if (!memory_operand (operands[0], E_VNx1DImode)
          || GET_MODE (x3) != E_VNx1DImode
          || !register_operand (operands[2], E_VNx2BImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_VNx2DImode:
          if (!register_operand (operands[1], E_VNx2DImode)
              || !
#line 433 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 11203; /* aarch64_sve_st1_truncqvnx2di */

        case E_VNx2DFmode:
          if (!register_operand (operands[1], E_VNx2DFmode)
              || !
#line 433 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
            return -1;
          return 11205; /* aarch64_sve_st1_truncqvnx2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_331 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern167 (x3, 
E_VNx16BImode, 
E_V16QImode, 
E_VNx16QImode) != 0
          || !
#line 11171 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN))
        return -1;
      return 11057; /* aarch64_sve_set_neonq_vnx16qi */

    case E_VNx8HImode:
      if (pattern167 (x3, 
E_VNx8BImode, 
E_V8HImode, 
E_VNx8HImode) != 0
          || !
#line 11171 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN))
        return -1;
      return 11058; /* aarch64_sve_set_neonq_vnx8hi */

    case E_VNx4SImode:
      if (pattern167 (x3, 
E_VNx4BImode, 
E_V4SImode, 
E_VNx4SImode) != 0
          || !
#line 11171 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN))
        return -1;
      return 11059; /* aarch64_sve_set_neonq_vnx4si */

    case E_VNx2DImode:
      if (pattern167 (x3, 
E_VNx2BImode, 
E_V2DImode, 
E_VNx2DImode) != 0
          || !
#line 11171 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN))
        return -1;
      return 11060; /* aarch64_sve_set_neonq_vnx2di */

    case E_VNx8BFmode:
      if (pattern167 (x3, 
E_VNx8BImode, 
E_V8BFmode, 
E_VNx8BFmode) != 0
          || !
#line 11171 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN))
        return -1;
      return 11061; /* aarch64_sve_set_neonq_vnx8bf */

    case E_VNx8HFmode:
      if (pattern167 (x3, 
E_VNx8BImode, 
E_V8HFmode, 
E_VNx8HFmode) != 0
          || !
#line 11171 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN))
        return -1;
      return 11062; /* aarch64_sve_set_neonq_vnx8hf */

    case E_VNx4SFmode:
      if (pattern167 (x3, 
E_VNx4BImode, 
E_V4SFmode, 
E_VNx4SFmode) != 0
          || !
#line 11171 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN))
        return -1;
      return 11063; /* aarch64_sve_set_neonq_vnx4sf */

    case E_VNx2DFmode:
      if (pattern167 (x3, 
E_VNx2BImode, 
E_V2DFmode, 
E_VNx2DFmode) != 0
          || !
#line 11171 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN))
        return -1;
      return 11064; /* aarch64_sve_set_neonq_vnx2df */

    default:
      return -1;
    }
}

 int
recog_340 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_VNx16BImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_VNx16BImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[3]))
    {
    case E_VNx16BImode:
      if (!aarch64_simd_imm_zero (operands[3], E_VNx16BImode)
          || !
#line 9298 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10735; /* aarch64_sve_trn1_convvnx16bi */

    case E_VNx8BImode:
      if (!aarch64_simd_imm_zero (operands[3], E_VNx8BImode)
          || !
#line 9298 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10736; /* aarch64_sve_trn1_convvnx8bi */

    case E_VNx4BImode:
      if (!aarch64_simd_imm_zero (operands[3], E_VNx4BImode)
          || !
#line 9298 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10737; /* aarch64_sve_trn1_convvnx4bi */

    case E_VNx2BImode:
      if (!aarch64_simd_imm_zero (operands[3], E_VNx2BImode)
          || !
#line 9298 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10738; /* aarch64_sve_trn1_convvnx2bi */

    default:
      return -1;
    }
}

 int
recog_347 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (pattern792 (x3, 
E_VNx16QImode) != 0
          || !
#line 2002 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11977; /* aarch64_sve_slivnx16qi */

    case E_VNx8HImode:
      if (pattern792 (x3, 
E_VNx8HImode) != 0
          || !
#line 2002 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11979; /* aarch64_sve_slivnx8hi */

    case E_VNx4SImode:
      if (pattern792 (x3, 
E_VNx4SImode) != 0
          || !
#line 2002 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11981; /* aarch64_sve_slivnx4si */

    case E_VNx2DImode:
      if (pattern792 (x3, 
E_VNx2DImode) != 0
          || !
#line 2002 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11983; /* aarch64_sve_slivnx2di */

    default:
      return -1;
    }
}

 int
recog_352 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      if (pattern868 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_VNx8HImode) != 0
          || !
#line 3529 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12590; /* aarch64_pred_flogbvnx8hf */

    case E_VNx4SImode:
      if (pattern868 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_VNx4SImode) != 0
          || !
#line 3529 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12591; /* aarch64_pred_flogbvnx4sf */

    case E_VNx2DImode:
      if (pattern868 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_VNx2DImode) != 0
          || !
#line 3529 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12592; /* aarch64_pred_flogbvnx2df */

    default:
      return -1;
    }
}

 int
recog_360 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern193 (x1))
    {
    case 0:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12486; /* aarch64_sve_cmla180vnx16qi */

    case 1:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12494; /* aarch64_sve_cmla180vnx8hi */

    case 2:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12502; /* aarch64_sve_cmla180vnx4si */

    case 3:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12510; /* aarch64_sve_cmla180vnx2di */

    case 4:
      if (!
#line 3032 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12518; /* aarch64_cmla180_lane_vnx8hi */

    case 5:
      if (!
#line 3032 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12526; /* aarch64_cmla180_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_369 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern195 (x1))
    {
    case 0:
      if (!
#line 3095 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12534; /* aarch64_sve_cdot180vnx4si */

    case 1:
      if (!
#line 3095 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12538; /* aarch64_sve_cdot180vnx2di */

    case 2:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12542; /* aarch64_cdot180_lane_vnx4si */

    case 3:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12546; /* aarch64_cdot180_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_376 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern189 (x1))
    {
    case 0:
      if (!
#line 2820 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12415; /* aarch64_pred_addpvnx16qi */

    case 1:
      if (!
#line 2820 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12420; /* aarch64_pred_addpvnx8hi */

    case 2:
      if (!
#line 2820 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12425; /* aarch64_pred_addpvnx4si */

    case 3:
      if (!
#line 2820 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12430; /* aarch64_pred_addpvnx2di */

    default:
      return -1;
    }
}

 int
recog_383 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern181 (x1, 
E_DImode))
    {
    case 0:
      if (!
#line 676 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11363; /* aarch64_sve_cntp_c8 */

    case 1:
      if (!
#line 676 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11364; /* aarch64_sve_cntp_c16 */

    case 2:
      if (!
#line 676 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11365; /* aarch64_sve_cntp_c32 */

    case 3:
      if (!
#line 676 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11366; /* aarch64_sve_cntp_c64 */

    default:
      return -1;
    }
}

 int
recog_391 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[3] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[4] = x6;
  x7 = XVECEXP (x3, 0, 1);
  operands[1] = x7;
  x8 = XVECEXP (x3, 0, 2);
  operands[2] = x8;
  switch (GET_MODE (x3))
    {
    case E_VNx16BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10102; /* while_rwsivnx16bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10112; /* while_rwdivnx16bi_ptest */

    case E_VNx8BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10122; /* while_rwsivnx8bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10132; /* while_rwdivnx8bi_ptest */

    case E_VNx4BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10142; /* while_rwsivnx4bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10152; /* while_rwdivnx4bi_ptest */

    case E_VNx2BImode:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        {
          *pnum_clobbers = 1;
          return 10162; /* while_rwsivnx2bi_ptest */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      *pnum_clobbers = 1;
      return 10172; /* while_rwdivnx2bi_ptest */

    default:
      return -1;
    }
}

 int
recog_401 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pattern215 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[1] = x4;
  if (!aarch64_reg_or_zero (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 3);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[3] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4BImode:
          if (!register_operand (operands[0], E_VNx4BImode)
              || !register_operand (operands[2], E_VNx4SImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_VNx4SImode:
              if (!register_operand (operands[3], E_VNx4SImode)
                  || !
#line 556 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11327; /* aarch64_scatter_stntvnx4si */

            case E_VNx4SFmode:
              if (!register_operand (operands[3], E_VNx4SFmode)
                  || !
#line 556 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11329; /* aarch64_scatter_stntvnx4sf */

            default:
              return -1;
            }

        case E_VNx2BImode:
          if (!register_operand (operands[0], E_VNx2BImode)
              || !register_operand (operands[2], E_VNx2DImode))
            return -1;
          switch (GET_MODE (operands[3]))
            {
            case E_VNx2DImode:
              if (!register_operand (operands[3], E_VNx2DImode)
                  || !
#line 556 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11328; /* aarch64_scatter_stntvnx2di */

            case E_VNx2DFmode:
              if (!register_operand (operands[3], E_VNx2DFmode)
                  || !
#line 556 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 11330; /* aarch64_scatter_stntvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx4BImode:
          switch (pattern1162 (x6, 
E_VNx4SImode, 
E_VNx4BImode))
            {
            case 0:
              if (!
#line 573 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x81) == 0))
                return -1;
              return 11331; /* aarch64_scatter_stnt_vnx4sivnx8qi */

            case 1:
              if (!
#line 573 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x41) == 0))
                return -1;
              return 11332; /* aarch64_scatter_stnt_vnx4sivnx4qi */

            case 2:
              if (!
#line 573 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x21) == 0))
                return -1;
              return 11333; /* aarch64_scatter_stnt_vnx4sivnx2qi */

            case 3:
              if (!
#line 573 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x42) == 0))
                return -1;
              return 11334; /* aarch64_scatter_stnt_vnx4sivnx4hi */

            case 4:
              if (!
#line 573 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x22) == 0))
                return -1;
              return 11335; /* aarch64_scatter_stnt_vnx4sivnx2hi */

            case 5:
              if (!
#line 573 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x43 & 0x24) == 0))
                return -1;
              return 11336; /* aarch64_scatter_stnt_vnx4sivnx2si */

            default:
              return -1;
            }

        case E_VNx2BImode:
          switch (pattern1162 (x6, 
E_VNx2DImode, 
E_VNx2BImode))
            {
            case 0:
              if (!
#line 573 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x81) == 0))
                return -1;
              return 11337; /* aarch64_scatter_stnt_vnx2divnx8qi */

            case 1:
              if (!
#line 573 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x41) == 0))
                return -1;
              return 11338; /* aarch64_scatter_stnt_vnx2divnx4qi */

            case 2:
              if (!
#line 573 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x21) == 0))
                return -1;
              return 11339; /* aarch64_scatter_stnt_vnx2divnx2qi */

            case 3:
              if (!
#line 573 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x42) == 0))
                return -1;
              return 11340; /* aarch64_scatter_stnt_vnx2divnx4hi */

            case 4:
              if (!
#line 573 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x22) == 0))
                return -1;
              return 11341; /* aarch64_scatter_stnt_vnx2divnx2hi */

            case 5:
              if (!
#line 573 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && (~0x27 & 0x24) == 0))
                return -1;
              return 11342; /* aarch64_scatter_stnt_vnx2divnx2si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_410 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[4] = x3;
  if (aarch64_sve_gp_strictness (operands[4], E_SImode))
    {
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      switch (pattern203 (x2))
        {
        case 0:
          if (
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9009; /* aarch64_pred_fminvnx8hf */
          break;

        case 1:
          if (
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9015; /* aarch64_pred_fminvnx4sf */
          break;

        case 2:
          if (
#line 6728 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 9021; /* aarch64_pred_fminvnx2df */
          break;

        case 3:
          if (
#line 1346 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SSVE_B16B16 && true))
            return 11772; /* aarch64_pred_fminvnx8bf */
          break;

        default:
          break;
        }
    }
  if (XWINT (x3, 0) != 0L)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  if (pattern479 (x6, 
372) != 0)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (pattern918 (x2))
    {
    case 0:
      if (!
#line 491 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16))
        return -1;
      return 11782; /* *aarch64_sve_fclampvnx8bf_x */

    case 1:
      if (!
#line 492 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11783; /* *aarch64_sve_fclampvnx8hf_x */

    case 2:
      if (!
#line 493 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11784; /* *aarch64_sve_fclampvnx4sf_x */

    case 3:
      if (!
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11785; /* *aarch64_sve_fclampvnx2df_x */

    default:
      return -1;
    }
}

 int
recog_415 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern212 (x1))
    {
    case 0:
      if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10176; /* aarch64_pred_fcmgtvnx8hf */

    case 1:
      if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10182; /* aarch64_pred_fcmgtvnx4sf */

    case 2:
      if (!
#line 8512 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10188; /* aarch64_pred_fcmgtvnx2df */

    case 3:
      x2 = XEXP (x1, 1);
      x3 = XVECEXP (x2, 0, 2);
      x4 = XVECEXP (x3, 0, 1);
      if (XWINT (x4, 0) == 0L)
        {
          switch (pattern1250 (x2))
            {
            case 0:
              if (
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10259; /* *aarch64_pred_facgtvnx8hf_relaxed */
              break;

            case 1:
              if (
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10263; /* *aarch64_pred_facgtvnx4sf_relaxed */
              break;

            case 2:
              if (
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 10267; /* *aarch64_pred_facgtvnx2df_relaxed */
              break;

            default:
              break;
            }
        }
      operands[5] = x4;
      switch (pattern1251 (x2))
        {
        case 0:
          if (!
#line 8811 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10271; /* *aarch64_pred_facgtvnx8hf_strict */

        case 1:
          if (!
#line 8811 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10275; /* *aarch64_pred_facgtvnx4sf_strict */

        case 2:
          if (!
#line 8811 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10279; /* *aarch64_pred_facgtvnx2df_strict */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_424 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern221 (x1))
    {
    case 0:
      if (!
#line 1159 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13336; /* aarch64_sme_addvnx8si */

    case 1:
      if (!(
#line 1159 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 714 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13338; /* aarch64_sme_addvnx4di */

    case 2:
      if (!
#line 1159 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13340; /* aarch64_sme_addvnx16si */

    case 3:
      if (!(
#line 1159 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 715 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13342; /* aarch64_sme_addvnx8di */

    case 4:
      if (!
#line 1172 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13344; /* *aarch64_sme_addvnx8si_plus */

    case 5:
      if (!(
#line 1172 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 714 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13346; /* *aarch64_sme_addvnx4di_plus */

    case 6:
      if (!
#line 1172 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 13348; /* *aarch64_sme_addvnx16si_plus */

    case 7:
      if (!(
#line 1172 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2) && 
#line 715 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13350; /* *aarch64_sme_addvnx8di_plus */

    default:
      return -1;
    }
}

 int
recog_432 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  if (pattern62 (x1, 
E_VNx4SImode, 
93, 
89) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 3);
      operands[1] = x4;
      x5 = XVECEXP (x2, 0, 4);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16BFmode:
              if (!aligned_register_operand (operands[1], E_VNx16BFmode)
                  || !aligned_register_operand (operands[2], E_VNx16BFmode)
                  || !
#line 1768 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13858; /* aarch64_sme_fdotvnx4sivnx16bf */

            case E_VNx32BFmode:
              if (!aligned_register_operand (operands[1], E_VNx32BFmode)
                  || !aligned_register_operand (operands[2], E_VNx32BFmode)
                  || !
#line 1768 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13859; /* aarch64_sme_fdotvnx4sivnx32bf */

            case E_VNx16HFmode:
              if (!aligned_register_operand (operands[1], E_VNx16HFmode)
                  || !aligned_register_operand (operands[2], E_VNx16HFmode)
                  || !
#line 1768 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13860; /* aarch64_sme_fdotvnx4sivnx16hf */

            case E_VNx32HFmode:
              if (!aligned_register_operand (operands[1], E_VNx32HFmode)
                  || !aligned_register_operand (operands[2], E_VNx32HFmode)
                  || !
#line 1768 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13861; /* aarch64_sme_fdotvnx4sivnx32hf */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x6 = XEXP (x5, 0);
          operands[2] = x6;
          switch (pattern247 (x5))
            {
            case 0:
              if (!
#line 1796 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13866; /* aarch64_sme_single_fdotvnx4sivnx16bf */

            case 1:
              if (!
#line 1796 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13867; /* aarch64_sme_single_fdotvnx4sivnx32bf */

            case 2:
              if (!
#line 1796 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13868; /* aarch64_sme_single_fdotvnx4sivnx16hf */

            case 3:
              if (!
#line 1796 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13869; /* aarch64_sme_single_fdotvnx4sivnx32hf */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 167)
            return -1;
          x7 = XVECEXP (x5, 0, 0);
          operands[2] = x7;
          x8 = XVECEXP (x5, 0, 1);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1331 (x5))
            {
            case 0:
              if (!
#line 1827 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13874; /* aarch64_sme_lane_fdotvnx4sivnx16bf */

            case 1:
              if (!
#line 1827 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13876; /* aarch64_sme_lane_fdotvnx4sivnx32bf */

            case 2:
              if (!
#line 1827 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13878; /* aarch64_sme_lane_fdotvnx4sivnx16hf */

            case 3:
              if (!
#line 1827 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13880; /* aarch64_sme_lane_fdotvnx4sivnx32hf */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[1] = x10;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x4 = XVECEXP (x2, 0, 3);
      operands[2] = x4;
      x5 = XVECEXP (x2, 0, 4);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[3] = x5;
          switch (pattern1315 ())
            {
            case 0:
              if (!
#line 1782 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13862; /* *aarch64_sme_fdotvnx4sivnx16bf_plus */

            case 1:
              if (!
#line 1782 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13863; /* *aarch64_sme_fdotvnx4sivnx32bf_plus */

            case 2:
              if (!
#line 1782 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13864; /* *aarch64_sme_fdotvnx4sivnx16hf_plus */

            case 3:
              if (!
#line 1782 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13865; /* *aarch64_sme_fdotvnx4sivnx32hf_plus */

            default:
              return -1;
            }

        case VEC_DUPLICATE:
          x6 = XEXP (x5, 0);
          operands[3] = x6;
          switch (pattern251 (x5))
            {
            case 0:
              if (!
#line 1811 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13870; /* *aarch64_sme_single_fdotvnx4sivnx16bf_plus */

            case 1:
              if (!
#line 1811 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13871; /* *aarch64_sme_single_fdotvnx4sivnx32bf_plus */

            case 2:
              if (!
#line 1811 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13872; /* *aarch64_sme_single_fdotvnx4sivnx16hf_plus */

            case 3:
              if (!
#line 1811 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13873; /* *aarch64_sme_single_fdotvnx4sivnx32hf_plus */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 167)
            return -1;
          x7 = XVECEXP (x5, 0, 0);
          operands[3] = x7;
          x8 = XVECEXP (x5, 0, 1);
          operands[4] = x8;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (pattern1344 (x5))
            {
            case 0:
              if (!
#line 1844 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13882; /* *aarch64_sme_lane_fdotvnx4sivnx16bf_plus */

            case 1:
              if (!
#line 1844 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13884; /* *aarch64_sme_lane_fdotvnx4sivnx32bf_plus */

            case 2:
              if (!
#line 1844 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13886; /* *aarch64_sme_lane_fdotvnx4sivnx16hf_plus */

            case 3:
              if (!
#line 1844 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2))
                return -1;
              return 13888; /* *aarch64_sme_lane_fdotvnx4sivnx32hf_plus */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_434 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern243 (x1))
    {
    case 0:
      if (!
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13416; /* aarch64_sme_sdotvnx4sivnx32qi */

    case 1:
      if (!
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13419; /* aarch64_sme_sdotvnx4sivnx64qi */

    case 2:
      if (!
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13422; /* aarch64_sme_sdotvnx4sivnx16hi */

    case 3:
      if (!
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13425; /* aarch64_sme_sdotvnx4sivnx32hi */

    case 4:
      if (!(
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13428; /* aarch64_sme_sdotvnx2divnx32qi */

    case 5:
      if (!(
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13431; /* aarch64_sme_sdotvnx2divnx64qi */

    case 6:
      if (!(
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13434; /* aarch64_sme_sdotvnx2divnx16hi */

    case 7:
      if (!(
#line 1288 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13437; /* aarch64_sme_sdotvnx2divnx32hi */

    case 8:
      if (!
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13464; /* aarch64_sme_single_sdotvnx4sivnx32qi */

    case 9:
      if (!
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13467; /* aarch64_sme_single_sdotvnx4sivnx64qi */

    case 10:
      if (!
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13470; /* aarch64_sme_single_sdotvnx4sivnx16hi */

    case 11:
      if (!
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13473; /* aarch64_sme_single_sdotvnx4sivnx32hi */

    case 12:
      if (!(
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13476; /* aarch64_sme_single_sdotvnx2divnx32qi */

    case 13:
      if (!(
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13479; /* aarch64_sme_single_sdotvnx2divnx64qi */

    case 14:
      if (!(
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13482; /* aarch64_sme_single_sdotvnx2divnx16hi */

    case 15:
      if (!(
#line 1320 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13485; /* aarch64_sme_single_sdotvnx2divnx32hi */

    case 16:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13516; /* aarch64_sme_lane_sdotvnx4sivnx32qi */

    case 17:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13524; /* aarch64_sme_lane_sdotvnx4sivnx64qi */

    case 18:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13532; /* aarch64_sme_lane_sdotvnx4sivnx16hi */

    case 19:
      if (!
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13540; /* aarch64_sme_lane_sdotvnx4sivnx32hi */

    case 20:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13548; /* aarch64_sme_lane_sdotvnx2divnx32qi */

    case 21:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13556; /* aarch64_sme_lane_sdotvnx2divnx64qi */

    case 22:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13564; /* aarch64_sme_lane_sdotvnx2divnx16hi */

    case 23:
      if (!(
#line 1385 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13572; /* aarch64_sme_lane_sdotvnx2divnx32hi */

    case 24:
      if (!
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13440; /* *aarch64_sme_sdotvnx4sivnx32qi_plus */

    case 25:
      if (!
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13443; /* *aarch64_sme_sdotvnx4sivnx64qi_plus */

    case 26:
      if (!
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13446; /* *aarch64_sme_sdotvnx4sivnx16hi_plus */

    case 27:
      if (!
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13449; /* *aarch64_sme_sdotvnx4sivnx32hi_plus */

    case 28:
      if (!(
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13452; /* *aarch64_sme_sdotvnx2divnx32qi_plus */

    case 29:
      if (!(
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13455; /* *aarch64_sme_sdotvnx2divnx64qi_plus */

    case 30:
      if (!(
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13458; /* *aarch64_sme_sdotvnx2divnx16hi_plus */

    case 31:
      if (!(
#line 1304 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13461; /* *aarch64_sme_sdotvnx2divnx32hi_plus */

    case 32:
      if (!
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13488; /* *aarch64_sme_single_sdotvnx4sivnx32qi_plus */

    case 33:
      if (!
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13491; /* *aarch64_sme_single_sdotvnx4sivnx64qi_plus */

    case 34:
      if (!
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13494; /* *aarch64_sme_single_sdotvnx4sivnx16hi_plus */

    case 35:
      if (!
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13497; /* *aarch64_sme_single_sdotvnx4sivnx32hi_plus */

    case 36:
      if (!(
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13500; /* *aarch64_sme_single_sdotvnx2divnx32qi_plus */

    case 37:
      if (!(
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13503; /* *aarch64_sme_single_sdotvnx2divnx64qi_plus */

    case 38:
      if (!(
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13506; /* *aarch64_sme_single_sdotvnx2divnx16hi_plus */

    case 39:
      if (!(
#line 1337 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13509; /* *aarch64_sme_single_sdotvnx2divnx32hi_plus */

    case 40:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13580; /* *aarch64_sme_lane_sdotvnx4sivnx32qi_plus */

    case 41:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 8 == 16)
   && (8 == 8 || true)))
        return -1;
      return 13588; /* *aarch64_sme_lane_sdotvnx4sivnx64qi_plus */

    case 42:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13596; /* *aarch64_sme_lane_sdotvnx4sivnx16hi_plus */

    case 43:
      if (!
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (32 == 32 || 16 == 16)
   && (16 == 8 || true)))
        return -1;
      return 13604; /* *aarch64_sme_lane_sdotvnx4sivnx32hi_plus */

    case 44:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13612; /* *aarch64_sme_lane_sdotvnx2divnx32qi_plus */

    case 45:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 8 == 16)
   && (8 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13620; /* *aarch64_sme_lane_sdotvnx2divnx64qi_plus */

    case 46:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13628; /* *aarch64_sme_lane_sdotvnx2divnx16hi_plus */

    case 47:
      if (!(
#line 1404 "../../gcc/config/aarch64/aarch64-sme.md"
(TARGET_STREAMING_SME2
   && (64 == 32 || 16 == 16)
   && (16 == 8 || true)) && 
#line 696 "../../gcc/config/aarch64/iterators.md"
(TARGET_SME_I16I64)))
        return -1;
      return 13636; /* *aarch64_sme_lane_sdotvnx2divnx32hi_plus */

    default:
      return -1;
    }
}

 int
recog_449 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  operands[1] = x3;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  switch (GET_MODE (x2))
    {
    case E_SImode:
      switch (pattern940 (x4, 
E_SImode))
        {
        case 0:
          if (!
#line 6384 "../../gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 32))
            return -1;
          return 814; /* *aarch64_bfisihi_16 */

        case 1:
          if (!
#line 6384 "../../gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 32))
            return -1;
          return 818; /* *aarch64_bfisisi_16 */

        default:
          return -1;
        }

    case E_DImode:
      switch (pattern940 (x4, 
E_DImode))
        {
        case 0:
          if (!
#line 6384 "../../gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
            return -1;
          return 816; /* *aarch64_bfidihi_16 */

        case 1:
          if (!
#line 6384 "../../gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
            return -1;
          return 821; /* *aarch64_bfidisi_16 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_450 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x1, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode)
      || GET_MODE (x2) != E_DImode)
    return -1;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!cc_register (operands[2], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 1);
  operands[3] = x8;
  if (!aarch64_reg_zero_or_m1_or_1 (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x3, 2);
  operands[4] = x9;
  if (!aarch64_reg_zero_or_m1_or_1 (operands[4], E_SImode)
      || !
#line 4536 "../../gcc/config/aarch64/aarch64.md"
(!((operands[3] == const1_rtx && operands[4] == constm1_rtx)
     || (operands[3] == constm1_rtx && operands[4] == const1_rtx))))
    return -1;
  return 458; /* *cmovsi_insn_uxtw */
}

 int
recog_452 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      switch (XINT (x4, 1))
        {
        case 39:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode)
            return -1;
          x6 = XEXP (x5, 0);
          if (GET_CODE (x6) != LO_SUM
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!aarch64_valid_symref (operands[2], E_DImode)
              || !
#line 7633 "../../gcc/config/aarch64/aarch64.md"
(TARGET_ILP32))
            return -1;
          return 1114; /* ldr_got_small_28k_sidi */

        case 41:
          if (GET_MODE (x4) != E_SImode
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode)
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[1] = x5;
          if (!aarch64_valid_symref (operands[1], E_DImode)
              || !
#line 7652 "../../gcc/config/aarch64/aarch64.md"
(TARGET_ILP32))
            return -1;
          return 1117; /* ldr_got_tiny_sidi */

        case 40:
          if (pattern484 (x3) != 0)
            return -1;
          return 1123; /* tlsie_small_sidi */

        case 204:
          x5 = XVECEXP (x4, 0, 0);
          switch (GET_CODE (x5))
            {
            case REG:
            case SUBREG:
              operands[1] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_SImode:
                  switch (pattern796 (x3, 
E_SImode))
                    {
                    case 0:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2717; /* aarch64_zero_extendsi_reduc_plus_v8qi */

                    case 1:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2719; /* aarch64_zero_extendsi_reduc_plus_v16qi */

                    case 2:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2721; /* aarch64_zero_extendsi_reduc_plus_v4hi */

                    case 3:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2723; /* aarch64_zero_extendsi_reduc_plus_v8hi */

                    default:
                      return -1;
                    }

                case E_DImode:
                  switch (pattern796 (x3, 
E_DImode))
                    {
                    case 0:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2718; /* aarch64_zero_extenddi_reduc_plus_v8qi */

                    case 1:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2720; /* aarch64_zero_extenddi_reduc_plus_v16qi */

                    case 2:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2722; /* aarch64_zero_extenddi_reduc_plus_v4hi */

                    case 3:
                      if (!
#line 3402 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                        return -1;
                      return 2724; /* aarch64_zero_extenddi_reduc_plus_v8hi */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              switch (pattern606 (x3))
                {
                case 0:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2755; /* *aarch64_saddlvv8qi_zesi */

                case 1:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2759; /* *aarch64_saddlvv16qi_zesi */

                case 2:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2763; /* *aarch64_saddlvv4hi_zesi */

                case 3:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2767; /* *aarch64_saddlvv8hi_zesi */

                case 4:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2771; /* *aarch64_saddlvv4si_zesi */

                case 5:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2775; /* *aarch64_saddlvv2si_zesi */

                case 6:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2757; /* *aarch64_saddlvv8qi_zedi */

                case 7:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2761; /* *aarch64_saddlvv16qi_zedi */

                case 8:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2765; /* *aarch64_saddlvv4hi_zedi */

                case 9:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2769; /* *aarch64_saddlvv8hi_zedi */

                case 10:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2773; /* *aarch64_saddlvv4si_zedi */

                case 11:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2777; /* *aarch64_saddlvv2si_zedi */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern606 (x3))
                {
                case 0:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2756; /* *aarch64_uaddlvv8qi_zesi */

                case 1:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2760; /* *aarch64_uaddlvv16qi_zesi */

                case 2:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2764; /* *aarch64_uaddlvv4hi_zesi */

                case 3:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2768; /* *aarch64_uaddlvv8hi_zesi */

                case 4:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2772; /* *aarch64_uaddlvv4si_zesi */

                case 5:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (SImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2776; /* *aarch64_uaddlvv2si_zesi */

                case 6:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2758; /* *aarch64_uaddlvv8qi_zedi */

                case 7:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode))))
                    return -1;
                  return 2762; /* *aarch64_uaddlvv16qi_zedi */

                case 8:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2766; /* *aarch64_uaddlvv4hi_zedi */

                case 9:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode))))
                    return -1;
                  return 2770; /* *aarch64_uaddlvv8hi_zedi */

                case 10:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2774; /* *aarch64_uaddlvv4si_zedi */

                case 11:
                  if (!
#line 3508 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && (GET_MODE_SIZE (DImode) > GET_MODE_SIZE (DImode))))
                    return -1;
                  return 2778; /* *aarch64_uaddlvv2si_zedi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x4, 1) != 42
          || pattern484 (x3) != 0)
        return -1;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      return 1126; /* tlsie_tiny_sidi */

    case 3:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[1] = x5;
      x9 = XVECEXP (x4, 0, 1);
      operands[2] = x9;
      x10 = XVECEXP (x4, 0, 2);
      operands[3] = x10;
      switch (XINT (x4, 1))
        {
        case 168:
          if (!const_int_operand (operands[1], E_DImode)
              || !const_int_operand (operands[2], E_DImode)
              || !const_int_operand (operands[3], E_DImode)
              || !
#line 10356 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 10948; /* aarch64_sve_cnt_pat */

        case 306:
          if (!aarch64_sve_ptrue_flag (operands[2], E_SImode))
            return -1;
          switch (GET_MODE (operands[1]))
            {
            case E_VNx16BImode:
              if (!register_operand (operands[1], E_VNx16BImode)
                  || !register_operand (operands[3], E_VNx16BImode)
                  || !
#line 10678 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10979; /* aarch64_pred_cntpvnx16bi */

            case E_VNx8BImode:
              if (!register_operand (operands[1], E_VNx8BImode)
                  || !register_operand (operands[3], E_VNx8BImode)
                  || !
#line 10678 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10980; /* aarch64_pred_cntpvnx8bi */

            case E_VNx4BImode:
              if (!register_operand (operands[1], E_VNx4BImode)
                  || !register_operand (operands[3], E_VNx4BImode)
                  || !
#line 10678 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10981; /* aarch64_pred_cntpvnx4bi */

            case E_VNx2BImode:
              if (!register_operand (operands[1], E_VNx2BImode)
                  || !register_operand (operands[3], E_VNx2BImode)
                  || !
#line 10678 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10982; /* aarch64_pred_cntpvnx2bi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_455 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (XVECLEN (x3, 0) != 2)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x3, 0, 0);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_SImode))
    return -1;
  switch (XINT (x3, 1))
    {
    case 24:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          switch (pattern870 (x2, 
E_HImode))
            {
            case 0:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (HImode) > GET_MODE_SIZE (QImode)))
                return -1;
              return 5472; /* *atomic_loadqi_zexthi */

            case 1:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (HImode) > GET_MODE_SIZE (HImode)))
                return -1;
              return 5475; /* *atomic_loadhi_zexthi */

            case 2:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (HImode) > GET_MODE_SIZE (SImode)))
                return -1;
              return 5478; /* *atomic_loadsi_zexthi */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern870 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (SImode) > GET_MODE_SIZE (QImode)))
                return -1;
              return 5473; /* *atomic_loadqi_zextsi */

            case 1:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (SImode) > GET_MODE_SIZE (HImode)))
                return -1;
              return 5476; /* *atomic_loadhi_zextsi */

            case 2:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (SImode) > GET_MODE_SIZE (SImode)))
                return -1;
              return 5479; /* *atomic_loadsi_zextsi */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern870 (x2, 
E_DImode))
            {
            case 0:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (DImode) > GET_MODE_SIZE (QImode)))
                return -1;
              return 5474; /* *atomic_loadqi_zextdi */

            case 1:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (DImode) > GET_MODE_SIZE (HImode)))
                return -1;
              return 5477; /* *atomic_loadhi_zextdi */

            case 2:
              if (!
#line 650 "../../gcc/config/aarch64/atomics.md"
(GET_MODE_SIZE (DImode) > GET_MODE_SIZE (SImode)))
                return -1;
              return 5480; /* *atomic_loadsi_zextdi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 25:
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          switch (pattern870 (x2, 
E_HImode))
            {
            case 0:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (16 > 8)))
                return -1;
              return 5489; /* *aarch64_atomic_loadqi_rcpc_zext */

            case 1:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (16 > 16)))
                return -1;
              return 5492; /* *aarch64_atomic_loadhi_rcpc_zext */

            case 2:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (16 > 32)))
                return -1;
              return 5495; /* *aarch64_atomic_loadsi_rcpc_zext */

            default:
              return -1;
            }

        case E_SImode:
          switch (pattern870 (x2, 
E_SImode))
            {
            case 0:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (32 > 8)))
                return -1;
              return 5490; /* *aarch64_atomic_loadqi_rcpc_zext */

            case 1:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (32 > 16)))
                return -1;
              return 5493; /* *aarch64_atomic_loadhi_rcpc_zext */

            case 2:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (32 > 32)))
                return -1;
              return 5496; /* *aarch64_atomic_loadsi_rcpc_zext */

            default:
              return -1;
            }

        case E_DImode:
          switch (pattern870 (x2, 
E_DImode))
            {
            case 0:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (64 > 8)))
                return -1;
              return 5491; /* *aarch64_atomic_loadqi_rcpc_zext */

            case 1:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (64 > 16)))
                return -1;
              return 5494; /* *aarch64_atomic_loadhi_rcpc_zext */

            case 2:
              if (!
#line 714 "../../gcc/config/aarch64/atomics.md"
(TARGET_RCPC && (64 > 32)))
                return -1;
              return 5497; /* *aarch64_atomic_loadsi_rcpc_zext */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 22:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      switch (GET_MODE (x3))
        {
        case E_QImode:
          if (!aarch64_sync_memory_operand (operands[1], E_QImode))
            return -1;
          return 5508; /* aarch64_load_exclusiveqi */

        case E_HImode:
          if (!aarch64_sync_memory_operand (operands[1], E_HImode))
            return -1;
          return 5509; /* aarch64_load_exclusivehi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_459 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_POLY_INT:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return -1;
          if (aarch64_pluslong_operand (operands[2], E_SImode))
            return 119; /* *addsi3_aarch64 */
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_SImode)
              || !
#line 2543 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx))
            return -1;
          return 122; /* *addsi3_poly_1 */

        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return -1;
          if (aarch64_pluslong_operand (operands[2], E_DImode))
            return 120; /* *adddi3_aarch64 */
          if (!aarch64_pluslong_or_poly_operand (operands[2], E_DImode)
              || !
#line 2543 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE && operands[0] != stack_pointer_rtx))
            return -1;
          return 123; /* *adddi3_poly_1 */

        case E_HFmode:
          if (pattern31 (x2, 
E_HFmode) != 0
              || !(
#line 7215 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return -1;
          return 1042; /* addhf3 */

        case E_SFmode:
          if (pattern31 (x2, 
E_SFmode) != 0
              || !
#line 7215 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1043; /* addsf3 */

        case E_DFmode:
          if (pattern31 (x2, 
E_DFmode) != 0
              || !
#line 7215 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1044; /* adddf3 */

        case E_V8QImode:
          if (pattern31 (x2, 
E_V8QImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1338; /* addv8qi3 */

        case E_V16QImode:
          if (pattern31 (x2, 
E_V16QImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1341; /* addv16qi3 */

        case E_V4HImode:
          if (pattern31 (x2, 
E_V4HImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1342; /* addv4hi3 */

        case E_V8HImode:
          if (pattern31 (x2, 
E_V8HImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1345; /* addv8hi3 */

        case E_V2SImode:
          if (pattern31 (x2, 
E_V2SImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1346; /* addv2si3 */

        case E_V4SImode:
          if (pattern31 (x2, 
E_V4SImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1349; /* addv4si3 */

        case E_V2DImode:
          if (pattern31 (x2, 
E_V2DImode) != 0
              || !
#line 346 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1350; /* addv2di3 */

        case E_V4HFmode:
          if (pattern31 (x2, 
E_V4HFmode) != 0
              || !(
#line 2635 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2345; /* addv4hf3 */

        case E_V8HFmode:
          if (pattern31 (x2, 
E_V8HFmode) != 0
              || !(
#line 2635 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2348; /* addv8hf3 */

        case E_V2SFmode:
          if (pattern31 (x2, 
E_V2SFmode) != 0
              || !
#line 2635 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2349; /* addv2sf3 */

        case E_V4SFmode:
          if (pattern31 (x2, 
E_V4SFmode) != 0
              || !
#line 2635 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2352; /* addv4sf3 */

        case E_V2DFmode:
          if (pattern31 (x2, 
E_V2DFmode) != 0
              || !
#line 2635 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2353; /* addv2df3 */

        case E_VNx16QImode:
          if (pattern728 (x2, 
E_VNx16QImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7947; /* addvnx16qi3 */

        case E_VNx8QImode:
          if (pattern728 (x2, 
E_VNx8QImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7948; /* addvnx8qi3 */

        case E_VNx4QImode:
          if (pattern728 (x2, 
E_VNx4QImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7949; /* addvnx4qi3 */

        case E_VNx2QImode:
          if (pattern728 (x2, 
E_VNx2QImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7950; /* addvnx2qi3 */

        case E_VNx8HImode:
          if (pattern728 (x2, 
E_VNx8HImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7951; /* addvnx8hi3 */

        case E_VNx4HImode:
          if (pattern728 (x2, 
E_VNx4HImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7952; /* addvnx4hi3 */

        case E_VNx2HImode:
          if (pattern728 (x2, 
E_VNx2HImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7953; /* addvnx2hi3 */

        case E_VNx4SImode:
          if (pattern728 (x2, 
E_VNx4SImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7954; /* addvnx4si3 */

        case E_VNx2SImode:
          if (pattern728 (x2, 
E_VNx2SImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7955; /* addvnx2si3 */

        case E_VNx2DImode:
          if (pattern728 (x2, 
E_VNx2DImode) != 0
              || !
#line 4081 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 7956; /* addvnx2di3 */

        case E_VNx8BFmode:
          if (pattern31 (x2, 
E_VNx8BFmode) != 0
              || !(
#line 5372 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
            return -1;
          return 8462; /* *post_ra_faddvnx8bf3 */

        case E_VNx8HFmode:
          if (pattern31 (x2, 
E_VNx8HFmode) != 0
              || !
#line 5372 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8465; /* *post_ra_faddvnx8hf3 */

        case E_VNx4SFmode:
          if (pattern31 (x2, 
E_VNx4SFmode) != 0
              || !
#line 5372 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8468; /* *post_ra_faddvnx4sf3 */

        case E_VNx2DFmode:
          if (pattern31 (x2, 
E_VNx2DFmode) != 0
              || !
#line 5372 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
            return -1;
          return 8471; /* *post_ra_faddvnx2df3 */

        default:
          return -1;
        }

    case UNSPEC:
      if (pattern485 (x2, 
E_V4SFmode) != 0)
        return -1;
      switch (XVECLEN (x4, 0))
        {
        case 2:
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!register_operand (operands[2], E_V8BFmode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[3] = x6;
          if (!register_operand (operands[3], E_V8BFmode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 583:
              if (!
#line 9927 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                return -1;
              return 5248; /* aarch64_bfmmlaqv4sf */

            case 579:
              if (!
#line 9939 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                return -1;
              return 5249; /* aarch64_bfmlalbv4sf */

            case 580:
              if (!
#line 9939 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                return -1;
              return 5250; /* aarch64_bfmlaltv4sf */

            default:
              return -1;
            }

        case 3:
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!register_operand (operands[2], E_V8BFmode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[3] = x6;
          x7 = XVECEXP (x4, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_SImode))
            return -1;
          switch (XINT (x4, 1))
            {
            case 579:
              switch (GET_MODE (operands[3]))
                {
                case E_V4BFmode:
                  if (!register_operand (operands[3], E_V4BFmode)
                      || !
#line 9951 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5251; /* aarch64_bfmlalb_lanev4sf */

                case E_V8BFmode:
                  if (!register_operand (operands[3], E_V8BFmode)
                      || !
#line 9951 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5253; /* aarch64_bfmlalb_lane_qv4sf */

                default:
                  return -1;
                }

            case 580:
              switch (GET_MODE (operands[3]))
                {
                case E_V4BFmode:
                  if (!register_operand (operands[3], E_V4BFmode)
                      || !
#line 9951 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5252; /* aarch64_bfmlalt_lanev4sf */

                case E_V8BFmode:
                  if (!register_operand (operands[3], E_V8BFmode)
                      || !
#line 9951 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
                    return -1;
                  return 5254; /* aarch64_bfmlalt_lane_qv4sf */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      switch (pattern35 (x2))
        {
        case 0:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11407; /* aarch64_sve_single_addvnx32qi */

        case 1:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11412; /* aarch64_sve_single_addvnx16hi */

        case 2:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11417; /* aarch64_sve_single_addvnx8si */

        case 3:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11422; /* aarch64_sve_single_addvnx4di */

        case 4:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11427; /* aarch64_sve_single_addvnx64qi */

        case 5:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11432; /* aarch64_sve_single_addvnx32hi */

        case 6:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11437; /* aarch64_sve_single_addvnx16si */

        case 7:
          if (!
#line 744 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
            return -1;
          return 11442; /* aarch64_sve_single_addvnx8di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_464 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern632 (x2, 
E_SImode) != 0)
            return -1;
          return 382; /* *msubsi */

        case E_DImode:
          if (pattern632 (x2, 
E_DImode) != 0)
            return -1;
          return 383; /* *msubdi */

        case E_V8QImode:
          if (pattern633 (x2, 
E_V8QImode) != 0
              || !
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2021; /* aarch64_mlsv8qi */

        case E_V16QImode:
          if (pattern633 (x2, 
E_V16QImode) != 0
              || !
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2024; /* aarch64_mlsv16qi */

        case E_V4HImode:
          if (pattern633 (x2, 
E_V4HImode) != 0
              || !
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2025; /* aarch64_mlsv4hi */

        case E_V8HImode:
          if (pattern633 (x2, 
E_V8HImode) != 0
              || !
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2028; /* aarch64_mlsv8hi */

        case E_V2SImode:
          if (pattern633 (x2, 
E_V2SImode) != 0
              || !
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2029; /* aarch64_mlsv2si */

        case E_V4SImode:
          if (pattern633 (x2, 
E_V4SImode) != 0
              || !
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2032; /* aarch64_mlsv4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern736 (x2))
                {
                case 0:
                  return 392; /* msubsidi4 */

                case 1:
                  if (!
#line 2201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2261; /* aarch64_smlslv8qi */

                case 2:
                  if (!
#line 2201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2263; /* aarch64_smlslv4hi */

                case 3:
                  if (!
#line 2201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2265; /* aarch64_smlslv2si */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern738 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2216 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2267; /* aarch64_smlsl_nv4hi */

                case 1:
                  if (!
#line 2216 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2269; /* aarch64_smlsl_nv2si */

                case 2:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2329; /* aarch64_vec_smlsl_lane_v4hi */

                case 3:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2331; /* aarch64_vec_smlsl_laneq_v4hi */

                case 4:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2333; /* aarch64_vec_smlsl_lane_v2si */

                case 5:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2335; /* aarch64_vec_smlsl_laneq_v2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              switch (pattern943 (x2))
                {
                case 0:
                  if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                      && 
#line 2097 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2235; /* *aarch64_smlsl_lov16qi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                      || !
#line 2113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2241; /* aarch64_smlsl_hiv16qi_insn */

                case 1:
                  if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                      && 
#line 2097 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2237; /* *aarch64_smlsl_lov8hi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                      || !
#line 2113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2243; /* aarch64_smlsl_hiv8hi_insn */

                case 2:
                  if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                      && 
#line 2097 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2239; /* *aarch64_smlsl_lov4si */
                  if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                      || !
#line 2113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2245; /* aarch64_smlsl_hiv4si_insn */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern945 (x2, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 2144 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2247; /* aarch64_smlsl_hi_nv8hi_insn */

                case 1:
                  if (!
#line 2144 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2249; /* aarch64_smlsl_hi_nv4si_insn */

                case 2:
                  if (!
#line 2545 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2337; /* aarch64_smlsl_hi_lanev8hi_insn */

                case 3:
                  if (!
#line 2583 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2341; /* aarch64_smlsl_hi_laneqv8hi_insn */

                case 4:
                  if (!
#line 2545 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2339; /* aarch64_smlsl_hi_lanev4si_insn */

                case 5:
                  if (!
#line 2583 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2343; /* aarch64_smlsl_hi_laneqv4si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ZERO_EXTEND:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern736 (x2))
                {
                case 0:
                  return 393; /* umsubsidi4 */

                case 1:
                  if (!
#line 2201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2262; /* aarch64_umlslv8qi */

                case 2:
                  if (!
#line 2201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2264; /* aarch64_umlslv4hi */

                case 3:
                  if (!
#line 2201 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2266; /* aarch64_umlslv2si */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern738 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2216 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2268; /* aarch64_umlsl_nv4hi */

                case 1:
                  if (!
#line 2216 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2270; /* aarch64_umlsl_nv2si */

                case 2:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2330; /* aarch64_vec_umlsl_lane_v4hi */

                case 3:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2332; /* aarch64_vec_umlsl_laneq_v4hi */

                case 4:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2334; /* aarch64_vec_umlsl_lane_v2si */

                case 5:
                  if (!
#line 2522 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2336; /* aarch64_vec_umlsl_laneq_v2si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case VEC_SELECT:
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          x9 = XEXP (x5, 1);
          operands[3] = x9;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              switch (pattern943 (x2))
                {
                case 0:
                  if (vect_par_cnst_lo_half (operands[3], E_V16QImode)
                      && 
#line 2097 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2236; /* *aarch64_umlsl_lov16qi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V16QImode)
                      || !
#line 2113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2242; /* aarch64_umlsl_hiv16qi_insn */

                case 1:
                  if (vect_par_cnst_lo_half (operands[3], E_V8HImode)
                      && 
#line 2097 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2238; /* *aarch64_umlsl_lov8hi */
                  if (!vect_par_cnst_hi_half (operands[3], E_V8HImode)
                      || !
#line 2113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2244; /* aarch64_umlsl_hiv8hi_insn */

                case 2:
                  if (vect_par_cnst_lo_half (operands[3], E_V4SImode)
                      && 
#line 2097 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 2240; /* *aarch64_umlsl_lov4si */
                  if (!vect_par_cnst_hi_half (operands[3], E_V4SImode)
                      || !
#line 2113 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2246; /* aarch64_umlsl_hiv4si_insn */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              switch (pattern945 (x2, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 2144 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2248; /* aarch64_umlsl_hi_nv8hi_insn */

                case 1:
                  if (!
#line 2144 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2250; /* aarch64_umlsl_hi_nv4si_insn */

                case 2:
                  if (!
#line 2545 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2338; /* aarch64_umlsl_hi_lanev8hi_insn */

                case 3:
                  if (!
#line 2583 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2342; /* aarch64_umlsl_hi_laneqv8hi_insn */

                case 4:
                  if (!
#line 2545 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2340; /* aarch64_umlsl_hi_lanev4si_insn */

                case 5:
                  if (!
#line 2583 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2344; /* aarch64_umlsl_hi_laneqv4si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case VEC_SELECT:
          x9 = XEXP (x5, 1);
          if (GET_CODE (x9) != PARALLEL
              || XVECLEN (x9, 0) != 1)
            return -1;
          x7 = XEXP (x2, 0);
          operands[4] = x7;
          x8 = XEXP (x5, 0);
          operands[1] = x8;
          x10 = XVECEXP (x9, 0, 0);
          operands[2] = x10;
          if (!immediate_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern1163 (x2, 
E_V4HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (!register_operand (operands[1], E_V4HImode)
                      || !
#line 1710 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2033; /* *aarch64_mls_eltv4hi */

                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !
#line 1728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2041; /* *aarch64_mls_elt_to_128v4hi */

                default:
                  return -1;
                }

            case E_V8HImode:
              if (pattern1163 (x2, 
E_V8HImode, 
E_HImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V8HImode:
                  if (!register_operand (operands[1], E_V8HImode)
                      || !
#line 1710 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2036; /* *aarch64_mls_eltv8hi */

                case E_V4HImode:
                  if (!register_operand (operands[1], E_V4HImode)
                      || !
#line 1728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2044; /* *aarch64_mls_elt_to_64v8hi */

                default:
                  return -1;
                }

            case E_V2SImode:
              if (pattern1163 (x2, 
E_V2SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (!register_operand (operands[1], E_V2SImode)
                      || !
#line 1710 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2037; /* *aarch64_mls_eltv2si */

                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !
#line 1728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2045; /* *aarch64_mls_elt_to_128v2si */

                default:
                  return -1;
                }

            case E_V4SImode:
              if (pattern1163 (x2, 
E_V4SImode, 
E_SImode) != 0)
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (!register_operand (operands[1], E_V4SImode)
                      || !
#line 1710 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2040; /* *aarch64_mls_eltv4si */

                case E_V2SImode:
                  if (!register_operand (operands[1], E_V2SImode)
                      || !
#line 1728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return -1;
                  return 2048; /* *aarch64_mls_elt_to_64v4si */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[3] = x5;
          x7 = XEXP (x2, 0);
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HImode:
              if (pattern946 (x2, 
E_V4HImode, 
E_HImode) != 0
                  || !
#line 1744 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2049; /* aarch64_mls_nv4hi */

            case E_V8HImode:
              if (pattern946 (x2, 
E_V8HImode, 
E_HImode) != 0
                  || !
#line 1744 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2052; /* aarch64_mls_nv8hi */

            case E_V2SImode:
              if (pattern946 (x2, 
E_V2SImode, 
E_SImode) != 0
                  || !
#line 1744 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2053; /* aarch64_mls_nv2si */

            case E_V4SImode:
              if (pattern946 (x2, 
E_V4SImode, 
E_SImode) != 0
                  || !
#line 1744 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 2056; /* aarch64_mls_nv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 167)
        return -1;
      x7 = XEXP (x2, 0);
      operands[1] = x7;
      x11 = XVECEXP (x4, 0, 0);
      operands[3] = x11;
      x12 = XVECEXP (x4, 0, 1);
      operands[4] = x12;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HImode:
          if (pattern1126 (x2, 
E_VNx8HImode) != 0
              || !
#line 1509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11835; /* aarch64_sve_sub_mul_lane_vnx8hi */

        case E_VNx4SImode:
          if (pattern1126 (x2, 
E_VNx4SImode) != 0
              || !
#line 1509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11836; /* aarch64_sve_sub_mul_lane_vnx4si */

        case E_VNx2DImode:
          if (pattern1126 (x2, 
E_VNx2DImode) != 0
              || !
#line 1509 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11837; /* aarch64_sve_sub_mul_lane_vnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_480 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (XVECLEN (x4, 0) == 1)
    {
      x6 = XVECEXP (x4, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern810 (x2, 
E_V8QImode, 
E_QImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1244; /* aarch64_dup_lanev8qi */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1258; /* aarch64_dup_lane_to_128v8qi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V16QImode:
          if (pattern810 (x2, 
E_V16QImode, 
E_QImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V16QImode:
                  if (register_operand (operands[1], E_V16QImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1245; /* aarch64_dup_lanev16qi */
                  break;

                case E_V8QImode:
                  if (register_operand (operands[1], E_V8QImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1259; /* aarch64_dup_lane_to_64v16qi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4HImode:
          if (pattern810 (x2, 
E_V4HImode, 
E_HImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1246; /* aarch64_dup_lanev4hi */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1260; /* aarch64_dup_lane_to_128v4hi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V8HImode:
          if (pattern810 (x2, 
E_V8HImode, 
E_HImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8HImode:
                  if (register_operand (operands[1], E_V8HImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1247; /* aarch64_dup_lanev8hi */
                  break;

                case E_V4HImode:
                  if (register_operand (operands[1], E_V4HImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1261; /* aarch64_dup_lane_to_64v8hi */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2SImode:
          if (pattern810 (x2, 
E_V2SImode, 
E_SImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1248; /* aarch64_dup_lanev2si */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1262; /* aarch64_dup_lane_to_128v2si */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SImode:
          if (pattern810 (x2, 
E_V4SImode, 
E_SImode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4SImode:
                  if (register_operand (operands[1], E_V4SImode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1249; /* aarch64_dup_lanev4si */
                  break;

                case E_V2SImode:
                  if (register_operand (operands[1], E_V2SImode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1263; /* aarch64_dup_lane_to_64v4si */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2DImode:
          if (pattern811 (x2, 
E_V2DImode, 
E_DImode) == 0
              && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1250; /* aarch64_dup_lanev2di */
          break;

        case E_V4HFmode:
          if (pattern810 (x2, 
E_V4HFmode, 
E_HFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1251; /* aarch64_dup_lanev4hf */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1264; /* aarch64_dup_lane_to_128v4hf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V8HFmode:
          if (pattern810 (x2, 
E_V8HFmode, 
E_HFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V8HFmode:
                  if (register_operand (operands[1], E_V8HFmode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1252; /* aarch64_dup_lanev8hf */
                  break;

                case E_V4HFmode:
                  if (register_operand (operands[1], E_V4HFmode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1265; /* aarch64_dup_lane_to_64v8hf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4BFmode:
          if (pattern811 (x2, 
E_V4BFmode, 
E_BFmode) == 0
              && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1253; /* aarch64_dup_lanev4bf */
          break;

        case E_V8BFmode:
          if (pattern811 (x2, 
E_V8BFmode, 
E_BFmode) == 0
              && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1254; /* aarch64_dup_lanev8bf */
          break;

        case E_V2SFmode:
          if (pattern810 (x2, 
E_V2SFmode, 
E_SFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1255; /* aarch64_dup_lanev2sf */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1266; /* aarch64_dup_lane_to_128v2sf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V4SFmode:
          if (pattern810 (x2, 
E_V4SFmode, 
E_SFmode) == 0)
            {
              switch (GET_MODE (operands[1]))
                {
                case E_V4SFmode:
                  if (register_operand (operands[1], E_V4SFmode)
                      && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1256; /* aarch64_dup_lanev4sf */
                  break;

                case E_V2SFmode:
                  if (register_operand (operands[1], E_V2SFmode)
                      && 
#line 137 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1267; /* aarch64_dup_lane_to_64v4sf */
                  break;

                default:
                  break;
                }
            }
          break;

        case E_V2DFmode:
          if (pattern811 (x2, 
E_V2DFmode, 
E_DFmode) == 0
              && 
#line 122 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1257; /* aarch64_dup_lanev2df */
          break;

        case E_VNx16QImode:
          if (pattern812 (x2, 
E_VNx16QImode, 
E_QImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 8 / 8, 0, 63)))
            return 10396; /* aarch64_sve_dup_lanevnx16qi */
          break;

        case E_VNx8QImode:
          if (pattern812 (x2, 
E_VNx8QImode, 
E_QImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10397; /* aarch64_sve_dup_lanevnx8qi */
          break;

        case E_VNx4QImode:
          if (pattern812 (x2, 
E_VNx4QImode, 
E_QImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10398; /* aarch64_sve_dup_lanevnx4qi */
          break;

        case E_VNx2QImode:
          if (pattern812 (x2, 
E_VNx2QImode, 
E_QImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10399; /* aarch64_sve_dup_lanevnx2qi */
          break;

        case E_VNx8HImode:
          if (pattern812 (x2, 
E_VNx8HImode, 
E_HImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10400; /* aarch64_sve_dup_lanevnx8hi */
          break;

        case E_VNx4HImode:
          if (pattern812 (x2, 
E_VNx4HImode, 
E_HImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10401; /* aarch64_sve_dup_lanevnx4hi */
          break;

        case E_VNx2HImode:
          if (pattern812 (x2, 
E_VNx2HImode, 
E_HImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10402; /* aarch64_sve_dup_lanevnx2hi */
          break;

        case E_VNx4SImode:
          if (pattern812 (x2, 
E_VNx4SImode, 
E_SImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10403; /* aarch64_sve_dup_lanevnx4si */
          break;

        case E_VNx2SImode:
          if (pattern812 (x2, 
E_VNx2SImode, 
E_SImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10404; /* aarch64_sve_dup_lanevnx2si */
          break;

        case E_VNx2DImode:
          if (pattern812 (x2, 
E_VNx2DImode, 
E_DImode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10405; /* aarch64_sve_dup_lanevnx2di */
          break;

        case E_VNx8HFmode:
          if (pattern812 (x2, 
E_VNx8HFmode, 
E_HFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10406; /* aarch64_sve_dup_lanevnx8hf */
          break;

        case E_VNx4HFmode:
          if (pattern812 (x2, 
E_VNx4HFmode, 
E_HFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10407; /* aarch64_sve_dup_lanevnx4hf */
          break;

        case E_VNx2HFmode:
          if (pattern812 (x2, 
E_VNx2HFmode, 
E_HFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10408; /* aarch64_sve_dup_lanevnx2hf */
          break;

        case E_VNx8BFmode:
          if (pattern812 (x2, 
E_VNx8BFmode, 
E_BFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 16 / 8, 0, 63)))
            return 10409; /* aarch64_sve_dup_lanevnx8bf */
          break;

        case E_VNx4BFmode:
          if (pattern812 (x2, 
E_VNx4BFmode, 
E_BFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10410; /* aarch64_sve_dup_lanevnx4bf */
          break;

        case E_VNx2BFmode:
          if (pattern812 (x2, 
E_VNx2BFmode, 
E_BFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10411; /* aarch64_sve_dup_lanevnx2bf */
          break;

        case E_VNx4SFmode:
          if (pattern812 (x2, 
E_VNx4SFmode, 
E_SFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 32 / 8, 0, 63)))
            return 10412; /* aarch64_sve_dup_lanevnx4sf */
          break;

        case E_VNx2SFmode:
          if (pattern812 (x2, 
E_VNx2SFmode, 
E_SFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10413; /* aarch64_sve_dup_lanevnx2sf */
          break;

        case E_VNx2DFmode:
          if (pattern812 (x2, 
E_VNx2DFmode, 
E_DFmode) == 0
              && 
#line 9124 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && IN_RANGE (INTVAL (operands[2]) * 64 / 8, 0, 63)))
            return 10414; /* aarch64_sve_dup_lanevnx2df */
          break;

        default:
          break;
        }
    }
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x2) != E_VNx16QImode
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V16QImode:
          if (!register_operand (operands[1], E_V16QImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V16QImode) - 1)))
            return -1;
          return 6413; /* aarch64_vec_duplicate_vqvnx16qi_be */

        case E_VNx16QImode:
          if (!register_operand (operands[1], E_VNx16QImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (QImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (QImode), 0, 63)))
            return -1;
          return 10415; /* aarch64_sve_dupq_lanevnx16qi */

        default:
          return -1;
        }

    case E_VNx8HImode:
      if (!register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x2) != E_VNx8HImode
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HImode:
          if (!register_operand (operands[1], E_V8HImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HImode) - 1)))
            return -1;
          return 6414; /* aarch64_vec_duplicate_vqvnx8hi_be */

        case E_VNx8HImode:
          if (!register_operand (operands[1], E_VNx8HImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (HImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (HImode), 0, 63)))
            return -1;
          return 10416; /* aarch64_sve_dupq_lanevnx8hi */

        default:
          return -1;
        }

    case E_VNx4SImode:
      if (!register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SImode:
          if (!register_operand (operands[1], E_V4SImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SImode) - 1)))
            return -1;
          return 6415; /* aarch64_vec_duplicate_vqvnx4si_be */

        case E_VNx4SImode:
          if (!register_operand (operands[1], E_VNx4SImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (SImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (SImode), 0, 63)))
            return -1;
          return 10417; /* aarch64_sve_dupq_lanevnx4si */

        default:
          return -1;
        }

    case E_VNx2DImode:
      if (!register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x2) != E_VNx2DImode
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DImode:
          if (!register_operand (operands[1], E_V2DImode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DImode) - 1)))
            return -1;
          return 6416; /* aarch64_vec_duplicate_vqvnx2di_be */

        case E_VNx2DImode:
          if (!register_operand (operands[1], E_VNx2DImode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (DImode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (DImode), 0, 63)))
            return -1;
          return 10418; /* aarch64_sve_dupq_lanevnx2di */

        default:
          return -1;
        }

    case E_VNx8BFmode:
      if (!register_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x2) != E_VNx8BFmode
          || GET_MODE (x3) != E_V8BFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8BFmode:
          if (!register_operand (operands[1], E_V8BFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8BFmode) - 1)))
            return -1;
          return 6417; /* aarch64_vec_duplicate_vqvnx8bf_be */

        case E_VNx8BFmode:
          if (!register_operand (operands[1], E_VNx8BFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (BFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (BFmode), 0, 63)))
            return -1;
          return 10419; /* aarch64_sve_dupq_lanevnx8bf */

        default:
          return -1;
        }

    case E_VNx8HFmode:
      if (!register_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x2) != E_VNx8HFmode
          || GET_MODE (x3) != E_V8HFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V8HFmode:
          if (!register_operand (operands[1], E_V8HFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V8HFmode) - 1)))
            return -1;
          return 6418; /* aarch64_vec_duplicate_vqvnx8hf_be */

        case E_VNx8HFmode:
          if (!register_operand (operands[1], E_VNx8HFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (HFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (HFmode), 0, 63)))
            return -1;
          return 10420; /* aarch64_sve_dupq_lanevnx8hf */

        default:
          return -1;
        }

    case E_VNx4SFmode:
      if (!register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x2) != E_VNx4SFmode
          || GET_MODE (x3) != E_V4SFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4SFmode:
          if (!register_operand (operands[1], E_V4SFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V4SFmode) - 1)))
            return -1;
          return 6419; /* aarch64_vec_duplicate_vqvnx4sf_be */

        case E_VNx4SFmode:
          if (!register_operand (operands[1], E_VNx4SFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (SFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (SFmode), 0, 63)))
            return -1;
          return 10421; /* aarch64_sve_dupq_lanevnx4sf */

        default:
          return -1;
        }

    case E_VNx2DFmode:
      if (!register_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x2) != E_VNx2DFmode
          || GET_MODE (x3) != E_V2DFmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V2DFmode:
          if (!register_operand (operands[1], E_V2DFmode)
              || !descending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 2771 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && BYTES_BIG_ENDIAN
   && known_eq (INTVAL (XVECEXP (operands[2], 0, 0)),
		GET_MODE_NUNITS (V2DFmode) - 1)))
            return -1;
          return 6420; /* aarch64_vec_duplicate_vqvnx2df_be */

        case E_VNx2DFmode:
          if (!register_operand (operands[1], E_VNx2DFmode)
              || !ascending_int_parallel (operands[2], E_VOIDmode)
              || !
#line 9152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (INTVAL (XVECEXP (operands[2], 0, 0))
       * GET_MODE_SIZE (DFmode)) % 16 == 0
   && IN_RANGE (INTVAL (XVECEXP (operands[2], 0, 0))
		* GET_MODE_SIZE (DFmode), 0, 63)))
            return -1;
          return 10422; /* aarch64_sve_dupq_lanevnx2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_491 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[0]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern827 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V16QImode, operands[1], operands[2])))
            return 2935; /* load_pair_lanesv8qi */
          break;

        case E_V8HImode:
          if (pattern827 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V8HImode, operands[1], operands[2])))
            return 2936; /* load_pair_lanesv4hi */
          break;

        case E_V8BFmode:
          if (pattern827 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V8BFmode, operands[1], operands[2])))
            return 2937; /* load_pair_lanesv4bf */
          break;

        case E_V8HFmode:
          if (pattern827 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V8HFmode, operands[1], operands[2])))
            return 2938; /* load_pair_lanesv4hf */
          break;

        case E_V4SImode:
          if (pattern827 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V4SImode, operands[1], operands[2])))
            return 2939; /* load_pair_lanesv2si */
          break;

        case E_V4SFmode:
          if (pattern827 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V4SFmode, operands[1], operands[2])))
            return 2940; /* load_pair_lanesv2sf */
          break;

        case E_V2SImode:
          if (pattern827 (x2, 
E_SImode, 
E_V2SImode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2SImode, operands[1], operands[2])))
            return 2941; /* load_pair_lanessi */
          break;

        case E_V2SFmode:
          if (pattern827 (x2, 
E_SFmode, 
E_V2SFmode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2SFmode, operands[1], operands[2])))
            return 2942; /* load_pair_lanessf */
          break;

        case E_V2DImode:
          if (pattern827 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2DImode, operands[1], operands[2])))
            return 2943; /* load_pair_lanesdi */
          break;

        case E_V2DFmode:
          if (pattern827 (x2, 
E_DFmode, 
E_V2DFmode) == 0
              && 
#line 4302 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && aarch64_mergeable_load_pair_p (V2DFmode, operands[1], operands[2])))
            return 2944; /* load_pair_lanesdf */
          break;

        case E_VNx16QImode:
          if (pattern828 (x2, 
E_VNx8QImode, 
E_VNx16QImode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10742; /* aarch64_pack_partialvnx16qi */
          break;

        case E_VNx8QImode:
          if (pattern828 (x2, 
E_VNx4QImode, 
E_VNx8QImode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10743; /* aarch64_pack_partialvnx8qi */
          break;

        case E_VNx8HImode:
          if (pattern828 (x2, 
E_VNx4HImode, 
E_VNx8HImode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10744; /* aarch64_pack_partialvnx8hi */
          break;

        case E_VNx8HFmode:
          if (pattern828 (x2, 
E_VNx4HFmode, 
E_VNx8HFmode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10745; /* aarch64_pack_partialvnx8hf */
          break;

        case E_VNx8BFmode:
          if (pattern828 (x2, 
E_VNx4BFmode, 
E_VNx8BFmode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10746; /* aarch64_pack_partialvnx8bf */
          break;

        case E_VNx4QImode:
          if (pattern828 (x2, 
E_VNx2QImode, 
E_VNx4QImode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10747; /* aarch64_pack_partialvnx4qi */
          break;

        case E_VNx4HImode:
          if (pattern828 (x2, 
E_VNx2HImode, 
E_VNx4HImode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10748; /* aarch64_pack_partialvnx4hi */
          break;

        case E_VNx4HFmode:
          if (pattern828 (x2, 
E_VNx2HFmode, 
E_VNx4HFmode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10749; /* aarch64_pack_partialvnx4hf */
          break;

        case E_VNx4BFmode:
          if (pattern828 (x2, 
E_VNx2BFmode, 
E_VNx4BFmode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10750; /* aarch64_pack_partialvnx4bf */
          break;

        case E_VNx4SImode:
          if (pattern828 (x2, 
E_VNx2SImode, 
E_VNx4SImode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10751; /* aarch64_pack_partialvnx4si */
          break;

        case E_VNx4SFmode:
          if (pattern828 (x2, 
E_VNx2SFmode, 
E_VNx4SFmode) == 0
              && 
#line 9334 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 10752; /* aarch64_pack_partialvnx4sf */
          break;

        default:
          break;
        }
      break;

    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern829 (x2, 
E_V8QImode, 
E_V16QImode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2945; /* store_pair_lanesv8qi */
          break;

        case E_V8HImode:
          if (pattern829 (x2, 
E_V4HImode, 
E_V8HImode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2946; /* store_pair_lanesv4hi */
          break;

        case E_V8BFmode:
          if (pattern829 (x2, 
E_V4BFmode, 
E_V8BFmode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2947; /* store_pair_lanesv4bf */
          break;

        case E_V8HFmode:
          if (pattern829 (x2, 
E_V4HFmode, 
E_V8HFmode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2948; /* store_pair_lanesv4hf */
          break;

        case E_V4SImode:
          if (pattern829 (x2, 
E_V2SImode, 
E_V4SImode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2949; /* store_pair_lanesv2si */
          break;

        case E_V4SFmode:
          if (pattern829 (x2, 
E_V2SFmode, 
E_V4SFmode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2950; /* store_pair_lanesv2sf */
          break;

        case E_V2SImode:
          if (pattern829 (x2, 
E_SImode, 
E_V2SImode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2951; /* store_pair_lanessi */
          break;

        case E_V2SFmode:
          if (pattern829 (x2, 
E_SFmode, 
E_V2SFmode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2952; /* store_pair_lanessf */
          break;

        case E_V2DImode:
          if (pattern829 (x2, 
E_DImode, 
E_V2DImode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2953; /* store_pair_lanesdi */
          break;

        case E_V2DFmode:
          if (pattern829 (x2, 
E_DFmode, 
E_V2DFmode) == 0
              && 
#line 4332 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT))
            return 2954; /* store_pair_lanesdf */
          break;

        default:
          break;
        }
      break;

    default:
      break;
    }
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V8QImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V8QImode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[2], V8QImode))))
            return 2955; /* *aarch64_combine_internalv8qi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V8QImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V8QImode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V16QImode)
       || register_operand (operands[2], V8QImode))))
        return -1;
      return 2965; /* *aarch64_combine_internal_bev8qi */

    case E_V8HImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V4HImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V4HImode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[2], V4HImode))))
            return 2956; /* *aarch64_combine_internalv4hi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V4HImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4HImode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HImode)
       || register_operand (operands[2], V4HImode))))
        return -1;
      return 2966; /* *aarch64_combine_internal_bev4hi */

    case E_V8BFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V8BFmode)
          || GET_MODE (x2) != E_V8BFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V4BFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V4BFmode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[2], V4BFmode))))
            return 2957; /* *aarch64_combine_internalv4bf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V4BFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4BFmode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8BFmode)
       || register_operand (operands[2], V4BFmode))))
        return -1;
      return 2967; /* *aarch64_combine_internal_bev4bf */

    case E_V8HFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V8HFmode)
          || GET_MODE (x2) != E_V8HFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V4HFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V4HFmode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[2], V4HFmode))))
            return 2958; /* *aarch64_combine_internalv4hf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V4HFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V4HFmode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V8HFmode)
       || register_operand (operands[2], V4HFmode))))
        return -1;
      return 2968; /* *aarch64_combine_internal_bev4hf */

    case E_V4SImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V2SImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V2SImode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[2], V2SImode))))
            return 2959; /* *aarch64_combine_internalv2si */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V2SImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V2SImode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SImode)
       || register_operand (operands[2], V2SImode))))
        return -1;
      return 2969; /* *aarch64_combine_internal_bev2si */

    case E_V4SFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V4SFmode)
          || GET_MODE (x2) != E_V4SFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_V2SFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_V2SFmode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[2], V2SFmode))))
            return 2960; /* *aarch64_combine_internalv2sf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_V2SFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_V2SFmode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V4SFmode)
       || register_operand (operands[2], V2SFmode))))
        return -1;
      return 2970; /* *aarch64_combine_internal_bev2sf */

    case E_V2SImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2SImode)
          || GET_MODE (x2) != E_V2SImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_SImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_SImode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SImode)
       || register_operand (operands[2], SImode))))
            return 2961; /* *aarch64_combine_internalsi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_SImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SImode)
       || register_operand (operands[2], SImode))))
        return -1;
      return 2971; /* *aarch64_combine_internal_besi */

    case E_V2SFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2SFmode)
          || GET_MODE (x2) != E_V2SFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_SFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_SFmode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[2], SFmode))))
            return 2962; /* *aarch64_combine_internalsf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_SFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_SFmode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2SFmode)
       || register_operand (operands[2], SFmode))))
        return -1;
      return 2972; /* *aarch64_combine_internal_besf */

    case E_V2DImode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_DImode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_DImode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[2], DImode))))
            return 2963; /* *aarch64_combine_internaldi */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_DImode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DImode)
       || register_operand (operands[2], DImode))))
        return -1;
      return 2973; /* *aarch64_combine_internal_bedi */

    case E_V2DFmode:
      if (!aarch64_reg_or_mem_pair_operand (operands[0], E_V2DFmode)
          || GET_MODE (x2) != E_V2DFmode)
        return -1;
      operands[1] = x4;
      if (register_operand (operands[1], E_DFmode))
        {
          operands[2] = x3;
          if (aarch64_simd_nonimmediate_operand (operands[2], E_DFmode)
              && 
#line 4351 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && !BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[2], DFmode))))
            return 2964; /* *aarch64_combine_internaldf */
        }
      operands[2] = x4;
      if (!aarch64_simd_nonimmediate_operand (operands[2], E_DFmode))
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_DFmode)
          || !
#line 4370 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && BYTES_BIG_ENDIAN
   && (register_operand (operands[0], V2DFmode)
       || register_operand (operands[2], DFmode))))
        return -1;
      return 2974; /* *aarch64_combine_internal_bedf */

    default:
      return -1;
    }
}

 int
recog_500 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          operands[1] = x4;
          switch (pattern315 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1352; /* subv8qi3_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1356; /* subv4hi3_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 355 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1360; /* subv2si3_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 2644 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2355; /* subv4hf3_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 2644 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2359; /* subv2sf3_vec_concatz_le */

            default:
              return -1;
            }

        case MULT:
          x6 = XEXP (x5, 0);
          switch (GET_CODE (x6))
            {
            case REG:
            case SUBREG:
              operands[2] = x6;
              operands[1] = x4;
              x7 = XEXP (x5, 1);
              operands[3] = x7;
              x8 = XEXP (x2, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1020 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2022; /* aarch64_mlsv8qi_vec_concatz_le */

                case E_V8HImode:
                  if (pattern1020 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2026; /* aarch64_mlsv4hi_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1020 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1695 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 2030; /* aarch64_mlsv2si_vec_concatz_le */

                default:
                  return -1;
                }

            case VEC_DUPLICATE:
              x9 = XEXP (x6, 0);
              switch (GET_CODE (x9))
                {
                case VEC_SELECT:
                  x10 = XEXP (x9, 1);
                  if (GET_CODE (x10) != PARALLEL
                      || XVECLEN (x10, 0) != 1)
                    return -1;
                  operands[4] = x4;
                  x11 = XEXP (x9, 0);
                  operands[1] = x11;
                  x12 = XVECEXP (x10, 0, 0);
                  operands[2] = x12;
                  if (!immediate_operand (operands[2], E_SImode))
                    return -1;
                  x7 = XEXP (x5, 1);
                  operands[3] = x7;
                  x8 = XEXP (x2, 1);
                  operands[5] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HImode:
                      if (pattern1228 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V4HImode:
                          if (!register_operand (operands[1], E_V4HImode)
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1710 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2034; /* *aarch64_mls_eltv4hi_vec_concatz_le */

                        case E_V8HImode:
                          if (!register_operand (operands[1], E_V8HImode)
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2042; /* *aarch64_mls_elt_to_128v4hi_vec_concatz_le */

                        default:
                          return -1;
                        }

                    case E_V4SImode:
                      if (pattern1228 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0)
                        return -1;
                      switch (GET_MODE (operands[1]))
                        {
                        case E_V2SImode:
                          if (!register_operand (operands[1], E_V2SImode)
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1710 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2038; /* *aarch64_mls_eltv2si_vec_concatz_le */

                        case E_V4SImode:
                          if (!register_operand (operands[1], E_V4SImode)
                              || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1728 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                            return -1;
                          return 2046; /* *aarch64_mls_elt_to_128v2si_vec_concatz_le */

                        default:
                          return -1;
                        }

                    default:
                      return -1;
                    }

                case REG:
                case SUBREG:
                  operands[3] = x9;
                  operands[1] = x4;
                  x7 = XEXP (x5, 1);
                  operands[2] = x7;
                  x8 = XEXP (x2, 1);
                  operands[4] = x8;
                  switch (GET_MODE (operands[0]))
                    {
                    case E_V8HImode:
                      if (pattern1076 (x2, 
E_V4HImode, 
E_HImode, 
E_V8HImode) != 0
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1744 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2050; /* aarch64_mls_nv4hi_vec_concatz_le */

                    case E_V4SImode:
                      if (pattern1076 (x2, 
E_V2SImode, 
E_SImode, 
E_V4SImode) != 0
                          || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 1744 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                        return -1;
                      return 2054; /* aarch64_mls_nv2si_vec_concatz_le */

                    default:
                      return -1;
                    }

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SMAX:
      switch (pattern417 (x2, 
SMIN))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1627; /* aarch64_sabdv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1635; /* aarch64_sabdv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1643; /* aarch64_sabdv2si_vec_concatz_le */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern417 (x2, 
UMIN))
        {
        case 0:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1630; /* aarch64_uabdv8qi_vec_concatz_le */

        case 1:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1638; /* aarch64_uabdv4hi_vec_concatz_le */

        case 2:
          if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1646; /* aarch64_uabdv2si_vec_concatz_le */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_503 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return recog_459 (x1, insn, pnum_clobbers);

    case ASHIFT:
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[3] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          switch (pattern49 (x3))
            {
            case 0:
              return 205; /* *add_lsl_si */

            case 1:
              return 208; /* *add_lsl_di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern608 (x3))
            {
            case 0:
              return 234; /* *add_extendqi_shft_si */

            case 1:
              return 238; /* *add_extendhi_shft_si */

            case 2:
              return 242; /* *add_extendsi_shft_si */

            case 3:
              return 236; /* *add_extendqi_shft_di */

            case 4:
              return 240; /* *add_extendhi_shft_di */

            case 5:
              return 244; /* *add_extendsi_shft_di */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern608 (x3))
            {
            case 0:
              return 235; /* *add_zero_extendqi_shft_si */

            case 1:
              return 239; /* *add_zero_extendhi_shft_si */

            case 2:
              return 243; /* *add_zero_extendsi_shft_si */

            case 3:
              return 237; /* *add_zero_extendqi_shft_di */

            case 4:
              return 241; /* *add_zero_extendhi_shft_di */

            case 5:
              return 245; /* *add_zero_extendsi_shft_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern284 (x3))
        {
        case 0:
          return 206; /* *add_asr_si */

        case 1:
          return 209; /* *add_asr_di */

        case 2:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1878; /* aarch64_ssra_nv8qi_insn */

        case 3:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1880; /* aarch64_ssra_nv16qi_insn */

        case 4:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1882; /* aarch64_ssra_nv4hi_insn */

        case 5:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1884; /* aarch64_ssra_nv8hi_insn */

        case 6:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1886; /* aarch64_ssra_nv2si_insn */

        case 7:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1888; /* aarch64_ssra_nv4si_insn */

        case 8:
          if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1890; /* aarch64_ssra_nv2di_insn */

        default:
          return -1;
        }

    case LSHIFTRT:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern284 (x3))
            {
            case 0:
              return 207; /* *add_lsr_si */

            case 1:
              return 210; /* *add_lsr_di */

            case 2:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1879; /* aarch64_usra_nv8qi_insn */

            case 3:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1881; /* aarch64_usra_nv16qi_insn */

            case 4:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1883; /* aarch64_usra_nv4hi_insn */

            case 5:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1885; /* aarch64_usra_nv8hi_insn */

            case 6:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1887; /* aarch64_usra_nv2si_insn */

            case 7:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1889; /* aarch64_usra_nv4si_insn */

            case 8:
              if (!
#line 1292 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1891; /* aarch64_usra_nv2di_insn */

            default:
              return -1;
            }

        case PLUS:
          switch (pattern378 (x3))
            {
            case 0:
              if (!
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3199; /* *bitmask_shift_plusv8hi */

            case 1:
              if (!
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3200; /* *bitmask_shift_plusv4si */

            case 2:
              if (!
#line 5014 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 3201; /* *bitmask_shift_plusv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      return recog_462 (x1, insn, pnum_clobbers);

    case ZERO_EXTEND:
      return recog_461 (x1, insn, pnum_clobbers);

    case PLUS:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case GEU:
        case LTU:
          operands[3] = x7;
          x5 = XEXP (x4, 1);
          operands[1] = x5;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern797 (x3, 
E_SImode) != 0)
                return -1;
              return 250; /* *addsi3_carryin */

            case E_DImode:
              if (pattern797 (x3, 
E_DImode) != 0)
                return -1;
              return 251; /* *adddi3_carryin */

            default:
              return -1;
            }

        case VEC_SELECT:
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != VEC_SELECT)
            return -1;
          x8 = XEXP (x7, 1);
          operands[3] = x8;
          x9 = XEXP (x5, 1);
          operands[4] = x9;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          x10 = XEXP (x7, 0);
          switch (GET_CODE (x10))
            {
            case SIGN_EXTEND:
              switch (pattern873 (x3, 
SIGN_EXTEND))
                {
                case 0:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1686; /* *aarch64_sadalpv8qi_insn */

                case 1:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1692; /* *aarch64_sadalpv16qi_insn */

                case 2:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1694; /* *aarch64_sadalpv4hi_insn */

                case 3:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1700; /* *aarch64_sadalpv8hi_insn */

                case 4:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1702; /* *aarch64_sadalpv4si_insn */

                case 5:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1704; /* *aarch64_sadalpv2si_insn */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern873 (x3, 
ZERO_EXTEND))
                {
                case 0:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1689; /* *aarch64_uadalpv8qi_insn */

                case 1:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1693; /* *aarch64_uadalpv16qi_insn */

                case 2:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1697; /* *aarch64_uadalpv4hi_insn */

                case 3:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1701; /* *aarch64_uadalpv8hi_insn */

                case 4:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1703; /* *aarch64_uadalpv4si_insn */

                case 5:
                  if (!
#line 1039 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[3], operands[4])))
                    return -1;
                  return 1707; /* *aarch64_uadalpv2si_insn */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      x5 = XEXP (x4, 1);
      operands[3] = x5;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case ASHIFT:
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          x8 = XEXP (x7, 1);
          operands[2] = x8;
          if (!aarch64_imm3 (operands[2], E_VOIDmode)
              || !const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern991 (x3, 
E_SImode) != 0
                  || !
#line 3214 "../../gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]), INTVAL (operands[3])) != 0))
                return -1;
              return 261; /* *add_uxtsi_shift2 */

            case E_DImode:
              if (pattern991 (x3, 
E_DImode) != 0
                  || !
#line 3214 "../../gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]), INTVAL (operands[3])) != 0))
                return -1;
              return 262; /* *add_uxtdi_shift2 */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x7;
          if (!register_operand (operands[2], E_VNx2DImode)
              || !register_operand (operands[0], E_VNx2DImode)
              || GET_MODE (x3) != E_VNx2DImode
              || GET_MODE (x4) != E_VNx2DImode
              || !aarch64_sve_uxtw_immediate (operands[3], E_VNx2DImode))
            return -1;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          if (!register_operand (operands[1], E_VNx2DImode)
              || !
#line 4177 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
            return -1;
          return 7971; /* *aarch64_adr_uxtw_and */

        default:
          return -1;
        }

    case MULT:
      return recog_458 (x1, insn, pnum_clobbers);

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_463 (x1, insn, pnum_clobbers);

    case SMAX:
      switch (pattern286 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 493; /* *aarch64_minmax_plus */

        case 1:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMAX, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 497; /* *aarch64_minmax_plus */

        default:
          return -1;
        }

    case SMIN:
      switch (pattern286 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 494; /* *aarch64_minmax_plus */

        case 1:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (SMIN, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 498; /* *aarch64_minmax_plus */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern286 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 495; /* *aarch64_minmax_plus */

        case 1:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMAX, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 499; /* *aarch64_minmax_plus */

        default:
          return -1;
        }

    case UMIN:
      switch (pattern286 (x3, pnum_clobbers))
        {
        case 0:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 496; /* *aarch64_minmax_plus */

        case 1:
          if (!
#line 4964 "../../gcc/config/aarch64/aarch64.md"
(aarch64_maxmin_plus_const (UMIN, operands, false)))
            return -1;
          *pnum_clobbers = 1;
          return 500; /* *aarch64_minmax_plus */

        default:
          return -1;
        }

    case UNSPEC:
      return recog_460 (x1, insn, pnum_clobbers);

    case MINUS:
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case SMAX:
          switch (pattern500 (x3, 
SMIN))
            {
            case 0:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1710; /* aarch64_sabav8qi */

            case 1:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1716; /* aarch64_sabav16qi */

            case 2:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1718; /* aarch64_sabav4hi */

            case 3:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1724; /* aarch64_sabav8hi */

            case 4:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1726; /* aarch64_sabav2si */

            case 5:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1732; /* aarch64_sabav4si */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern500 (x3, 
UMIN))
            {
            case 0:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1713; /* aarch64_uabav8qi */

            case 1:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1717; /* aarch64_uabav16qi */

            case 2:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1721; /* aarch64_uabav4hi */

            case 3:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1725; /* aarch64_uabav8hi */

            case 4:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1729; /* aarch64_uabav2si */

            case 5:
              if (!
#line 1104 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1733; /* aarch64_uabav4si */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x7, 0) != 2
              || XINT (x7, 1) != 125)
            return -1;
          x5 = XEXP (x4, 1);
          if (GET_CODE (x5) != UNSPEC
              || XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 125)
            return -1;
          x11 = XVECEXP (x7, 0, 0);
          operands[4] = x11;
          x12 = XVECEXP (x5, 0, 0);
          operands[5] = x12;
          x13 = XVECEXP (x7, 0, 1);
          switch (GET_CODE (x13))
            {
            case SMAX:
              switch (pattern1124 (x3, 
SMIN))
                {
                case 0:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11985; /* *aarch64_sve2_sabavnx16qi */

                case 1:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11987; /* *aarch64_sve2_sabavnx8hi */

                case 2:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11989; /* *aarch64_sve2_sabavnx4si */

                case 3:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11991; /* *aarch64_sve2_sabavnx2di */

                default:
                  return -1;
                }

            case UMAX:
              switch (pattern1124 (x3, 
UMIN))
                {
                case 0:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11986; /* *aarch64_sve2_uabavnx16qi */

                case 1:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11988; /* *aarch64_sve2_uabavnx8hi */

                case 2:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11990; /* *aarch64_sve2_uabavnx4si */

                case 3:
                  if (!
#line 2057 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                    return -1;
                  return 11992; /* *aarch64_sve2_uabavnx2di */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case TRUNCATE:
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case ASHIFTRT:
          switch (pattern501 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1899; /* aarch64_srsra_nv8qi_insn */

            case 1:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1901; /* aarch64_srsra_nv16qi_insn */

            case 2:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1903; /* aarch64_srsra_nv4hi_insn */

            case 3:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1905; /* aarch64_srsra_nv8hi_insn */

            case 4:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1907; /* aarch64_srsra_nv2si_insn */

            case 5:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1909; /* aarch64_srsra_nv4si_insn */

            case 6:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1911; /* aarch64_srsra_nv2di_insn */

            case 7:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1913; /* aarch64_srsra_ndi_insn */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern501 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1900; /* aarch64_ursra_nv8qi_insn */

            case 1:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1902; /* aarch64_ursra_nv16qi_insn */

            case 2:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1904; /* aarch64_ursra_nv4hi_insn */

            case 3:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1906; /* aarch64_ursra_nv8hi_insn */

            case 4:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1908; /* aarch64_ursra_nv2si_insn */

            case 5:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1910; /* aarch64_ursra_nv4si_insn */

            case 6:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1912; /* aarch64_ursra_nv2di_insn */

            case 7:
              if (!
#line 1342 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                return -1;
              return 1914; /* aarch64_ursra_ndi_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x3, 1);
      if (GET_CODE (x6) != VEC_SELECT)
        return -1;
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          switch (pattern503 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2779; /* *aarch64_saddlpv8qi_insn */

            case 1:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2785; /* *aarch64_saddlpv16qi_insn */

            case 2:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2787; /* *aarch64_saddlpv4hi_insn */

            case 3:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2793; /* *aarch64_saddlpv8hi_insn */

            case 4:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2795; /* *aarch64_saddlpv4si_insn */

            case 5:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2797; /* *aarch64_saddlpv2si_insn */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern503 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2782; /* *aarch64_uaddlpv8qi_insn */

            case 1:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2786; /* *aarch64_uaddlpv16qi_insn */

            case 2:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2790; /* *aarch64_uaddlpv4hi_insn */

            case 3:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2794; /* *aarch64_uaddlpv8hi_insn */

            case 4:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2796; /* *aarch64_uaddlpv4si_insn */

            case 5:
              if (!
#line 3540 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
  && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 2800; /* *aarch64_uaddlpv2si_insn */

            default:
              return -1;
            }

        case VEC_CONCAT:
          x14 = XEXP (x6, 0);
          if (GET_CODE (x14) != VEC_CONCAT)
            return -1;
          x10 = XEXP (x7, 0);
          operands[1] = x10;
          x8 = XEXP (x7, 1);
          operands[2] = x8;
          x5 = XEXP (x4, 1);
          operands[3] = x5;
          x15 = XEXP (x6, 1);
          operands[4] = x15;
          x16 = XEXP (x14, 0);
          if (!rtx_equal_p (x16, operands[1]))
            return -1;
          x17 = XEXP (x14, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (pattern1125 (x3, 
E_V16QImode, 
E_V8QImode) != 0
                  || !
#line 7484 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4356; /* aarch64_addpv8qi_insn */

            case E_V4HImode:
              if (pattern1125 (x3, 
E_V8HImode, 
E_V4HImode) != 0
                  || !
#line 7484 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4359; /* aarch64_addpv4hi_insn */

            case E_V2SImode:
              if (pattern1125 (x3, 
E_V4SImode, 
E_V2SImode) != 0
                  || !
#line 7484 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[3], operands[4])))
                return -1;
              return 4362; /* aarch64_addpv2si_insn */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          switch (pattern449 (x3))
            {
            case 0:
              if (!
#line 7501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 4365; /* *aarch64_addp_same_regv16qi */

            case 1:
              if (!
#line 7501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 4366; /* *aarch64_addp_same_regv8hi */

            case 2:
              if (!
#line 7501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 4367; /* *aarch64_addp_same_regv4si */

            case 3:
              if (!
#line 7501 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !rtx_equal_p (operands[2], operands[3])))
                return -1;
              return 4368; /* *aarch64_addp_same_regv2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x7 = XEXP (x4, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
        case TRUNCATE:
          operands[1] = x7;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern729 (x3, 
E_VNx16QImode, 
E_QImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6474; /* *vec_seriesvnx16qi_plus */
              break;

            case E_VNx8QImode:
              if (pattern729 (x3, 
E_VNx8QImode, 
E_QImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6475; /* *vec_seriesvnx8qi_plus */
              break;

            case E_VNx4QImode:
              if (pattern729 (x3, 
E_VNx4QImode, 
E_QImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6476; /* *vec_seriesvnx4qi_plus */
              break;

            case E_VNx2QImode:
              if (pattern729 (x3, 
E_VNx2QImode, 
E_QImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6477; /* *vec_seriesvnx2qi_plus */
              break;

            case E_VNx8HImode:
              if (pattern729 (x3, 
E_VNx8HImode, 
E_HImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6478; /* *vec_seriesvnx8hi_plus */
              break;

            case E_VNx4HImode:
              if (pattern729 (x3, 
E_VNx4HImode, 
E_HImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6479; /* *vec_seriesvnx4hi_plus */
              break;

            case E_VNx2HImode:
              if (pattern729 (x3, 
E_VNx2HImode, 
E_HImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6480; /* *vec_seriesvnx2hi_plus */
              break;

            case E_VNx4SImode:
              if (pattern729 (x3, 
E_VNx4SImode, 
E_SImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6481; /* *vec_seriesvnx4si_plus */
              break;

            case E_VNx2SImode:
              if (pattern729 (x3, 
E_VNx2SImode, 
E_SImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6482; /* *vec_seriesvnx2si_plus */
              break;

            case E_VNx2DImode:
              if (pattern729 (x3, 
E_VNx2DImode, 
E_DImode) == 0
                  && 
#line 2919 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && aarch64_check_zero_based_sve_index_immediate (operands[2])))
                return 6483; /* *vec_seriesvnx2di_plus */
              break;

            default:
              break;
            }
          if (!subreg_lowpart_operator (x7, E_HImode)
              || pattern504 (x3, 
E_VNx8HImode) != 0)
            return -1;
          switch (pattern329 (x7))
            {
            case 0:
              if (!
#line 10502 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10961; /* *aarch64_sve_incvnx8hi_pat */

            case 1:
              if (!
#line 10903 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11013; /* *aarch64_sve_incvnx8hi_cntp */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x7) != E_DImode
              || pattern504 (x3, 
E_VNx2DImode) != 0)
            return -1;
          x10 = XEXP (x7, 0);
          switch (pattern327 (x10))
            {
            case 0:
              if (!
#line 10446 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10955; /* aarch64_sve_incvnx2di_pat */

            case 1:
              if (!
#line 10823 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11007; /* *aarch64_sve_incvnx2di_cntp */

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern379 (x3, 
E_VNx4SImode) != 0
              || GET_MODE (x7) != E_SImode)
            return -1;
          x6 = XEXP (x3, 1);
          operands[1] = x6;
          switch (pattern328 (x7))
            {
            case 0:
              if (!
#line 10467 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 10958; /* aarch64_sve_incvnx4si_pat */

            case 1:
              if (!
#line 10862 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 11010; /* *aarch64_sve_incvnx4si_cntp */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_518 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
      return recog_465 (x1, insn, pnum_clobbers);

    case MINUS:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          operands[3] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern801 (x3, 
E_SImode) != 0)
                return -1;
              return 330; /* *subsi3_carryin */

            case E_DImode:
              if (pattern801 (x3, 
E_DImode) != 0)
                return -1;
              return 331; /* *subdi3_carryin */

            default:
              return -1;
            }

        case GEU:
        case LTU:
          operands[3] = x6;
          x7 = XEXP (x3, 1);
          operands[2] = x7;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern802 (x3, 
E_SImode) != 0)
                return -1;
              return 333; /* *subsi3_carryin_alt */

            case E_DImode:
              if (pattern802 (x3, 
E_DImode) != 0)
                return -1;
              return 334; /* *subdi3_carryin_alt */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern639 (x3, 
E_SImode) != 0)
            return -1;
          return 354; /* *ngcsi */

        case E_DImode:
          if (pattern639 (x3, 
E_DImode) != 0)
            return -1;
          return 355; /* *ngcdi */

        default:
          return -1;
        }

    case UMAX:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_CODE (operands[2]))
        {
        case CONST_POLY_INT:
          x7 = XEXP (x3, 1);
          if (!rtx_equal_p (x7, operands[2]))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_SImode:
              if (pattern803 (x3, 
E_SImode) != 0
                  || !
#line 4948 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE))
                return -1;
              return 491; /* aarch64_uqdecsi */

            case E_DImode:
              if (pattern803 (x3, 
E_DImode) != 0
                  || !
#line 4948 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SVE))
                return -1;
              return 492; /* aarch64_uqdecdi */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != UMIN)
            return -1;
          switch (pattern641 (x3))
            {
            case 0:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1629; /* aarch64_uabdv8qi */

            case 1:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1633; /* aarch64_uabdv16qi */

            case 2:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1637; /* aarch64_uabdv4hi */

            case 3:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1641; /* aarch64_uabdv8hi */

            case 4:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1645; /* aarch64_uabdv2si */

            case 5:
              if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1649; /* aarch64_uabdv4si */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case AND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT
          || XWINT (x6, 0) != 72057594037927935L)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != AND
          || GET_MODE (x7) != E_DImode)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != CONST_INT
          || XWINT (x8, 0) != 72057594037927935L
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x9 = XEXP (x7, 0);
      operands[2] = x9;
      if (!register_operand (operands[2], E_DImode)
          || !
#line 8381 "../../gcc/config/aarch64/aarch64.md"
(TARGET_MEMTAG))
        return -1;
      return 1214; /* subp */

    case SMAX:
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != SMIN)
        return -1;
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (pattern641 (x3))
        {
        case 0:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1626; /* aarch64_sabdv8qi */

        case 1:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1632; /* aarch64_sabdv16qi */

        case 2:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1634; /* aarch64_sabdv4hi */

        case 3:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1640; /* aarch64_sabdv8hi */

        case 4:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1642; /* aarch64_sabdv2si */

        case 5:
          if (!
#line 822 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1648; /* aarch64_sabdv4si */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      switch (pattern292 (x3, 
SIGN_EXTEND))
        {
        case 0:
          if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
              && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2996; /* aarch64_ssublv16qi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
              || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3008; /* aarch64_ssublv16qi_lo_internal */

        case 1:
          if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
              && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3000; /* aarch64_ssublv8hi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
              || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3012; /* aarch64_ssublv8hi_lo_internal */

        case 2:
          if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
              && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3004; /* aarch64_ssublv4si_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
              || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3016; /* aarch64_ssublv4si_lo_internal */

        case 3:
          if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3020; /* aarch64_ssublv8qi */

        case 4:
          if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3024; /* aarch64_ssublv4hi */

        case 5:
          if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3028; /* aarch64_ssublv2si */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern292 (x3, 
ZERO_EXTEND))
        {
        case 0:
          if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
              && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2998; /* aarch64_usublv16qi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
              || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3010; /* aarch64_usublv16qi_lo_internal */

        case 1:
          if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
              && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3002; /* aarch64_usublv8hi_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
              || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3014; /* aarch64_usublv8hi_lo_internal */

        case 2:
          if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
              && 
#line 4481 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 3006; /* aarch64_usublv4si_hi_internal */
          if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
              || !
#line 4494 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3018; /* aarch64_usublv4si_lo_internal */

        case 3:
          if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3022; /* aarch64_usublv8qi */

        case 4:
          if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3026; /* aarch64_usublv4hi */

        case 5:
          if (!
#line 4601 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 3030; /* aarch64_usublv2si */

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 125)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != UNSPEC
          || XVECLEN (x7, 0) != 2
          || XINT (x7, 1) != 125)
        return -1;
      x10 = XVECEXP (x4, 0, 0);
      operands[1] = x10;
      x11 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x11, operands[1]))
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      switch (GET_CODE (x12))
        {
        case SMAX:
          switch (pattern995 (x3, 
SMIN))
            {
            case 0:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7981; /* aarch64_pred_sabdvnx16qi */

            case 1:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7983; /* aarch64_pred_sabdvnx8qi */

            case 2:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7985; /* aarch64_pred_sabdvnx4qi */

            case 3:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7987; /* aarch64_pred_sabdvnx2qi */

            case 4:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7989; /* aarch64_pred_sabdvnx8hi */

            case 5:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7991; /* aarch64_pred_sabdvnx4hi */

            case 6:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7993; /* aarch64_pred_sabdvnx2hi */

            case 7:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7995; /* aarch64_pred_sabdvnx4si */

            case 8:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7997; /* aarch64_pred_sabdvnx2si */

            case 9:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7999; /* aarch64_pred_sabdvnx2di */

            default:
              return -1;
            }

        case UMAX:
          switch (pattern995 (x3, 
UMIN))
            {
            case 0:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7982; /* aarch64_pred_uabdvnx16qi */

            case 1:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7984; /* aarch64_pred_uabdvnx8qi */

            case 2:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7986; /* aarch64_pred_uabdvnx4qi */

            case 3:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7988; /* aarch64_pred_uabdvnx2qi */

            case 4:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7990; /* aarch64_pred_uabdvnx8hi */

            case 5:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7992; /* aarch64_pred_uabdvnx4hi */

            case 6:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7994; /* aarch64_pred_uabdvnx2hi */

            case 7:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7996; /* aarch64_pred_uabdvnx4si */

            case 8:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 7998; /* aarch64_pred_uabdvnx2si */

            case 9:
              if (!
#line 4300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8000; /* aarch64_pred_uabdvnx2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_526 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (pattern384 (x3))
        {
        case 0:
          if (!
#line 3948 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 349; /* *aarch64_abssi2_cssc_insn */

        case 1:
          if (!
#line 3948 "../../gcc/config/aarch64/aarch64.md"
(TARGET_CSSC))
            return -1;
          return 350; /* *aarch64_absdi2_cssc_insn */

        case 2:
          if (!(
#line 7309 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return -1;
          return 1064; /* abshf2 */

        case 3:
          if (!
#line 7309 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1065; /* abssf2 */

        case 4:
          if (!
#line 7309 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1066; /* absdf2 */

        case 5:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1597; /* absv8qi2 */

        case 6:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1600; /* absv16qi2 */

        case 7:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1601; /* absv4hi2 */

        case 8:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1604; /* absv8hi2 */

        case 9:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1605; /* absv2si2 */

        case 10:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1608; /* absv4si2 */

        case 11:
          if (!
#line 790 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1609; /* absv2di2 */

        case 12:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2391; /* absv4hf2 */

        case 13:
          if (!(
#line 2699 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 2394; /* absv8hf2 */

        case 14:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2395; /* absv2sf2 */

        case 15:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2398; /* absv4sf2 */

        case 16:
          if (!
#line 2699 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 2399; /* absv2df2 */

        default:
          return -1;
        }

    case MINUS:
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SIGN_EXTEND:
          switch (pattern386 (x3, 
SIGN_EXTEND))
            {
            case 0:
              if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  && 
#line 904 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1662; /* aarch64_sabdlv16qi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  || !
#line 921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1668; /* aarch64_sabdlv16qi_lo_internal */

            case 1:
              if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  && 
#line 904 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1664; /* aarch64_sabdlv8hi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  || !
#line 921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1670; /* aarch64_sabdlv8hi_lo_internal */

            case 2:
              if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  && 
#line 904 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1666; /* aarch64_sabdlv4si_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  || !
#line 921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1672; /* aarch64_sabdlv4si_lo_internal */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern386 (x3, 
ZERO_EXTEND))
            {
            case 0:
              if (vect_par_cnst_hi_half (operands[3], E_V16QImode)
                  && 
#line 904 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1663; /* aarch64_uabdlv16qi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V16QImode)
                  || !
#line 921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1669; /* aarch64_uabdlv16qi_lo_internal */

            case 1:
              if (vect_par_cnst_hi_half (operands[3], E_V8HImode)
                  && 
#line 904 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1665; /* aarch64_uabdlv8hi_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V8HImode)
                  || !
#line 921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1671; /* aarch64_uabdlv8hi_lo_internal */

            case 2:
              if (vect_par_cnst_hi_half (operands[3], E_V4SImode)
                  && 
#line 904 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 1667; /* aarch64_uabdlv4si_hi_internal */
              if (!vect_par_cnst_lo_half (operands[3], E_V4SImode)
                  || !
#line 921 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1673; /* aarch64_uabdlv4si_lo_internal */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x5;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V4HFmode:
              if (pattern362 (x3, 
E_V4HFmode) != 0
                  || !(
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1734; /* fabdv4hf3 */

            case E_V8HFmode:
              if (pattern362 (x3, 
E_V8HFmode) != 0
                  || !(
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1737; /* fabdv8hf3 */

            case E_V2SFmode:
              if (pattern362 (x3, 
E_V2SFmode) != 0
                  || !
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1738; /* fabdv2sf3 */

            case E_V4SFmode:
              if (pattern362 (x3, 
E_V4SFmode) != 0
                  || !
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1741; /* fabdv4sf3 */

            case E_V2DFmode:
              if (pattern362 (x3, 
E_V2DFmode) != 0
                  || !
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1742; /* fabdv2df3 */

            case E_HFmode:
              if (pattern362 (x3, 
E_HFmode) != 0
                  || !(
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
                return -1;
              return 1743; /* fabdhf3 */

            case E_SFmode:
              if (pattern362 (x3, 
E_SFmode) != 0
                  || !
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1744; /* fabdsf3 */

            case E_DFmode:
              if (pattern362 (x3, 
E_DFmode) != 0
                  || !
#line 1115 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return -1;
              return 1745; /* fabddf3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_535 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern6 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case SUBREG:
        case TRUNCATE:
          switch (pattern513 (x2))
            {
            case 0:
              if (
#line 5820 "../../gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0))
                return 718; /* *aarch64_ashr_reg_si3_mask1 */
              break;

            case 1:
              if (
#line 5820 "../../gcc/config/aarch64/aarch64.md"
((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0))
                return 723; /* *aarch64_ashr_reg_di3_mask1 */
              break;

            case 2:
              if (
#line 5884 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                return 740; /* *aarch64_ashr_reg_di3_mask2 */
              break;

            case 3:
              if (
#line 5832 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (SImode) - 1)) == 0)))
                return 728; /* *aarch64_ashr_reg_si3_neg_mask2 */
              break;

            case 4:
              if (
#line 5832 "../../gcc/config/aarch64/aarch64.md"
(((~INTVAL (operands[3]) & (GET_MODE_BITSIZE (DImode) - 1)) == 0)))
                return 733; /* *aarch64_ashr_reg_di3_neg_mask2 */
              break;

            default:
              break;
            }
          break;

        case CONST_INT:
          switch (pattern514 (x2))
            {
            case 0:
              if (
#line 6148 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (QImode)))
                return 771; /* *ashrqi3_insn */
              break;

            case 1:
              if (
#line 6148 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) < GET_MODE_BITSIZE (HImode)))
                return 774; /* *ashrhi3_insn */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      operands[2] = x3;
      if (!aarch64_reg_or_shift_imm_di (operands[2], E_QImode))
        return -1;
      switch (pattern2 (x2))
        {
        case 0:
          return 754; /* *aarch64_ashr_sisd_or_int_si3 */

        case 1:
          return 755; /* *aarch64_ashr_sisd_or_int_di3 */

        default:
          return -1;
        }

    case 1:
      if (!
#line 5902 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (SImode)))
        return -1;
      return 745; /* *aarch64_ashr_reg_minussi3 */

    case 2:
      if (!
#line 5902 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) == GET_MODE_BITSIZE (DImode)))
        return -1;
      return 748; /* *aarch64_ashr_reg_minusdi3 */

    case 3:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1865; /* aarch64_simd_ashrv8qi */

    case 4:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1868; /* aarch64_simd_ashrv16qi */

    case 5:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1869; /* aarch64_simd_ashrv4hi */

    case 6:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1872; /* aarch64_simd_ashrv8hi */

    case 7:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1873; /* aarch64_simd_ashrv2si */

    case 8:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1876; /* aarch64_simd_ashrv4si */

    case 9:
      if (!
#line 1278 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1877; /* aarch64_simd_ashrv2di */

    case 10:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8233; /* *post_ra_v_ashrvnx16qi3 */

    case 11:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8235; /* *post_ra_v_ashrvnx8qi3 */

    case 12:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8237; /* *post_ra_v_ashrvnx4qi3 */

    case 13:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8239; /* *post_ra_v_ashrvnx2qi3 */

    case 14:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8241; /* *post_ra_v_ashrvnx8hi3 */

    case 15:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8243; /* *post_ra_v_ashrvnx4hi3 */

    case 16:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8245; /* *post_ra_v_ashrvnx2hi3 */

    case 17:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8247; /* *post_ra_v_ashrvnx4si3 */

    case 18:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8249; /* *post_ra_v_ashrvnx2si3 */

    case 19:
      if (!
#line 4923 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && reload_completed))
        return -1;
      return 8251; /* *post_ra_v_ashrvnx2di3 */

    default:
      return -1;
    }
}

 int
recog_562 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3439 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10121; /* while_ugesivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3439 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10131; /* while_ugedivnx8bi_ptest */
}

 int
recog_571 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10100; /* while_ugtsivnx16bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10110; /* while_ugtdivnx16bi_ptest */
}

 int
recog_581 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10059; /* *while_gtsivnx4bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10069; /* *while_gtdivnx4bi_cc */
}

 int
recog_591 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10018; /* *while_gesivnx16bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10028; /* *while_gedivnx16bi_cc */
}

 int
recog_601 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern678 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9940; /* while_ugtsivnx16bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9950; /* while_ugtdivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9960; /* while_ugtsivnx8bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9970; /* while_ugtdivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 9980; /* while_ugtsivnx4bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 9990; /* while_ugtdivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 10000; /* while_ugtsivnx2bi */
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 10010; /* while_ugtdivnx2bi */

    default:
      return -1;
    }
}

 int
recog_606 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_NZmode
              || GET_MODE (x3) != E_CC_NZmode)
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 1);
          switch (GET_CODE (x10))
            {
            case PLUS:
              switch (pattern1240 (x1))
                {
                case 0:
                  return 124; /* addsi3_compare0 */

                case 1:
                  return 125; /* adddi3_compare0 */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              if (pattern1178 (x1, 
PLUS) != 0
                  || !aarch64_plus_operand (operands[2], E_SImode)
                  || !register_operand (operands[0], E_DImode))
                return -1;
              x11 = XEXP (x10, 0);
              x12 = XEXP (x11, 0);
              if (!rtx_equal_p (x12, operands[1]))
                return -1;
              x13 = XEXP (x11, 1);
              if (!rtx_equal_p (x13, operands[2]))
                return -1;
              return 126; /* *addsi3_compare0_uxtw */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          if (!rtx_equal_p (x7, operands[1]))
            return -1;
          x9 = XVECEXP (x1, 0, 1);
          x10 = XEXP (x9, 1);
          if (GET_CODE (x10) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Cmode
              || GET_MODE (x3) != E_CC_Cmode)
            return -1;
          switch (pattern1240 (x1))
            {
            case 0:
              return 129; /* addsi3_compareC */

            case 1:
              return 130; /* adddi3_compareC */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x14 = XEXP (x5, 0);
      operands[1] = x14;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case CONST_INT:
          operands[2] = x6;
          if (pattern1087 (x2) != 0)
            return -1;
          switch (pattern1257 (x1))
            {
            case 0:
              if (pattern1326 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 135; /* addsi3_compareV_imm */

            case 1:
              if (pattern1326 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 136; /* adddi3_compareV_imm */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          if (pattern1087 (x2) != 0)
            return -1;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          switch (pattern1257 (x1))
            {
            case 0:
              if (pattern1327 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 137; /* addsi3_compareV */

            case 1:
              if (pattern1327 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 138; /* adddi3_compareV */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[2] = x6;
          x7 = XEXP (x3, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SIGN_EXTEND)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_NZmode
              || GET_MODE (x3) != E_CC_NZmode)
            return -1;
          switch (pattern1242 (x1))
            {
            case 0:
              return 151; /* *adds_extendqi_si */

            case 1:
              return 155; /* *adds_extendhi_si */

            case 2:
              return 159; /* *adds_extendsi_si */

            case 3:
              return 153; /* *adds_extendqi_di */

            case 4:
              return 157; /* *adds_extendhi_di */

            case 5:
              return 161; /* *adds_extendsi_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern906 (x1, 
ASHIFT) != 0)
        return -1;
      x16 = XEXP (x5, 1);
      operands[2] = x16;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      x11 = XEXP (x10, 0);
      x13 = XEXP (x11, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return -1;
      x17 = XEXP (x10, 1);
      if (!rtx_equal_p (x17, operands[3]))
        return -1;
      x14 = XEXP (x5, 0);
      switch (GET_CODE (x14))
        {
        case REG:
        case SUBREG:
          operands[1] = x14;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[1]))
            return -1;
          switch (pattern908 (x1))
            {
            case 0:
              return 139; /* *adds_shift_imm_si */

            case 1:
              return 142; /* *adds_shift_imm_di */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          switch (pattern1289 (x1, 
SIGN_EXTEND))
            {
            case 0:
              return 175; /* *adds_extendqi_shift_si */

            case 1:
              return 179; /* *adds_extendhi_shift_si */

            case 2:
              return 183; /* *adds_extendsi_shift_si */

            case 3:
              return 177; /* *adds_extendqi_shift_di */

            case 4:
              return 181; /* *adds_extendhi_shift_di */

            case 5:
              return 185; /* *adds_extendsi_shift_di */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern1289 (x1, 
ZERO_EXTEND))
            {
            case 0:
              return 176; /* *adds_zero_extendqi_shift_si */

            case 1:
              return 180; /* *adds_zero_extendhi_shift_si */

            case 2:
              return 184; /* *adds_zero_extendsi_shift_si */

            case 3:
              return 178; /* *adds_zero_extendqi_shift_di */

            case 4:
              return 182; /* *adds_zero_extendhi_shift_di */

            case 5:
              return 186; /* *adds_zero_extendsi_shift_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern910 (x1, 
ASHIFTRT))
        {
        case 0:
          return 140; /* *adds_shift_imm_si */

        case 1:
          return 143; /* *adds_shift_imm_di */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern910 (x1, 
LSHIFTRT))
        {
        case 0:
          return 141; /* *adds_shift_imm_si */

        case 1:
          return 144; /* *adds_shift_imm_di */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern906 (x1, 
ZERO_EXTEND) != 0)
        return -1;
      x14 = XEXP (x5, 0);
      operands[1] = x14;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (pattern1242 (x1))
        {
        case 0:
          return 152; /* *adds_zero_extendqi_si */

        case 1:
          return 156; /* *adds_zero_extendhi_si */

        case 2:
          return 160; /* *adds_zero_extendsi_si */

        case 3:
          return 154; /* *adds_zero_extendqi_di */

        case 4:
          return 158; /* *adds_zero_extendhi_di */

        case 5:
          return 162; /* *adds_zero_extendsi_di */

        default:
          return -1;
        }

    case GEU:
    case LTU:
      operands[2] = x5;
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_ADCmode
              || GET_MODE (x3) != E_CC_ADCmode)
            return -1;
          x15 = XEXP (x6, 0);
          operands[1] = x15;
          x7 = XEXP (x3, 1);
          operands[4] = x7;
          if (!const_scalar_int_operand (operands[4], E_VOIDmode))
            return -1;
          x11 = XEXP (x10, 0);
          operands[3] = x11;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1301 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 3115 "../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[4], DImode)
   == (wi::shwi (1, DImode) << (unsigned) GET_MODE_BITSIZE (SImode))))
                return -1;
              return 253; /* *addsi3_carryinC_zero */

            case E_TImode:
              if (pattern1301 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 3115 "../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[4], TImode)
   == (wi::shwi (1, TImode) << (unsigned) GET_MODE_BITSIZE (DImode))))
                return -1;
              return 254; /* *adddi3_carryinC_zero */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x18 = XEXP (x7, 0);
          if (GET_CODE (x18) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Vmode
              || GET_MODE (x3) != E_CC_Vmode)
            return -1;
          x15 = XEXP (x6, 0);
          operands[1] = x15;
          x19 = XEXP (x18, 0);
          operands[3] = x19;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[1]))
            return -1;
          x11 = XEXP (x10, 0);
          if (!rtx_equal_p (x11, operands[3]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1328 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 257; /* *addsi3_carryinV_zero */

            case E_TImode:
              if (pattern1328 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 258; /* *adddi3_carryinV_zero */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case PLUS:
      x9 = XVECEXP (x1, 0, 1);
      x10 = XEXP (x9, 1);
      if (GET_CODE (x10) != PLUS)
        return -1;
      x11 = XEXP (x10, 0);
      if (GET_CODE (x11) != PLUS)
        return -1;
      x14 = XEXP (x5, 0);
      operands[3] = x14;
      x16 = XEXP (x5, 1);
      switch (GET_CODE (x16))
        {
        case ZERO_EXTEND:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != ZERO_EXTEND)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_ADCmode
              || GET_MODE (x3) != E_CC_ADCmode)
            return -1;
          x21 = XEXP (x16, 0);
          operands[1] = x21;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x7 = XEXP (x3, 1);
          operands[5] = x7;
          if (!const_scalar_int_operand (operands[5], E_VOIDmode))
            return -1;
          x12 = XEXP (x11, 0);
          operands[4] = x12;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1336 (x1, 
E_SImode, 
E_DImode) != 0
                  || !
#line 3135 "../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[5], DImode)
   == (wi::shwi (1, DImode) << (unsigned) GET_MODE_BITSIZE (SImode))))
                return -1;
              return 255; /* *addsi3_carryinC */

            case E_TImode:
              if (pattern1336 (x1, 
E_DImode, 
E_TImode) != 0
                  || !
#line 3135 "../../gcc/config/aarch64/aarch64.md"
(rtx_mode_t (operands[5], TImode)
   == (wi::shwi (1, TImode) << (unsigned) GET_MODE_BITSIZE (DImode))))
                return -1;
              return 256; /* *adddi3_carryinC */

            default:
              return -1;
            }

        case SIGN_EXTEND:
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != SIGN_EXTEND)
            return -1;
          x7 = XEXP (x3, 1);
          if (GET_CODE (x7) != SIGN_EXTEND)
            return -1;
          x18 = XEXP (x7, 0);
          if (GET_CODE (x18) != PLUS)
            return -1;
          x19 = XEXP (x18, 0);
          if (GET_CODE (x19) != PLUS)
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_MODE (x8) != E_CC_Vmode
              || GET_MODE (x3) != E_CC_Vmode)
            return -1;
          x21 = XEXP (x16, 0);
          operands[1] = x21;
          x15 = XEXP (x6, 0);
          operands[2] = x15;
          x22 = XEXP (x19, 0);
          operands[4] = x22;
          x23 = XEXP (x19, 1);
          if (!rtx_equal_p (x23, operands[1]))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[2]))
            return -1;
          x12 = XEXP (x11, 0);
          if (!rtx_equal_p (x12, operands[4]))
            return -1;
          x13 = XEXP (x11, 1);
          if (!rtx_equal_p (x13, operands[1]))
            return -1;
          x17 = XEXP (x10, 1);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_DImode:
              if (pattern1354 (x1, 
E_SImode, 
E_DImode) != 0)
                return -1;
              return 259; /* *addsi3_carryinV */

            case E_TImode:
              if (pattern1354 (x1, 
E_DImode, 
E_TImode) != 0)
                return -1;
              return 260; /* *adddi3_carryinV */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_613 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (XINT (x4, 1))
        {
        case 17:
          if (pattern769 (x1) != 0
              || !
#line 8278 "../../gcc/config/aarch64/aarch64.md"
(TARGET_TME))
            return -1;
          return 1205; /* tstart */

        case 157:
          if (pattern769 (x1) != 0
              || !
#line 8287 "../../gcc/config/aarch64/aarch64.md"
(TARGET_TME))
            return -1;
          return 1206; /* ttest */

        case 20:
          if (pattern770 (x1, 
20) != 0
              || !
#line 8314 "../../gcc/config/aarch64/aarch64.md"
(TARGET_RNG))
            return -1;
          return 1209; /* aarch64_rndr */

        case 21:
          if (pattern770 (x1, 
21) != 0
              || !
#line 8324 "../../gcc/config/aarch64/aarch64.md"
(TARGET_RNG))
            return -1;
          return 1210; /* aarch64_rndrrs */

        case 66:
          if (pattern771 (x1, 
65) != 0
              || !
#line 8445 "../../gcc/config/aarch64/aarch64.md"
(TARGET_LS64))
            return -1;
          return 1219; /* st64bv */

        case 68:
          if (pattern771 (x1, 
67) != 0
              || !
#line 8457 "../../gcc/config/aarch64/aarch64.md"
(TARGET_LS64))
            return -1;
          return 1220; /* st64bv0 */

        case 23:
          if (GET_MODE (x4) != E_SImode)
            return -1;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != SET)
            return -1;
          x7 = XEXP (x6, 1);
          if (GET_CODE (x7) != UNSPEC_VOLATILE
              || XINT (x7, 1) != 23
              || !register_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x6, 0);
          operands[1] = x8;
          switch (XVECLEN (x7, 0))
            {
            case 2:
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              if (!const_int_operand (operands[3], E_SImode))
                return -1;
              switch (GET_MODE (operands[1]))
                {
                case E_QImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_QImode)
                      || GET_MODE (x7) != E_QImode
                      || !aarch64_reg_or_zero (operands[2], E_QImode))
                    return -1;
                  return 5513; /* aarch64_store_exclusiveqi */

                case E_HImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_HImode)
                      || GET_MODE (x7) != E_HImode
                      || !aarch64_reg_or_zero (operands[2], E_HImode))
                    return -1;
                  return 5514; /* aarch64_store_exclusivehi */

                case E_SImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_SImode)
                      || GET_MODE (x7) != E_SImode
                      || !aarch64_reg_or_zero (operands[2], E_SImode))
                    return -1;
                  return 5515; /* aarch64_store_exclusivesi */

                case E_DImode:
                  if (!aarch64_sync_memory_operand (operands[1], E_DImode)
                      || GET_MODE (x7) != E_DImode
                      || !aarch64_reg_or_zero (operands[2], E_DImode))
                    return -1;
                  return 5516; /* aarch64_store_exclusivedi */

                default:
                  return -1;
                }

            case 3:
              if (GET_MODE (x7) != E_TImode
                  || !aarch64_sync_memory_operand (operands[1], E_TImode))
                return -1;
              x9 = XVECEXP (x7, 0, 0);
              operands[2] = x9;
              if (!aarch64_reg_or_zero (operands[2], E_DImode))
                return -1;
              x10 = XVECEXP (x7, 0, 1);
              operands[3] = x10;
              if (!aarch64_reg_or_zero (operands[3], E_DImode))
                return -1;
              x11 = XVECEXP (x7, 0, 2);
              operands[4] = x11;
              if (!const_int_operand (operands[4], E_SImode))
                return -1;
              return 5517; /* aarch64_store_exclusive_pair */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      operands[1] = x12;
      x13 = XVECEXP (x4, 0, 2);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[3] = x8;
      x5 = XVECEXP (x4, 0, 0);
      if (!rtx_equal_p (x5, operands[0]))
        return -1;
      switch (XINT (x4, 1))
        {
        case 32:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1144 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5388; /* aarch64_atomic_iorqi_lse */

            case E_HImode:
              if (pattern1144 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5392; /* aarch64_atomic_iorhi_lse */

            case E_SImode:
              if (pattern1144 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5396; /* aarch64_atomic_iorsi_lse */

            case E_DImode:
              if (pattern1144 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5400; /* aarch64_atomic_iordi_lse */

            default:
              return -1;
            }

        case 33:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1144 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5389; /* aarch64_atomic_bicqi_lse */

            case E_HImode:
              if (pattern1144 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5393; /* aarch64_atomic_bichi_lse */

            case E_SImode:
              if (pattern1144 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5397; /* aarch64_atomic_bicsi_lse */

            case E_DImode:
              if (pattern1144 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5401; /* aarch64_atomic_bicdi_lse */

            default:
              return -1;
            }

        case 34:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1144 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5390; /* aarch64_atomic_xorqi_lse */

            case E_HImode:
              if (pattern1144 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5394; /* aarch64_atomic_xorhi_lse */

            case E_SImode:
              if (pattern1144 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5398; /* aarch64_atomic_xorsi_lse */

            case E_DImode:
              if (pattern1144 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5402; /* aarch64_atomic_xordi_lse */

            default:
              return -1;
            }

        case 35:
          switch (GET_MODE (operands[0]))
            {
            case E_QImode:
              if (pattern1144 (x4, 
E_QImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5391; /* aarch64_atomic_addqi_lse */

            case E_HImode:
              if (pattern1144 (x4, 
E_HImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5395; /* aarch64_atomic_addhi_lse */

            case E_SImode:
              if (pattern1144 (x4, 
E_SImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5399; /* aarch64_atomic_addsi_lse */

            case E_DImode:
              if (pattern1144 (x4, 
E_DImode) != 0
                  || !
#line 379 "../../gcc/config/aarch64/atomics.md"
(TARGET_LSE))
                return -1;
              return 5403; /* aarch64_atomic_adddi_lse */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      if (XINT (x4, 1) != 22
          || GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (pattern772 (x6, 
E_DImode, 
22, 
2, 
UNSPEC_VOLATILE) != 0
          || !register_operand (operands[0], E_DImode))
        return -1;
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      if (!aarch64_sync_memory_operand (operands[2], E_TImode))
        return -1;
      x12 = XVECEXP (x4, 0, 1);
      operands[3] = x12;
      if (!const_int_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x6, 1);
      x9 = XVECEXP (x7, 0, 0);
      if (!rtx_equal_p (x9, operands[2]))
        return -1;
      x10 = XVECEXP (x7, 0, 1);
      if (!rtx_equal_p (x10, operands[3]))
        return -1;
      return 5512; /* aarch64_load_exclusive_pair */

    default:
      return -1;
    }
}

 int
recog_621 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52, x53, x54, x55, x56, x57;
  rtx x58, x59, x60;
  int res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 5:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x4) != CLOBBER)
        return -1;
      x5 = XEXP (x2, 1);
      switch (GET_CODE (x5))
        {
        case SUBREG:
        case MEM:
          x6 = XEXP (x4, 0);
          operands[4] = x6;
          if (scratch_operand (operands[4], E_DImode))
            {
              res = recog_543 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != SET)
            return -1;
          x8 = XEXP (x7, 1);
          if (GET_CODE (x8) != UNSPEC_VOLATILE
              || XVECLEN (x8, 0) != 2
              || XINT (x8, 1) != 31)
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 66
              || GET_MODE (x9) != E_CCmode)
            return -1;
          x10 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x11 = XEXP (x2, 0);
          operands[0] = x11;
          operands[1] = x5;
          x12 = XVECEXP (x8, 0, 1);
          operands[3] = x12;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          switch (pattern1268 (x1))
            {
            case 0:
              return 5408; /* aarch64_atomic_fetch_addqi */

            case 1:
              return 5413; /* aarch64_atomic_fetch_addhi */

            case 2:
              return 5418; /* aarch64_atomic_fetch_addsi */

            case 3:
              return 5423; /* aarch64_atomic_fetch_adddi */

            case 4:
              return 5409; /* aarch64_atomic_fetch_subqi */

            case 5:
              return 5414; /* aarch64_atomic_fetch_subhi */

            case 6:
              return 5419; /* aarch64_atomic_fetch_subsi */

            case 7:
              return 5424; /* aarch64_atomic_fetch_subdi */

            case 8:
              return 5410; /* aarch64_atomic_fetch_orqi */

            case 9:
              return 5415; /* aarch64_atomic_fetch_orhi */

            case 10:
              return 5420; /* aarch64_atomic_fetch_orsi */

            case 11:
              return 5425; /* aarch64_atomic_fetch_ordi */

            case 12:
              return 5411; /* aarch64_atomic_fetch_xorqi */

            case 13:
              return 5416; /* aarch64_atomic_fetch_xorhi */

            case 14:
              return 5421; /* aarch64_atomic_fetch_xorsi */

            case 15:
              return 5426; /* aarch64_atomic_fetch_xordi */

            case 16:
              return 5412; /* aarch64_atomic_fetch_andqi */

            case 17:
              return 5417; /* aarch64_atomic_fetch_andhi */

            case 18:
              return 5422; /* aarch64_atomic_fetch_andsi */

            case 19:
              return 5427; /* aarch64_atomic_fetch_anddi */

            case 20:
              return 5444; /* atomic_fetch_nandqi */

            case 21:
              return 5445; /* atomic_fetch_nandhi */

            case 22:
              return 5446; /* atomic_fetch_nandsi */

            case 23:
              return 5447; /* atomic_fetch_nanddi */

            default:
              return -1;
            }

        case CONST_INT:
          if (XWINT (x5, 0) != 0L)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 66
              || GET_MODE (x6) != E_CCmode)
            return -1;
          x10 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x10) != SET)
            return -1;
          x13 = XEXP (x10, 1);
          if (GET_CODE (x13) != UNSPEC
              || XVECLEN (x13, 0) != 2)
            return -1;
          x14 = XVECEXP (x13, 0, 0);
          if (GET_CODE (x14) != MEM
              || GET_MODE (x14) != E_BLKmode)
            return -1;
          x15 = XEXP (x10, 0);
          if (GET_CODE (x15) != MEM
              || GET_MODE (x15) != E_BLKmode)
            return -1;
          x11 = XEXP (x2, 0);
          operands[2] = x11;
          if (!register_operand (operands[2], E_DImode))
            return -1;
          x16 = XEXP (x7, 0);
          operands[0] = x16;
          if (!register_operand (operands[0], E_DImode))
            return -1;
          x9 = XEXP (x3, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_DImode)
              || GET_MODE (x13) != E_BLKmode)
            return -1;
          x17 = XEXP (x14, 0);
          if (!rtx_equal_p (x17, operands[1]))
            return -1;
          x18 = XVECEXP (x13, 0, 1);
          if (!rtx_equal_p (x18, operands[2]))
            return -1;
          x19 = XEXP (x15, 0);
          if (!rtx_equal_p (x19, operands[0]))
            return -1;
          switch (XINT (x13, 1))
            {
            case 8:
              if (!
#line 1908 "../../gcc/config/aarch64/aarch64.md"
(TARGET_MOPS))
                return -1;
              return 84; /* *aarch64_cpymemdi */

            case 70:
              if (!
#line 1954 "../../gcc/config/aarch64/aarch64.md"
(TARGET_MOPS))
                return -1;
              return 85; /* *aarch64_movmemdi */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 1
              || XINT (x5, 1) != 98)
            return -1;
          x11 = XEXP (x2, 0);
          if (GET_CODE (x11) != REG
              || REGNO (x11) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern443 (x7, 
30, 
E_DImode, 
CLOBBER) != 0)
            return -1;
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != REG
              || REGNO (x9) != 66
              || GET_MODE (x9) != E_CCmode)
            return -1;
          x10 = XVECEXP (x1, 0, 4);
          if (pattern1233 (x10, 
29, 
USE) != 0)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          operands[0] = x20;
          if (!aarch64_valid_symref (operands[0], E_VOIDmode))
            return -1;
          x6 = XEXP (x4, 0);
          operands[1] = x6;
          if (!scratch_operand (operands[1], E_DImode))
            return -1;
          switch (GET_MODE (x11))
            {
            case E_SImode:
              if (GET_MODE (x5) != E_SImode
                  || !(
#line 7807 "../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && !TARGET_SVE) && 
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == SImode)))
                return -1;
              return 1135; /* tlsdesc_small_advsimd_si */

            case E_DImode:
              if (GET_MODE (x5) != E_DImode
                  || !(
#line 7807 "../../gcc/config/aarch64/aarch64.md"
(TARGET_TLS_DESC && !TARGET_SVE) && 
#line 168 "../../gcc/config/aarch64/iterators.md"
(ptr_mode == DImode)))
                return -1;
              return 1136; /* tlsdesc_small_advsimd_di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_617 (x1, insn, pnum_clobbers);

    case 3:
      return recog_619 (x1, insn, pnum_clobbers);

    case 4:
      return recog_618 (x1, insn, pnum_clobbers);

    case 6:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC_VOLATILE
          || pattern357 (x5, 
E_TImode, 
682) != 0
          || pattern445 (x1, 
17, 
CLOBBER, 
16, 
E_TImode, 
0) != 0)
        return -1;
      x4 = XVECEXP (x1, 0, 3);
      if (pattern1213 (x4, 
18) != 0)
        return -1;
      x10 = XVECEXP (x1, 0, 4);
      if (pattern1233 (x10, 
30, 
CLOBBER) != 0)
        return -1;
      x21 = XVECEXP (x1, 0, 5);
      if (GET_CODE (x21) != CLOBBER)
        return -1;
      x22 = XEXP (x21, 0);
      if (GET_CODE (x22) != REG
          || REGNO (x22) != 66
          || GET_MODE (x22) != E_CCmode)
        return -1;
      return 12895; /* aarch64_get_sme_state */

    case 26:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != UNSPEC_VOLATILE
          || XVECLEN (x2, 0) != 1)
        return -1;
      x23 = XVECEXP (x2, 0, 0);
      if (x23 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != USE
          || pattern565 (x1, 
32, 
67, 
CLOBBER) != 0
          || pattern1027 (x1, 
E_V4x16QImode, 
48, 
44, 
40, 
36) != 0)
        return -1;
      x24 = XVECEXP (x1, 0, 7);
      if (pattern1356 (x24, 
E_V4x16QImode, 
52) != 0)
        return -1;
      x25 = XVECEXP (x1, 0, 8);
      if (pattern689 (x25, 
E_V4x16QImode, 
56) != 0)
        return -1;
      x26 = XVECEXP (x1, 0, 9);
      if (GET_CODE (x26) != CLOBBER)
        return -1;
      x27 = XEXP (x26, 0);
      if (GET_CODE (x27) != REG
          || REGNO (x27) != 60
          || GET_MODE (x27) != E_V4x16QImode)
        return -1;
      x28 = XVECEXP (x1, 0, 10);
      if (GET_CODE (x28) != CLOBBER)
        return -1;
      x29 = XEXP (x28, 0);
      if (GET_CODE (x29) != REG
          || REGNO (x29) != 68
          || GET_MODE (x29) != E_VNx16BImode)
        return -1;
      x30 = XVECEXP (x1, 0, 11);
      if (GET_CODE (x30) != CLOBBER)
        return -1;
      x31 = XEXP (x30, 0);
      if (GET_CODE (x31) != REG
          || REGNO (x31) != 69
          || GET_MODE (x31) != E_VNx16BImode)
        return -1;
      x32 = XVECEXP (x1, 0, 12);
      if (GET_CODE (x32) != CLOBBER)
        return -1;
      x33 = XEXP (x32, 0);
      if (GET_CODE (x33) != REG
          || REGNO (x33) != 70
          || GET_MODE (x33) != E_VNx16BImode)
        return -1;
      x34 = XVECEXP (x1, 0, 13);
      if (GET_CODE (x34) != CLOBBER)
        return -1;
      x35 = XEXP (x34, 0);
      if (GET_CODE (x35) != REG
          || REGNO (x35) != 71
          || GET_MODE (x35) != E_VNx16BImode)
        return -1;
      x36 = XVECEXP (x1, 0, 14);
      if (GET_CODE (x36) != CLOBBER)
        return -1;
      x37 = XEXP (x36, 0);
      if (GET_CODE (x37) != REG
          || REGNO (x37) != 72
          || GET_MODE (x37) != E_VNx16BImode)
        return -1;
      x38 = XVECEXP (x1, 0, 15);
      if (GET_CODE (x38) != CLOBBER)
        return -1;
      x39 = XEXP (x38, 0);
      if (GET_CODE (x39) != REG
          || REGNO (x39) != 73
          || GET_MODE (x39) != E_VNx16BImode)
        return -1;
      x40 = XVECEXP (x1, 0, 16);
      if (GET_CODE (x40) != CLOBBER)
        return -1;
      x41 = XEXP (x40, 0);
      if (GET_CODE (x41) != REG
          || REGNO (x41) != 74
          || GET_MODE (x41) != E_VNx16BImode)
        return -1;
      x42 = XVECEXP (x1, 0, 17);
      if (GET_CODE (x42) != CLOBBER)
        return -1;
      x43 = XEXP (x42, 0);
      if (GET_CODE (x43) != REG
          || REGNO (x43) != 75
          || GET_MODE (x43) != E_VNx16BImode)
        return -1;
      x44 = XVECEXP (x1, 0, 18);
      if (GET_CODE (x44) != CLOBBER)
        return -1;
      x45 = XEXP (x44, 0);
      if (GET_CODE (x45) != REG
          || REGNO (x45) != 76
          || GET_MODE (x45) != E_VNx16BImode)
        return -1;
      x46 = XVECEXP (x1, 0, 19);
      if (GET_CODE (x46) != CLOBBER)
        return -1;
      x47 = XEXP (x46, 0);
      if (GET_CODE (x47) != REG
          || REGNO (x47) != 77
          || GET_MODE (x47) != E_VNx16BImode)
        return -1;
      x48 = XVECEXP (x1, 0, 20);
      if (GET_CODE (x48) != CLOBBER)
        return -1;
      x49 = XEXP (x48, 0);
      if (GET_CODE (x49) != REG
          || REGNO (x49) != 78
          || GET_MODE (x49) != E_VNx16BImode)
        return -1;
      x50 = XVECEXP (x1, 0, 21);
      if (GET_CODE (x50) != CLOBBER)
        return -1;
      x51 = XEXP (x50, 0);
      if (GET_CODE (x51) != REG
          || REGNO (x51) != 79
          || GET_MODE (x51) != E_VNx16BImode)
        return -1;
      x52 = XVECEXP (x1, 0, 22);
      if (GET_CODE (x52) != CLOBBER)
        return -1;
      x53 = XEXP (x52, 0);
      if (GET_CODE (x53) != REG
          || REGNO (x53) != 80
          || GET_MODE (x53) != E_VNx16BImode)
        return -1;
      x54 = XVECEXP (x1, 0, 23);
      if (GET_CODE (x54) != CLOBBER)
        return -1;
      x55 = XEXP (x54, 0);
      if (GET_CODE (x55) != REG
          || REGNO (x55) != 81
          || GET_MODE (x55) != E_VNx16BImode)
        return -1;
      x56 = XVECEXP (x1, 0, 24);
      if (GET_CODE (x56) != CLOBBER)
        return -1;
      x57 = XEXP (x56, 0);
      if (GET_CODE (x57) != REG
          || REGNO (x57) != 82
          || GET_MODE (x57) != E_VNx16BImode)
        return -1;
      x58 = XVECEXP (x1, 0, 25);
      if (GET_CODE (x58) != CLOBBER)
        return -1;
      x59 = XEXP (x58, 0);
      if (GET_CODE (x59) != REG
          || REGNO (x59) != 83
          || GET_MODE (x59) != E_VNx16BImode)
        return -1;
      switch (XINT (x2, 1))
        {
        case 684:
          return 12897; /* aarch64_smstart_sm */

        case 685:
          return 12898; /* aarch64_smstop_sm */

        default:
          return -1;
        }

    case 8:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 688
          || pattern566 (x5, 
89) != 0)
        return -1;
      x60 = XVECEXP (x5, 0, 1);
      if (GET_CODE (x60) != REG
          || REGNO (x60) != 90
          || GET_MODE (x60) != E_DImode)
        return -1;
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 91
          || GET_MODE (x11) != E_DImode)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER
          || pattern565 (x1, 
15, 
14, 
CLOBBER) != 0
          || pattern1027 (x1, 
E_DImode, 
30, 
18, 
17, 
16) != 0)
        return -1;
      x24 = XVECEXP (x1, 0, 7);
      if (pattern1356 (x24, 
E_CCmode, 
66) != 0)
        return -1;
      return 12899; /* aarch64_tpidr2_save */

    case 9:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return -1;
      x5 = XEXP (x2, 1);
      if (GET_CODE (x5) != UNSPEC)
        return -1;
      x11 = XEXP (x2, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 92
          || GET_MODE (x11) != E_DImode
          || pattern690 (x1) != 0
          || GET_MODE (x5) != E_DImode)
        return -1;
      switch (XVECLEN (x5, 0))
        {
        case 1:
          if (XINT (x5, 1) != 689)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 0
              || GET_MODE (x20) != E_DImode)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern1141 (x7) != 0)
            return -1;
          return 12907; /* aarch64_tpidr2_restore */

        case 4:
          if (XINT (x5, 1) != 693
              || pattern706 (x5) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 1);
          if (pattern443 (x7, 
0, 
E_DImode, 
CLOBBER) != 0)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          operands[0] = x20;
          if (!pmode_register_operand (operands[0], E_VOIDmode))
            return -1;
          return 12908; /* aarch64_restore_za */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern973 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1123 (insn, operands);
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1156 (insn, operands);

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1134 (insn, operands);
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1167 (insn, operands);

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[3] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1145 (insn, operands);
      operands[4] = x4;
      operands[3] = x5;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1178 (insn, operands);

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x6 = XVECEXP (x3, 0, 2);
      x7 = XVECEXP (x6, 0, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x8 = XVECEXP (x6, 0, 2);
      operands[2] = x8;
      x9 = XVECEXP (x6, 0, 3);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8HFmode:
          if (pattern1261 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          x10 = XVECEXP (x6, 0, 0);
          operands[5] = x10;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && (
#line 6300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6305 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[4])
       || !rtx_equal_p (operands[1], operands[5])))))
            return gen_split_1979 (insn, operands);
          if (rtx_equal_p (x5, operands[3])
              && (
#line 6354 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6359 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[4])
       || !rtx_equal_p (operands[1], operands[5])))))
            return gen_split_1982 (insn, operands);
          operands[5] = x4;
          operands[6] = x10;
          operands[4] = x5;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 6408 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 6418 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1985 (insn, operands);

        case E_VNx4SFmode:
          if (pattern1261 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          x10 = XVECEXP (x6, 0, 0);
          operands[5] = x10;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && (
#line 6300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6305 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[4])
       || !rtx_equal_p (operands[1], operands[5])))))
            return gen_split_1980 (insn, operands);
          if (rtx_equal_p (x5, operands[3])
              && (
#line 6354 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6359 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[4])
       || !rtx_equal_p (operands[1], operands[5])))))
            return gen_split_1983 (insn, operands);
          operands[5] = x4;
          operands[6] = x10;
          operands[4] = x5;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 6408 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 6418 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1986 (insn, operands);

        case E_VNx2DFmode:
          if (pattern1261 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
            return NULL;
          x4 = XVECEXP (x3, 0, 0);
          operands[4] = x4;
          x10 = XVECEXP (x6, 0, 0);
          operands[5] = x10;
          x5 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x5, operands[2])
              && (
#line 6300 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6305 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[4])
       || !rtx_equal_p (operands[1], operands[5])))))
            return gen_split_1981 (insn, operands);
          if (rtx_equal_p (x5, operands[3])
              && (
#line 6354 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6359 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[4])
       || !rtx_equal_p (operands[1], operands[5])))))
            return gen_split_1984 (insn, operands);
          operands[5] = x4;
          operands[6] = x10;
          operands[4] = x5;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 6408 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 6418 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1987 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return NULL;
  x5 = XVECEXP (x3, 0, 2);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern857 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1131 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HFmode)
          || !(
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1164 (insn, operands);

    case E_VNx4SFmode:
      if (pattern857 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1142 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SFmode)
          || !(
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1175 (insn, operands);

    case E_VNx2DFmode:
      if (pattern857 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return NULL;
      x6 = XVECEXP (x3, 0, 0);
      operands[3] = x6;
      x7 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x7, operands[2])
          && (
#line 3710 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3715 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[3]))))
        return gen_split_1153 (insn, operands);
      operands[4] = x6;
      operands[3] = x7;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DFmode)
          || !(
#line 3758 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 3764 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
        return NULL;
      return gen_split_1186 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_14 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx8HImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1241 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1248 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2941 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx8HImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1268 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1273 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2949 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx8HImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1293 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1307 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2957 (insn, operands);
}

 rtx_insn *
split_19 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 1241 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1248 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2938 (insn, operands);
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && (
#line 1268 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1273 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
        return gen_split_2946 (insn, operands);
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return NULL;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1293 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))) && 
#line 1307 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2954 (insn, operands);
}

 rtx_insn *
split_25 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2835 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2878 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2918 (insn, operands);
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2822 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2867 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2907 (insn, operands);
}

 rtx_insn *
split_35 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2809 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2856 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2896 (insn, operands);
}

 rtx_insn *
split_40 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2842 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2884 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2924 (insn, operands);
}

 rtx_insn *
split_45 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2829 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2873 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2913 (insn, operands);
}

 rtx_insn *
split_51 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && (
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1044 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2804 (insn, operands);
  if (rtx_equal_p (x5, operands[3])
      && (
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1069 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
    return gen_split_2852 (insn, operands);
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !(
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 1099 "../../gcc/config/aarch64/aarch64-sve2.md"
( 1)))
    return NULL;
  return gen_split_2892 (insn, operands);
}

 rtx_insn *
split_57 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 1);
  switch (XWINT (x4, 0))
    {
    case 0L:
      switch (pattern1095 (x2))
        {
        case 0:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && ((
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1679 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && ((
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1752 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
              || !((
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1804 (insn, operands);

        case 1:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1692 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1765 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1817 (insn, operands);

        case 2:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1705 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1778 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1830 (insn, operands);

        case 3:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[2])
              && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 5479 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1718 (insn, operands);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 5565 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1791 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5615 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1843 (insn, operands);

        case 4:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 6096 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6101 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1967 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
              || !(
#line 6140 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1970 (insn, operands);

        case 5:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 6096 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6101 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1968 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
              || !(
#line 6140 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1971 (insn, operands);

        case 6:
          x5 = XVECEXP (x3, 0, 0);
          operands[4] = x5;
          x6 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 6096 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 6101 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[4]))))
            return gen_split_1969 (insn, operands);
          operands[5] = x5;
          operands[4] = x6;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
              || !(
#line 6140 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6146 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
            return NULL;
          return gen_split_1972 (insn, operands);

        default:
          return NULL;
        }

    case 1L:
      x6 = XVECEXP (x2, 0, 2);
      operands[4] = x6;
      x5 = XVECEXP (x3, 0, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return NULL;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8BFmode:
              if (pattern1031 (x2, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
                  || !((
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1856 (insn, operands);

            case E_VNx8HFmode:
              if (pattern1031 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1869 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1031 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1882 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1031 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 5659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1895 (insn, operands);

            default:
              return NULL;
            }

        case CONST_VECTOR:
        case CONST:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx8HFmode:
              if (pattern1247 (x2, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
                  || !(
#line 6176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6182 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1973 (insn, operands);

            case E_VNx4SFmode:
              if (pattern1247 (x2, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
                  || !(
#line 6176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6182 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1974 (insn, operands);

            case E_VNx2DFmode:
              if (pattern1247 (x2, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
                  || !(
#line 6176 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[3], operands[4])) && 
#line 6182 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[4]))))
                return NULL;
              return gen_split_1975 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_69 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      return split_67 (x1, insn);

    case 2:
      return split_66 (x1, insn);

    case 4:
      return split_68 (x1, insn);

    case 5:
      x4 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x4) != CONST_INT)
        return NULL;
      x5 = XVECEXP (x3, 0, 2);
      operands[2] = x5;
      x6 = XVECEXP (x3, 0, 3);
      operands[3] = x6;
      x7 = XVECEXP (x3, 0, 4);
      operands[4] = x7;
      switch (XINT (x3, 1))
        {
        case 375:
          switch (pattern1098 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2011 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2027 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2043 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2015 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2031 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2047 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2019 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2035 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2051 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2023 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2039 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2055 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2059 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2063 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2067 (insn, operands);

            default:
              return NULL;
            }

        case 376:
          switch (pattern1098 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2012 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2028 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2044 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2016 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2032 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2048 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2020 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2036 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2052 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2024 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2040 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2056 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2060 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2064 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2068 (insn, operands);

            default:
              return NULL;
            }

        case 380:
          switch (pattern1098 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2013 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2029 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2045 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2017 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2033 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2049 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2021 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2037 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2053 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2025 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2041 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2057 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2061 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2065 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2069 (insn, operands);

            default:
              return NULL;
            }

        case 381:
          switch (pattern1098 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2014 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2030 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2046 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2018 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2034 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2050 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[2])
                  && (
#line 7508 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7513 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2022 (insn, operands);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2038 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2054 (insn, operands);

            case 3:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && ((
#line 7554 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7559 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2026 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8BFmode)
                  || !((
#line 7600 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7613 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2042 (insn, operands);

            case 4:
              if (!((
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && (true || !rtx_equal_p (operands[2], operands[5]))
   && (true || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8BFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2058 (insn, operands);

            case 5:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2062 (insn, operands);

            case 6:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2066 (insn, operands);

            case 7:
              if (!(
#line 7646 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && (false || !rtx_equal_p (operands[2], operands[5]))
   && (false || !rtx_equal_p (operands[3], operands[5]))
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7659 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2070 (insn, operands);

            default:
              return NULL;
            }

        case 359:
          switch (pattern1099 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2071 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2083 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2075 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2087 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2079 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2091 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2095 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2099 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2103 (insn, operands);

            default:
              return NULL;
            }

        case 360:
          switch (pattern1099 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2072 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2084 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2076 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2088 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2080 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2092 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2096 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2100 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2104 (insn, operands);

            default:
              return NULL;
            }

        case 361:
          switch (pattern1099 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2073 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2085 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2077 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2089 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2081 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2093 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2097 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2101 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2105 (insn, operands);

            default:
              return NULL;
            }

        case 362:
          switch (pattern1099 (x2))
            {
            case 0:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2074 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx8HFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2086 (insn, operands);

            case 1:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2078 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx4SFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2090 (insn, operands);

            case 2:
              x8 = XVECEXP (x3, 0, 0);
              operands[5] = x8;
              x9 = XVECEXP (x2, 0, 2);
              if (rtx_equal_p (x9, operands[4])
                  && (
#line 7802 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 7807 "../../gcc/config/aarch64/aarch64-sve.md"
( !rtx_equal_p (operands[1], operands[5]))))
                return gen_split_2082 (insn, operands);
              operands[6] = x8;
              operands[5] = x9;
              if (!aarch64_simd_reg_or_zero (operands[5], E_VNx2DFmode)
                  || !(
#line 7847 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7854 "../../gcc/config/aarch64/aarch64-sve.md"
( 1)))
                return NULL;
              return gen_split_2094 (insn, operands);

            case 3:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2098 (insn, operands);

            case 4:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2102 (insn, operands);

            case 5:
              if (!(
#line 7885 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[4], operands[5])) && 
#line 7892 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DFmode)
   && !rtx_equal_p (operands[0], operands[5]))))
                return NULL;
              return gen_split_2106 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_85 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2536 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2546 (insn, operands);
}

 rtx_insn *
split_88 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2476 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2486 (insn, operands);
}

 rtx_insn *
split_91 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2416 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2426 (insn, operands);
}

 rtx_insn *
split_94 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2515 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2525 (insn, operands);
}

 rtx_insn *
split_97 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2455 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2465 (insn, operands);
}

 rtx_insn *
split_101 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3439 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2534 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3439 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2544 (insn, operands);
}

 rtx_insn *
split_105 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3439 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2454 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3439 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2464 (insn, operands);
}

 rtx_insn *
split_110 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2513 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3438 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2523 (insn, operands);
}

 rtx_insn *
split_117 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2532 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2542 (insn, operands);
}

 rtx_insn *
split_124 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && ((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return gen_split_2551 (insn, operands);
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !((
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
    return NULL;
  return gen_split_2561 (insn, operands);
}

 rtx_insn *
split_132 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern1086 (x1))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2407 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2417 (insn, operands);

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2427 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2437 (insn, operands);

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2447 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2457 (insn, operands);

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2467 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2477 (insn, operands);

    case 4:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2487 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2497 (insn, operands);

    case 5:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2507 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2517 (insn, operands);

    case 6:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2527 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2537 (insn, operands);

    case 7:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2547 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2557 (insn, operands);

    case 8:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2408 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2418 (insn, operands);

    case 9:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2428 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2438 (insn, operands);

    case 10:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2448 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2458 (insn, operands);

    case 11:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2468 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2478 (insn, operands);

    case 12:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2488 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2498 (insn, operands);

    case 13:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2508 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2518 (insn, operands);

    case 14:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2528 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2538 (insn, operands);

    case 15:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2548 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2558 (insn, operands);

    case 16:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2409 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2419 (insn, operands);

    case 17:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2429 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2439 (insn, operands);

    case 18:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2449 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2459 (insn, operands);

    case 19:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2469 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2479 (insn, operands);

    case 20:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2489 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2499 (insn, operands);

    case 21:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2509 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2519 (insn, operands);

    case 22:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2529 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2539 (insn, operands);

    case 23:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2549 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2559 (insn, operands);

    case 24:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2410 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2420 (insn, operands);

    case 25:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2430 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2440 (insn, operands);

    case 26:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2450 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2460 (insn, operands);

    case 27:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2470 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8442 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2480 (insn, operands);

    case 28:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2490 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2500 (insn, operands);

    case 29:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2510 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2520 (insn, operands);

    case 30:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2530 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2540 (insn, operands);

    case 31:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return gen_split_2550 (insn, operands);
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8467 "../../gcc/config/aarch64/aarch64-sve.md"
( (!CONSTANT_P (operands[3]) || !CONSTANT_P (operands[4])))))
        return NULL;
      return gen_split_2560 (insn, operands);

    case 32:
      return split_131 (x1, insn);

    case 33:
      return split_130 (x1, insn);

    case 34:
      return split_129 (x1, insn);

    case 35:
      return split_128 (x1, insn);

    case 36:
      return split_127 (x1, insn);

    case 37:
      return split_126 (x1, insn);

    case 38:
      return split_125 (x1, insn);

    case 39:
      return split_124 (x1, insn);

    case 40:
      return split_123 (x1, insn);

    case 41:
      return split_122 (x1, insn);

    case 42:
      return split_121 (x1, insn);

    case 43:
      return split_120 (x1, insn);

    case 44:
      return split_119 (x1, insn);

    case 45:
      return split_118 (x1, insn);

    case 46:
      return split_117 (x1, insn);

    case 47:
      return split_116 (x1, insn);

    case 48:
      return split_115 (x1, insn);

    case 49:
      return split_114 (x1, insn);

    case 50:
      return split_113 (x1, insn);

    case 51:
      return split_112 (x1, insn);

    case 52:
      return split_111 (x1, insn);

    case 53:
      return split_110 (x1, insn);

    case 54:
      return split_109 (x1, insn);

    case 55:
      return split_108 (x1, insn);

    case 56:
      return split_107 (x1, insn);

    case 57:
      return split_106 (x1, insn);

    case 58:
      return split_105 (x1, insn);

    case 59:
      return split_104 (x1, insn);

    case 60:
      return split_103 (x1, insn);

    case 61:
      return split_102 (x1, insn);

    case 62:
      return split_101 (x1, insn);

    case 63:
      return split_100 (x1, insn);

    case 64:
      return split_99 (x1, insn);

    case 65:
      return split_98 (x1, insn);

    case 66:
      return split_97 (x1, insn);

    case 67:
      return split_96 (x1, insn);

    case 68:
      return split_95 (x1, insn);

    case 69:
      return split_94 (x1, insn);

    case 70:
      return split_93 (x1, insn);

    case 71:
      return split_92 (x1, insn);

    case 72:
      return split_91 (x1, insn);

    case 73:
      return split_90 (x1, insn);

    case 74:
      return split_89 (x1, insn);

    case 75:
      return split_88 (x1, insn);

    case 76:
      return split_87 (x1, insn);

    case 77:
      return split_86 (x1, insn);

    case 78:
      return split_85 (x1, insn);

    case 79:
      return split_84 (x1, insn);

    case 80:
      if (!(
#line 10172 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10174 "../../gcc/config/aarch64/aarch64-sve.md"
( (operands[4] != CONST0_RTX (VNx16BImode)
       || operands[5] != CONST0_RTX (VNx16BImode)))))
        return NULL;
      return gen_split_2678 (insn, operands);

    case 81:
      if (!(
#line 10196 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 10198 "../../gcc/config/aarch64/aarch64-sve.md"
( (operands[4] != CONST0_RTX (VNx16BImode)
       || operands[5] != CONST0_RTX (VNx16BImode)))))
        return NULL;
      return gen_split_2679 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (GET_MODE (x2) != E_SImode
              || !register_operand (operands[1], E_SImode))
            return NULL;
          if (register_operand (operands[0], E_SImode)
              && aarch64_pluslong_strict_immedate (operands[2], E_SImode)
              && 
#line 2487 "../../gcc/config/aarch64/aarch64.md"
(aarch64_move_imm (INTVAL (operands[2]), SImode)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_1 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 2)
            return NULL;
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern850 (x6, 
E_SImode) != 0
              || !
#line 3590 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && INTVAL (operands[3]) == -INTVAL (operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_8 (insn, operands);

        case E_DImode:
          if (GET_MODE (x2) != E_DImode
              || !register_operand (operands[1], E_DImode))
            return NULL;
          if (register_operand (operands[0], E_DImode)
              && aarch64_pluslong_strict_immedate (operands[2], E_DImode)
              && 
#line 2487 "../../gcc/config/aarch64/aarch64.md"
(aarch64_move_imm (INTVAL (operands[2]), DImode)))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_2 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 2)
            return NULL;
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern850 (x6, 
E_DImode) != 0
              || !
#line 3590 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && INTVAL (operands[3]) == -INTVAL (operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_9 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      if (GET_MODE (x2) != E_DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x2, 0);
      switch (GET_CODE (x4))
        {
        case PLUS:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!aarch64_pluslong_strict_immedate (operands[2], E_SImode)
              || !
#line 2499 "../../gcc/config/aarch64/aarch64.md"
(aarch64_move_imm (INTVAL (operands[2]), SImode)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_3 (insn, operands);

        case SUBREG:
        case MEM:
          if (peep2_current_count < 2
              || pattern571 (x4, 
ZERO_EXTEND) != 0)
            return NULL;
          if (
#line 139 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_221 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (peep2_current_count < 3)
            return NULL;
          x9 = PATTERN (peep2_next_insn (2));
          if (pattern1216 (x9, 
ZERO_EXTEND) != 0
              || !
#line 244 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, SImode)))
            return NULL;
          *pmatch_len_ = 3;
          return gen_peephole2_231 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      if (peep2_current_count < 2)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x10 = XEXP (x6, 1);
      if (GET_CODE (x10) != COMPARE
          || GET_MODE (x10) != E_CCmode)
        return NULL;
      x11 = XEXP (x6, 0);
      if (GET_CODE (x11) != REG
          || REGNO (x11) != 66
          || GET_MODE (x11) != E_CCmode)
        return NULL;
      x12 = XEXP (x10, 0);
      if (!rtx_equal_p (x12, operands[1]))
        return NULL;
      x13 = XEXP (x10, 1);
      if (!rtx_equal_p (x13, operands[2]))
        return NULL;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (pattern1187 (x2, 
E_SImode) != 0
              || !
#line 3552 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_4 (insn, operands);

        case E_DImode:
          if (pattern1187 (x2, 
E_DImode) != 0
              || !
#line 3552 "../../gcc/config/aarch64/aarch64.md"
(!reg_overlap_mentioned_p (operands[0], operands[1])
   && !reg_overlap_mentioned_p (operands[0], operands[2])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_5 (insn, operands);

        default:
          return NULL;
        }

    case COMPARE:
      if (peep2_current_count < 2
          || pattern41 (x1, 
E_CCmode, 
66) != 0)
        return NULL;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      if (aarch64_reg_or_zero (operands[2], E_SImode))
        {
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern919 (x6, 
E_SImode) == 0)
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_6 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (aarch64_reg_or_zero (operands[2], E_DImode))
        {
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern919 (x6, 
E_DImode) == 0)
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_7 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      operands[3] = x5;
      if (const_int_operand (operands[3], E_SImode))
        {
          x6 = PATTERN (peep2_next_insn (1));
          if (pattern920 (x6, 
E_SImode) == 0
              && 
#line 3611 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[3]) == -INTVAL (operands[2])))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_10 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
      if (!const_int_operand (operands[3], E_DImode))
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (pattern920 (x6, 
E_DImode) != 0
          || !
#line 3611 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[3]) == -INTVAL (operands[2])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_11 (insn, operands);

    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
    case MEM:
      return peephole2_12 (x1, insn, pmatch_len_);

    case SIGN_EXTEND:
      if (peep2_current_count < 2
          || GET_MODE (x2) != E_DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_DImode))
        return NULL;
      x4 = XEXP (x2, 0);
      if (pattern571 (x4, 
SIGN_EXTEND) != 0)
        return NULL;
      if (
#line 127 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
        {
          *pmatch_len_ = 1;
          res = gen_peephole2_220 (insn, operands);
          if (res != NULL_RTX)
            return res;
        }
      if (peep2_current_count < 3)
        return NULL;
      x9 = PATTERN (peep2_next_insn (2));
      if (pattern1216 (x9, 
SIGN_EXTEND) != 0
          || !
#line 224 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_adjust_ok_for_ldpstp (operands, true, SImode)))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_230 (insn, operands);

    default:
      return NULL;
    }
}
