/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern6 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
    case TRUNCATE:
      return 0;

    case MINUS:
      res = pattern4 (x3);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case CONST_VECTOR:
    case CONST:
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (pattern5 (x3, 
E_V8QImode) != 0)
            return -1;
          return 3;

        case E_V16QImode:
          if (pattern5 (x3, 
E_V16QImode) != 0)
            return -1;
          return 4;

        case E_V4HImode:
          if (pattern5 (x3, 
E_V4HImode) != 0)
            return -1;
          return 5;

        case E_V8HImode:
          if (pattern5 (x3, 
E_V8HImode) != 0)
            return -1;
          return 6;

        case E_V2SImode:
          if (pattern5 (x3, 
E_V2SImode) != 0)
            return -1;
          return 7;

        case E_V4SImode:
          if (pattern5 (x3, 
E_V4SImode) != 0)
            return -1;
          return 8;

        case E_V2DImode:
          if (pattern5 (x3, 
E_V2DImode) != 0)
            return -1;
          return 9;

        case E_VNx16QImode:
          if (pattern5 (x3, 
E_VNx16QImode) != 0)
            return -1;
          return 10;

        case E_VNx8QImode:
          if (pattern5 (x3, 
E_VNx8QImode) != 0)
            return -1;
          return 11;

        case E_VNx4QImode:
          if (pattern5 (x3, 
E_VNx4QImode) != 0)
            return -1;
          return 12;

        case E_VNx2QImode:
          if (pattern5 (x3, 
E_VNx2QImode) != 0)
            return -1;
          return 13;

        case E_VNx8HImode:
          if (pattern5 (x3, 
E_VNx8HImode) != 0)
            return -1;
          return 14;

        case E_VNx4HImode:
          if (pattern5 (x3, 
E_VNx4HImode) != 0)
            return -1;
          return 15;

        case E_VNx2HImode:
          if (pattern5 (x3, 
E_VNx2HImode) != 0)
            return -1;
          return 16;

        case E_VNx4SImode:
          if (pattern5 (x3, 
E_VNx4SImode) != 0)
            return -1;
          return 17;

        case E_VNx2SImode:
          if (pattern5 (x3, 
E_VNx2SImode) != 0)
            return -1;
          return 18;

        case E_VNx2DImode:
          if (pattern5 (x3, 
E_VNx2DImode) != 0)
            return -1;
          return 19;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern30 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_uminmax_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern32 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aligned_register_operand (operands[1], i1)
      || !aligned_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern37 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != UNSPEC
      || XVECLEN (x4, 0) != 1
      || XINT (x4, 1) != 5
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[0] = x5;
  if (!aarch64_call_insn_operand (operands[0], E_DImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  x7 = XVECEXP (x4, 0, 0);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  return 0;
}

int
pattern42 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern51 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i2))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern56 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aligned_register_operand (operands[1], i1)
      || !aligned_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i3
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern66 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern55 (x3, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (pattern55 (x3, 
E_V8HFmode) != 0)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern55 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (pattern55 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 3;

    case E_V2DFmode:
      if (pattern55 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 4;

    case E_HFmode:
      if (pattern55 (x3, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_SFmode:
      if (pattern55 (x3, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_DFmode:
      if (pattern55 (x3, 
E_DFmode) != 0)
        return -1;
      return 7;

    case E_VNx8HFmode:
      if (pattern55 (x3, 
E_VNx8HFmode) != 0)
        return -1;
      return 8;

    case E_VNx4SFmode:
      if (pattern55 (x3, 
E_VNx4SFmode) != 0)
        return -1;
      return 9;

    case E_VNx2DFmode:
      if (pattern55 (x3, 
E_VNx2DFmode) != 0)
        return -1;
      return 10;

    default:
      return -1;
    }
}

int
pattern78 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_shift_imm_qi (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern83 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern68 (x3, 
E_VNx16QImode, 
E_VNx16BImode, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern68 (x3, 
E_VNx8HImode, 
E_VNx8BImode, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern68 (x3, 
E_VNx4SImode, 
E_VNx4BImode, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern68 (x3, 
E_VNx2DImode, 
E_VNx2BImode, 
E_DImode) != 0)
        return -1;
      return 3;

    case E_BFmode:
      if (pattern68 (x3, 
E_VNx8BFmode, 
E_VNx8BImode, 
E_BFmode) != 0)
        return -1;
      return 4;

    case E_HFmode:
      if (pattern68 (x3, 
E_VNx8HFmode, 
E_VNx8BImode, 
E_HFmode) != 0)
        return -1;
      return 5;

    case E_SFmode:
      if (pattern68 (x3, 
E_VNx4SFmode, 
E_VNx4BImode, 
E_SFmode) != 0)
        return -1;
      return 6;

    case E_DFmode:
      if (pattern68 (x3, 
E_VNx2DFmode, 
E_VNx2BImode, 
E_DFmode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern98 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern91 (x3, 
E_VNx16QImode, 
E_VNx8HImode); /* [-1, 0] */

    case E_VNx4SImode:
      if (pattern91 (x3, 
E_VNx8HImode, 
E_VNx4SImode) != 0)
        return -1;
      return 1;

    case E_VNx2DImode:
      if (pattern91 (x3, 
E_VNx4SImode, 
E_VNx2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern106 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern91 (x3, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern91 (x3, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern91 (x3, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern113 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 84
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16QImode))
    return -1;
  return pattern112 (x2); /* [-1, 1] */
}

int
pattern121 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[0] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[1] = x5;
  return 0;
}

int
pattern128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 4;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern142 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4HImode:
      if (!register_operand (operands[3], E_V4HImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern149 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_si (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern155 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_shift_imm_offset_di (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern161 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  if (!aarch64_sve_gp_strictness (operands[3], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern160 (x3, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern160 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern160 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern170 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx8HFmode:
      if (!register_operand (operands[2], E_VNx8HFmode))
        return -1;
      return 0;

    case E_VNx4SFmode:
      if (!register_operand (operands[2], E_VNx4SFmode))
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (!register_operand (operands[2], E_VNx2DFmode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern178 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aligned_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !memory_operand (operands[1], i1)
      || !aarch64_maskload_else_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern181 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  if (!const_int_operand (operands[2], E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 8L:
      return 0;

    case 16L:
      return 1;

    case 32L:
      return 2;

    case 64L:
      return 3;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern91 (x3, 
E_VNx8HImode, 
E_VNx16QImode); /* [-1, 0] */

    case E_VNx8HImode:
      if (pattern91 (x3, 
E_VNx4SImode, 
E_VNx8HImode) != 0)
        return -1;
      return 1;

    case E_VNx4SImode:
      if (pattern91 (x3, 
E_VNx2DImode, 
E_VNx4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern196 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[4] = x7;
  if (!aarch64_imm2 (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[4] = x5;
  if (!aarch64_sve_gp_strictness (operands[4], E_SImode))
    return -1;
  return pattern203 (x3); /* [-1, 3] */
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XVECEXP (x2, 0, 0);
  operands[5] = x3;
  x4 = XVECEXP (x2, 0, 2);
  operands[2] = x4;
  x5 = XVECEXP (x1, 0, 3);
  x6 = XVECEXP (x5, 0, 0);
  operands[6] = x6;
  x7 = XVECEXP (x5, 0, 2);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern206 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4SFmode:
      if (pattern206 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2DFmode:
      if (pattern206 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern221 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[0] = x6;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[1] = x7;
      switch (GET_MODE (x5))
        {
        case E_VNx8SImode:
          if (GET_MODE (x2) != E_VNx8SImode
              || GET_MODE (x3) != E_VNx8SImode
              || !aligned_register_operand (operands[1], E_VNx8SImode))
            return -1;
          return 0;

        case E_VNx4DImode:
          if (GET_MODE (x2) != E_VNx4DImode
              || GET_MODE (x3) != E_VNx4DImode
              || !aligned_register_operand (operands[1], E_VNx4DImode))
            return -1;
          return 1;

        case E_VNx16SImode:
          if (GET_MODE (x2) != E_VNx16SImode
              || GET_MODE (x3) != E_VNx16SImode
              || !aligned_register_operand (operands[1], E_VNx16SImode))
            return -1;
          return 2;

        case E_VNx8DImode:
          if (GET_MODE (x2) != E_VNx8DImode
              || GET_MODE (x3) != E_VNx8DImode
              || !aligned_register_operand (operands[1], E_VNx8DImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x6) != E_SImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[0] = x8;
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      operands[1] = x9;
      if (!const_0_to_7_operand (operands[1], E_SImode))
        return -1;
      x7 = XVECEXP (x2, 0, 3);
      operands[2] = x7;
      switch (GET_MODE (x5))
        {
        case E_VNx8SImode:
          if (GET_MODE (x2) != E_VNx8SImode
              || GET_MODE (x3) != E_VNx8SImode
              || !aligned_register_operand (operands[2], E_VNx8SImode))
            return -1;
          return 4;

        case E_VNx4DImode:
          if (GET_MODE (x2) != E_VNx4DImode
              || GET_MODE (x3) != E_VNx4DImode
              || !aligned_register_operand (operands[2], E_VNx4DImode))
            return -1;
          return 5;

        case E_VNx16SImode:
          if (GET_MODE (x2) != E_VNx16SImode
              || GET_MODE (x3) != E_VNx16SImode
              || !aligned_register_operand (operands[2], E_VNx16SImode))
            return -1;
          return 6;

        case E_VNx8DImode:
          if (GET_MODE (x2) != E_VNx8DImode
              || GET_MODE (x3) != E_VNx8DImode
              || !aligned_register_operand (operands[2], E_VNx8DImode))
            return -1;
          return 7;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern242 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 4);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[3] = x4;
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_VNx4SImode:
          return pattern239 (x2, 
E_VNx4SImode); /* [-1, 3] */

        case E_VNx2DImode:
          res = pattern239 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 4; /* [4, 7] */
          return -1;

        default:
          return -1;
        }

    case VEC_DUPLICATE:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_VNx4SImode:
          res = pattern240 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 8; /* [8, 11] */
          return -1;

        case E_VNx2DImode:
          res = pattern240 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 12; /* [12, 15] */
          return -1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x4, 0) != 2
          || XINT (x4, 1) != 167)
        return -1;
      x7 = XVECEXP (x4, 0, 0);
      operands[3] = x7;
      x8 = XVECEXP (x4, 0, 1);
      operands[4] = x8;
      if (!const_int_operand (operands[4], E_SImode))
        return -1;
      x5 = XEXP (x1, 0);
      switch (GET_MODE (x5))
        {
        case E_VNx4SImode:
          res = pattern241 (x2, 
E_VNx4SImode);
          if (res >= 0)
            return res + 16; /* [16, 19] */
          return -1;

        case E_VNx2DImode:
          res = pattern241 (x2, 
E_VNx2DImode);
          if (res >= 0)
            return res + 20; /* [20, 23] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern254 (rtx x1, unsigned int i1, machine_mode i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern259 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 93)
    return -1;
  x4 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 89
      || GET_MODE (x4) != E_DImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 93)
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[0] = x6;
  if (!const_int_operand (operands[0], E_DImode))
    return -1;
  x7 = XVECEXP (x2, 0, 3);
  operands[1] = x7;
  x8 = XVECEXP (x2, 0, 4);
  operands[2] = x8;
  x9 = XVECEXP (x2, 0, 5);
  operands[3] = x9;
  x10 = XVECEXP (x2, 0, 6);
  operands[4] = x10;
  switch (GET_MODE (x5))
    {
    case E_VNx4SImode:
      return pattern257 (x2, 
E_VNx16QImode, 
E_VNx4BImode, 
E_VNx4SImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern257 (x2, 
E_VNx8HImode, 
E_VNx2BImode, 
E_VNx2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern268 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_ldff1_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i2))
    return -1;
  return 0;
}

int
pattern271 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_MODE (x2))
    {
    case E_VNx8HImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 0;

    case E_VNx1TImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern274 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern278 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern281 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern280 (x1, 
E_SImode); /* [-1, 1] */

    case E_DImode:
      res = pattern280 (x1, 
E_DImode);
      if (res >= 0)
        return res + 2; /* [2, 3] */
      return -1;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern287 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern293 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || !aarch64_shift_imm_si (operands[2], E_QImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || GET_MODE (x2) != E_DImode
          || !register_operand (operands[1], E_DImode)
          || !aarch64_shift_imm_di (operands[2], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern301 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  return pattern300 (); /* [-1, 2] */
}

int
pattern303 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !register_operand (operands[1], i2)
      || !vect_par_cnst_hi_half (operands[2], i2)
      || !aarch64_simd_shll_imm_vec (operands[3], i1))
    return -1;
  return 0;
}

int
pattern309 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern313 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NOT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x3, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern312 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern312 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern312 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return 3;

        case E_V8HImode:
          return 4;

        case E_V4SImode:
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern322 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern314 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern314 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern314 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern328 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx4SImode))
    return -1;
  switch (XINT (x1, 1))
    {
    case 168:
      x2 = XVECEXP (x1, 0, 0);
      operands[2] = x2;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      operands[3] = x3;
      if (!const_int_operand (operands[3], E_DImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      operands[4] = x4;
      if (!const_int_operand (operands[4], E_DImode))
        return -1;
      return 0;

    case 306:
      x3 = XVECEXP (x1, 0, 1);
      if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      operands[3] = x2;
      x4 = XVECEXP (x1, 0, 2);
      operands[2] = x4;
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern338 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return pattern333 (x1); /* [-1, 2] */
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern341 (x6, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern341 (x6, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern352 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 66
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  x10 = XEXP (x2, 0);
  operands[3] = x10;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern351 (x7, 
E_SImode); /* [-1, 0] */

    case E_DImode:
      if (pattern351 (x7, 
E_DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_SImode
          || !aarch64_shift_imm_si (operands[2], E_QImode)
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      x4 = XEXP (x1, 0);
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_MODE (x5) != E_DImode
          || !aarch64_shift_imm_di (operands[2], E_QImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern371 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], E_VNx16BImode))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!aarch64_any_register_operand (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx16QImode)
          || GET_MODE (x1) != E_VNx16QImode)
        return -1;
      return 0;

    case E_VNx8QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8QImode)
          || GET_MODE (x1) != E_VNx8QImode)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4QImode)
          || GET_MODE (x1) != E_VNx4QImode)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2QImode)
          || GET_MODE (x1) != E_VNx2QImode)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4HImode)
          || GET_MODE (x1) != E_VNx4HImode)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2HImode)
          || GET_MODE (x1) != E_VNx2HImode)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2SImode)
          || GET_MODE (x1) != E_VNx2SImode)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode)
        return -1;
      return 9;

    case E_VNx8HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8HFmode)
          || GET_MODE (x1) != E_VNx8HFmode)
        return -1;
      return 10;

    case E_VNx4HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4HFmode)
          || GET_MODE (x1) != E_VNx4HFmode)
        return -1;
      return 11;

    case E_VNx2HFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2HFmode)
          || GET_MODE (x1) != E_VNx2HFmode)
        return -1;
      return 12;

    case E_VNx8BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx8BFmode)
          || GET_MODE (x1) != E_VNx8BFmode)
        return -1;
      return 13;

    case E_VNx4BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4BFmode)
          || GET_MODE (x1) != E_VNx4BFmode)
        return -1;
      return 14;

    case E_VNx2BFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2BFmode)
          || GET_MODE (x1) != E_VNx2BFmode)
        return -1;
      return 15;

    case E_VNx4SFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x1) != E_VNx4SFmode)
        return -1;
      return 16;

    case E_VNx2SFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2SFmode)
          || GET_MODE (x1) != E_VNx2SFmode)
        return -1;
      return 17;

    case E_VNx2DFmode:
      if (!aarch64_sve_nonimmediate_operand (operands[0], E_VNx2DFmode)
          || GET_MODE (x1) != E_VNx2DFmode)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern395 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern399 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern403 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XVECEXP (x2, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 2);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 3);
  operands[3] = x6;
  x7 = XEXP (x1, 1);
  operands[4] = x7;
  switch (XINT (x2, 1))
    {
    case 356:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          return pattern401 (x1, 
E_VNx8BImode, 
E_VNx8HFmode); /* [-1, 0] */

        case E_VNx4BImode:
          if (pattern401 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 1;

        case E_VNx2BImode:
          if (pattern401 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 357:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern401 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 3;

        case E_VNx4BImode:
          if (pattern401 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 4;

        case E_VNx2BImode:
          if (pattern401 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    case 358:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern401 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 6;

        case E_VNx4BImode:
          if (pattern401 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 7;

        case E_VNx2BImode:
          if (pattern401 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    case 363:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern401 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 9;

        case E_VNx4BImode:
          if (pattern401 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 10;

        case E_VNx2BImode:
          if (pattern401 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 11;

        default:
          return -1;
        }

    case 364:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern401 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 12;

        case E_VNx4BImode:
          if (pattern401 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 13;

        case E_VNx2BImode:
          if (pattern401 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 14;

        default:
          return -1;
        }

    case 365:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern401 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 15;

        case E_VNx4BImode:
          if (pattern401 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 16;

        case E_VNx2BImode:
          if (pattern401 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 17;

        default:
          return -1;
        }

    case 366:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8BImode:
          if (pattern402 (x1, 
E_VNx8BImode, 
E_VNx8HFmode) != 0)
            return -1;
          return 18;

        case E_VNx4BImode:
          if (pattern402 (x1, 
E_VNx4BImode, 
E_VNx4SFmode) != 0)
            return -1;
          return 19;

        case E_VNx2BImode:
          if (pattern402 (x1, 
E_VNx2BImode, 
E_VNx2DFmode) != 0)
            return -1;
          return 20;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern435 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_sqadd_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern441 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_DImode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || !register_operand (operands[0], E_VNx2DImode)
          || GET_MODE (x1) != E_VNx2DImode
          || !register_operand (operands[1], E_VNx2DImode)
          || GET_MODE (x2) != E_VNx2DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (XINT (x4, 1))
        {
        case 168:
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          return 0;

        case 306:
          x6 = XVECEXP (x4, 0, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x5 = XVECEXP (x4, 0, 0);
          operands[3] = x5;
          x7 = XVECEXP (x4, 0, 2);
          operands[2] = x7;
          if (!register_operand (operands[2], E_VNx2BImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case UNSPEC:
      if (XVECLEN (x3, 0) != 3
          || !register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x1) != E_VNx4SImode
          || !register_operand (operands[1], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (XINT (x3, 1))
        {
        case 168:
          x8 = XVECEXP (x3, 0, 0);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x9 = XVECEXP (x3, 0, 1);
          operands[3] = x9;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x10 = XVECEXP (x3, 0, 2);
          operands[4] = x10;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          return 2;

        case 306:
          x9 = XVECEXP (x3, 0, 1);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          x8 = XVECEXP (x3, 0, 0);
          operands[3] = x8;
          x10 = XVECEXP (x3, 0, 2);
          operands[2] = x10;
          if (!register_operand (operands[2], E_VNx4BImode))
            return -1;
          return 3;

        default:
          return -1;
        }

    case SUBREG:
    case TRUNCATE:
      if (!subreg_lowpart_operator (x3, E_HImode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC
          || XVECLEN (x4, 0) != 3
          || !register_operand (operands[0], E_VNx8HImode)
          || GET_MODE (x1) != E_VNx8HImode
          || !register_operand (operands[1], E_VNx8HImode)
          || GET_MODE (x2) != E_VNx8HImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (XINT (x4, 1))
        {
        case 168:
          operands[5] = x3;
          x5 = XVECEXP (x4, 0, 0);
          operands[2] = x5;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x6 = XVECEXP (x4, 0, 1);
          operands[3] = x6;
          if (!const_int_operand (operands[3], E_DImode))
            return -1;
          x7 = XVECEXP (x4, 0, 2);
          operands[4] = x7;
          if (!const_int_operand (operands[4], E_DImode))
            return -1;
          return 4;

        case 306:
          x6 = XVECEXP (x4, 0, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
            return -1;
          operands[3] = x3;
          x5 = XVECEXP (x4, 0, 0);
          operands[4] = x5;
          x7 = XVECEXP (x4, 0, 2);
          operands[2] = x7;
          if (!register_operand (operands[2], E_VNx8BImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern476 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i3)
      || !vect_par_cnst_select_half (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !vect_par_cnst_select_half (operands[3], i1))
    return -1;
  return 0;
}

int
pattern484 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode
      || !register_operand (operands[0], E_DImode)
      || GET_MODE (x1) != E_DImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  if (!aarch64_tls_ie_symref (operands[1], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern489 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[4], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[1], E_VNx16QImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_VNx16QImode
          || !register_operand (operands[2], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[1], E_VNx8HImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      if (GET_MODE (x3) != E_VNx8HImode
          || !register_operand (operands[2], E_VNx8HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern500 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  x7 = XEXP (x3, 0);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XEXP (x3, 1);
  if (!rtx_equal_p (x8, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern499 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern499 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern499 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern499 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern499 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern499 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern513 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  if (!subreg_lowpart_operator (operands[4], E_VOIDmode))
    return -1;
  return pattern512 (x1); /* [-1, 4] */
}

int
pattern517 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern523 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      return pattern521 (x1); /* [-1, 5] */

    case ABS:
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ABS)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V8HImode:
          if (pattern522 (x1, 
E_V4HFmode, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          return 6;

        case E_V4SImode:
          if (pattern522 (x1, 
E_V2SFmode, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          return 7;

        case E_V2DImode:
          if (pattern522 (x1, 
E_DFmode, 
E_DImode, 
E_V2DImode) != 0)
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern535 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_V4SImode)
      || GET_MODE (x1) != E_V4SImode
      || !aarch64_simd_or_scalar_imm_zero (operands[4], E_V2SImode))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V2SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  return pattern534 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern543 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern547 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (!register_operand (x4, i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[2], i1))
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (!register_operand (x7, i1))
    return -1;
  return 0;
}

int
pattern558 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x3) != E_SImode
          || !register_operand (operands[0], E_SImode))
        return -1;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!aarch64_sync_memory_operand (operands[1], E_QImode))
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_MODE (x7) != E_QImode
              || !aarch64_reg_or_imm (operands[2], E_QImode)
              || !aarch64_reg_or_zero (operands[3], E_QImode))
            return -1;
          return 0;

        case E_HImode:
          if (!aarch64_sync_memory_operand (operands[1], E_HImode))
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_MODE (x7) != E_HImode
              || !aarch64_plushi_operand (operands[2], E_HImode)
              || !aarch64_reg_or_zero (operands[3], E_HImode))
            return -1;
          return 1;

        default:
          return -1;
        }

    case SUBREG:
    case MEM:
      operands[1] = x3;
      x5 = XVECEXP (x1, 0, 2);
      x6 = XEXP (x5, 0);
      if (!rtx_equal_p (x6, operands[1]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          x7 = XEXP (x5, 1);
          if (pattern557 (x7, 
E_SImode) != 0)
            return -1;
          return 2;

        case E_DImode:
          x7 = XEXP (x5, 1);
          if (pattern557 (x7, 
E_DImode) != 0)
            return -1;
          return 3;

        case E_TImode:
          if (!register_operand (operands[0], E_TImode)
              || !aarch64_sync_memory_operand (operands[1], E_TImode))
            return -1;
          x7 = XEXP (x5, 1);
          if (GET_MODE (x7) != E_TImode
              || !aarch64_reg_or_zero (operands[2], E_TImode)
              || !aarch64_reg_or_zero (operands[3], E_TImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern586 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_VNx2QImode:
      if (!aarch64_gather_scale_operand_b (operands[4], E_DImode))
        return -1;
      return 0;

    case E_VNx2HImode:
      if (!aarch64_gather_scale_operand_h (operands[4], E_DImode))
        return -1;
      return 1;

    case E_VNx2SImode:
      if (!aarch64_gather_scale_operand_w (operands[4], E_DImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern590 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XVECEXP (x1, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HImode:
      return pattern589 (x1, 
E_VNx8HImode, 
E_VNx8BImode); /* [-1, 5] */

    case E_VNx4HImode:
      res = pattern589 (x1, 
E_VNx4HImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 6; /* [6, 11] */
      return -1;

    case E_VNx2HImode:
      res = pattern589 (x1, 
E_VNx2HImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 12; /* [12, 17] */
      return -1;

    case E_VNx4SImode:
      res = pattern589 (x1, 
E_VNx4SImode, 
E_VNx4BImode);
      if (res >= 0)
        return res + 18; /* [18, 23] */
      return -1;

    case E_VNx2SImode:
      res = pattern589 (x1, 
E_VNx2SImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 24; /* [24, 29] */
      return -1;

    case E_VNx2DImode:
      res = pattern589 (x1, 
E_VNx2DImode, 
E_VNx2BImode);
      if (res >= 0)
        return res + 30; /* [30, 35] */
      return -1;

    default:
      return -1;
    }
}

int
pattern601 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  x3 = XVECEXP (x1, 0, 1);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  x5 = XEXP (x3, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      return pattern469 (x1, 
E_VNx4SImode, 
E_VNx4BImode); /* [-1, 0] */

    case E_VNx2DImode:
      if (pattern469 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern607 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern615 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[2], i3)
      || !vect_par_cnst_hi_half (operands[4], i3))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[3], i3))
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_MODE (x7) != i2)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x7, 1);
  if (GET_MODE (x9) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern624 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V8QImode:
      if (!register_operand (operands[3], E_V8QImode))
        return -1;
      return 0;

    case E_V16QImode:
      if (!register_operand (operands[3], E_V16QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern629 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern627 (x1, 
E_SImode); /* [-1, 2] */

    case E_DImode:
      res = pattern627 (x1, 
E_DImode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_V8HImode:
      if (pattern628 (x1, 
E_V8QImode, 
E_V8HImode) != 0)
        return -1;
      return 6;

    case E_V4SImode:
      if (pattern628 (x1, 
E_V4HImode, 
E_V4SImode) != 0)
        return -1;
      return 7;

    case E_V2DImode:
      if (pattern628 (x1, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern636 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern645 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != PARALLEL
          || XVECLEN (x5, 0) != 1)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      x7 = XVECEXP (x5, 0, 0);
      operands[3] = x7;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_MODE (x8) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || GET_MODE (x2) != E_V4SImode
              || GET_MODE (x3) != E_SImode
              || GET_MODE (x4) != E_HImode)
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V4HImode:
              if (!register_operand (operands[2], E_V4HImode))
                return -1;
              return 0;

            case E_V8HImode:
              if (!register_operand (operands[2], E_V8HImode))
                return -1;
              return 1;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode)
            return -1;
          x8 = XEXP (x1, 0);
          if (GET_MODE (x8) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || GET_MODE (x2) != E_V2DImode
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_SImode)
            return -1;
          switch (GET_MODE (operands[2]))
            {
            case E_V2SImode:
              if (!register_operand (operands[2], E_V2SImode))
                return -1;
              return 2;

            case E_V4SImode:
              if (!register_operand (operands[2], E_V4SImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[2] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (pattern644 (x1, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V4HImode) != 0)
            return -1;
          return 4;

        case E_V2DImode:
          if (pattern644 (x1, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern674 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
      operands[4] = x2;
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      x7 = XEXP (x5, 1);
      operands[2] = x7;
      x8 = XEXP (x4, 1);
      operands[3] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern672 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern672 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern672 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      x4 = XEXP (x3, 0);
      x5 = XEXP (x4, 0);
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      x8 = XEXP (x4, 1);
      operands[4] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern673 (x1, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V8HImode:
          if (pattern673 (x1, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern673 (x1, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern689 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern693 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_logical_and_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern697 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x2, 0);
  x6 = XVECEXP (x5, 0, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  x8 = XEXP (x6, 1);
  operands[3] = x8;
  x9 = XEXP (x4, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  x10 = XEXP (x4, 1);
  if (!rtx_equal_p (x10, operands[3]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16QImode:
      return pattern696 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8QImode:
      if (pattern696 (x1, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4QImode:
      if (pattern696 (x1, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    case E_VNx2QImode:
      if (pattern696 (x1, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
        return -1;
      return 3;

    case E_VNx8HImode:
      if (pattern696 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 4;

    case E_VNx4HImode:
      if (pattern696 (x1, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
        return -1;
      return 5;

    case E_VNx2HImode:
      if (pattern696 (x1, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
        return -1;
      return 6;

    case E_VNx4SImode:
      if (pattern696 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 7;

    case E_VNx2SImode:
      if (pattern696 (x1, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
        return -1;
      return 8;

    case E_VNx2DImode:
      if (pattern696 (x1, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern708 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[0] = x3;
      return 0;

    case ZERO_EXTRACT:
      if (pnum_clobbers == NULL)
        return -1;
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x2, 1);
      if (XWINT (x5, 0) != 0L)
        return -1;
      x6 = XEXP (x3, 0);
      operands[0] = x6;
      x7 = XEXP (x3, 2);
      operands[1] = x7;
      x8 = XEXP (x1, 1);
      x9 = XEXP (x8, 0);
      operands[2] = x9;
      switch (GET_MODE (x3))
        {
        case E_SImode:
          res = pattern707 ();
          if (res >= 0)
            return res + 1; /* [1, 4] */
          return -1;

        case E_DImode:
          res = pattern707 ();
          if (res >= 0)
            return res + 5; /* [5, 8] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern721 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_VNx16QImode:
      if (!register_operand (operands[1], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8HImode:
      if (!register_operand (operands[1], E_VNx8HImode))
        return -1;
      return 1;

    case E_VNx4SImode:
      if (!register_operand (operands[1], E_VNx4SImode))
        return -1;
      return 2;

    case E_VNx2DImode:
      if (!register_operand (operands[1], E_VNx2DImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern728 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_add_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern733 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !aarch64_sve_arith_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern737 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i3)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i3
      || !register_operand (operands[2], i4))
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern746 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[2], i2)
      || !aarch64_simd_imm_one (operands[3], i1))
    return -1;
  return 0;
}

int
pattern753 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern751 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern751 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern751 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern760 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[3] = x5;
  x6 = XEXP (x2, 1);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern759 (x1, 
E_V4HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern759 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern766 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[2], i1))
    return -1;
  return 0;
}

int
pattern771 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != UNSPEC_VOLATILE
      || XVECLEN (x5, 0) != 1
      || XINT (x5, 1) != i1
      || GET_MODE (x5) != E_V8DImode)
    return -1;
  x6 = XEXP (x4, 0);
  if (GET_CODE (x6) != MEM
      || GET_MODE (x6) != E_V8DImode
      || !register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  x8 = XVECEXP (x5, 0, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_V8DImode))
    return -1;
  return 0;
}

int
pattern782 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_sve_arith_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern787 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !const_int_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern795 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 0);
  operands[2] = x4;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern807 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 2);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern812 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern818 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern828 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern834 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x3, 0, 2);
  if (GET_MODE (x4) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_one (operands[4], i1))
    return -1;
  return 0;
}

int
pattern843 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_rshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern850 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_general_reg (operands[0], i1)
      || !aarch64_plus_immediate (operands[2], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE
      || GET_MODE (x2) != E_CCmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 66
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  if (!const_int_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  return 0;
}

int
pattern857 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern865 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[2] = x3;
  x4 = XVECEXP (x2, 0, 1);
  operands[3] = x4;
  if (!register_operand (operands[3], E_VNx2DImode))
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (!rtx_equal_p (x5, operands[2]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          return pattern863 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

        case E_VNx8HImode:
          if (pattern863 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 1;

        case E_VNx4SImode:
          if (pattern863 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern864 (x1, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          return 3;

        case E_VNx8HImode:
          if (pattern864 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          return 4;

        case E_VNx4SImode:
          if (pattern864 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern879 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern886 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern891 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x3 = XEXP (x1, 2);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern897 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !aarch64_simd_or_scalar_imm_zero (operands[3], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !aarch64_simd_lshift_imm (operands[2], i1))
    return -1;
  return 0;
}

int
pattern903 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern910 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != PLUS)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_MODE (x8) != E_CC_NZmode
      || GET_MODE (x3) != E_CC_NZmode)
    return -1;
  x9 = XEXP (x3, 0);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  operands[1] = x11;
  x12 = XEXP (x10, 1);
  operands[2] = x12;
  x13 = XEXP (x9, 1);
  operands[3] = x13;
  return pattern909 (x1); /* [-1, 1] */
}

int
pattern918 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[4] = x2;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XVECEXP (x3, 0, 0);
  operands[5] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[1] = x5;
  x6 = XVECEXP (x3, 0, 3);
  operands[2] = x6;
  x7 = XVECEXP (x1, 0, 3);
  operands[3] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BFmode:
      return pattern917 (x1, 
E_VNx8BFmode); /* [-1, 0] */

    case E_VNx8HFmode:
      if (pattern917 (x1, 
E_VNx8HFmode) != 0)
        return -1;
      return 1;

    case E_VNx4SFmode:
      if (pattern917 (x1, 
E_VNx4SFmode) != 0)
        return -1;
      return 2;

    case E_VNx2DFmode:
      if (pattern917 (x1, 
E_VNx2DFmode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern925 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 2);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_DImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case CONST_INT:
      if (XWINT (x5, 0) != 0L)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern933 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !aligned_register_operand (operands[1], i1)
      || !aligned_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern938 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern945 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[4] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          return pattern944 (x1, 
E_HImode, 
E_SImode, 
E_V4SImode, 
E_V8HImode, 
E_V4HImode); /* [-1, 0] */

        case E_V2DImode:
          if (pattern944 (x1, 
E_SImode, 
E_DImode, 
E_V2DImode, 
E_V4SImode, 
E_V2SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case VEC_SELECT:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != PARALLEL
          || XVECLEN (x6, 0) != 1)
        return -1;
      x7 = XEXP (x5, 0);
      operands[4] = x7;
      x8 = XVECEXP (x6, 0, 0);
      operands[5] = x8;
      if (!immediate_operand (operands[5], E_SImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || GET_MODE (x2) != E_V4SImode)
            return -1;
          x9 = XEXP (x2, 0);
          if (GET_MODE (x9) != E_V4SImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V4HImode
              || !register_operand (operands[2], E_V8HImode)
              || !vect_par_cnst_hi_half (operands[3], E_V8HImode)
              || GET_MODE (x3) != E_V4SImode
              || GET_MODE (x4) != E_SImode
              || GET_MODE (x5) != E_HImode)
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_V4HImode:
              if (!register_operand (operands[4], E_V4HImode))
                return -1;
              return 2;

            case E_V8HImode:
              if (!register_operand (operands[4], E_V8HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x1) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || GET_MODE (x2) != E_V2DImode)
            return -1;
          x9 = XEXP (x2, 0);
          if (GET_MODE (x9) != E_V2DImode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_MODE (x10) != E_V2SImode
              || !register_operand (operands[2], E_V4SImode)
              || !vect_par_cnst_hi_half (operands[3], E_V4SImode)
              || GET_MODE (x3) != E_V2DImode
              || GET_MODE (x4) != E_DImode
              || GET_MODE (x5) != E_SImode)
            return -1;
          switch (GET_MODE (operands[4]))
            {
            case E_V2SImode:
              if (!register_operand (operands[4], E_V2SImode))
                return -1;
              return 4;

            case E_V4SImode:
              if (!register_operand (operands[4], E_V4SImode))
                return -1;
              return 5;

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern977 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  operands[5] = x1;
  if (!aarch64_reg_or_zero (operands[5], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!memory_operand (operands[6], i1))
    return -1;
  x4 = XEXP (x2, 1);
  operands[7] = x4;
  if (!aarch64_reg_or_zero (operands[7], i1))
    return -1;
  return 0;
}

int
pattern982 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern988 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_simd_lshift_imm (operands[3], i1))
    return -1;
  return 0;
}

int
pattern993 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[3]))
    {
    case E_V4BFmode:
      if (!register_operand (operands[3], E_V4BFmode))
        return -1;
      return 0;

    case E_V8BFmode:
      if (!register_operand (operands[3], E_V8BFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1003 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  return pattern336 (x3, 
i1, 
i2); /* [-1, 0] */
}

int
pattern1011 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_raddsubhn_imm_vec (operands[3], i1)
      || !aarch64_simd_shift_imm_vec_exact_top (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1019 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !aarch64_simd_imm_zero (operands[3], i1)
      || !aarch64_simd_imm_minus_one (operands[4], i1)
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1027 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, unsigned int i4, unsigned int i5)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i5
      || GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != i4
      || GET_MODE (x7) != i1)
    return -1;
  x8 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG
      || REGNO (x9) != i3
      || GET_MODE (x9) != i1)
    return -1;
  x10 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x10) != CLOBBER)
    return -1;
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != i2
      || GET_MODE (x11) != i1)
    return -1;
  return 0;
}

int
pattern1040 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[3] = x2;
  x3 = XVECEXP (x1, 0, 2);
  operands[2] = x3;
  switch (GET_MODE (operands[2]))
    {
    case E_VNx16BImode:
      if (!register_operand (operands[2], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (!register_operand (operands[2], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      if (!register_operand (operands[2], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      if (!register_operand (operands[2], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1051 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4DImode:
      if (!aligned_register_operand (operands[0], E_VNx4DImode)
          || GET_MODE (x1) != E_VNx4DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx4DImode)
        return -1;
      return 0;

    case E_VNx8DImode:
      if (!aligned_register_operand (operands[0], E_VNx8DImode)
          || GET_MODE (x1) != E_VNx8DImode)
        return -1;
      x2 = XVECEXP (x1, 0, 0);
      if (GET_MODE (x2) != E_VNx8DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern1060 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1069 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != i1)
    return -1;
  x6 = XEXP (x3, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  x9 = XEXP (x5, 0);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern1068 (x1, 
E_V4HImode, 
E_V8HImode, 
E_V8QImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern1068 (x1, 
E_V2SImode, 
E_V4SImode, 
E_V4HImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern1068 (x1, 
E_DImode, 
E_V2DImode, 
E_V2SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1083 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  if (maybe_ne (SUBREG_BYTE (x4), 0))
    return -1;
  x5 = XEXP (x4, 0);
  if (!aarch64_sve_ptrue_svpattern_immediate (x5, E_VNx16BImode))
    return -1;
  operands[1] = x5;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != 128
      || GET_MODE (x6) != E_VNx16BImode)
    return -1;
  x7 = XVECEXP (x3, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x3, 0, 1);
  operands[3] = x8;
  x9 = XVECEXP (x6, 0, 0);
  operands[4] = x9;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x10 = XVECEXP (x6, 0, 1);
  operands[5] = x10;
  x11 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x11))
    {
    case SET:
      x12 = XEXP (x11, 0);
      operands[0] = x12;
      if (!register_operand (operands[0], E_VNx16BImode))
        return -1;
      x13 = XEXP (x11, 1);
      if (!rtx_equal_p (x13, operands[1]))
        return -1;
      return pattern1082 (x4); /* [-1, 2] */

    case CLOBBER:
      x12 = XEXP (x11, 0);
      operands[0] = x12;
      if (!scratch_operand (operands[0], E_VNx16BImode))
        return -1;
      res = pattern1082 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1097 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1)
      || !aarch64_simd_reg_or_zero (operands[5], i1))
    return -1;
  return 0;
}

int
pattern1102 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1107 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x3, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      return pattern838 (x1, 
E_VNx8HFmode); /* [-1, 2] */

    case E_VNx4SFmode:
      res = pattern838 (x1, 
E_VNx4SFmode);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_VNx2DFmode:
      res = pattern838 (x1, 
E_VNx2DFmode);
      if (res >= 0)
        return res + 6; /* [6, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern1123 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x3, 0, 1);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XVECEXP (x5, 0, 1);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1132 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[4], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1
      || !register_operand (operands[3], i2)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1144 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sync_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1148 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i3))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern1158 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16BImode)
          || !register_operand (operands[3], E_VNx16BImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx8BImode
          || !register_operand (operands[2], E_VNx8BImode)
          || !register_operand (operands[3], E_VNx8BImode))
        return -1;
      return 1;

    case E_VNx4BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx4BImode
          || !register_operand (operands[2], E_VNx4BImode)
          || !register_operand (operands[3], E_VNx4BImode))
        return -1;
      return 2;

    case E_VNx2BImode:
      x2 = XEXP (x1, 0);
      if (GET_MODE (x2) != E_VNx2BImode
          || !register_operand (operands[2], E_VNx2BImode)
          || !register_operand (operands[3], E_VNx2BImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1176 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[2], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1184 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  operands[2] = x3;
  x4 = XEXP (x2, 0);
  if (!rtx_equal_p (x4, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern1183 (x1, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pattern1183 (x1, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_SImode:
      if (pattern1183 (x1, 
E_SImode) != 0)
        return -1;
      return 2;

    case E_DImode:
      if (pattern1183 (x1, 
E_DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern1194 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[0], i1)
      || !const_scalar_int_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !aarch64_plus_immediate (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1199 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i3
      || !register_operand (operands[2], i2)
      || !vect_par_cnst_hi_half (operands[4], i2))
    return -1;
  x6 = XEXP (x3, 1);
  return pattern1169 (x6, 
i1, 
i2, 
i3); /* [-1, 0] */
}

int
pattern1207 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern1213 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern1219 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], i3)
      || !aarch64_sve_gather_offset_h (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || !aarch64_gather_scale_operand_h (operands[4], E_DImode)
      || !aarch64_maskload_else_operand (operands[6], i1))
    return -1;
  return 0;
}

int
pattern1225 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !aarch64_simd_or_scalar_imm_zero (operands[5], i1))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1232 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern1236 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 3);
  if (GET_MODE (x4) != E_VNx16BImode)
    return -1;
  x5 = XVECEXP (x3, 0, 2);
  operands[4] = x5;
  x6 = XVECEXP (x4, 0, 1);
  operands[2] = x6;
  if (!register_operand (operands[2], E_VNx16BImode))
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  operands[3] = x7;
  if (!register_operand (operands[3], E_VNx16BImode))
    return -1;
  return pattern1234 (x1, 
i1); /* [-1, 1] */
}

int
pattern1245 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1)
      || !aarch64_sve_float_arith_with_sub_immediate (operands[3], i1)
      || !aarch64_simd_reg_or_zero (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1251 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  if (!aarch64_sve_gp_strictness (operands[5], E_SImode))
    return -1;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XVECEXP (x2, 0, 1);
  operands[6] = x3;
  if (!aarch64_sve_gp_strictness (operands[6], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XVECEXP (x4, 0, 0);
  if (!rtx_equal_p (x5, operands[1]))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8BImode:
      return pattern453 (x1, 
E_VNx8HFmode, 
E_VNx8BImode); /* [-1, 0] */

    case E_VNx4BImode:
      if (pattern453 (x1, 
E_VNx4SFmode, 
E_VNx4BImode) != 0)
        return -1;
      return 1;

    case E_VNx2BImode:
      if (pattern453 (x1, 
E_VNx2DFmode, 
E_VNx2BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1263 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !aarch64_sync_memory_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !aarch64_plus_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1270 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[5], i3)
      || !aarch64_sve_gather_offset_w (operands[1], E_DImode)
      || !register_operand (operands[2], i2)
      || !aarch64_gather_scale_operand_w (operands[4], E_DImode))
    return -1;
  return 0;
}

int
pattern1279 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_VNx16BImode)
      || !register_operand (operands[4], E_VNx2DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx16BImode:
      return pattern1278 (x1, 
E_VNx16QImode, 
E_VNx16BImode); /* [-1, 0] */

    case E_VNx8BImode:
      if (pattern1278 (x1, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
        return -1;
      return 1;

    case E_VNx4BImode:
      if (pattern1278 (x1, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1288 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern1306 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  x4 = XEXP (x2, 1);
  operands[3] = x4;
  switch (GET_MODE (x1))
    {
    case E_VNx16BImode:
      if (GET_MODE (x2) != E_VNx16BImode
          || !register_operand (operands[2], E_VNx16QImode)
          || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx16QImode))
        return -1;
      return 0;

    case E_VNx8BImode:
      if (GET_MODE (x2) != E_VNx8BImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx8QImode:
          if (!register_operand (operands[2], E_VNx8QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8QImode))
            return -1;
          return 1;

        case E_VNx8HImode:
          if (!register_operand (operands[2], E_VNx8HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx8HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_VNx4BImode:
      if (GET_MODE (x2) != E_VNx4BImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx4QImode:
          if (!register_operand (operands[2], E_VNx4QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4QImode))
            return -1;
          return 3;

        case E_VNx4HImode:
          if (!register_operand (operands[2], E_VNx4HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4HImode))
            return -1;
          return 4;

        case E_VNx4SImode:
          if (!register_operand (operands[2], E_VNx4SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx4SImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    case E_VNx2BImode:
      if (GET_MODE (x2) != E_VNx2BImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_VNx2QImode:
          if (!register_operand (operands[2], E_VNx2QImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2QImode))
            return -1;
          return 6;

        case E_VNx2HImode:
          if (!register_operand (operands[2], E_VNx2HImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2HImode))
            return -1;
          return 7;

        case E_VNx2SImode:
          if (!register_operand (operands[2], E_VNx2SImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2SImode))
            return -1;
          return 8;

        case E_VNx2DImode:
          if (!register_operand (operands[2], E_VNx2DImode)
              || !aarch64_sve_cmp_vsd_operand (operands[3], E_VNx2DImode))
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern1336 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !aarch64_carry_operation (operands[3], i2))
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_MODE (x6) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x7 = XEXP (x4, 1);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1
      || !aarch64_carry_operation (operands[4], i1))
    return -1;
  return 0;
}

int
pattern1346 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_VNx2DImode))
    return -1;
  return pattern1332 (x1); /* [-1, 1] */
}

int
pattern1350 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i2)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern1355 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[1], i1))
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i2)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i2
      || !register_operand (operands[2], i1)
      || !aarch64_borrow_operation (operands[3], i2))
    return -1;
  x8 = XEXP (x3, 1);
  if (GET_MODE (x8) != i2)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_MODE (x9) != i1)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_MODE (x10) != i1
      || !aarch64_borrow_operation (operands[4], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x11 = XVECEXP (x1, 0, 1);
  x12 = XEXP (x11, 1);
  if (GET_MODE (x12) != i1)
    return -1;
  x13 = XEXP (x12, 0);
  if (GET_MODE (x13) != i1)
    return -1;
  return 0;
}

 int
recog_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  x9 = XEXP (x6, 2);
  operands[5] = x9;
  switch (pattern927 (x2))
    {
    case 0:
      if (!aarch64_simd_shift_imm_si (operands[5], E_SImode)
          || !
#line 6541 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_M1U << INTVAL (operands[4])
   && INTVAL (operands[4])
   && (UINTVAL (operands[4]) + UINTVAL (operands[5])
       <= GET_MODE_BITSIZE (SImode))))
        return -1;
      return 847; /* *aarch64_bfxilsi_extr */

    case 1:
      if (!aarch64_simd_shift_imm_di (operands[5], E_DImode)
          || !
#line 6541 "../../gcc/config/aarch64/aarch64.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_M1U << INTVAL (operands[4])
   && INTVAL (operands[4])
   && (UINTVAL (operands[4]) + UINTVAL (operands[5])
       <= GET_MODE_BITSIZE (DImode))))
        return -1;
      return 848; /* *aarch64_bfxildi_extr */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      switch (XINT (x4, 1))
        {
        case 315:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern863 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
                return -1;
              return 6874; /* aarch64_pred_revbvnx16qi */

            case E_VNx8HImode:
              if (pattern863 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
                return -1;
              return 6877; /* aarch64_pred_revbvnx8hi */

            case E_VNx4SImode:
              if (pattern863 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
                return -1;
              return 6880; /* aarch64_pred_revbvnx4si */

            case E_VNx2DImode:
              if (pattern863 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
                return -1;
              return 6883; /* aarch64_pred_revbvnx2di */

            default:
              return -1;
            }

        case 317:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern863 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
                return -1;
              return 6875; /* aarch64_pred_revhvnx16qi */

            case E_VNx8HImode:
              if (pattern863 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
                return -1;
              return 6878; /* aarch64_pred_revhvnx8hi */

            case E_VNx4SImode:
              if (pattern863 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
                return -1;
              return 6881; /* aarch64_pred_revhvnx4si */

            case E_VNx2DImode:
              if (pattern863 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
                return -1;
              return 6884; /* aarch64_pred_revhvnx2di */

            default:
              return -1;
            }

        case 318:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern863 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
                return -1;
              return 6876; /* aarch64_pred_revwvnx16qi */

            case E_VNx8HImode:
              if (pattern863 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
                return -1;
              return 6879; /* aarch64_pred_revwvnx8hi */

            case E_VNx4SImode:
              if (pattern863 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
                return -1;
              return 6882; /* aarch64_pred_revwvnx4si */

            case E_VNx2DImode:
              if (pattern863 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3277 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
                return -1;
              return 6885; /* aarch64_pred_revwvnx2di */

            default:
              return -1;
            }

        case 319:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              switch (pattern929 (x2, 
E_VNx16QImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 8))
                    return -1;
                  return 6886; /* aarch64_sve_revbhw_vnx16qivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 8))
                    return -1;
                  return 6905; /* aarch64_sve_revbhw_vnx16qivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 8))
                    return -1;
                  return 6924; /* aarch64_sve_revbhw_vnx16qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx8QImode:
              switch (pattern929 (x2, 
E_VNx8QImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6887; /* aarch64_sve_revbhw_vnx8qivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6906; /* aarch64_sve_revbhw_vnx8qivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6925; /* aarch64_sve_revbhw_vnx8qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4QImode:
              switch (pattern929 (x2, 
E_VNx4QImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6888; /* aarch64_sve_revbhw_vnx4qivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6907; /* aarch64_sve_revbhw_vnx4qivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6926; /* aarch64_sve_revbhw_vnx4qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2QImode:
              switch (pattern929 (x2, 
E_VNx2QImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6889; /* aarch64_sve_revbhw_vnx2qivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6908; /* aarch64_sve_revbhw_vnx2qivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6927; /* aarch64_sve_revbhw_vnx2qivnx2bi */

                default:
                  return -1;
                }

            case E_VNx8HImode:
              switch (pattern929 (x2, 
E_VNx8HImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6890; /* aarch64_sve_revbhw_vnx8hivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6909; /* aarch64_sve_revbhw_vnx8hivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6928; /* aarch64_sve_revbhw_vnx8hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4HImode:
              switch (pattern929 (x2, 
E_VNx4HImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6891; /* aarch64_sve_revbhw_vnx4hivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6910; /* aarch64_sve_revbhw_vnx4hivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6929; /* aarch64_sve_revbhw_vnx4hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2HImode:
              switch (pattern929 (x2, 
E_VNx2HImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6892; /* aarch64_sve_revbhw_vnx2hivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6911; /* aarch64_sve_revbhw_vnx2hivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6930; /* aarch64_sve_revbhw_vnx2hivnx2bi */

                default:
                  return -1;
                }

            case E_VNx4SImode:
              switch (pattern929 (x2, 
E_VNx4SImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6893; /* aarch64_sve_revbhw_vnx4sivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6912; /* aarch64_sve_revbhw_vnx4sivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6931; /* aarch64_sve_revbhw_vnx4sivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2SImode:
              switch (pattern929 (x2, 
E_VNx2SImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6894; /* aarch64_sve_revbhw_vnx2sivnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6913; /* aarch64_sve_revbhw_vnx2sivnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6932; /* aarch64_sve_revbhw_vnx2sivnx2bi */

                default:
                  return -1;
                }

            case E_VNx2DImode:
              switch (pattern929 (x2, 
E_VNx2DImode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6895; /* aarch64_sve_revbhw_vnx2divnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6914; /* aarch64_sve_revbhw_vnx2divnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6933; /* aarch64_sve_revbhw_vnx2divnx2bi */

                default:
                  return -1;
                }

            case E_VNx8HFmode:
              switch (pattern929 (x2, 
E_VNx8HFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6896; /* aarch64_sve_revbhw_vnx8hfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6915; /* aarch64_sve_revbhw_vnx8hfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6934; /* aarch64_sve_revbhw_vnx8hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4HFmode:
              switch (pattern929 (x2, 
E_VNx4HFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6897; /* aarch64_sve_revbhw_vnx4hfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6916; /* aarch64_sve_revbhw_vnx4hfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6935; /* aarch64_sve_revbhw_vnx4hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2HFmode:
              switch (pattern929 (x2, 
E_VNx2HFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6898; /* aarch64_sve_revbhw_vnx2hfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6917; /* aarch64_sve_revbhw_vnx2hfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6936; /* aarch64_sve_revbhw_vnx2hfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx8BFmode:
              switch (pattern929 (x2, 
E_VNx8BFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 16))
                    return -1;
                  return 6899; /* aarch64_sve_revbhw_vnx8bfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 16))
                    return -1;
                  return 6918; /* aarch64_sve_revbhw_vnx8bfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 16))
                    return -1;
                  return 6937; /* aarch64_sve_revbhw_vnx8bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4BFmode:
              switch (pattern929 (x2, 
E_VNx4BFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6900; /* aarch64_sve_revbhw_vnx4bfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6919; /* aarch64_sve_revbhw_vnx4bfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6938; /* aarch64_sve_revbhw_vnx4bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2BFmode:
              switch (pattern929 (x2, 
E_VNx2BFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6901; /* aarch64_sve_revbhw_vnx2bfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6920; /* aarch64_sve_revbhw_vnx2bfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6939; /* aarch64_sve_revbhw_vnx2bfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx4SFmode:
              switch (pattern929 (x2, 
E_VNx4SFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 32))
                    return -1;
                  return 6902; /* aarch64_sve_revbhw_vnx4sfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 32))
                    return -1;
                  return 6921; /* aarch64_sve_revbhw_vnx4sfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 32))
                    return -1;
                  return 6940; /* aarch64_sve_revbhw_vnx4sfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2SFmode:
              switch (pattern929 (x2, 
E_VNx2SFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6903; /* aarch64_sve_revbhw_vnx2sfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6922; /* aarch64_sve_revbhw_vnx2sfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6941; /* aarch64_sve_revbhw_vnx2sfvnx2bi */

                default:
                  return -1;
                }

            case E_VNx2DFmode:
              switch (pattern929 (x2, 
E_VNx2DFmode))
                {
                case 0:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 > 64))
                    return -1;
                  return 6904; /* aarch64_sve_revbhw_vnx2dfvnx8bi */

                case 1:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 > 64))
                    return -1;
                  return 6923; /* aarch64_sve_revbhw_vnx2dfvnx4bi */

                case 2:
                  if (!
#line 3296 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 > 64))
                    return -1;
                  return 6942; /* aarch64_sve_revbhw_vnx2dfvnx2bi */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 26:
          if (pattern853 (x2) != 0
              || !
#line 3464 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12586; /* aarch64_pred_urecpevnx4si */

        case 111:
          if (pattern853 (x2) != 0
              || !
#line 3464 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12587; /* aarch64_pred_ursqrtevnx4si */

        case 316:
          if (!register_operand (operands[1], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern982 (x2, 
E_VNx16QImode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12737; /* aarch64_pred_revdvnx16qi */

            case E_VNx8HImode:
              if (pattern982 (x2, 
E_VNx8HImode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12738; /* aarch64_pred_revdvnx8hi */

            case E_VNx4SImode:
              if (pattern982 (x2, 
E_VNx4SImode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12739; /* aarch64_pred_revdvnx4si */

            case E_VNx2DImode:
              if (pattern982 (x2, 
E_VNx2DImode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12740; /* aarch64_pred_revdvnx2di */

            case E_VNx8BFmode:
              if (pattern982 (x2, 
E_VNx8BFmode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12741; /* aarch64_pred_revdvnx8bf */

            case E_VNx8HFmode:
              if (pattern982 (x2, 
E_VNx8HFmode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12742; /* aarch64_pred_revdvnx8hf */

            case E_VNx4SFmode:
              if (pattern982 (x2, 
E_VNx4SFmode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12743; /* aarch64_pred_revdvnx4sf */

            case E_VNx2DFmode:
              if (pattern982 (x2, 
E_VNx2DFmode) != 0
                  || !
#line 3766 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12744; /* aarch64_pred_revdvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      return recog_11 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_28 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern370 (x3))
    {
    case 0:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4578; /* aarch64_rev_reglistv2x8qi */

    case 1:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4579; /* aarch64_rev_reglistv2x4hi */

    case 2:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4580; /* aarch64_rev_reglistv2x2si */

    case 3:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4581; /* aarch64_rev_reglistv2x1di */

    case 4:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4582; /* aarch64_rev_reglistv2x4hf */

    case 5:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4583; /* aarch64_rev_reglistv2x2sf */

    case 6:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4584; /* aarch64_rev_reglistv2x1df */

    case 7:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4585; /* aarch64_rev_reglistv2x4bf */

    case 8:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4586; /* aarch64_rev_reglistv3x8qi */

    case 9:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4587; /* aarch64_rev_reglistv3x4hi */

    case 10:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4588; /* aarch64_rev_reglistv3x2si */

    case 11:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4589; /* aarch64_rev_reglistv3x1di */

    case 12:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4590; /* aarch64_rev_reglistv3x4hf */

    case 13:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4591; /* aarch64_rev_reglistv3x2sf */

    case 14:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4592; /* aarch64_rev_reglistv3x1df */

    case 15:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4593; /* aarch64_rev_reglistv3x4bf */

    case 16:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4594; /* aarch64_rev_reglistv4x8qi */

    case 17:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4595; /* aarch64_rev_reglistv4x4hi */

    case 18:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4596; /* aarch64_rev_reglistv4x2si */

    case 19:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4597; /* aarch64_rev_reglistv4x1di */

    case 20:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4598; /* aarch64_rev_reglistv4x4hf */

    case 21:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4599; /* aarch64_rev_reglistv4x2sf */

    case 22:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4600; /* aarch64_rev_reglistv4x1df */

    case 23:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4601; /* aarch64_rev_reglistv4x4bf */

    case 24:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4602; /* aarch64_rev_reglistv2x16qi */

    case 25:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4603; /* aarch64_rev_reglistv2x8hi */

    case 26:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4604; /* aarch64_rev_reglistv2x4si */

    case 27:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4605; /* aarch64_rev_reglistv2x2di */

    case 28:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4606; /* aarch64_rev_reglistv2x8hf */

    case 29:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4607; /* aarch64_rev_reglistv2x4sf */

    case 30:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4608; /* aarch64_rev_reglistv2x2df */

    case 31:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4609; /* aarch64_rev_reglistv2x8bf */

    case 32:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4610; /* aarch64_rev_reglistv3x16qi */

    case 33:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4611; /* aarch64_rev_reglistv3x8hi */

    case 34:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4612; /* aarch64_rev_reglistv3x4si */

    case 35:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4613; /* aarch64_rev_reglistv3x2di */

    case 36:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4614; /* aarch64_rev_reglistv3x8hf */

    case 37:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4615; /* aarch64_rev_reglistv3x4sf */

    case 38:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4616; /* aarch64_rev_reglistv3x2df */

    case 39:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4617; /* aarch64_rev_reglistv3x8bf */

    case 40:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4618; /* aarch64_rev_reglistv4x16qi */

    case 41:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4619; /* aarch64_rev_reglistv4x8hi */

    case 42:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4620; /* aarch64_rev_reglistv4x4si */

    case 43:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4621; /* aarch64_rev_reglistv4x2di */

    case 44:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4622; /* aarch64_rev_reglistv4x8hf */

    case 45:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4623; /* aarch64_rev_reglistv4x4sf */

    case 46:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4624; /* aarch64_rev_reglistv4x2df */

    case 47:
      if (!
#line 7928 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4625; /* aarch64_rev_reglistv4x8bf */

    default:
      return -1;
    }
}

 int
recog_37 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!aarch64_simd_struct_operand (operands[0], E_BLKmode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V2x8QImode:
      if (!register_operand (operands[1], E_V2x8QImode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4426; /* aarch64_vec_store_lanesv2x8qi_lanev8qi */

    case E_V2x4HImode:
      if (!register_operand (operands[1], E_V2x4HImode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4427; /* aarch64_vec_store_lanesv2x4hi_lanev4hi */

    case E_V2x2SImode:
      if (!register_operand (operands[1], E_V2x2SImode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4428; /* aarch64_vec_store_lanesv2x2si_lanev2si */

    case E_V2x1DImode:
      if (!register_operand (operands[1], E_V2x1DImode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4429; /* aarch64_vec_store_lanesv2x1di_lanedi */

    case E_V2x4HFmode:
      if (!register_operand (operands[1], E_V2x4HFmode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4430; /* aarch64_vec_store_lanesv2x4hf_lanev4hf */

    case E_V2x2SFmode:
      if (!register_operand (operands[1], E_V2x2SFmode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4431; /* aarch64_vec_store_lanesv2x2sf_lanev2sf */

    case E_V2x1DFmode:
      if (!register_operand (operands[1], E_V2x1DFmode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4432; /* aarch64_vec_store_lanesv2x1df_lanedf */

    case E_V2x4BFmode:
      if (!register_operand (operands[1], E_V2x4BFmode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4433; /* aarch64_vec_store_lanesv2x4bf_lanev4bf */

    case E_V2x16QImode:
      if (!register_operand (operands[1], E_V2x16QImode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4434; /* aarch64_vec_store_lanesv2x16qi_lanev16qi */

    case E_V2x8HImode:
      if (!register_operand (operands[1], E_V2x8HImode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4435; /* aarch64_vec_store_lanesv2x8hi_lanev8hi */

    case E_V2x4SImode:
      if (!register_operand (operands[1], E_V2x4SImode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4436; /* aarch64_vec_store_lanesv2x4si_lanev4si */

    case E_V2x2DImode:
      if (!register_operand (operands[1], E_V2x2DImode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4437; /* aarch64_vec_store_lanesv2x2di_lanev2di */

    case E_V2x8HFmode:
      if (!register_operand (operands[1], E_V2x8HFmode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4438; /* aarch64_vec_store_lanesv2x8hf_lanev8hf */

    case E_V2x4SFmode:
      if (!register_operand (operands[1], E_V2x4SFmode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4439; /* aarch64_vec_store_lanesv2x4sf_lanev4sf */

    case E_V2x2DFmode:
      if (!register_operand (operands[1], E_V2x2DFmode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4440; /* aarch64_vec_store_lanesv2x2df_lanev2df */

    case E_V2x8BFmode:
      if (!register_operand (operands[1], E_V2x8BFmode)
          || !
#line 7629 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4441; /* aarch64_vec_store_lanesv2x8bf_lanev8bf */

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern59 (x1))
    {
    case 0:
      if (!(
#line 7386 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 1085; /* fmaxhf3 */

    case 1:
      if (!
#line 7386 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1089; /* fmaxsf3 */

    case 2:
      if (!
#line 7386 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 1093; /* fmaxdf3 */

    case 3:
      if (!(
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2671; /* fmaxv4hf3 */

    case 4:
      if (!(
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2679; /* fmaxv8hf3 */

    case 5:
      if (!
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2687; /* fmaxv2sf3 */

    case 6:
      if (!
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2695; /* fmaxv4sf3 */

    case 7:
      if (!
#line 3361 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2699; /* fmaxv2df3 */

    case 8:
      if (!(
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 687 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12213; /* *aarch64_sve_fmaxnmvnx16bf */

    case 9:
      if (!(
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 688 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12217; /* *aarch64_sve_fmaxnmvnx32bf */

    case 10:
      if (!
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12221; /* *aarch64_sve_fmaxnmvnx16hf */

    case 11:
      if (!
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12225; /* *aarch64_sve_fmaxnmvnx8sf */

    case 12:
      if (!
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12229; /* *aarch64_sve_fmaxnmvnx4df */

    case 13:
      if (!
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12233; /* *aarch64_sve_fmaxnmvnx32hf */

    case 14:
      if (!
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12237; /* *aarch64_sve_fmaxnmvnx16sf */

    case 15:
      if (!
#line 2514 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12241; /* *aarch64_sve_fmaxnmvnx8df */

    case 16:
      if (!(
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 687 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12245; /* aarch64_sve_single_fmaxnmvnx16bf */

    case 17:
      if (!(
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2) && 
#line 688 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 12249; /* aarch64_sve_single_fmaxnmvnx32bf */

    case 18:
      if (!
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12253; /* aarch64_sve_single_fmaxnmvnx16hf */

    case 19:
      if (!
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12257; /* aarch64_sve_single_fmaxnmvnx8sf */

    case 20:
      if (!
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12261; /* aarch64_sve_single_fmaxnmvnx4df */

    case 21:
      if (!
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12265; /* aarch64_sve_single_fmaxnmvnx32hf */

    case 22:
      if (!
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12269; /* aarch64_sve_single_fmaxnmvnx16sf */

    case 23:
      if (!
#line 2525 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12273; /* aarch64_sve_single_fmaxnmvnx8df */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern96 (x1))
    {
    case 0:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10457; /* aarch64_sve_uzpq2vnx16qi */

    case 1:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10467; /* aarch64_sve_uzpq2vnx8qi */

    case 2:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10477; /* aarch64_sve_uzpq2vnx4qi */

    case 3:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10487; /* aarch64_sve_uzpq2vnx2qi */

    case 4:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10497; /* aarch64_sve_uzpq2vnx8hi */

    case 5:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10507; /* aarch64_sve_uzpq2vnx4hi */

    case 6:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10517; /* aarch64_sve_uzpq2vnx2hi */

    case 7:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10527; /* aarch64_sve_uzpq2vnx4si */

    case 8:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10537; /* aarch64_sve_uzpq2vnx2si */

    case 9:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10547; /* aarch64_sve_uzpq2vnx2di */

    case 10:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10557; /* aarch64_sve_uzpq2vnx8hf */

    case 11:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10567; /* aarch64_sve_uzpq2vnx4hf */

    case 12:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10577; /* aarch64_sve_uzpq2vnx2hf */

    case 13:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10587; /* aarch64_sve_uzpq2vnx8bf */

    case 14:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10597; /* aarch64_sve_uzpq2vnx4bf */

    case 15:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10607; /* aarch64_sve_uzpq2vnx2bf */

    case 16:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10617; /* aarch64_sve_uzpq2vnx4sf */

    case 17:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10627; /* aarch64_sve_uzpq2vnx2sf */

    case 18:
      if (!(
#line 9215 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3169 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING)))
        return -1;
      return 10637; /* aarch64_sve_uzpq2vnx2df */

    default:
      return -1;
    }
}

 int
recog_63 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern66 (x1))
    {
    case 0:
      if (!(
#line 8858 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 185 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5150; /* aarch64_frecpsv4hf */

    case 1:
      if (!(
#line 8858 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 186 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5151; /* aarch64_frecpsv8hf */

    case 2:
      if (!
#line 8858 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5152; /* aarch64_frecpsv2sf */

    case 3:
      if (!
#line 8858 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5153; /* aarch64_frecpsv4sf */

    case 4:
      if (!
#line 8858 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5154; /* aarch64_frecpsv2df */

    case 5:
      if (!(
#line 8858 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 188 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 5155; /* aarch64_frecpshf */

    case 6:
      if (!
#line 8858 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5156; /* aarch64_frecpssf */

    case 7:
      if (!
#line 8858 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5157; /* aarch64_frecpsdf */

    case 8:
      if (!
#line 5408 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8474; /* aarch64_sve_frecpsvnx8hf */

    case 9:
      if (!
#line 5408 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8476; /* aarch64_sve_frecpsvnx4sf */

    case 10:
      if (!
#line 5408 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8478; /* aarch64_sve_frecpsvnx2df */

    default:
      return -1;
    }
}

 int
recog_74 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern93 (x1))
    {
    case 0:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8980; /* *iorvnx8hf3 */

    case 1:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8983; /* *iorvnx4hf3 */

    case 2:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8986; /* *iorvnx2hf3 */

    case 3:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8989; /* *iorvnx8bf3 */

    case 4:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8992; /* *iorvnx4bf3 */

    case 5:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8995; /* *iorvnx2bf3 */

    case 6:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 8998; /* *iorvnx4sf3 */

    case 7:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9001; /* *iorvnx2sf3 */

    case 8:
      if (!
#line 6579 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9004; /* *iorvnx2df3 */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx4SImode:
      if (pattern719 (x3, 
E_VNx4BImode, 
E_VNx4SImode, 
E_VNx1SImode) != 0
          || !
#line 228 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11081; /* aarch64_sve_ld1_extendqvnx4si */

    case E_VNx2DImode:
      if (pattern719 (x3, 
E_VNx2BImode, 
E_VNx2DImode, 
E_VNx1DImode) != 0
          || !
#line 228 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11082; /* aarch64_sve_ld1_extendqvnx2di */

    case E_VNx4SFmode:
      if (pattern719 (x3, 
E_VNx4BImode, 
E_VNx4SFmode, 
E_VNx1SImode) != 0
          || !
#line 228 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11083; /* aarch64_sve_ld1_extendqvnx4sf */

    case E_VNx2DFmode:
      if (pattern719 (x3, 
E_VNx2BImode, 
E_VNx2DFmode, 
E_VNx1DImode) != 0
          || !
#line 228 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 11084; /* aarch64_sve_ld1_extendqvnx2df */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern76 (x1))
    {
    case 0:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3630; /* aarch64_ushlv8qi */

    case 1:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3640; /* aarch64_ushlv16qi */

    case 2:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3646; /* aarch64_ushlv4hi */

    case 3:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3656; /* aarch64_ushlv8hi */

    case 4:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3662; /* aarch64_ushlv2si */

    case 5:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3672; /* aarch64_ushlv4si */

    case 6:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3676; /* aarch64_ushlv2di */

    case 7:
      if (!
#line 6507 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3682; /* aarch64_ushldi */

    default:
      return -1;
    }
}

 int
recog_102 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern53 (x1))
    {
    case 0:
      return 1023; /* fcvtzusf3 */

    case 1:
      if (!
#line 7171 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1031; /* fcvtzuhfsi3 */

    case 2:
      return 1025; /* fcvtzudf3 */

    case 3:
      if (!
#line 7171 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 1033; /* fcvtzuhfdi3 */

    case 4:
      if (!
#line 7191 "../../gcc/config/aarch64/aarch64.md"
(TARGET_SIMD))
        return -1;
      return 1039; /* fcvtzuhf3 */

    case 5:
      if (!(
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2618; /* fcvtzuv4hf3 */

    case 6:
      if (!(
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2620; /* fcvtzuv8hf3 */

    case 7:
      if (!
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2622; /* fcvtzuv2sf3 */

    case 8:
      if (!
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2624; /* fcvtzuv4sf3 */

    case 9:
      if (!
#line 3125 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2626; /* fcvtzuv2df3 */

    default:
      return -1;
    }
}

 int
recog_113 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern103 (x1))
    {
    case 0:
      if (!
#line 2269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12062; /* aarch64_sve_umullbvnx8hi */

    case 1:
      if (!
#line 2269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12083; /* aarch64_sve_umullbvnx4si */

    case 2:
      if (!
#line 2269 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12104; /* aarch64_sve_umullbvnx2di */

    case 3:
      if (!
#line 2282 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12112; /* aarch64_sve_umullb_lane_vnx4si */

    case 4:
      if (!
#line 2282 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12118; /* aarch64_sve_umullb_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_123 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern111 (x1))
    {
    case 0:
      if (!
#line 3921 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12858; /* aarch64_sve_bextvnx16qi */

    case 1:
      if (!
#line 3921 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12861; /* aarch64_sve_bextvnx8hi */

    case 2:
      if (!
#line 3921 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12864; /* aarch64_sve_bextvnx4si */

    case 3:
      if (!
#line 3921 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2_BITPERM))
        return -1;
      return 12867; /* aarch64_sve_bextvnx2di */

    default:
      return -1;
    }
}

 int
recog_132 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern117 (x1))
    {
    case 0:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12691; /* aarch64_pred_reduc_andqv_vnx16qi */

    case 1:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12699; /* aarch64_pred_reduc_andqv_vnx8hi */

    case 2:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12707; /* aarch64_pred_reduc_andqv_vnx4si */

    case 3:
      if (!
#line 3722 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1 && TARGET_NON_STREAMING))
        return -1;
      return 12715; /* aarch64_pred_reduc_andqv_vnx2di */

    default:
      return -1;
    }
}

 int
recog_144 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V3x8QImode:
      if (!register_operand (operands[0], E_V3x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8QImode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4626; /* aarch64_ld1_x3_v8qi */

    case E_V3x4HImode:
      if (!register_operand (operands[0], E_V3x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4HImode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4627; /* aarch64_ld1_x3_v4hi */

    case E_V3x2SImode:
      if (!register_operand (operands[0], E_V3x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2SImode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4628; /* aarch64_ld1_x3_v2si */

    case E_V3x1DImode:
      if (!register_operand (operands[0], E_V3x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x1DImode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4629; /* aarch64_ld1_x3_di */

    case E_V3x4HFmode:
      if (!register_operand (operands[0], E_V3x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4HFmode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4630; /* aarch64_ld1_x3_v4hf */

    case E_V3x2SFmode:
      if (!register_operand (operands[0], E_V3x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2SFmode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4631; /* aarch64_ld1_x3_v2sf */

    case E_V3x1DFmode:
      if (!register_operand (operands[0], E_V3x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x1DFmode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4632; /* aarch64_ld1_x3_df */

    case E_V3x4BFmode:
      if (!register_operand (operands[0], E_V3x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4BFmode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4633; /* aarch64_ld1_x3_v4bf */

    case E_V3x16QImode:
      if (!register_operand (operands[0], E_V3x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x16QImode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4634; /* aarch64_ld1_x3_v16qi */

    case E_V3x8HImode:
      if (!register_operand (operands[0], E_V3x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8HImode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4635; /* aarch64_ld1_x3_v8hi */

    case E_V3x4SImode:
      if (!register_operand (operands[0], E_V3x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4SImode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4636; /* aarch64_ld1_x3_v4si */

    case E_V3x2DImode:
      if (!register_operand (operands[0], E_V3x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2DImode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4637; /* aarch64_ld1_x3_v2di */

    case E_V3x8HFmode:
      if (!register_operand (operands[0], E_V3x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8HFmode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4638; /* aarch64_ld1_x3_v8hf */

    case E_V3x4SFmode:
      if (!register_operand (operands[0], E_V3x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x4SFmode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4639; /* aarch64_ld1_x3_v4sf */

    case E_V3x2DFmode:
      if (!register_operand (operands[0], E_V3x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x2DFmode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4640; /* aarch64_ld1_x3_v2df */

    case E_V3x8BFmode:
      if (!register_operand (operands[0], E_V3x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V3x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V3x8BFmode)
          || !
#line 8006 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4641; /* aarch64_ld1_x3_v8bf */

    case E_V4x8QImode:
      if (!register_operand (operands[0], E_V4x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8QImode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4642; /* aarch64_ld1_x4_v8qi */

    case E_V4x4HImode:
      if (!register_operand (operands[0], E_V4x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4HImode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4643; /* aarch64_ld1_x4_v4hi */

    case E_V4x2SImode:
      if (!register_operand (operands[0], E_V4x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2SImode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4644; /* aarch64_ld1_x4_v2si */

    case E_V4x1DImode:
      if (!register_operand (operands[0], E_V4x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x1DImode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4645; /* aarch64_ld1_x4_di */

    case E_V4x4HFmode:
      if (!register_operand (operands[0], E_V4x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4HFmode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4646; /* aarch64_ld1_x4_v4hf */

    case E_V4x2SFmode:
      if (!register_operand (operands[0], E_V4x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2SFmode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4647; /* aarch64_ld1_x4_v2sf */

    case E_V4x1DFmode:
      if (!register_operand (operands[0], E_V4x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x1DFmode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4648; /* aarch64_ld1_x4_df */

    case E_V4x4BFmode:
      if (!register_operand (operands[0], E_V4x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4BFmode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4649; /* aarch64_ld1_x4_v4bf */

    case E_V4x16QImode:
      if (!register_operand (operands[0], E_V4x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x16QImode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4650; /* aarch64_ld1_x4_v16qi */

    case E_V4x8HImode:
      if (!register_operand (operands[0], E_V4x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8HImode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4651; /* aarch64_ld1_x4_v8hi */

    case E_V4x4SImode:
      if (!register_operand (operands[0], E_V4x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4SImode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4652; /* aarch64_ld1_x4_v4si */

    case E_V4x2DImode:
      if (!register_operand (operands[0], E_V4x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2DImode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4653; /* aarch64_ld1_x4_v2di */

    case E_V4x8HFmode:
      if (!register_operand (operands[0], E_V4x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8HFmode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4654; /* aarch64_ld1_x4_v8hf */

    case E_V4x4SFmode:
      if (!register_operand (operands[0], E_V4x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x4SFmode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4655; /* aarch64_ld1_x4_v4sf */

    case E_V4x2DFmode:
      if (!register_operand (operands[0], E_V4x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x2DFmode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4656; /* aarch64_ld1_x4_v2df */

    case E_V4x8BFmode:
      if (!register_operand (operands[0], E_V4x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4x8BFmode)
          || !
#line 8026 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4657; /* aarch64_ld1_x4_v8bf */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V8QImode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4707; /* aarch64_be_ld1v8qi */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V16QImode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4708; /* aarch64_be_ld1v16qi */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V4HImode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4709; /* aarch64_be_ld1v4hi */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V8HImode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4710; /* aarch64_be_ld1v8hi */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2SImode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4711; /* aarch64_be_ld1v2si */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V4SImode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4712; /* aarch64_be_ld1v4si */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2DImode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4713; /* aarch64_be_ld1v2di */

    case E_V4HFmode:
      if (!register_operand (operands[0], E_V4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4HFmode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4714; /* aarch64_be_ld1v4hf */

    case E_V8HFmode:
      if (!register_operand (operands[0], E_V8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V8HFmode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4715; /* aarch64_be_ld1v8hf */

    case E_V4BFmode:
      if (!register_operand (operands[0], E_V4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4BFmode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4716; /* aarch64_be_ld1v4bf */

    case E_V8BFmode:
      if (!register_operand (operands[0], E_V8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V8BFmode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4717; /* aarch64_be_ld1v8bf */

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2SFmode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4718; /* aarch64_be_ld1v2sf */

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V4SFmode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4719; /* aarch64_be_ld1v4sf */

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2DFmode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4720; /* aarch64_be_ld1v2df */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_DImode
          || !aarch64_simd_struct_operand (operands[1], E_DImode)
          || !
#line 8106 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 4721; /* aarch64_be_ld1di */

    case E_V2x8QImode:
      if (!register_operand (operands[0], E_V2x8QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8QImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8QImode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5123; /* aarch64_simd_ld1v8qi_x2 */

    case E_V2x4HImode:
      if (!register_operand (operands[0], E_V2x4HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HImode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5124; /* aarch64_simd_ld1v4hi_x2 */

    case E_V2x2SImode:
      if (!register_operand (operands[0], E_V2x2SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SImode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5125; /* aarch64_simd_ld1v2si_x2 */

    case E_V2x1DImode:
      if (!register_operand (operands[0], E_V2x1DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DImode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5126; /* aarch64_simd_ld1di_x2 */

    case E_V2x4HFmode:
      if (!register_operand (operands[0], E_V2x4HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4HFmode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5127; /* aarch64_simd_ld1v4hf_x2 */

    case E_V2x2SFmode:
      if (!register_operand (operands[0], E_V2x2SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2SFmode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5128; /* aarch64_simd_ld1v2sf_x2 */

    case E_V2x1DFmode:
      if (!register_operand (operands[0], E_V2x1DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x1DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x1DFmode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5129; /* aarch64_simd_ld1df_x2 */

    case E_V2x4BFmode:
      if (!register_operand (operands[0], E_V2x4BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4BFmode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5130; /* aarch64_simd_ld1v4bf_x2 */

    case E_V2x16QImode:
      if (!register_operand (operands[0], E_V2x16QImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x16QImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x16QImode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5131; /* aarch64_simd_ld1v16qi_x2 */

    case E_V2x8HImode:
      if (!register_operand (operands[0], E_V2x8HImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8HImode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5132; /* aarch64_simd_ld1v8hi_x2 */

    case E_V2x4SImode:
      if (!register_operand (operands[0], E_V2x4SImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4SImode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5133; /* aarch64_simd_ld1v4si_x2 */

    case E_V2x2DImode:
      if (!register_operand (operands[0], E_V2x2DImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DImode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2DImode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5134; /* aarch64_simd_ld1v2di_x2 */

    case E_V2x8HFmode:
      if (!register_operand (operands[0], E_V2x8HFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8HFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8HFmode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5135; /* aarch64_simd_ld1v8hf_x2 */

    case E_V2x4SFmode:
      if (!register_operand (operands[0], E_V2x4SFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x4SFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x4SFmode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5136; /* aarch64_simd_ld1v4sf_x2 */

    case E_V2x2DFmode:
      if (!register_operand (operands[0], E_V2x2DFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x2DFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x2DFmode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5137; /* aarch64_simd_ld1v2df_x2 */

    case E_V2x8BFmode:
      if (!register_operand (operands[0], E_V2x8BFmode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V2x8BFmode
          || !aarch64_simd_struct_operand (operands[1], E_V2x8BFmode)
          || !
#line 8827 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 5138; /* aarch64_simd_ld1v8bf_x2 */

    default:
      return -1;
    }
}

 int
recog_210 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  if (aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 1241 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11745; /* *cond_uqshlvnx16qi_2 */
    }
  if (register_operand (operands[3], E_VNx16QImode))
    {
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[3])
          && 
#line 1268 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return 11753; /* *cond_uqshlvnx16qi_3 */
    }
  operands[5] = x4;
  if (!aarch64_sve_lshift_operand (operands[3], E_VNx16QImode))
    return -1;
  x5 = XVECEXP (x2, 0, 2);
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
      || !
#line 1293 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && (CONSTANT_P (operands[4]) || !rtx_equal_p (operands[3], operands[4]))))
    return -1;
  return 11761; /* *cond_uqshlvnx16qi_any */
}

 int
recog_217 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11608; /* *cond_urshlvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11653; /* *cond_urshlvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11693; /* *cond_urshlvnx8hi_any */
}

 int
recog_227 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11629; /* *cond_uhsubvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11670; /* *cond_uhsubvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11710; /* *cond_uhsubvnx2di_any */
}

 int
recog_237 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11602; /* *cond_srshlvnx8hi_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11648; /* *cond_srshlvnx8hi_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11688; /* *cond_srshlvnx8hi_any */
}

 int
recog_247 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[4] = x4;
  x5 = XVECEXP (x2, 0, 2);
  if (rtx_equal_p (x5, operands[2])
      && 
#line 1039 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11623; /* *cond_shsubvnx2di_2 */
  if (rtx_equal_p (x5, operands[3])
      && 
#line 1064 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
    return 11665; /* *cond_shsubvnx2di_3 */
  operands[5] = x4;
  operands[4] = x5;
  if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
      || !
#line 1089 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
    return -1;
  return 11705; /* *cond_shsubvnx2di_any */
}

 int
recog_257 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1047 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8503; /* *cond_smaxvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8649; /* *cond_smaxvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8753; /* *cond_smaxvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8516; /* *cond_smaxvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8662; /* *cond_smaxvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8766; /* *cond_smaxvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8529; /* *cond_smaxvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8675; /* *cond_smaxvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8779; /* *cond_smaxvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8542; /* *cond_smaxvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8688; /* *cond_smaxvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8792; /* *cond_smaxvnx2df_any_relaxed */

    case 4:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8601; /* *cond_smaxvnx8hf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8851; /* *cond_smaxvnx8hf_any_const_relaxed */

    case 5:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8608; /* *cond_smaxvnx4sf_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8858; /* *cond_smaxvnx4sf_any_const_relaxed */

    case 6:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5517 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8615; /* *cond_smaxvnx2df_2_const_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5685 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8865; /* *cond_smaxvnx2df_any_const_relaxed */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8555; /* *cond_smaxvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8701; /* *cond_smaxvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8805; /* *cond_smaxvnx8bf_any_strict */

    case 8:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8568; /* *cond_smaxvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8714; /* *cond_smaxvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8818; /* *cond_smaxvnx8hf_any_strict */

    case 9:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8581; /* *cond_smaxvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8727; /* *cond_smaxvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8831; /* *cond_smaxvnx4sf_any_strict */

    case 10:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8594; /* *cond_smaxvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (true || !false)))
        return 8740; /* *cond_smaxvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (true || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((true || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8844; /* *cond_smaxvnx2df_any_strict */

    case 11:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8622; /* *cond_smaxvnx8hf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8872; /* *cond_smaxvnx8hf_any_const_strict */

    case 12:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8629; /* *cond_smaxvnx4sf_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8879; /* *cond_smaxvnx4sf_any_const_strict */

    case 13:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5540 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return 8636; /* *cond_smaxvnx2df_2_const_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5721 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
        return -1;
      return 8886; /* *cond_smaxvnx2df_any_const_strict */

    default:
      return -1;
    }
}

 int
recog_263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern1046 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8495; /* *cond_divvnx8bf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8641; /* *cond_divvnx8bf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8745; /* *cond_divvnx8bf_any_relaxed */

    case 1:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8508; /* *cond_divvnx8hf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8654; /* *cond_divvnx8hf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8758; /* *cond_divvnx8hf_any_relaxed */

    case 2:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8521; /* *cond_divvnx4sf_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8667; /* *cond_divvnx4sf_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8771; /* *cond_divvnx4sf_any_relaxed */

    case 3:
      x3 = XVECEXP (x2, 0, 1);
      x4 = XVECEXP (x3, 0, 0);
      operands[4] = x4;
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5474 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8534; /* *cond_divvnx2df_2_relaxed */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5560 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8680; /* *cond_divvnx2df_3_relaxed */
      operands[5] = x4;
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5603 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8784; /* *cond_divvnx2df_any_relaxed */

    case 4:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && (
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8547; /* *cond_divvnx8bf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && (
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !true)) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return 8693; /* *cond_divvnx8bf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8BFmode)
          || !(
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !true)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !true)
	&& rtx_equal_p (operands[3], operands[4]))) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
        return -1;
      return 8797; /* *cond_divvnx8bf_any_strict */

    case 5:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8560; /* *cond_divvnx8hf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8706; /* *cond_divvnx8hf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8810; /* *cond_divvnx8hf_any_strict */

    case 6:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8573; /* *cond_divvnx4sf_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8719; /* *cond_divvnx4sf_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8823; /* *cond_divvnx4sf_any_strict */

    case 7:
      x5 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x5, operands[2])
          && 
#line 5497 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8586; /* *cond_divvnx2df_2_strict */
      if (rtx_equal_p (x5, operands[3])
          && 
#line 5583 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && (false || !false)))
        return 8732; /* *cond_divvnx2df_3_strict */
      operands[4] = x5;
      if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DFmode)
          || !
#line 5647 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (false || !false)
   && !rtx_equal_p (operands[2], operands[4])
   && !((false || !false)
	&& rtx_equal_p (operands[3], operands[4]))))
        return -1;
      return 8836; /* *cond_divvnx2df_any_strict */

    default:
      return -1;
    }
}

 int
recog_274 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x4, 1);
  operands[3] = x6;
  switch (GET_CODE (operands[3]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern469 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7444; /* *cond_ashlvnx16qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7614; /* *cond_ashlvnx16qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7784; /* *cond_ashlvnx16qi_any */

        case E_VNx8QImode:
          if (pattern469 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7461; /* *cond_ashlvnx8qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7631; /* *cond_ashlvnx8qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7801; /* *cond_ashlvnx8qi_any */

        case E_VNx4QImode:
          if (pattern469 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7478; /* *cond_ashlvnx4qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7648; /* *cond_ashlvnx4qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7818; /* *cond_ashlvnx4qi_any */

        case E_VNx2QImode:
          if (pattern469 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7495; /* *cond_ashlvnx2qi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7665; /* *cond_ashlvnx2qi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7835; /* *cond_ashlvnx2qi_any */

        case E_VNx8HImode:
          if (pattern469 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7512; /* *cond_ashlvnx8hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7682; /* *cond_ashlvnx8hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7852; /* *cond_ashlvnx8hi_any */

        case E_VNx4HImode:
          if (pattern469 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7529; /* *cond_ashlvnx4hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7699; /* *cond_ashlvnx4hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7869; /* *cond_ashlvnx4hi_any */

        case E_VNx2HImode:
          if (pattern469 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7546; /* *cond_ashlvnx2hi_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7716; /* *cond_ashlvnx2hi_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7886; /* *cond_ashlvnx2hi_any */

        case E_VNx4SImode:
          if (pattern469 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7563; /* *cond_ashlvnx4si_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7733; /* *cond_ashlvnx4si_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7903; /* *cond_ashlvnx4si_any */

        case E_VNx2SImode:
          if (pattern469 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7580; /* *cond_ashlvnx2si_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7750; /* *cond_ashlvnx2si_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7920; /* *cond_ashlvnx2si_any */

        case E_VNx2DImode:
          if (pattern469 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4005 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7597; /* *cond_ashlvnx2di_2 */
          if (rtx_equal_p (x7, operands[3])
              && 
#line 4022 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 7767; /* *cond_ashlvnx2di_3 */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])))
            return -1;
          return 7937; /* *cond_ashlvnx2di_any */

        default:
          return -1;
        }

    case CONST_VECTOR:
    case CONST:
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern988 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8253; /* *cond_ashlvnx16qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx16QImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8283; /* *cond_ashlvnx16qi_any_const */

        case E_VNx8QImode:
          if (pattern988 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8256; /* *cond_ashlvnx8qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8QImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8286; /* *cond_ashlvnx8qi_any_const */

        case E_VNx4QImode:
          if (pattern988 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8259; /* *cond_ashlvnx4qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4QImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8289; /* *cond_ashlvnx4qi_any_const */

        case E_VNx2QImode:
          if (pattern988 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8262; /* *cond_ashlvnx2qi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2QImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8292; /* *cond_ashlvnx2qi_any_const */

        case E_VNx8HImode:
          if (pattern988 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8265; /* *cond_ashlvnx8hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx8HImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8295; /* *cond_ashlvnx8hi_any_const */

        case E_VNx4HImode:
          if (pattern988 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8268; /* *cond_ashlvnx4hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4HImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8298; /* *cond_ashlvnx4hi_any_const */

        case E_VNx2HImode:
          if (pattern988 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8271; /* *cond_ashlvnx2hi_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2HImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8301; /* *cond_ashlvnx2hi_any_const */

        case E_VNx4SImode:
          if (pattern988 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8274; /* *cond_ashlvnx4si_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx4SImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8304; /* *cond_ashlvnx4si_any_const */

        case E_VNx2SImode:
          if (pattern988 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8277; /* *cond_ashlvnx2si_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2SImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8307; /* *cond_ashlvnx2si_any_const */

        case E_VNx2DImode:
          if (pattern988 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0)
            return -1;
          x7 = XVECEXP (x2, 0, 2);
          if (rtx_equal_p (x7, operands[2])
              && 
#line 4937 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 8280; /* *cond_ashlvnx2di_2_const */
          operands[4] = x7;
          if (!aarch64_simd_reg_or_zero (operands[4], E_VNx2DImode)
              || !
#line 4954 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[4])))
            return -1;
          return 8310; /* *cond_ashlvnx2di_any_const */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_277 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x2, 0, 1);
  switch (XVECLEN (x4, 0))
    {
    case 1:
      x5 = XVECEXP (x4, 0, 0);
      operands[2] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[3] = x6;
      switch (XINT (x4, 1))
        {
        case 315:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1045 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
                return -1;
              return 6943; /* cond_revbvnx16qi */

            case E_VNx8HImode:
              if (pattern1045 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 16))
                return -1;
              return 6946; /* cond_revbvnx8hi */

            case E_VNx4SImode:
              if (pattern1045 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 16))
                return -1;
              return 6949; /* cond_revbvnx4si */

            case E_VNx2DImode:
              if (pattern1045 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 16))
                return -1;
              return 6952; /* cond_revbvnx2di */

            default:
              return -1;
            }

        case 317:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1045 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
                return -1;
              return 6944; /* cond_revhvnx16qi */

            case E_VNx8HImode:
              if (pattern1045 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 32))
                return -1;
              return 6947; /* cond_revhvnx8hi */

            case E_VNx4SImode:
              if (pattern1045 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 32))
                return -1;
              return 6950; /* cond_revhvnx4si */

            case E_VNx2DImode:
              if (pattern1045 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 32))
                return -1;
              return 6953; /* cond_revhvnx2di */

            default:
              return -1;
            }

        case 318:
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1045 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
                return -1;
              return 6945; /* cond_revwvnx16qi */

            case E_VNx8HImode:
              if (pattern1045 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 16 >= 64))
                return -1;
              return 6948; /* cond_revwvnx8hi */

            case E_VNx4SImode:
              if (pattern1045 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 32 >= 64))
                return -1;
              return 6951; /* cond_revwvnx4si */

            case E_VNx2DImode:
              if (pattern1045 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 3313 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 64 >= 64))
                return -1;
              return 6954; /* cond_revwvnx2di */

            default:
              return -1;
            }

        case 316:
          if (!register_operand (operands[1], E_VNx2BImode))
            return -1;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern1107 (x2, 
E_VNx16QImode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12745; /* cond_revdvnx16qi */

            case E_VNx8HImode:
              if (pattern1107 (x2, 
E_VNx8HImode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12746; /* cond_revdvnx8hi */

            case E_VNx4SImode:
              if (pattern1107 (x2, 
E_VNx4SImode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12747; /* cond_revdvnx4si */

            case E_VNx2DImode:
              if (pattern1107 (x2, 
E_VNx2DImode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12748; /* cond_revdvnx2di */

            case E_VNx8BFmode:
              if (pattern1107 (x2, 
E_VNx8BFmode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12749; /* cond_revdvnx8bf */

            case E_VNx8HFmode:
              if (pattern1107 (x2, 
E_VNx8HFmode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12750; /* cond_revdvnx8hf */

            case E_VNx4SFmode:
              if (pattern1107 (x2, 
E_VNx4SFmode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12751; /* cond_revdvnx4sf */

            case E_VNx2DFmode:
              if (pattern1107 (x2, 
E_VNx2DFmode) != 0
                  || !
#line 3782 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME))
                return -1;
              return 12752; /* cond_revdvnx2df */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      return recog_268 (x1, insn, pnum_clobbers);

    case 2:
      switch (XINT (x4, 1))
        {
        case 320:
          switch (pattern862 (x2))
            {
            case 0:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8097; /* *cond_smulhvnx16qi_2 */

            case 1:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8099; /* *cond_smulhvnx8hi_2 */

            case 2:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8101; /* *cond_smulhvnx4si_2 */

            case 3:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8103; /* *cond_smulhvnx2di_2 */

            case 4:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8105; /* *cond_smulhvnx16qi_z */

            case 5:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8107; /* *cond_smulhvnx8hi_z */

            case 6:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8109; /* *cond_smulhvnx4si_z */

            case 7:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8111; /* *cond_smulhvnx2di_z */

            default:
              return -1;
            }

        case 321:
          switch (pattern862 (x2))
            {
            case 0:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8098; /* *cond_umulhvnx16qi_2 */

            case 1:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8100; /* *cond_umulhvnx8hi_2 */

            case 2:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8102; /* *cond_umulhvnx4si_2 */

            case 3:
              if (!
#line 4552 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8104; /* *cond_umulhvnx2di_2 */

            case 4:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8106; /* *cond_umulhvnx16qi_z */

            case 5:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8108; /* *cond_umulhvnx8hi_z */

            case 6:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8110; /* *cond_umulhvnx4si_z */

            case 7:
              if (!
#line 4570 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8112; /* *cond_umulhvnx2di_z */

            default:
              return -1;
            }

        case 399:
          switch (pattern865 (x2))
            {
            case 0:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8322; /* *cond_lslvnx16qi_m */

            case 1:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8325; /* *cond_lslvnx8hi_m */

            case 2:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8328; /* *cond_lslvnx4si_m */

            case 3:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8331; /* *cond_lslvnx16qi_z */

            case 4:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8334; /* *cond_lslvnx8hi_z */

            case 5:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8337; /* *cond_lslvnx4si_z */

            default:
              return -1;
            }

        case 400:
          switch (pattern865 (x2))
            {
            case 0:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8323; /* *cond_asrvnx16qi_m */

            case 1:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8326; /* *cond_asrvnx8hi_m */

            case 2:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8329; /* *cond_asrvnx4si_m */

            case 3:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8332; /* *cond_asrvnx16qi_z */

            case 4:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8335; /* *cond_asrvnx8hi_z */

            case 5:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8338; /* *cond_asrvnx4si_z */

            default:
              return -1;
            }

        case 401:
          switch (pattern865 (x2))
            {
            case 0:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8324; /* *cond_lsrvnx16qi_m */

            case 1:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8327; /* *cond_lsrvnx8hi_m */

            case 2:
              if (!
#line 5008 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8330; /* *cond_lsrvnx4si_m */

            case 3:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8333; /* *cond_lsrvnx16qi_z */

            case 4:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8336; /* *cond_lsrvnx8hi_z */

            case 5:
              if (!
#line 5026 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 8339; /* *cond_lsrvnx4si_z */

            default:
              return -1;
            }

        case 125:
          return recog_252 (x1, insn, pnum_clobbers);

        default:
          return -1;
        }

    case 4:
      return recog_267 (x1, insn, pnum_clobbers);

    case 5:
      return recog_266 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_290 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (pattern598 (x2))
    {
    case 0:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6701; /* *cond_qabsvnx16qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx16QImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6791; /* *cond_qabsvnx16qi_any */

    case 1:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6710; /* *cond_qabsvnx8qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8QImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6800; /* *cond_qabsvnx8qi_any */

    case 2:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6719; /* *cond_qabsvnx4qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4QImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6809; /* *cond_qabsvnx4qi_any */

    case 3:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6728; /* *cond_qabsvnx2qi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2QImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6818; /* *cond_qabsvnx2qi_any */

    case 4:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6737; /* *cond_qabsvnx8hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx8HImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6827; /* *cond_qabsvnx8hi_any */

    case 5:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6746; /* *cond_qabsvnx4hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4HImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6836; /* *cond_qabsvnx4hi_any */

    case 6:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6755; /* *cond_qabsvnx2hi_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2HImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6845; /* *cond_qabsvnx2hi_any */

    case 7:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6764; /* *cond_qabsvnx4si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx4SImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6854; /* *cond_qabsvnx4si_any */

    case 8:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6773; /* *cond_qabsvnx2si_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2SImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6863; /* *cond_qabsvnx2si_any */

    case 9:
      x3 = XVECEXP (x2, 0, 2);
      if (rtx_equal_p (x3, operands[2])
          && (
#line 3228 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return 6782; /* *cond_qabsvnx2di_2 */
      operands[3] = x3;
      if (!aarch64_simd_reg_or_zero (operands[3], E_VNx2DImode)
          || !(
#line 3250 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && !rtx_equal_p (operands[2], operands[3])) && 
#line 2747 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
        return -1;
      return 6872; /* *cond_qabsvnx2di_any */

    default:
      return -1;
    }
}

 int
recog_303 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[2] = x4;
  x5 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  x6 = XVECEXP (x3, 0, 1);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern789 (x3, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6272; /* maskstorevnx16qivnx16bi */

        case E_VNx8QImode:
          if (pattern789 (x3, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6273; /* maskstorevnx8qivnx8bi */

        case E_VNx4QImode:
          if (pattern789 (x3, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6274; /* maskstorevnx4qivnx4bi */

        case E_VNx2QImode:
          if (pattern789 (x3, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6275; /* maskstorevnx2qivnx2bi */

        case E_VNx8HImode:
          if (pattern789 (x3, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6276; /* maskstorevnx8hivnx8bi */

        case E_VNx4HImode:
          if (pattern789 (x3, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6277; /* maskstorevnx4hivnx4bi */

        case E_VNx2HImode:
          if (pattern789 (x3, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6278; /* maskstorevnx2hivnx2bi */

        case E_VNx4SImode:
          if (pattern789 (x3, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6279; /* maskstorevnx4sivnx4bi */

        case E_VNx2SImode:
          if (pattern789 (x3, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6280; /* maskstorevnx2sivnx2bi */

        case E_VNx2DImode:
          if (pattern789 (x3, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6281; /* maskstorevnx2divnx2bi */

        case E_VNx8HFmode:
          if (pattern789 (x3, 
E_VNx8HFmode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6282; /* maskstorevnx8hfvnx8bi */

        case E_VNx4HFmode:
          if (pattern789 (x3, 
E_VNx4HFmode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6283; /* maskstorevnx4hfvnx4bi */

        case E_VNx2HFmode:
          if (pattern789 (x3, 
E_VNx2HFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6284; /* maskstorevnx2hfvnx2bi */

        case E_VNx8BFmode:
          if (pattern789 (x3, 
E_VNx8BFmode, 
E_VNx8BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6285; /* maskstorevnx8bfvnx8bi */

        case E_VNx4BFmode:
          if (pattern789 (x3, 
E_VNx4BFmode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6286; /* maskstorevnx4bfvnx4bi */

        case E_VNx2BFmode:
          if (pattern789 (x3, 
E_VNx2BFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6287; /* maskstorevnx2bfvnx2bi */

        case E_VNx4SFmode:
          if (pattern789 (x3, 
E_VNx4SFmode, 
E_VNx4BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6288; /* maskstorevnx4sfvnx4bi */

        case E_VNx2SFmode:
          if (pattern789 (x3, 
E_VNx2SFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6289; /* maskstorevnx2sfvnx2bi */

        case E_VNx2DFmode:
          if (pattern789 (x3, 
E_VNx2DFmode, 
E_VNx2BImode) != 0
              || !
#line 2297 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6290; /* maskstorevnx2dfvnx2bi */

        default:
          return -1;
        }

    case TRUNCATE:
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx8QImode:
          if (pattern856 (x3, 
E_VNx8QImode, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !
#line 2349 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6315; /* aarch64_store_truncvnx8qivnx8hi */

        case E_VNx4QImode:
          if (pattern856 (x3, 
E_VNx4QImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 2362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6316; /* aarch64_store_truncvnx4qivnx4si */

        case E_VNx4HImode:
          if (pattern856 (x3, 
E_VNx4HImode, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !
#line 2362 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6317; /* aarch64_store_truncvnx4hivnx4si */

        case E_VNx2QImode:
          if (pattern856 (x3, 
E_VNx2QImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2375 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6318; /* aarch64_store_truncvnx2qivnx2di */

        case E_VNx2HImode:
          if (pattern856 (x3, 
E_VNx2HImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2375 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6319; /* aarch64_store_truncvnx2hivnx2di */

        case E_VNx2SImode:
          if (pattern856 (x3, 
E_VNx2SImode, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !
#line 2375 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 6320; /* aarch64_store_truncvnx2sivnx2di */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_310 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern145 (x1))
    {
    case 0:
      if (!
#line 5643 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3504; /* aarch64_sqrdmlshv4hi */

    case 1:
      if (!
#line 5643 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3508; /* aarch64_sqrdmlshv8hi */

    case 2:
      if (!
#line 5643 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3512; /* aarch64_sqrdmlshv2si */

    case 3:
      if (!
#line 5643 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3516; /* aarch64_sqrdmlshv4si */

    case 4:
      if (!
#line 5643 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3518; /* aarch64_sqrdmlshhi */

    case 5:
      if (!
#line 5643 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3520; /* aarch64_sqrdmlshsi */

    case 6:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11801; /* aarch64_sve_sqrdmlshvnx16qi */

    case 7:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11809; /* aarch64_sve_sqrdmlshvnx8hi */

    case 8:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11817; /* aarch64_sve_sqrdmlshvnx4si */

    case 9:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11825; /* aarch64_sve_sqrdmlshvnx2di */

    case 10:
      if (!
#line 5659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3524; /* aarch64_sqrdmlsh_lanev4hi */

    case 11:
      if (!
#line 5697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3544; /* aarch64_sqrdmlsh_laneqv4hi */

    case 12:
      if (!
#line 5659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3528; /* aarch64_sqrdmlsh_lanev8hi */

    case 13:
      if (!
#line 5697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3548; /* aarch64_sqrdmlsh_laneqv8hi */

    case 14:
      if (!
#line 5659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3532; /* aarch64_sqrdmlsh_lanev2si */

    case 15:
      if (!
#line 5697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3552; /* aarch64_sqrdmlsh_laneqv2si */

    case 16:
      if (!
#line 5659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3536; /* aarch64_sqrdmlsh_lanev4si */

    case 17:
      if (!
#line 5697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3556; /* aarch64_sqrdmlsh_laneqv4si */

    case 18:
      if (!
#line 5677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3538; /* aarch64_sqrdmlsh_lanehi */

    case 19:
      if (!
#line 5715 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3558; /* aarch64_sqrdmlsh_laneqhi */

    case 20:
      if (!
#line 5677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3540; /* aarch64_sqrdmlsh_lanesi */

    case 21:
      if (!
#line 5715 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA))
        return -1;
      return 3560; /* aarch64_sqrdmlsh_laneqsi */

    case 22:
      if (!
#line 1467 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11827; /* aarch64_sve_sqrdmlsh_lane_vnx8hi */

    case 23:
      if (!
#line 1467 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11829; /* aarch64_sve_sqrdmlsh_lane_vnx4si */

    case 24:
      if (!
#line 1467 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11831; /* aarch64_sve_sqrdmlsh_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_319 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern166 (x1, pnum_clobbers))
    {
    case 0:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9936; /* while_ulesivnx16bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9946; /* while_uledivnx16bi */

    case 1:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9956; /* while_ulesivnx8bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9966; /* while_uledivnx8bi */

    case 2:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9976; /* while_ulesivnx4bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 9986; /* while_uledivnx4bi */

    case 3:
      if (aarch64_reg_or_zero (operands[1], E_SImode)
          && aarch64_reg_or_zero (operands[2], E_SImode)
          && 
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        {
          *pnum_clobbers = 1;
          return 9996; /* while_ulesivnx2bi */
        }
      if (!aarch64_reg_or_zero (operands[1], E_DImode)
          || !aarch64_reg_or_zero (operands[2], E_DImode)
          || !
#line 8414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10006; /* while_uledivnx2bi */

    default:
      return -1;
    }
}

 int
recog_327 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern180 (x1))
    {
    case 0:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11231; /* aarch64_stnt1vnx32qi */

    case 1:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11233; /* aarch64_stnt1vnx16hi */

    case 2:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11235; /* aarch64_stnt1vnx8si */

    case 3:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11237; /* aarch64_stnt1vnx4di */

    case 4:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11239; /* aarch64_stnt1vnx16bf */

    case 5:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11241; /* aarch64_stnt1vnx16hf */

    case 6:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11243; /* aarch64_stnt1vnx8sf */

    case 7:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11245; /* aarch64_stnt1vnx4df */

    case 8:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11247; /* aarch64_stnt1vnx64qi */

    case 9:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11249; /* aarch64_stnt1vnx32hi */

    case 10:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11251; /* aarch64_stnt1vnx16si */

    case 11:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11253; /* aarch64_stnt1vnx8di */

    case 12:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11255; /* aarch64_stnt1vnx32bf */

    case 13:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11257; /* aarch64_stnt1vnx32hf */

    case 14:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11259; /* aarch64_stnt1vnx16sf */

    case 15:
      if (!
#line 479 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
        return -1;
      return 11261; /* aarch64_stnt1vnx8df */

    default:
      return -1;
    }
}

 int
recog_334 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern169 (x1))
    {
    case 0:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10290; /* fold_extract_after_last_vnx16qi */

    case 1:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10292; /* fold_extract_after_last_vnx8hi */

    case 2:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10294; /* fold_extract_after_last_vnx4si */

    case 3:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10296; /* fold_extract_after_last_vnx2di */

    case 4:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10298; /* fold_extract_after_last_vnx8bf */

    case 5:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10300; /* fold_extract_after_last_vnx8hf */

    case 6:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10302; /* fold_extract_after_last_vnx4sf */

    case 7:
      if (!
#line 8904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10304; /* fold_extract_after_last_vnx2df */

    case 8:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10306; /* aarch64_fold_extract_vector_after_last_vnx16qi */

    case 9:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10308; /* aarch64_fold_extract_vector_after_last_vnx8hi */

    case 10:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10310; /* aarch64_fold_extract_vector_after_last_vnx4si */

    case 11:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10312; /* aarch64_fold_extract_vector_after_last_vnx2di */

    case 12:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10314; /* aarch64_fold_extract_vector_after_last_vnx8bf */

    case 13:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10316; /* aarch64_fold_extract_vector_after_last_vnx8hf */

    case 14:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10318; /* aarch64_fold_extract_vector_after_last_vnx4sf */

    case 15:
      if (!
#line 8918 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 10320; /* aarch64_fold_extract_vector_after_last_vnx2df */

    default:
      return -1;
    }
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1))
    {
    case 0:
      if (!
#line 6655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3816; /* aarch64_usri_nv8qi */

    case 1:
      if (!
#line 6655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3820; /* aarch64_usri_nv16qi */

    case 2:
      if (!
#line 6655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3824; /* aarch64_usri_nv4hi */

    case 3:
      if (!
#line 6655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3828; /* aarch64_usri_nv8hi */

    case 4:
      if (!
#line 6655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3832; /* aarch64_usri_nv2si */

    case 5:
      if (!
#line 6655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3836; /* aarch64_usri_nv4si */

    case 6:
      if (!
#line 6655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3840; /* aarch64_usri_nv2di */

    case 7:
      if (!
#line 6655 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 3844; /* aarch64_usri_ndi */

    default:
      return -1;
    }
}

 int
recog_354 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_VNx8HFmode:
      if (pattern55 (x3, 
E_VNx8HFmode) != 0
          || !
#line 7935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9390; /* aarch64_sve_tmadvnx8hf */

    case E_VNx4SFmode:
      if (pattern55 (x3, 
E_VNx4SFmode) != 0
          || !
#line 7935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9391; /* aarch64_sve_tmadvnx4sf */

    case E_VNx2DFmode:
      if (pattern55 (x3, 
E_VNx2DFmode) != 0
          || !
#line 7935 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      return 9392; /* aarch64_sve_tmadvnx2df */

    default:
      return -1;
    }
}

 int
recog_362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern193 (x1))
    {
    case 0:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12484; /* aarch64_sve_cmlavnx16qi */

    case 1:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12492; /* aarch64_sve_cmlavnx8hi */

    case 2:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12500; /* aarch64_sve_cmlavnx4si */

    case 3:
      if (!
#line 3015 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12508; /* aarch64_sve_cmlavnx2di */

    case 4:
      if (!
#line 3032 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12516; /* aarch64_cmla_lane_vnx8hi */

    case 5:
      if (!
#line 3032 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12524; /* aarch64_cmla_lane_vnx4si */

    default:
      return -1;
    }
}

 int
recog_371 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern195 (x1))
    {
    case 0:
      if (!
#line 3095 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12532; /* aarch64_sve_cdotvnx4si */

    case 1:
      if (!
#line 3095 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12536; /* aarch64_sve_cdotvnx2di */

    case 2:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12540; /* aarch64_cdot_lane_vnx4si */

    case 3:
      if (!
#line 3112 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 12544; /* aarch64_cdot_lane_vnx2di */

    default:
      return -1;
    }
}

 int
recog_379 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern183 (x1))
    {
    case 0:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11797; /* aarch64_sve_eortbvnx16qi */

    case 1:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11805; /* aarch64_sve_eortbvnx8hi */

    case 2:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11813; /* aarch64_sve_eortbvnx4si */

    case 3:
      if (!
#line 1450 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
        return -1;
      return 11821; /* aarch64_sve_eortbvnx2di */

    default:
      return -1;
    }
}

 int
recog_387 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern177 (x1, pnum_clobbers))
    {
    case 0:
      if (!
#line 10271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 8))
        return -1;
      *pnum_clobbers = 1;
      return 10924; /* aarch64_sve_pfirstvnx16bi */

    case 1:
      if (!
#line 10271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 16))
        return -1;
      *pnum_clobbers = 1;
      return 10926; /* aarch64_sve_pfirstvnx8bi */

    case 2:
      if (!
#line 10271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 32))
        return -1;
      *pnum_clobbers = 1;
      return 10928; /* aarch64_sve_pfirstvnx4bi */

    case 3:
      if (!
#line 10271 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && 8 >= 64))
        return -1;
      *pnum_clobbers = 1;
      return 10930; /* aarch64_sve_pfirstvnx2bi */

    default:
      return -1;
    }
}

 int
recog_395 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (XVECLEN (x3, 0) != 3)
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (XINT (x3, 1))
    {
    case 126:
      x5 = XVECEXP (x2, 0, 1);
      operands[4] = x5;
      x6 = XVECEXP (x2, 0, 2);
      operands[5] = x6;
      x7 = XVECEXP (x3, 0, 0);
      operands[6] = x7;
      x8 = XVECEXP (x3, 0, 1);
      operands[7] = x8;
      if (!aarch64_sve_ptrue_flag (operands[7], E_SImode))
        return -1;
      x9 = XVECEXP (x3, 0, 2);
      switch (GET_CODE (x9))
        {
        case LT:
          switch (pattern1305 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9644; /* *cmpltvnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9654; /* *cmpltvnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9684; /* *cmpltvnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9664; /* *cmpltvnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9694; /* *cmpltvnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9714; /* *cmpltvnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9674; /* *cmpltvnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9704; /* *cmpltvnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9724; /* *cmpltvnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9734; /* *cmpltvnx2di_ptest */

            default:
              return -1;
            }

        case LE:
          switch (pattern1305 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9645; /* *cmplevnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9655; /* *cmplevnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9685; /* *cmplevnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9665; /* *cmplevnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9695; /* *cmplevnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9715; /* *cmplevnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9675; /* *cmplevnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9705; /* *cmplevnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9725; /* *cmplevnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9735; /* *cmplevnx2di_ptest */

            default:
              return -1;
            }

        case EQ:
          switch (pattern1305 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9646; /* *cmpeqvnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9656; /* *cmpeqvnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9686; /* *cmpeqvnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9666; /* *cmpeqvnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9696; /* *cmpeqvnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9716; /* *cmpeqvnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9676; /* *cmpeqvnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9706; /* *cmpeqvnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9726; /* *cmpeqvnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9736; /* *cmpeqvnx2di_ptest */

            default:
              return -1;
            }

        case NE:
          switch (pattern1305 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9647; /* *cmpnevnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9657; /* *cmpnevnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9687; /* *cmpnevnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9667; /* *cmpnevnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9697; /* *cmpnevnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9717; /* *cmpnevnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9677; /* *cmpnevnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9707; /* *cmpnevnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9727; /* *cmpnevnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9737; /* *cmpnevnx2di_ptest */

            default:
              return -1;
            }

        case GE:
          switch (pattern1305 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9648; /* *cmpgevnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9658; /* *cmpgevnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9688; /* *cmpgevnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9668; /* *cmpgevnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9698; /* *cmpgevnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9718; /* *cmpgevnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9678; /* *cmpgevnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9708; /* *cmpgevnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9728; /* *cmpgevnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9738; /* *cmpgevnx2di_ptest */

            default:
              return -1;
            }

        case GT:
          switch (pattern1305 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9649; /* *cmpgtvnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9659; /* *cmpgtvnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9689; /* *cmpgtvnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9669; /* *cmpgtvnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9699; /* *cmpgtvnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9719; /* *cmpgtvnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9679; /* *cmpgtvnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9709; /* *cmpgtvnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9729; /* *cmpgtvnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9739; /* *cmpgtvnx2di_ptest */

            default:
              return -1;
            }

        case LTU:
          switch (pattern1306 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9650; /* *cmplovnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9660; /* *cmplovnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9690; /* *cmplovnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9670; /* *cmplovnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9700; /* *cmplovnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9720; /* *cmplovnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9680; /* *cmplovnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9710; /* *cmplovnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9730; /* *cmplovnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9740; /* *cmplovnx2di_ptest */

            default:
              return -1;
            }

        case LEU:
          switch (pattern1306 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9651; /* *cmplsvnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9661; /* *cmplsvnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9691; /* *cmplsvnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9671; /* *cmplsvnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9701; /* *cmplsvnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9721; /* *cmplsvnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9681; /* *cmplsvnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9711; /* *cmplsvnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9731; /* *cmplsvnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9741; /* *cmplsvnx2di_ptest */

            default:
              return -1;
            }

        case GEU:
          switch (pattern1306 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9652; /* *cmphsvnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9662; /* *cmphsvnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9692; /* *cmphsvnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9672; /* *cmphsvnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9702; /* *cmphsvnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9722; /* *cmphsvnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9682; /* *cmphsvnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9712; /* *cmphsvnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9732; /* *cmphsvnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9742; /* *cmphsvnx2di_ptest */

            default:
              return -1;
            }

        case GTU:
          switch (pattern1306 (x3))
            {
            case 0:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9653; /* *cmphivnx16qi_ptest */

            case 1:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9663; /* *cmphivnx8qi_ptest */

            case 2:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9693; /* *cmphivnx8hi_ptest */

            case 3:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9673; /* *cmphivnx4qi_ptest */

            case 4:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9703; /* *cmphivnx4hi_ptest */

            case 5:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9723; /* *cmphivnx4si_ptest */

            case 6:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9683; /* *cmphivnx2qi_ptest */

            case 7:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9713; /* *cmphivnx2hi_ptest */

            case 8:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9733; /* *cmphivnx2si_ptest */

            case 9:
              if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                return -1;
              *pnum_clobbers = 1;
              return 9743; /* *cmphivnx2di_ptest */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x9, 0) != 2)
            return -1;
          x10 = XVECEXP (x9, 0, 0);
          operands[2] = x10;
          x11 = XVECEXP (x9, 0, 1);
          operands[3] = x11;
          switch (XINT (x9, 1))
            {
            case 340:
              switch (pattern1337 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9904; /* *aarch64_pred_cmpeqvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9914; /* *aarch64_pred_cmpeqvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9924; /* *aarch64_pred_cmpeqvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 341:
              switch (pattern1337 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9905; /* *aarch64_pred_cmpgevnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9915; /* *aarch64_pred_cmpgevnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9925; /* *aarch64_pred_cmpgevnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 342:
              switch (pattern1337 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9906; /* *aarch64_pred_cmpgtvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9916; /* *aarch64_pred_cmpgtvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9926; /* *aarch64_pred_cmpgtvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 343:
              switch (pattern1337 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9907; /* *aarch64_pred_cmphivnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9917; /* *aarch64_pred_cmphivnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9927; /* *aarch64_pred_cmphivnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 344:
              switch (pattern1337 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9908; /* *aarch64_pred_cmphsvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9918; /* *aarch64_pred_cmphsvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9928; /* *aarch64_pred_cmphsvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 345:
              switch (pattern1337 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9909; /* *aarch64_pred_cmplevnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9919; /* *aarch64_pred_cmplevnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9929; /* *aarch64_pred_cmplevnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 346:
              switch (pattern1337 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9910; /* *aarch64_pred_cmplovnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9920; /* *aarch64_pred_cmplovnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9930; /* *aarch64_pred_cmplovnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 347:
              switch (pattern1337 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9911; /* *aarch64_pred_cmplsvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9921; /* *aarch64_pred_cmplsvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9931; /* *aarch64_pred_cmplsvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 348:
              switch (pattern1337 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9912; /* *aarch64_pred_cmpltvnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9922; /* *aarch64_pred_cmpltvnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9932; /* *aarch64_pred_cmpltvnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 349:
              switch (pattern1337 (x3))
                {
                case 0:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9913; /* *aarch64_pred_cmpnevnx16qi_wide_ptest */

                case 1:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9923; /* *aarch64_pred_cmpnevnx8hi_wide_ptest */

                case 2:
                  if (!
#line 8374 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 9933; /* *aarch64_pred_cmpnevnx4si_wide_ptest */

                default:
                  return -1;
                }

            case 472:
              switch (pattern1338 (x3))
                {
                case 0:
                  if (!
#line 4081 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 12880; /* *aarch64_pred_matchvnx16qi_ptest */

                case 1:
                  if (!
#line 4081 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 12882; /* *aarch64_pred_matchvnx8hi_ptest */

                default:
                  return -1;
                }

            case 473:
              switch (pattern1338 (x3))
                {
                case 0:
                  if (!
#line 4081 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 12881; /* *aarch64_pred_nmatchvnx16qi_ptest */

                case 1:
                  if (!
#line 4081 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2
   && TARGET_NON_STREAMING
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 12883; /* *aarch64_pred_nmatchvnx8hi_ptest */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 299:
      if (pattern1191 (x2) != 0
          || !
#line 10116 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10913; /* *aarch64_brka_ptest */

    case 300:
      if (pattern1191 (x2) != 0
          || !
#line 10116 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10914; /* *aarch64_brkb_ptest */

    case 302:
      if (pattern1192 (x2) != 0
          || !
#line 10247 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10922; /* *aarch64_brkpa_ptest */

    case 303:
      if (pattern1192 (x2) != 0
          || !
#line 10247 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
        return -1;
      *pnum_clobbers = 1;
      return 10923; /* *aarch64_brkpb_ptest */

    case 304:
      switch (pattern1193 (x2))
        {
        case 0:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10940; /* *aarch64_sve_pfirstvnx16bi_ptest */

        case 1:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10942; /* *aarch64_sve_pfirstvnx8bi_ptest */

        case 2:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10944; /* *aarch64_sve_pfirstvnx4bi_ptest */

        case 3:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 8 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10946; /* *aarch64_sve_pfirstvnx2bi_ptest */

        default:
          return -1;
        }

    case 305:
      switch (pattern1193 (x2))
        {
        case 0:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 8
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10941; /* *aarch64_sve_pnextvnx16bi_ptest */

        case 1:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 16
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10943; /* *aarch64_sve_pnextvnx8bi_ptest */

        case 2:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 32
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10945; /* *aarch64_sve_pnextvnx4bi_ptest */

        case 3:
          if (!
#line 10319 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && 64 >= 64
   && aarch64_sve_same_pred_for_ptest_p (&operands[2], &operands[4])))
            return -1;
          *pnum_clobbers = 1;
          return 10947; /* *aarch64_sve_pnextvnx2bi_ptest */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_453 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case CONST_INT:
    case CONST_DOUBLE:
    case REG:
    case SUBREG:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          operands[1] = x5;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 265; /* *subsi3_uxtw */

        case ASHIFT:
          if (GET_MODE (x6) != E_SImode
              || !register_operand (x5, E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          switch (GET_CODE (x7))
            {
            case REG:
            case SUBREG:
              operands[1] = x7;
              if (!register_operand (operands[1], E_SImode))
                return -1;
              operands[3] = x5;
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              if (!aarch64_shift_imm_si (operands[2], E_QImode))
                return -1;
              return 292; /* *sub_lsl_si_uxtw */

            case SIGN_EXTEND:
              switch (pattern990 (x4))
                {
                case 0:
                  return 323; /* *sub_extendqi_shft_si_uxtw */

                case 1:
                  return 325; /* *sub_extendhi_shft_si_uxtw */

                default:
                  return -1;
                }

            case ZERO_EXTEND:
              switch (pattern990 (x4))
                {
                case 0:
                  return 324; /* *sub_zero_extendqi_shft_si_uxtw */

                case 1:
                  return 326; /* *sub_zero_extendhi_shft_si_uxtw */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case ASHIFTRT:
          if (pattern794 (x4) != 0)
            return -1;
          return 293; /* *sub_asr_si_uxtw */

        case LSHIFTRT:
          if (pattern794 (x4) != 0)
            return -1;
          return 294; /* *sub_lsr_si_uxtw */

        case SIGN_EXTEND:
          switch (pattern795 (x4))
            {
            case 0:
              return 307; /* *sub_extendqi_si_uxtw */

            case 1:
              return 309; /* *sub_extendhi_si_uxtw */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          switch (pattern795 (x4))
            {
            case 0:
              return 308; /* *sub_zero_extendqi_si_uxtw */

            case 1:
              return 310; /* *sub_zero_extendhi_si_uxtw */

            default:
              return -1;
            }

        case GEU:
        case LTU:
          operands[2] = x6;
          if (!aarch64_borrow_operation (operands[2], E_SImode))
            return -1;
          operands[1] = x5;
          if (!aarch64_reg_or_zero (operands[1], E_SImode))
            return -1;
          return 329; /* *subsi3_carryin_uxtw */

        case AND:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != ASHIFT
              || GET_MODE (x7) != E_SImode)
            return -1;
          operands[4] = x5;
          if (!register_operand (operands[4], E_SImode))
            return -1;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x7, 1);
          operands[2] = x10;
          if (!aarch64_imm3 (operands[2], E_VOIDmode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_VOIDmode)
              || !
#line 3937 "../../gcc/config/aarch64/aarch64.md"
(aarch64_uxt_size (INTVAL (operands[2]),INTVAL (operands[3])) != 0))
            return -1;
          return 348; /* *sub_uxtsi_shift2_uxtw */

        case MULT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          operands[3] = x5;
          if (!register_operand (operands[3], E_SImode))
            return -1;
          x7 = XEXP (x6, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x6, 1);
          operands[2] = x8;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 384; /* *msubsi_uxtw */

        default:
          return -1;
        }

    case MINUS:
      if (pattern373 (x3) != 0)
        return -1;
      x11 = XEXP (x5, 0);
      operands[1] = x11;
      if (!aarch64_reg_or_zero (operands[1], E_SImode))
        return -1;
      x12 = XEXP (x5, 1);
      switch (GET_CODE (x12))
        {
        case REG:
        case SUBREG:
          operands[2] = x12;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          if (!aarch64_borrow_operation (operands[3], E_SImode))
            return -1;
          return 332; /* *subsi3_carryin_uxtw */

        case GEU:
        case LTU:
          operands[3] = x12;
          if (!aarch64_borrow_operation (operands[3], E_SImode))
            return -1;
          x6 = XEXP (x4, 1);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode))
            return -1;
          return 335; /* *subsi3_carryin_alt_uxtw */

        default:
          return -1;
        }

    case NEG:
      if (pattern373 (x3) != 0)
        return -1;
      x11 = XEXP (x5, 0);
      operands[2] = x11;
      if (!aarch64_borrow_operation (operands[2], E_SImode))
        return -1;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 356; /* *ngcsi_uxtw */

    case SMAX:
      switch (pattern376 (x3, 
SMIN))
        {
        case 0:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1650; /* aarch64_sabdlv8qi */

        case 1:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1652; /* aarch64_sabdlv4hi */

        case 2:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1654; /* aarch64_sabdlv2si */

        case 3:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1656; /* aarch64_sabdl2v16qi_insn */

        case 4:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1658; /* aarch64_sabdl2v8hi_insn */

        case 5:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1660; /* aarch64_sabdl2v4si_insn */

        default:
          return -1;
        }

    case UMAX:
      switch (pattern376 (x3, 
UMIN))
        {
        case 0:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1651; /* aarch64_uabdlv8qi */

        case 1:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1653; /* aarch64_uabdlv4hi */

        case 2:
          if (!
#line 849 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1655; /* aarch64_uabdlv2si */

        case 3:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1657; /* aarch64_uabdl2v16qi_insn */

        case 4:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1659; /* aarch64_uabdl2v8hi_insn */

        case 5:
          if (!
#line 873 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return -1;
          return 1661; /* aarch64_uabdl2v4si_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_457 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XINT (x3, 1))
    {
    case 406:
      switch (pattern487 (x2))
        {
        case 0:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1403; /* aarch64_fcmla0v4hf */

        case 1:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1415; /* aarch64_fcmla0v8hf */

        case 2:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1419; /* aarch64_fcmla0v2sf */

        case 3:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1431; /* aarch64_fcmla0v4sf */

        case 4:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1435; /* aarch64_fcmla0v2df */

        default:
          return -1;
        }

    case 407:
      switch (pattern487 (x2))
        {
        case 0:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1406; /* aarch64_fcmla90v4hf */

        case 1:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1416; /* aarch64_fcmla90v8hf */

        case 2:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1422; /* aarch64_fcmla90v2sf */

        case 3:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1432; /* aarch64_fcmla90v4sf */

        case 4:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1436; /* aarch64_fcmla90v2df */

        default:
          return -1;
        }

    case 408:
      switch (pattern487 (x2))
        {
        case 0:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1409; /* aarch64_fcmla180v4hf */

        case 1:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1417; /* aarch64_fcmla180v8hf */

        case 2:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1425; /* aarch64_fcmla180v2sf */

        case 3:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1433; /* aarch64_fcmla180v4sf */

        case 4:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1437; /* aarch64_fcmla180v2df */

        default:
          return -1;
        }

    case 409:
      switch (pattern487 (x2))
        {
        case 0:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1412; /* aarch64_fcmla270v4hf */

        case 1:
          if (!(
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return -1;
          return 1418; /* aarch64_fcmla270v8hf */

        case 2:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1428; /* aarch64_fcmla270v2sf */

        case 3:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1434; /* aarch64_fcmla270v4sf */

        case 4:
          if (!
#line 458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_COMPLEX))
            return -1;
          return 1438; /* aarch64_fcmla270v2df */

        default:
          return -1;
        }

    case 278:
      switch (pattern490 (x2))
        {
        case 0:
          if (!
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
            return -1;
          return 1495; /* sdot_prodv2siv8qi */

        case 1:
          if (!
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
            return -1;
          return 1501; /* sdot_prodv4siv16qi */

        case 2:
          if (!
#line 7303 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9192; /* sdot_prodvnx4sivnx16qi */

        case 3:
          if (!
#line 2482 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12210; /* sdot_prodvnx4sivnx8hi */

        case 4:
          if (!
#line 7303 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9194; /* sdot_prodvnx2divnx8hi */

        case 5:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (32 == 8 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 32 == 32
	   && 8 == 16))))
            return -1;
          return 9196; /* aarch64_sdot_prod_lanevnx4sivnx16qi */

        case 6:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (32 == 16 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 32 == 32
	   && 16 == 16))))
            return -1;
          return 9200; /* aarch64_sdot_prod_lanevnx4sivnx8hi */

        case 7:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (64 == 8 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 64 == 32
	   && 8 == 16))))
            return -1;
          return 9198; /* aarch64_sdot_prod_lanevnx2divnx16qi */

        case 8:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (64 == 16 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 64 == 32
	   && 16 == 16))))
            return -1;
          return 9202; /* aarch64_sdot_prod_lanevnx2divnx8hi */

        default:
          return -1;
        }

    case 279:
      switch (pattern490 (x2))
        {
        case 0:
          if (!
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
            return -1;
          return 1498; /* udot_prodv2siv8qi */

        case 1:
          if (!
#line 577 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_DOTPROD))
            return -1;
          return 1502; /* udot_prodv4siv16qi */

        case 2:
          if (!
#line 7303 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9193; /* udot_prodvnx4sivnx16qi */

        case 3:
          if (!
#line 2482 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12211; /* udot_prodvnx4sivnx8hi */

        case 4:
          if (!
#line 7303 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return -1;
          return 9195; /* udot_prodvnx2divnx8hi */

        case 5:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (32 == 8 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 32 == 32
	   && 8 == 16))))
            return -1;
          return 9197; /* aarch64_udot_prod_lanevnx4sivnx16qi */

        case 6:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (32 == 16 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 32 == 32
	   && 16 == 16))))
            return -1;
          return 9201; /* aarch64_udot_prod_lanevnx4sivnx8hi */

        case 7:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (64 == 8 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 64 == 32
	   && 8 == 16))))
            return -1;
          return 9199; /* aarch64_udot_prod_lanevnx2divnx16qi */

        case 8:
          if (!
#line 7322 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (64 == 16 * 4
       || (TARGET_SVE2p1_OR_SME2
	   && 64 == 32
	   && 16 == 16))))
            return -1;
          return 9203; /* aarch64_udot_prod_lanevnx2divnx8hi */

        default:
          return -1;
        }

    case 572:
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          x6 = XEXP (x2, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_V2SImode:
              if (pattern488 (x2, 
E_V2SImode, 
E_V8QImode) != 0
                  || !
#line 591 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1503; /* usdot_prodv2siv8qi */

            case E_V4SImode:
              if (pattern488 (x2, 
E_V4SImode, 
E_V16QImode) != 0
                  || !
#line 591 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
                return -1;
              return 1506; /* usdot_prodv4siv16qi */

            case E_VNx4SImode:
              if (pattern488 (x2, 
E_VNx4SImode, 
E_VNx16QImode) != 0
                  || !
#line 7341 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_I8MM))
                return -1;
              return 9204; /* usdot_prodvnx4sivnx16qi */

            default:
              return -1;
            }

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 167
              || GET_MODE (x5) != E_VNx16QImode
              || !register_operand (operands[0], E_VNx4SImode)
              || GET_MODE (x2) != E_VNx4SImode
              || GET_MODE (x3) != E_VNx4SImode
              || pattern1122 (x2) != 0
              || !
#line 7359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_I8MM))
            return -1;
          return 9205; /* aarch64_usdot_prod_lanevnx4sivnx16qi */

        default:
          return -1;
        }

    case 578:
      x4 = XVECEXP (x3, 0, 0);
      operands[2] = x4;
      x5 = XVECEXP (x3, 0, 1);
      operands[3] = x5;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V2SFmode:
          if (pattern491 (x2, 
E_V2SFmode, 
E_V4BFmode) != 0
              || !
#line 9896 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
            return -1;
          return 5242; /* aarch64_bfdotv2sf */

        case E_V4SFmode:
          if (pattern491 (x2, 
E_V4SFmode, 
E_V8BFmode) != 0
              || !
#line 9896 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_BF16_SIMD))
            return -1;
          return 5243; /* aarch64_bfdotv4sf */

        default:
          return -1;
        }

    case 329:
      switch (pattern492 (x2))
        {
        case 0:
          if (!
#line 9966 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
            return -1;
          return 5255; /* aarch64_simd_smmlav16qi */

        case 1:
          if (!
#line 7414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_I8MM && TARGET_NON_STREAMING))
            return -1;
          return 9207; /* aarch64_sve_add_smatmulvnx16qi */

        default:
          return -1;
        }

    case 331:
      switch (pattern492 (x2))
        {
        case 0:
          if (!
#line 9966 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
            return -1;
          return 5256; /* aarch64_simd_ummlav16qi */

        case 1:
          if (!
#line 7414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_I8MM && TARGET_NON_STREAMING))
            return -1;
          return 9208; /* aarch64_sve_add_umatmulvnx16qi */

        default:
          return -1;
        }

    case 332:
      switch (pattern492 (x2))
        {
        case 0:
          if (!
#line 9966 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_I8MM))
            return -1;
          return 5257; /* aarch64_simd_usmmlav16qi */

        case 1:
          if (!
#line 7414 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_I8MM && TARGET_NON_STREAMING))
            return -1;
          return 9209; /* aarch64_sve_add_usmatmulvnx16qi */

        default:
          return -1;
        }

    case 125:
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case ASHIFT:
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          x6 = XEXP (x2, 1);
          operands[1] = x6;
          switch (pattern799 (x2))
            {
            case 0:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7972; /* *aarch64_adrvnx2qi_shift */

            case 1:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7973; /* *aarch64_adrvnx2hi_shift */

            case 2:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7974; /* *aarch64_adrvnx2si_shift */

            case 3:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7975; /* *aarch64_adrvnx2di_shift */

            case 4:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7976; /* *aarch64_adrvnx4qi_shift */

            case 5:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7977; /* *aarch64_adrvnx4hi_shift */

            case 6:
              if (!
#line 4208 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7978; /* *aarch64_adrvnx4si_shift */

            case 7:
              if (!
#line 4232 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7979; /* *aarch64_adr_shift_sxtw */

            case 8:
              if (!
#line 4253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return -1;
              return 7980; /* *aarch64_adr_shift_uxtw */

            default:
              return -1;
            }

        case MULT:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x8 = XEXP (x5, 0);
          operands[2] = x8;
          x7 = XEXP (x5, 1);
          operands[3] = x7;
          x6 = XEXP (x2, 1);
          operands[4] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_VNx16QImode:
              if (pattern992 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9112; /* aarch64_pred_fmavnx16qi */

            case E_VNx8QImode:
              if (pattern992 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9113; /* aarch64_pred_fmavnx8qi */

            case E_VNx4QImode:
              if (pattern992 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9114; /* aarch64_pred_fmavnx4qi */

            case E_VNx2QImode:
              if (pattern992 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9115; /* aarch64_pred_fmavnx2qi */

            case E_VNx8HImode:
              if (pattern992 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9116; /* aarch64_pred_fmavnx8hi */

            case E_VNx4HImode:
              if (pattern992 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9117; /* aarch64_pred_fmavnx4hi */

            case E_VNx2HImode:
              if (pattern992 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9118; /* aarch64_pred_fmavnx2hi */

            case E_VNx4SImode:
              if (pattern992 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9119; /* aarch64_pred_fmavnx4si */

            case E_VNx2SImode:
              if (pattern992 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9120; /* aarch64_pred_fmavnx2si */

            case E_VNx2DImode:
              if (pattern992 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
                  || !
#line 7037 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return -1;
              return 9121; /* aarch64_pred_fmavnx2di */

            default:
              return -1;
            }

        case ASHIFTRT:
          switch (pattern622 (x2))
            {
            case 0:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11961; /* *aarch64_sve2_sravnx16qi */

            case 1:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11963; /* *aarch64_sve2_sravnx8hi */

            case 2:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11965; /* *aarch64_sve2_sravnx4si */

            case 3:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11967; /* *aarch64_sve2_sravnx2di */

            default:
              return -1;
            }

        case LSHIFTRT:
          switch (pattern622 (x2))
            {
            case 0:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11962; /* *aarch64_sve2_sravnx16qi */

            case 1:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11964; /* *aarch64_sve2_sravnx8hi */

            case 2:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11966; /* *aarch64_sve2_sravnx4si */

            case 3:
              if (!
#line 1959 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
                return -1;
              return 11968; /* *aarch64_sve2_sravnx2di */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 577:
      if (GET_MODE (x3) != E_VNx4SImode)
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x5) != UNSPEC
          || XVECLEN (x5, 0) != 2
          || XINT (x5, 1) != 167
          || GET_MODE (x5) != E_VNx16QImode
          || !register_operand (operands[0], E_VNx4SImode)
          || GET_MODE (x2) != E_VNx4SImode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (pattern1122 (x2) != 0
          || !
#line 7359 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE_I8MM))
        return -1;
      return 9206; /* aarch64_sudot_prod_lanevnx4sivnx16qi */

    case 223:
      switch (pattern494 (x2))
        {
        case 0:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11969; /* aarch64_sve_add_srshrvnx16qi */

        case 1:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11971; /* aarch64_sve_add_srshrvnx8hi */

        case 2:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11973; /* aarch64_sve_add_srshrvnx4si */

        case 3:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11975; /* aarch64_sve_add_srshrvnx2di */

        default:
          return -1;
        }

    case 224:
      switch (pattern494 (x2))
        {
        case 0:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11970; /* aarch64_sve_add_urshrvnx16qi */

        case 1:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11972; /* aarch64_sve_add_urshrvnx8hi */

        case 2:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11974; /* aarch64_sve_add_urshrvnx4si */

        case 3:
          if (!
#line 1979 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 11976; /* aarch64_sve_add_urshrvnx2di */

        default:
          return -1;
        }

    case 488:
      switch (pattern495 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12132; /* aarch64_sve_add_sabdlbvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12140; /* aarch64_sve_add_sabdlbvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12148; /* aarch64_sve_add_sabdlbvnx2di */

        default:
          return -1;
        }

    case 489:
      switch (pattern495 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12133; /* aarch64_sve_add_sabdltvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12141; /* aarch64_sve_add_sabdltvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12149; /* aarch64_sve_add_sabdltvnx2di */

        default:
          return -1;
        }

    case 504:
      switch (pattern498 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12134; /* aarch64_sve_add_smullbvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12142; /* aarch64_sve_add_smullbvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12150; /* aarch64_sve_add_smullbvnx2di */

        case 3:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12156; /* aarch64_sve_add_smullb_lane_vnx4si */

        case 4:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12160; /* aarch64_sve_add_smullb_lane_vnx2di */

        default:
          return -1;
        }

    case 505:
      switch (pattern498 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12135; /* aarch64_sve_add_smulltvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12143; /* aarch64_sve_add_smulltvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12151; /* aarch64_sve_add_smulltvnx2di */

        case 3:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12157; /* aarch64_sve_add_smullt_lane_vnx4si */

        case 4:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12161; /* aarch64_sve_add_smullt_lane_vnx2di */

        default:
          return -1;
        }

    case 546:
      switch (pattern495 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12136; /* aarch64_sve_add_uabdlbvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12144; /* aarch64_sve_add_uabdlbvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12152; /* aarch64_sve_add_uabdlbvnx2di */

        default:
          return -1;
        }

    case 547:
      switch (pattern495 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12137; /* aarch64_sve_add_uabdltvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12145; /* aarch64_sve_add_uabdltvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12153; /* aarch64_sve_add_uabdltvnx2di */

        default:
          return -1;
        }

    case 556:
      switch (pattern498 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12138; /* aarch64_sve_add_umullbvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12146; /* aarch64_sve_add_umullbvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12154; /* aarch64_sve_add_umullbvnx2di */

        case 3:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12158; /* aarch64_sve_add_umullb_lane_vnx4si */

        case 4:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12162; /* aarch64_sve_add_umullb_lane_vnx2di */

        default:
          return -1;
        }

    case 557:
      switch (pattern498 (x2))
        {
        case 0:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12139; /* aarch64_sve_add_umulltvnx8hi */

        case 1:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12147; /* aarch64_sve_add_umulltvnx4si */

        case 2:
          if (!
#line 2342 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12155; /* aarch64_sve_add_umulltvnx2di */

        case 3:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12159; /* aarch64_sve_add_umullt_lane_vnx4si */

        case 4:
          if (!
#line 2361 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2))
            return -1;
          return 12163; /* aarch64_sve_add_umullt_lane_vnx2di */

        default:
          return -1;
        }

    case 605:
      if (GET_MODE (x3) != E_VNx4SFmode
          || !register_operand (operands[0], E_VNx4SFmode)
          || GET_MODE (x2) != E_VNx4SFmode)
        return -1;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_VNx8HFmode))
        return -1;
      x6 = XEXP (x2, 1);
      if (!register_operand (x6, E_VNx4SFmode))
        return -1;
      x5 = XVECEXP (x3, 0, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[2] = x5;
          if (!register_operand (operands[2], E_VNx8HFmode))
            return -1;
          operands[3] = x6;
          if (!
#line 2580 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12284; /* aarch64_sve_fdotvnx4sfvnx8hf */

        case UNSPEC:
          if (XVECLEN (x5, 0) != 2
              || XINT (x5, 1) != 167
              || GET_MODE (x5) != E_VNx8HFmode)
            return -1;
          x9 = XVECEXP (x5, 0, 0);
          operands[2] = x9;
          if (!register_operand (operands[2], E_VNx8HFmode))
            return -1;
          x10 = XVECEXP (x5, 0, 1);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          operands[4] = x6;
          if (!
#line 2598 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME2))
            return -1;
          return 12285; /* aarch64_fdot_prod_lanevnx4sfvnx8hf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_475 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !aarch64_mov_operand (operands[1], E_QImode)
          || !
#line 1514 "../../gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], QImode)
    || aarch64_reg_or_zero (operands[1], QImode))))
        return -1;
      return 67; /* *movqi_aarch64 */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !aarch64_mov_operand (operands[1], E_HImode)
          || !
#line 1514 "../../gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], HImode)
    || aarch64_reg_or_zero (operands[1], HImode))))
        return -1;
      return 68; /* *movhi_aarch64 */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !aarch64_mov_operand (operands[1], E_SImode)
          || !
#line 1575 "../../gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], SImode)
    || aarch64_reg_or_zero (operands[1], SImode))))
        return -1;
      return 69; /* *movsi_aarch64 */

    case E_DImode:
      if (!nonimmediate_operand (operands[0], E_DImode)
          || !aarch64_mov_operand (operands[1], E_DImode)
          || !
#line 1613 "../../gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], DImode)
    || aarch64_reg_or_zero (operands[1], DImode))))
        return -1;
      return 70; /* *movdi_aarch64 */

    case E_HFmode:
      if (!nonimmediate_operand (operands[0], E_HFmode)
          || !general_operand (operands[1], E_HFmode)
          || !
#line 1789 "../../gcc/config/aarch64/aarch64.md"
(aarch64_valid_fp_move (operands[0], operands[1], HFmode)))
        return -1;
      return 76; /* *movhf_aarch64 */

    case E_BFmode:
      if (!nonimmediate_operand (operands[0], E_BFmode)
          || !general_operand (operands[1], E_BFmode)
          || !
#line 1789 "../../gcc/config/aarch64/aarch64.md"
(aarch64_valid_fp_move (operands[0], operands[1], BFmode)))
        return -1;
      return 77; /* *movbf_aarch64 */

    case E_SDmode:
      if (!nonimmediate_operand (operands[0], E_SDmode)
          || !general_operand (operands[1], E_SDmode)
          || !
#line 1812 "../../gcc/config/aarch64/aarch64.md"
(aarch64_valid_fp_move (operands[0], operands[1], SDmode)))
        return -1;
      return 78; /* *movsd_aarch64 */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !general_operand (operands[1], E_SFmode)
          || !
#line 1812 "../../gcc/config/aarch64/aarch64.md"
(aarch64_valid_fp_move (operands[0], operands[1], SFmode)))
        return -1;
      return 79; /* *movsf_aarch64 */

    case E_DDmode:
      if (!nonimmediate_operand (operands[0], E_DDmode)
          || !general_operand (operands[1], E_DDmode)
          || !
#line 1832 "../../gcc/config/aarch64/aarch64.md"
(aarch64_valid_fp_move (operands[0], operands[1], DDmode)))
        return -1;
      return 80; /* *movdd_aarch64 */

    case E_DFmode:
      if (!nonimmediate_operand (operands[0], E_DFmode)
          || !general_operand (operands[1], E_DFmode)
          || !
#line 1832 "../../gcc/config/aarch64/aarch64.md"
(aarch64_valid_fp_move (operands[0], operands[1], DFmode)))
        return -1;
      return 81; /* *movdf_aarch64 */

    case E_TDmode:
      if (!nonimmediate_operand (operands[0], E_TDmode)
          || !general_operand (operands[1], E_TDmode)
          || !
#line 1854 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (register_operand (operands[0], TDmode)
    || aarch64_reg_or_fp_zero (operands[1], TDmode))))
        return -1;
      return 82; /* *movtd_aarch64 */

    case E_TFmode:
      if (!nonimmediate_operand (operands[0], E_TFmode)
          || !general_operand (operands[1], E_TFmode)
          || !
#line 1854 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT && (register_operand (operands[0], TFmode)
    || aarch64_reg_or_fp_zero (operands[1], TFmode))))
        return -1;
      return 83; /* *movtf_aarch64 */

    case E_V8QImode:
      if (!nonimmediate_operand (operands[0], E_V8QImode)
          || !general_operand (operands[1], E_V8QImode)
          || !
#line 148 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V8QImode)
       || aarch64_simd_reg_or_zero (operands[1], V8QImode))))
        return -1;
      return 1268; /* *aarch64_simd_movv8qi */

    case E_V4HImode:
      if (!nonimmediate_operand (operands[0], E_V4HImode)
          || !general_operand (operands[1], E_V4HImode)
          || !
#line 148 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4HImode)
       || aarch64_simd_reg_or_zero (operands[1], V4HImode))))
        return -1;
      return 1269; /* *aarch64_simd_movv4hi */

    case E_V4HFmode:
      if (!nonimmediate_operand (operands[0], E_V4HFmode)
          || !general_operand (operands[1], E_V4HFmode)
          || !
#line 148 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4HFmode)
       || aarch64_simd_reg_or_zero (operands[1], V4HFmode))))
        return -1;
      return 1270; /* *aarch64_simd_movv4hf */

    case E_V4BFmode:
      if (!nonimmediate_operand (operands[0], E_V4BFmode)
          || !general_operand (operands[1], E_V4BFmode)
          || !
#line 148 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4BFmode)
       || aarch64_simd_reg_or_zero (operands[1], V4BFmode))))
        return -1;
      return 1271; /* *aarch64_simd_movv4bf */

    case E_V2SImode:
      if (!nonimmediate_operand (operands[0], E_V2SImode)
          || !general_operand (operands[1], E_V2SImode)
          || !
#line 148 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2SImode)
       || aarch64_simd_reg_or_zero (operands[1], V2SImode))))
        return -1;
      return 1272; /* *aarch64_simd_movv2si */

    case E_V2SFmode:
      if (!nonimmediate_operand (operands[0], E_V2SFmode)
          || !general_operand (operands[1], E_V2SFmode)
          || !
#line 148 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2SFmode)
       || aarch64_simd_reg_or_zero (operands[1], V2SFmode))))
        return -1;
      return 1273; /* *aarch64_simd_movv2sf */

    case E_V16QImode:
      if (!nonimmediate_operand (operands[0], E_V16QImode)
          || !general_operand (operands[1], E_V16QImode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V16QImode)
       || aarch64_simd_reg_or_zero (operands[1], V16QImode))))
        return -1;
      return 1274; /* *aarch64_simd_movv16qi */

    case E_V8HImode:
      if (!nonimmediate_operand (operands[0], E_V8HImode)
          || !general_operand (operands[1], E_V8HImode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V8HImode)
       || aarch64_simd_reg_or_zero (operands[1], V8HImode))))
        return -1;
      return 1275; /* *aarch64_simd_movv8hi */

    case E_V4SImode:
      if (!nonimmediate_operand (operands[0], E_V4SImode)
          || !general_operand (operands[1], E_V4SImode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4SImode)
       || aarch64_simd_reg_or_zero (operands[1], V4SImode))))
        return -1;
      return 1276; /* *aarch64_simd_movv4si */

    case E_V2DImode:
      if (!nonimmediate_operand (operands[0], E_V2DImode)
          || !general_operand (operands[1], E_V2DImode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2DImode)
       || aarch64_simd_reg_or_zero (operands[1], V2DImode))))
        return -1;
      return 1277; /* *aarch64_simd_movv2di */

    case E_V8HFmode:
      if (!nonimmediate_operand (operands[0], E_V8HFmode)
          || !general_operand (operands[1], E_V8HFmode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V8HFmode)
       || aarch64_simd_reg_or_zero (operands[1], V8HFmode))))
        return -1;
      return 1278; /* *aarch64_simd_movv8hf */

    case E_V8BFmode:
      if (!nonimmediate_operand (operands[0], E_V8BFmode)
          || !general_operand (operands[1], E_V8BFmode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V8BFmode)
       || aarch64_simd_reg_or_zero (operands[1], V8BFmode))))
        return -1;
      return 1279; /* *aarch64_simd_movv8bf */

    case E_V4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4SFmode)
          || !general_operand (operands[1], E_V4SFmode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4SFmode)
       || aarch64_simd_reg_or_zero (operands[1], V4SFmode))))
        return -1;
      return 1280; /* *aarch64_simd_movv4sf */

    case E_V2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2DFmode)
          || !general_operand (operands[1], E_V2DFmode)
          || !
#line 180 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2DFmode)
       || aarch64_simd_reg_or_zero (operands[1], V2DFmode))))
        return -1;
      return 1281; /* *aarch64_simd_movv2df */

    case E_V8DImode:
      if (!nonimmediate_operand (operands[0], E_V8DImode)
          || !general_operand (operands[1], E_V8DImode)
          || !
#line 8094 "../../gcc/config/aarch64/aarch64-simd.md"
((register_operand (operands[0], V8DImode)
    || register_operand (operands[1], V8DImode))))
        return -1;
      return 4706; /* *aarch64_movv8di */

    case E_V2x8QImode:
      if (!nonimmediate_operand (operands[0], E_V2x8QImode)
          || !general_operand (operands[1], E_V2x8QImode)
          || !
#line 8123 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x8QImode)
       || register_operand (operands[1], V2x8QImode))))
        return -1;
      return 4737; /* *aarch64_movv2x8qi */

    case E_V2x4HImode:
      if (!nonimmediate_operand (operands[0], E_V2x4HImode)
          || !general_operand (operands[1], E_V2x4HImode)
          || !
#line 8123 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x4HImode)
       || register_operand (operands[1], V2x4HImode))))
        return -1;
      return 4738; /* *aarch64_movv2x4hi */

    case E_V2x2SImode:
      if (!nonimmediate_operand (operands[0], E_V2x2SImode)
          || !general_operand (operands[1], E_V2x2SImode)
          || !
#line 8123 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x2SImode)
       || register_operand (operands[1], V2x2SImode))))
        return -1;
      return 4739; /* *aarch64_movv2x2si */

    case E_V2x1DImode:
      if (!nonimmediate_operand (operands[0], E_V2x1DImode)
          || !general_operand (operands[1], E_V2x1DImode)
          || !
#line 8123 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x1DImode)
       || register_operand (operands[1], V2x1DImode))))
        return -1;
      return 4740; /* *aarch64_movv2x1di */

    case E_V2x4HFmode:
      if (!nonimmediate_operand (operands[0], E_V2x4HFmode)
          || !general_operand (operands[1], E_V2x4HFmode)
          || !
#line 8123 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x4HFmode)
       || register_operand (operands[1], V2x4HFmode))))
        return -1;
      return 4741; /* *aarch64_movv2x4hf */

    case E_V2x2SFmode:
      if (!nonimmediate_operand (operands[0], E_V2x2SFmode)
          || !general_operand (operands[1], E_V2x2SFmode)
          || !
#line 8123 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x2SFmode)
       || register_operand (operands[1], V2x2SFmode))))
        return -1;
      return 4742; /* *aarch64_movv2x2sf */

    case E_V2x1DFmode:
      if (!nonimmediate_operand (operands[0], E_V2x1DFmode)
          || !general_operand (operands[1], E_V2x1DFmode)
          || !
#line 8123 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x1DFmode)
       || register_operand (operands[1], V2x1DFmode))))
        return -1;
      return 4743; /* *aarch64_movv2x1df */

    case E_V2x4BFmode:
      if (!nonimmediate_operand (operands[0], E_V2x4BFmode)
          || !general_operand (operands[1], E_V2x4BFmode)
          || !
#line 8123 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x4BFmode)
       || register_operand (operands[1], V2x4BFmode))))
        return -1;
      return 4744; /* *aarch64_movv2x4bf */

    case E_V2x16QImode:
      if (!nonimmediate_operand (operands[0], E_V2x16QImode)
          || !general_operand (operands[1], E_V2x16QImode)
          || !
#line 8136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x16QImode)
       || register_operand (operands[1], V2x16QImode))))
        return -1;
      return 4745; /* *aarch64_movv2x16qi */

    case E_V2x8HImode:
      if (!nonimmediate_operand (operands[0], E_V2x8HImode)
          || !general_operand (operands[1], E_V2x8HImode)
          || !
#line 8136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x8HImode)
       || register_operand (operands[1], V2x8HImode))))
        return -1;
      return 4746; /* *aarch64_movv2x8hi */

    case E_V2x4SImode:
      if (!nonimmediate_operand (operands[0], E_V2x4SImode)
          || !general_operand (operands[1], E_V2x4SImode)
          || !
#line 8136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x4SImode)
       || register_operand (operands[1], V2x4SImode))))
        return -1;
      return 4747; /* *aarch64_movv2x4si */

    case E_V2x2DImode:
      if (!nonimmediate_operand (operands[0], E_V2x2DImode)
          || !general_operand (operands[1], E_V2x2DImode)
          || !
#line 8136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x2DImode)
       || register_operand (operands[1], V2x2DImode))))
        return -1;
      return 4748; /* *aarch64_movv2x2di */

    case E_V2x8HFmode:
      if (!nonimmediate_operand (operands[0], E_V2x8HFmode)
          || !general_operand (operands[1], E_V2x8HFmode)
          || !
#line 8136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x8HFmode)
       || register_operand (operands[1], V2x8HFmode))))
        return -1;
      return 4749; /* *aarch64_movv2x8hf */

    case E_V2x4SFmode:
      if (!nonimmediate_operand (operands[0], E_V2x4SFmode)
          || !general_operand (operands[1], E_V2x4SFmode)
          || !
#line 8136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x4SFmode)
       || register_operand (operands[1], V2x4SFmode))))
        return -1;
      return 4750; /* *aarch64_movv2x4sf */

    case E_V2x2DFmode:
      if (!nonimmediate_operand (operands[0], E_V2x2DFmode)
          || !general_operand (operands[1], E_V2x2DFmode)
          || !
#line 8136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x2DFmode)
       || register_operand (operands[1], V2x2DFmode))))
        return -1;
      return 4751; /* *aarch64_movv2x2df */

    case E_V2x8BFmode:
      if (!nonimmediate_operand (operands[0], E_V2x8BFmode)
          || !general_operand (operands[1], E_V2x8BFmode)
          || !
#line 8136 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V2x8BFmode)
       || register_operand (operands[1], V2x8BFmode))))
        return -1;
      return 4752; /* *aarch64_movv2x8bf */

    case E_OImode:
      if (!nonimmediate_operand (operands[0], E_OImode)
          || !general_operand (operands[1], E_OImode)
          || !
#line 8149 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], OImode)
       || register_operand (operands[1], OImode))))
        return -1;
      return 4753; /* *aarch64_movoi */

    case E_V3x8QImode:
      if (!nonimmediate_operand (operands[0], E_V3x8QImode)
          || !general_operand (operands[1], E_V3x8QImode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x8QImode)
       || register_operand (operands[1], V3x8QImode))))
        return -1;
      return 4754; /* *aarch64_movv3x8qi */

    case E_V3x4HImode:
      if (!nonimmediate_operand (operands[0], E_V3x4HImode)
          || !general_operand (operands[1], E_V3x4HImode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x4HImode)
       || register_operand (operands[1], V3x4HImode))))
        return -1;
      return 4755; /* *aarch64_movv3x4hi */

    case E_V3x2SImode:
      if (!nonimmediate_operand (operands[0], E_V3x2SImode)
          || !general_operand (operands[1], E_V3x2SImode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x2SImode)
       || register_operand (operands[1], V3x2SImode))))
        return -1;
      return 4756; /* *aarch64_movv3x2si */

    case E_V3x1DImode:
      if (!nonimmediate_operand (operands[0], E_V3x1DImode)
          || !general_operand (operands[1], E_V3x1DImode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x1DImode)
       || register_operand (operands[1], V3x1DImode))))
        return -1;
      return 4757; /* *aarch64_movv3x1di */

    case E_V3x4HFmode:
      if (!nonimmediate_operand (operands[0], E_V3x4HFmode)
          || !general_operand (operands[1], E_V3x4HFmode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x4HFmode)
       || register_operand (operands[1], V3x4HFmode))))
        return -1;
      return 4758; /* *aarch64_movv3x4hf */

    case E_V3x2SFmode:
      if (!nonimmediate_operand (operands[0], E_V3x2SFmode)
          || !general_operand (operands[1], E_V3x2SFmode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x2SFmode)
       || register_operand (operands[1], V3x2SFmode))))
        return -1;
      return 4759; /* *aarch64_movv3x2sf */

    case E_V3x1DFmode:
      if (!nonimmediate_operand (operands[0], E_V3x1DFmode)
          || !general_operand (operands[1], E_V3x1DFmode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x1DFmode)
       || register_operand (operands[1], V3x1DFmode))))
        return -1;
      return 4760; /* *aarch64_movv3x1df */

    case E_V3x4BFmode:
      if (!nonimmediate_operand (operands[0], E_V3x4BFmode)
          || !general_operand (operands[1], E_V3x4BFmode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x4BFmode)
       || register_operand (operands[1], V3x4BFmode))))
        return -1;
      return 4761; /* *aarch64_movv3x4bf */

    case E_V3x16QImode:
      if (!nonimmediate_operand (operands[0], E_V3x16QImode)
          || !general_operand (operands[1], E_V3x16QImode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x16QImode)
       || register_operand (operands[1], V3x16QImode))))
        return -1;
      return 4762; /* *aarch64_movv3x16qi */

    case E_V3x8HImode:
      if (!nonimmediate_operand (operands[0], E_V3x8HImode)
          || !general_operand (operands[1], E_V3x8HImode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x8HImode)
       || register_operand (operands[1], V3x8HImode))))
        return -1;
      return 4763; /* *aarch64_movv3x8hi */

    case E_V3x4SImode:
      if (!nonimmediate_operand (operands[0], E_V3x4SImode)
          || !general_operand (operands[1], E_V3x4SImode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x4SImode)
       || register_operand (operands[1], V3x4SImode))))
        return -1;
      return 4764; /* *aarch64_movv3x4si */

    case E_V3x2DImode:
      if (!nonimmediate_operand (operands[0], E_V3x2DImode)
          || !general_operand (operands[1], E_V3x2DImode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x2DImode)
       || register_operand (operands[1], V3x2DImode))))
        return -1;
      return 4765; /* *aarch64_movv3x2di */

    case E_V3x8HFmode:
      if (!nonimmediate_operand (operands[0], E_V3x8HFmode)
          || !general_operand (operands[1], E_V3x8HFmode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x8HFmode)
       || register_operand (operands[1], V3x8HFmode))))
        return -1;
      return 4766; /* *aarch64_movv3x8hf */

    case E_V3x4SFmode:
      if (!nonimmediate_operand (operands[0], E_V3x4SFmode)
          || !general_operand (operands[1], E_V3x4SFmode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x4SFmode)
       || register_operand (operands[1], V3x4SFmode))))
        return -1;
      return 4767; /* *aarch64_movv3x4sf */

    case E_V3x2DFmode:
      if (!nonimmediate_operand (operands[0], E_V3x2DFmode)
          || !general_operand (operands[1], E_V3x2DFmode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x2DFmode)
       || register_operand (operands[1], V3x2DFmode))))
        return -1;
      return 4768; /* *aarch64_movv3x2df */

    case E_V3x8BFmode:
      if (!nonimmediate_operand (operands[0], E_V3x8BFmode)
          || !general_operand (operands[1], E_V3x8BFmode)
          || !
#line 8162 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V3x8BFmode)
       || register_operand (operands[1], V3x8BFmode))))
        return -1;
      return 4769; /* *aarch64_movv3x8bf */

    case E_CImode:
      if (!nonimmediate_operand (operands[0], E_CImode)
          || !general_operand (operands[1], E_CImode)
          || !
#line 8174 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], CImode)
       || register_operand (operands[1], CImode))))
        return -1;
      return 4770; /* *aarch64_movci */

    case E_V4x8QImode:
      if (!nonimmediate_operand (operands[0], E_V4x8QImode)
          || !general_operand (operands[1], E_V4x8QImode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x8QImode)
       || register_operand (operands[1], V4x8QImode))))
        return -1;
      return 4771; /* *aarch64_movv4x8qi */

    case E_V4x4HImode:
      if (!nonimmediate_operand (operands[0], E_V4x4HImode)
          || !general_operand (operands[1], E_V4x4HImode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x4HImode)
       || register_operand (operands[1], V4x4HImode))))
        return -1;
      return 4772; /* *aarch64_movv4x4hi */

    case E_V4x2SImode:
      if (!nonimmediate_operand (operands[0], E_V4x2SImode)
          || !general_operand (operands[1], E_V4x2SImode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x2SImode)
       || register_operand (operands[1], V4x2SImode))))
        return -1;
      return 4773; /* *aarch64_movv4x2si */

    case E_V4x1DImode:
      if (!nonimmediate_operand (operands[0], E_V4x1DImode)
          || !general_operand (operands[1], E_V4x1DImode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x1DImode)
       || register_operand (operands[1], V4x1DImode))))
        return -1;
      return 4774; /* *aarch64_movv4x1di */

    case E_V4x4HFmode:
      if (!nonimmediate_operand (operands[0], E_V4x4HFmode)
          || !general_operand (operands[1], E_V4x4HFmode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x4HFmode)
       || register_operand (operands[1], V4x4HFmode))))
        return -1;
      return 4775; /* *aarch64_movv4x4hf */

    case E_V4x2SFmode:
      if (!nonimmediate_operand (operands[0], E_V4x2SFmode)
          || !general_operand (operands[1], E_V4x2SFmode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x2SFmode)
       || register_operand (operands[1], V4x2SFmode))))
        return -1;
      return 4776; /* *aarch64_movv4x2sf */

    case E_V4x1DFmode:
      if (!nonimmediate_operand (operands[0], E_V4x1DFmode)
          || !general_operand (operands[1], E_V4x1DFmode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x1DFmode)
       || register_operand (operands[1], V4x1DFmode))))
        return -1;
      return 4777; /* *aarch64_movv4x1df */

    case E_V4x4BFmode:
      if (!nonimmediate_operand (operands[0], E_V4x4BFmode)
          || !general_operand (operands[1], E_V4x4BFmode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x4BFmode)
       || register_operand (operands[1], V4x4BFmode))))
        return -1;
      return 4778; /* *aarch64_movv4x4bf */

    case E_V4x16QImode:
      if (!nonimmediate_operand (operands[0], E_V4x16QImode)
          || !general_operand (operands[1], E_V4x16QImode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x16QImode)
       || register_operand (operands[1], V4x16QImode))))
        return -1;
      return 4779; /* *aarch64_movv4x16qi */

    case E_V4x8HImode:
      if (!nonimmediate_operand (operands[0], E_V4x8HImode)
          || !general_operand (operands[1], E_V4x8HImode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x8HImode)
       || register_operand (operands[1], V4x8HImode))))
        return -1;
      return 4780; /* *aarch64_movv4x8hi */

    case E_V4x4SImode:
      if (!nonimmediate_operand (operands[0], E_V4x4SImode)
          || !general_operand (operands[1], E_V4x4SImode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x4SImode)
       || register_operand (operands[1], V4x4SImode))))
        return -1;
      return 4781; /* *aarch64_movv4x4si */

    case E_V4x2DImode:
      if (!nonimmediate_operand (operands[0], E_V4x2DImode)
          || !general_operand (operands[1], E_V4x2DImode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x2DImode)
       || register_operand (operands[1], V4x2DImode))))
        return -1;
      return 4782; /* *aarch64_movv4x2di */

    case E_V4x8HFmode:
      if (!nonimmediate_operand (operands[0], E_V4x8HFmode)
          || !general_operand (operands[1], E_V4x8HFmode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x8HFmode)
       || register_operand (operands[1], V4x8HFmode))))
        return -1;
      return 4783; /* *aarch64_movv4x8hf */

    case E_V4x4SFmode:
      if (!nonimmediate_operand (operands[0], E_V4x4SFmode)
          || !general_operand (operands[1], E_V4x4SFmode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x4SFmode)
       || register_operand (operands[1], V4x4SFmode))))
        return -1;
      return 4784; /* *aarch64_movv4x4sf */

    case E_V4x2DFmode:
      if (!nonimmediate_operand (operands[0], E_V4x2DFmode)
          || !general_operand (operands[1], E_V4x2DFmode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x2DFmode)
       || register_operand (operands[1], V4x2DFmode))))
        return -1;
      return 4785; /* *aarch64_movv4x2df */

    case E_V4x8BFmode:
      if (!nonimmediate_operand (operands[0], E_V4x8BFmode)
          || !general_operand (operands[1], E_V4x8BFmode)
          || !
#line 8186 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], V4x8BFmode)
       || register_operand (operands[1], V4x8BFmode))))
        return -1;
      return 4786; /* *aarch64_movv4x8bf */

    case E_XImode:
      if (!nonimmediate_operand (operands[0], E_XImode)
          || !general_operand (operands[1], E_XImode)
          || !
#line 8198 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FLOAT
   && (register_operand (operands[0], XImode)
       || register_operand (operands[1], XImode))))
        return -1;
      return 4787; /* *aarch64_movxi */

    default:
      return -1;
    }
}

 int
recog_489 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      x6 = XEXP (x3, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern896 (x2, 
E_V8QImode, 
E_V16QImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1776; /* xorv8qi3_vec_concatz_be */

        case E_V8HImode:
          if (pattern896 (x2, 
E_V4HImode, 
E_V8HImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1780; /* xorv4hi3_vec_concatz_be */

        case E_V4SImode:
          if (pattern896 (x2, 
E_V2SImode, 
E_V4SImode) != 0
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 1151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 1784; /* xorv2si3_vec_concatz_be */

        default:
          return -1;
        }

    case AND:
      x7 = XEXP (x4, 0);
      if (GET_CODE (x7) != XOR)
        return -1;
      x5 = XEXP (x2, 0);
      operands[4] = x5;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      x9 = XEXP (x7, 1);
      operands[2] = x9;
      x10 = XEXP (x4, 1);
      operands[1] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern1008 (x2, 
E_V8QImode, 
E_V16QImode) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3731 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return 2877; /* aarch64_simd_bslv8qi_internal_vec_concatz_be */
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3755 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2890; /* *aarch64_simd_bslv8qi_alt_vec_concatz_be */

        case E_V8HImode:
          if (pattern1008 (x2, 
E_V4HImode, 
E_V8HImode) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3731 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return 2881; /* aarch64_simd_bslv4hi_internal_vec_concatz_be */
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3755 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2894; /* *aarch64_simd_bslv4hi_alt_vec_concatz_be */

        case E_V4SImode:
          if (pattern1008 (x2, 
E_V2SImode, 
E_V4SImode) != 0)
            return -1;
          x6 = XEXP (x3, 1);
          if (rtx_equal_p (x6, operands[3])
              && (
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3731 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return 2885; /* aarch64_simd_bslv2si_internal_vec_concatz_be */
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 37 "../../gcc/config/aarch64/aarch64-simd.md"
(BYTES_BIG_ENDIAN) && 
#line 3755 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
            return -1;
          return 2898; /* *aarch64_simd_bslv2si_alt_vec_concatz_be */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_492 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SMAX)
    return -1;
  x6 = XEXP (x5, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
          operands[4] = x7;
          operands[1] = x6;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          x9 = XEXP (x4, 1);
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1078 (x2, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5466 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3373; /* *aarch64_sqmovunv8hi_insn_vec_concatz_le */

            case E_V8HImode:
              if (pattern1078 (x2, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5466 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3376; /* *aarch64_sqmovunv4si_insn_vec_concatz_le */

            case E_V4SImode:
              if (pattern1078 (x2, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5466 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 3379; /* *aarch64_sqmovunv2di_insn_vec_concatz_le */

            default:
              return -1;
            }

        case REG:
        case SUBREG:
          operands[1] = x7;
          operands[2] = x6;
          x8 = XEXP (x5, 1);
          operands[3] = x8;
          x9 = XEXP (x4, 1);
          operands[4] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern1079 (x2, 
E_V8QImode, 
E_V8HImode, 
E_V16QImode) != 0
                  || !
#line 5512 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 3384; /* aarch64_sqxtun2v8hi_be */

            case E_V8HImode:
              if (pattern1079 (x2, 
E_V4HImode, 
E_V4SImode, 
E_V8HImode) != 0
                  || !
#line 5512 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 3385; /* aarch64_sqxtun2v4si_be */

            case E_V4SImode:
              if (pattern1079 (x2, 
E_V2SImode, 
E_V2DImode, 
E_V4SImode) != 0
                  || !
#line 5512 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                return -1;
              return 3386; /* aarch64_sqxtun2v2di_be */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFTRT:
      x10 = XEXP (x6, 0);
      switch (GET_CODE (x10))
        {
        case REG:
        case SUBREG:
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
              operands[5] = x7;
              operands[1] = x10;
              x11 = XEXP (x6, 1);
              operands[2] = x11;
              x8 = XEXP (x5, 1);
              operands[3] = x8;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1167 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V8HImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V8HImode)
                      || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V8QImode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3972; /* *aarch64_sqshrun_nv8hi_insn_vec_concatz_le */

                case E_V8HImode:
                  if (pattern1167 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V4SImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V4SImode)
                      || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V4HImode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3975; /* *aarch64_sqshrun_nv4si_insn_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1167 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[3], E_V2DImode)
                      || !aarch64_simd_umax_half_mode (operands[4], E_V2DImode)
                      || !aarch64_simd_or_scalar_imm_zero (operands[5], E_V2SImode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6800 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                    return -1;
                  return 3978; /* *aarch64_sqshrun_nv2di_insn_vec_concatz_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x7;
              operands[2] = x10;
              x11 = XEXP (x6, 1);
              operands[3] = x11;
              x8 = XEXP (x5, 1);
              operands[4] = x8;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1168 (x2, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V8HImode)
                      || !aarch64_simd_umax_half_mode (operands[5], E_V8HImode)
                      || !register_operand (operands[1], E_V8QImode)
                      || !
#line 7085 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 4052; /* aarch64_sqshrun2_nv8hi_insn_be */

                case E_V8HImode:
                  if (pattern1168 (x2, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V4SImode)
                      || !aarch64_simd_umax_half_mode (operands[5], E_V4SImode)
                      || !register_operand (operands[1], E_V4HImode)
                      || !
#line 7085 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 4053; /* aarch64_sqshrun2_nv4si_insn_be */

                case E_V4SImode:
                  if (pattern1168 (x2, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V2DImode)
                      || !aarch64_simd_umax_half_mode (operands[5], E_V2DImode)
                      || !register_operand (operands[1], E_V2SImode)
                      || !
#line 7085 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
                    return -1;
                  return 4054; /* aarch64_sqshrun2_nv2di_insn_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case PLUS:
          x12 = XEXP (x10, 0);
          if (GET_CODE (x12) != SIGN_EXTEND)
            return -1;
          x7 = XEXP (x2, 1);
          switch (GET_CODE (x7))
            {
            case CONST_INT:
            case CONST_DOUBLE:
            case CONST_VECTOR:
            case CONST:
              operands[6] = x7;
              x13 = XEXP (x12, 0);
              operands[1] = x13;
              x14 = XEXP (x10, 1);
              operands[3] = x14;
              x11 = XEXP (x6, 1);
              operands[2] = x11;
              x8 = XEXP (x5, 1);
              operands[4] = x8;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1230 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[2], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V8SImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V8SImode)
                      || !aarch64_simd_or_scalar_imm_zero (operands[6], E_V8QImode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6867 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3984; /* *aarch64_sqrshrun_nv8hi_insn_vec_concatz_le */

                case E_V8HImode:
                  if (pattern1230 (x2, 
E_V4DImode, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[2], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V4DImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V4DImode)
                      || !aarch64_simd_or_scalar_imm_zero (operands[6], E_V4HImode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6867 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3987; /* *aarch64_sqrshrun_nv4si_insn_vec_concatz_le */

                case E_V4SImode:
                  if (pattern1230 (x2, 
E_V2TImode, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[2], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[4], E_V2TImode)
                      || !aarch64_simd_umax_quarter_mode (operands[5], E_V2TImode)
                      || !aarch64_simd_or_scalar_imm_zero (operands[6], E_V2SImode)
                      || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 6867 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && aarch64_const_vec_rnd_cst_p (operands[3], operands[2]))))
                    return -1;
                  return 3990; /* *aarch64_sqrshrun_nv2di_insn_vec_concatz_le */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[1] = x7;
              x13 = XEXP (x12, 0);
              operands[2] = x13;
              x14 = XEXP (x10, 1);
              operands[4] = x14;
              x11 = XEXP (x6, 1);
              operands[3] = x11;
              x8 = XEXP (x5, 1);
              operands[5] = x8;
              x9 = XEXP (x4, 1);
              operands[6] = x9;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern1231 (x2, 
E_V8SImode, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode) != 0
                      || !aarch64_simd_shift_imm_vec_qi (operands[3], E_V8HImode)
                      || !aarch64_simd_imm_zero (operands[5], E_V8SImode)
                      || !aarch64_simd_umax_quarter_mode (operands[6], E_V8SImode)
                      || !register_operand (operands[1], E_V8QImode)
                      || !
#line 7151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                    return -1;
                  return 4058; /* aarch64_sqrshrun2_nv8hi_insn_be */

                case E_V8HImode:
                  if (pattern1231 (x2, 
E_V4DImode, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0
                      || !aarch64_simd_shift_imm_vec_hi (operands[3], E_V4SImode)
                      || !aarch64_simd_imm_zero (operands[5], E_V4DImode)
                      || !aarch64_simd_umax_quarter_mode (operands[6], E_V4DImode)
                      || !register_operand (operands[1], E_V4HImode)
                      || !
#line 7151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                    return -1;
                  return 4059; /* aarch64_sqrshrun2_nv4si_insn_be */

                case E_V4SImode:
                  if (pattern1231 (x2, 
E_V2TImode, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0
                      || !aarch64_simd_shift_imm_vec_si (operands[3], E_V2DImode)
                      || !aarch64_simd_imm_zero (operands[5], E_V2TImode)
                      || !aarch64_simd_umax_quarter_mode (operands[6], E_V2TImode)
                      || !register_operand (operands[1], E_V2SImode)
                      || !
#line 7151 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN
   && aarch64_const_vec_rnd_cst_p (operands[4], operands[3])))
                    return -1;
                  return 4060; /* aarch64_sqrshrun2_nv2di_insn_be */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_497 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (XVECLEN (x3, 0))
    {
    case 2:
      return recog_490 (x1, insn, pnum_clobbers);

    case 1:
      switch (XINT (x3, 1))
        {
        case 186:
          x4 = XVECEXP (x3, 0, 0);
          operands[1] = x4;
          x5 = XEXP (x2, 1);
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_V16QImode:
              if (pattern538 (x2, 
E_V8QImode, 
E_V16QImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1611; /* aarch64_absv8qi_vec_concatz_le */

            case E_V8HImode:
              if (pattern538 (x2, 
E_V4HImode, 
E_V8HImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1615; /* aarch64_absv4hi_vec_concatz_le */

            case E_V4SImode:
              if (pattern538 (x2, 
E_V2SImode, 
E_V4SImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1619; /* aarch64_absv2si_vec_concatz_le */

            case E_V2DImode:
              if (pattern538 (x2, 
E_DImode, 
E_V2DImode) != 0
                  || !(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 803 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 1624; /* aarch64_absdi_vec_concatz_le */

            default:
              return -1;
            }

        case 36:
          switch (pattern539 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2473; /* btruncv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2501; /* btruncv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 34:
          switch (pattern539 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2476; /* ceilv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2504; /* ceilv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 32:
          switch (pattern539 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2479; /* floorv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2507; /* floorv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 33:
          switch (pattern539 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2482; /* roundevenv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2510; /* roundevenv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 31:
          switch (pattern539 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2485; /* nearbyintv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2513; /* nearbyintv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 35:
          switch (pattern539 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2488; /* rintv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2516; /* rintv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 30:
          switch (pattern539 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && (
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST))))
                return -1;
              return 2491; /* roundv4hf2_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 3005 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 2519; /* roundv2sf2_vec_concatz_le */

            default:
              return -1;
            }

        case 587:
          if (GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x2) != E_V4SFmode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[2] = x4;
          if (!register_operand (operands[2], E_V2DFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V2SFmode)
              || !
#line 3230 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && BYTES_BIG_ENDIAN))
            return -1;
          return 2644; /* aarch64_float_trunc_rodd_hi_v4sf_be */

        case 253:
          switch (pattern540 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5008; /* aarch64_rev64v8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5020; /* aarch64_rev64v4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5032; /* aarch64_rev64v2si_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5047; /* aarch64_rev64v4hf_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5059; /* aarch64_rev64v4bf_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5071; /* aarch64_rev64v2sf_vec_concatz_le */

            default:
              return -1;
            }

        case 254:
          switch (pattern540 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5011; /* aarch64_rev32v8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5023; /* aarch64_rev32v4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5035; /* aarch64_rev32v2si_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5050; /* aarch64_rev32v4hf_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5062; /* aarch64_rev32v4bf_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5074; /* aarch64_rev32v2sf_vec_concatz_le */

            default:
              return -1;
            }

        case 255:
          switch (pattern540 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5014; /* aarch64_rev16v8qi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5026; /* aarch64_rev16v4hi_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5038; /* aarch64_rev16v2si_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5053; /* aarch64_rev16v4hf_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5065; /* aarch64_rev16v4bf_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 8677 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD)))
                return -1;
              return 5077; /* aarch64_rev16v2sf_vec_concatz_le */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 3:
      switch (XINT (x3, 1))
        {
        case 274:
          switch (pattern542 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5643 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3502; /* aarch64_sqrdmlahv4hi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5643 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3510; /* aarch64_sqrdmlahv2si_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3522; /* aarch64_sqrdmlah_lanev4hi_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3542; /* aarch64_sqrdmlah_laneqv4hi_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3530; /* aarch64_sqrdmlah_lanev2si_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3550; /* aarch64_sqrdmlah_laneqv2si_vec_concatz_le */

            default:
              return -1;
            }

        case 275:
          switch (pattern542 (x2))
            {
            case 0:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5643 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3505; /* aarch64_sqrdmlshv4hi_vec_concatz_le */

            case 1:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5643 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3513; /* aarch64_sqrdmlshv2si_vec_concatz_le */

            case 2:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3525; /* aarch64_sqrdmlsh_lanev4hi_vec_concatz_le */

            case 3:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3545; /* aarch64_sqrdmlsh_laneqv4hi_vec_concatz_le */

            case 4:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5659 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3533; /* aarch64_sqrdmlsh_lanev2si_vec_concatz_le */

            case 5:
              if (!(
#line 28 "../../gcc/config/aarch64/aarch64-simd.md"
(!BYTES_BIG_ENDIAN) && 
#line 5697 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_RDMA)))
                return -1;
              return 3553; /* aarch64_sqrdmlsh_laneqv2si_vec_concatz_le */

            default:
              return -1;
            }

        case 187:
          if (GET_MODE (x3) != E_V8QImode)
            return -1;
          x6 = XVECEXP (x3, 0, 2);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 84
              || GET_MODE (x6) != E_DImode
              || !register_operand (operands[0], E_V16QImode)
              || GET_MODE (x2) != E_V16QImode)
            return -1;
          x4 = XVECEXP (x3, 0, 0);
          operands[2] = x4;
          if (!register_operand (operands[2], E_V4SFmode))
            return -1;
          x7 = XVECEXP (x3, 0, 1);
          operands[3] = x7;
          if (!register_operand (operands[3], E_V4SFmode))
            return -1;
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          if (!register_operand (operands[1], E_V8QImode)
              || !
#line 10131 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_FP8 && BYTES_BIG_ENDIAN))
            return -1;
          return 5314; /* aarch64_fcvtnv4sf_high_be */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_505 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      switch (GET_CODE (x2))
        {
        case LABEL_REF:
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            {
              x4 = XEXP (x2, 0);
              operands[0] = x4;
              return 6; /* jump */
            }
          break;

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
          switch (GET_CODE (x2))
            {
            case CONST_VECTOR:
            case CONST:
            case REG:
            case SUBREG:
            case MEM:
              res = recog_473 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            case CONST_INT:
              res = recog_474 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x2;
          if (aarch64_movti_operand (operands[1], E_TImode))
            {
              x3 = XEXP (x1, 0);
              operands[0] = x3;
              if (nonimmediate_operand (operands[0], E_TImode)
                  && 
#line 1709 "../../gcc/config/aarch64/aarch64.md"
((register_operand (operands[0], TImode)
    || aarch64_reg_or_zero (operands[1], TImode))))
                return 75; /* *movti_aarch64 */
            }
          break;

        default:
          break;
        }
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (register_operand (operands[0], E_VNx16QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16QImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx16QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx16QImode)))))
            return 5527; /* *aarch64_sve_movvnx16qi_no_ldr_str */
          break;

        case E_VNx8QImode:
          if (register_operand (operands[0], E_VNx8QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8QImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8QImode)))))
            return 5528; /* *aarch64_sve_movvnx8qi_no_ldr_str */
          break;

        case E_VNx4QImode:
          if (register_operand (operands[0], E_VNx4QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4QImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4QImode)))))
            return 5529; /* *aarch64_sve_movvnx4qi_no_ldr_str */
          break;

        case E_VNx2QImode:
          if (register_operand (operands[0], E_VNx2QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2QImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2QImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2QImode)))))
            return 5530; /* *aarch64_sve_movvnx2qi_no_ldr_str */
          break;

        case E_VNx8HImode:
          if (register_operand (operands[0], E_VNx8HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8HImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8HImode)))))
            return 5531; /* *aarch64_sve_movvnx8hi_no_ldr_str */
          break;

        case E_VNx4HImode:
          if (register_operand (operands[0], E_VNx4HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4HImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4HImode)))))
            return 5532; /* *aarch64_sve_movvnx4hi_no_ldr_str */
          break;

        case E_VNx2HImode:
          if (register_operand (operands[0], E_VNx2HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2HImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2HImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2HImode)))))
            return 5533; /* *aarch64_sve_movvnx2hi_no_ldr_str */
          break;

        case E_VNx4SImode:
          if (register_operand (operands[0], E_VNx4SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4SImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4SImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4SImode)))))
            return 5534; /* *aarch64_sve_movvnx4si_no_ldr_str */
          break;

        case E_VNx2SImode:
          if (register_operand (operands[0], E_VNx2SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2SImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2SImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2SImode)))))
            return 5535; /* *aarch64_sve_movvnx2si_no_ldr_str */
          break;

        case E_VNx2DImode:
          if (register_operand (operands[0], E_VNx2DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2DImode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2DImode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2DImode)))))
            return 5536; /* *aarch64_sve_movvnx2di_no_ldr_str */
          break;

        case E_VNx8HFmode:
          if (register_operand (operands[0], E_VNx8HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8HFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8HFmode)))))
            return 5537; /* *aarch64_sve_movvnx8hf_no_ldr_str */
          break;

        case E_VNx4HFmode:
          if (register_operand (operands[0], E_VNx4HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4HFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4HFmode)))))
            return 5538; /* *aarch64_sve_movvnx4hf_no_ldr_str */
          break;

        case E_VNx2HFmode:
          if (register_operand (operands[0], E_VNx2HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2HFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2HFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2HFmode)))))
            return 5539; /* *aarch64_sve_movvnx2hf_no_ldr_str */
          break;

        case E_VNx8BFmode:
          if (register_operand (operands[0], E_VNx8BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8BFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx8BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx8BFmode)))))
            return 5540; /* *aarch64_sve_movvnx8bf_no_ldr_str */
          break;

        case E_VNx4BFmode:
          if (register_operand (operands[0], E_VNx4BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4BFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4BFmode)))))
            return 5541; /* *aarch64_sve_movvnx4bf_no_ldr_str */
          break;

        case E_VNx2BFmode:
          if (register_operand (operands[0], E_VNx2BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2BFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2BFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2BFmode)))))
            return 5542; /* *aarch64_sve_movvnx2bf_no_ldr_str */
          break;

        case E_VNx4SFmode:
          if (register_operand (operands[0], E_VNx4SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4SFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx4SFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx4SFmode)))))
            return 5543; /* *aarch64_sve_movvnx4sf_no_ldr_str */
          break;

        case E_VNx2SFmode:
          if (register_operand (operands[0], E_VNx2SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2SFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2SFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2SFmode)))))
            return 5544; /* *aarch64_sve_movvnx2sf_no_ldr_str */
          break;

        case E_VNx2DFmode:
          if (register_operand (operands[0], E_VNx2DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx2DFmode)
              && 
#line 711 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && VNx2DFmode != VNx16QImode
   && (BYTES_BIG_ENDIAN
       || maybe_ne (BYTES_PER_SVE_VECTOR, GET_MODE_SIZE (VNx2DFmode)))))
            return 5545; /* *aarch64_sve_movvnx2df_no_ldr_str */
          break;

        case E_VNx32QImode:
          if (register_operand (operands[0], E_VNx32QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32QImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5651; /* *aarch64_sve_movvnx32qi_be */
          break;

        case E_VNx16HImode:
          if (register_operand (operands[0], E_VNx16HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16HImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5652; /* *aarch64_sve_movvnx16hi_be */
          break;

        case E_VNx8SImode:
          if (register_operand (operands[0], E_VNx8SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8SImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5653; /* *aarch64_sve_movvnx8si_be */
          break;

        case E_VNx4DImode:
          if (register_operand (operands[0], E_VNx4DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4DImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5654; /* *aarch64_sve_movvnx4di_be */
          break;

        case E_VNx16BFmode:
          if (register_operand (operands[0], E_VNx16BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16BFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5655; /* *aarch64_sve_movvnx16bf_be */
          break;

        case E_VNx16HFmode:
          if (register_operand (operands[0], E_VNx16HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16HFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5656; /* *aarch64_sve_movvnx16hf_be */
          break;

        case E_VNx8SFmode:
          if (register_operand (operands[0], E_VNx8SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8SFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5657; /* *aarch64_sve_movvnx8sf_be */
          break;

        case E_VNx4DFmode:
          if (register_operand (operands[0], E_VNx4DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx4DFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5658; /* *aarch64_sve_movvnx4df_be */
          break;

        case E_VNx48QImode:
          if (register_operand (operands[0], E_VNx48QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx48QImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5659; /* *aarch64_sve_movvnx48qi_be */
          break;

        case E_VNx24HImode:
          if (register_operand (operands[0], E_VNx24HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24HImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5660; /* *aarch64_sve_movvnx24hi_be */
          break;

        case E_VNx12SImode:
          if (register_operand (operands[0], E_VNx12SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx12SImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5661; /* *aarch64_sve_movvnx12si_be */
          break;

        case E_VNx6DImode:
          if (register_operand (operands[0], E_VNx6DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx6DImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5662; /* *aarch64_sve_movvnx6di_be */
          break;

        case E_VNx24BFmode:
          if (register_operand (operands[0], E_VNx24BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24BFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5663; /* *aarch64_sve_movvnx24bf_be */
          break;

        case E_VNx24HFmode:
          if (register_operand (operands[0], E_VNx24HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx24HFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5664; /* *aarch64_sve_movvnx24hf_be */
          break;

        case E_VNx12SFmode:
          if (register_operand (operands[0], E_VNx12SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx12SFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5665; /* *aarch64_sve_movvnx12sf_be */
          break;

        case E_VNx6DFmode:
          if (register_operand (operands[0], E_VNx6DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx6DFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5666; /* *aarch64_sve_movvnx6df_be */
          break;

        case E_VNx64QImode:
          if (register_operand (operands[0], E_VNx64QImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx64QImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5667; /* *aarch64_sve_movvnx64qi_be */
          break;

        case E_VNx32HImode:
          if (register_operand (operands[0], E_VNx32HImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32HImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5668; /* *aarch64_sve_movvnx32hi_be */
          break;

        case E_VNx16SImode:
          if (register_operand (operands[0], E_VNx16SImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16SImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5669; /* *aarch64_sve_movvnx16si_be */
          break;

        case E_VNx8DImode:
          if (register_operand (operands[0], E_VNx8DImode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8DImode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5670; /* *aarch64_sve_movvnx8di_be */
          break;

        case E_VNx32BFmode:
          if (register_operand (operands[0], E_VNx32BFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32BFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5671; /* *aarch64_sve_movvnx32bf_be */
          break;

        case E_VNx32HFmode:
          if (register_operand (operands[0], E_VNx32HFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx32HFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5672; /* *aarch64_sve_movvnx32hf_be */
          break;

        case E_VNx16SFmode:
          if (register_operand (operands[0], E_VNx16SFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx16SFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5673; /* *aarch64_sve_movvnx16sf_be */
          break;

        case E_VNx8DFmode:
          if (register_operand (operands[0], E_VNx8DFmode)
              && aarch64_nonmemory_operand (operands[1], E_VNx8DFmode)
              && 
#line 865 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && BYTES_BIG_ENDIAN))
            return 5674; /* *aarch64_sve_movvnx8df_be */
          break;

        case E_VNx16BImode:
          if (nonimmediate_operand (operands[0], E_VNx16BImode)
              && aarch64_mov_operand (operands[1], E_VNx16BImode)
              && 
#line 957 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16BImode)
       || register_operand (operands[1], VNx16BImode))))
            return 5699; /* *aarch64_sve_movvnx16bi */
          break;

        case E_VNx8BImode:
          if (nonimmediate_operand (operands[0], E_VNx8BImode)
              && aarch64_mov_operand (operands[1], E_VNx8BImode)
              && 
#line 957 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8BImode)
       || register_operand (operands[1], VNx8BImode))))
            return 5700; /* *aarch64_sve_movvnx8bi */
          break;

        case E_VNx4BImode:
          if (nonimmediate_operand (operands[0], E_VNx4BImode)
              && aarch64_mov_operand (operands[1], E_VNx4BImode)
              && 
#line 957 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4BImode)
       || register_operand (operands[1], VNx4BImode))))
            return 5701; /* *aarch64_sve_movvnx4bi */
          break;

        case E_VNx2BImode:
          if (nonimmediate_operand (operands[0], E_VNx2BImode)
              && aarch64_mov_operand (operands[1], E_VNx2BImode)
              && 
#line 957 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2BImode)
       || register_operand (operands[1], VNx2BImode))))
            return 5702; /* *aarch64_sve_movvnx2bi */
          break;

        case E_VNx32BImode:
          if (nonimmediate_operand (operands[0], E_VNx32BImode)
              && aarch64_mov_operand (operands[1], E_VNx32BImode)
              && 
#line 1079 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 5711; /* movvnx32bi */
          break;

        case E_VNx64BImode:
          if (nonimmediate_operand (operands[0], E_VNx64BImode)
              && aarch64_mov_operand (operands[1], E_VNx64BImode)
              && 
#line 1079 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
            return 5712; /* movvnx64bi */
          break;

        default:
          break;
        }
      if (GET_CODE (x2) == REG
          && GET_MODE (x2) == E_VNx16BImode)
        {
          switch (REGNO (x2))
            {
            case 85:
              if (GET_CODE (x3) == REG
                  && REGNO (x3) == 86
                  && GET_MODE (x3) == E_VNx16BImode
                  && 
#line 1141 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE))
                return 5715; /* aarch64_copy_ffr_to_ffrt */
              break;

            case 86:
              operands[0] = x3;
              if (register_operand (operands[0], E_VNx16BImode)
                  && 
#line 1152 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING))
                return 5716; /* aarch64_rdffr */
              break;

            default:
              break;
            }
        }
      operands[1] = x2;
      operands[0] = x3;
      res = recog_475 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (x2 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && GET_CODE (x3) == REG
          && REGNO (x3) == 90
          && GET_MODE (x3) == E_DImode)
        return 12904; /* aarch64_clear_tpidr2 */
      break;

    case TRUNCATE:
      res = recog_477 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (!subreg_lowpart_operator (x2, E_DImode))
    return -1;
  switch (pattern29 (x1))
    {
    case 0:
      if (!
#line 6417 "../../gcc/config/aarch64/aarch64.md"
(8 <= 8
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 829; /* *aarch64_bfidiqi_subreg_8 */

    case 1:
      if (!
#line 6417 "../../gcc/config/aarch64/aarch64.md"
(8 <= 16
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 830; /* *aarch64_bfidihi_subreg_8 */

    case 2:
      if (!
#line 6417 "../../gcc/config/aarch64/aarch64.md"
(8 <= 32
   && multiple_p (UINTVAL (operands[1]), 8)
   && UINTVAL (operands[1]) + 8 <= 64))
        return -1;
      return 832; /* *aarch64_bfidisi_subreg_8 */

    case 3:
      if (!
#line 6417 "../../gcc/config/aarch64/aarch64.md"
(16 <= 16
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
        return -1;
      return 831; /* *aarch64_bfidihi_subreg_16 */

    case 4:
      if (!
#line 6417 "../../gcc/config/aarch64/aarch64.md"
(16 <= 32
   && multiple_p (UINTVAL (operands[1]), 16)
   && UINTVAL (operands[1]) + 16 <= 64))
        return -1;
      return 833; /* *aarch64_bfidisi_subreg_16 */

    case 5:
      if (!
#line 6417 "../../gcc/config/aarch64/aarch64.md"
(32 <= 32
   && multiple_p (UINTVAL (operands[1]), 32)
   && UINTVAL (operands[1]) + 32 <= 64))
        return -1;
      return 834; /* *aarch64_bfidisi_subreg_32 */

    default:
      return -1;
    }
}

 int
recog_512 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case VEC_SELECT:
      return recog_480 (x1, insn, pnum_clobbers);

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_CODE (operands[1]))
        {
        case REG:
        case SUBREG:
          switch (GET_CODE (operands[0]))
            {
            case REG:
            case SUBREG:
              switch (GET_MODE (operands[0]))
                {
                case E_V8QImode:
                  if (register_operand (operands[0], E_V8QImode)
                      && GET_MODE (x3) == E_V8QImode
                      && register_operand (operands[1], E_QImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1230; /* aarch64_simd_dupv8qi */
                  break;

                case E_V16QImode:
                  if (register_operand (operands[0], E_V16QImode)
                      && GET_MODE (x3) == E_V16QImode
                      && register_operand (operands[1], E_QImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1231; /* aarch64_simd_dupv16qi */
                  break;

                case E_V4HImode:
                  if (register_operand (operands[0], E_V4HImode)
                      && GET_MODE (x3) == E_V4HImode
                      && register_operand (operands[1], E_HImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1232; /* aarch64_simd_dupv4hi */
                  break;

                case E_V8HImode:
                  if (register_operand (operands[0], E_V8HImode)
                      && GET_MODE (x3) == E_V8HImode
                      && register_operand (operands[1], E_HImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1233; /* aarch64_simd_dupv8hi */
                  break;

                case E_V2SImode:
                  if (register_operand (operands[0], E_V2SImode)
                      && GET_MODE (x3) == E_V2SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1234; /* aarch64_simd_dupv2si */
                  break;

                case E_V4SImode:
                  if (register_operand (operands[0], E_V4SImode)
                      && GET_MODE (x3) == E_V4SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1235; /* aarch64_simd_dupv4si */
                  break;

                case E_V2DImode:
                  if (register_operand (operands[0], E_V2DImode)
                      && GET_MODE (x3) == E_V2DImode
                      && register_operand (operands[1], E_DImode)
                      && 
#line 97 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1236; /* aarch64_simd_dupv2di */
                  break;

                case E_V4HFmode:
                  if (register_operand (operands[0], E_V4HFmode)
                      && GET_MODE (x3) == E_V4HFmode
                      && register_operand (operands[1], E_HFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1237; /* aarch64_simd_dupv4hf */
                  break;

                case E_V8HFmode:
                  if (register_operand (operands[0], E_V8HFmode)
                      && GET_MODE (x3) == E_V8HFmode
                      && register_operand (operands[1], E_HFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1238; /* aarch64_simd_dupv8hf */
                  break;

                case E_V2SFmode:
                  if (register_operand (operands[0], E_V2SFmode)
                      && GET_MODE (x3) == E_V2SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1239; /* aarch64_simd_dupv2sf */
                  break;

                case E_V4SFmode:
                  if (register_operand (operands[0], E_V4SFmode)
                      && GET_MODE (x3) == E_V4SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1240; /* aarch64_simd_dupv4sf */
                  break;

                case E_V2DFmode:
                  if (register_operand (operands[0], E_V2DFmode)
                      && GET_MODE (x3) == E_V2DFmode
                      && register_operand (operands[1], E_DFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1241; /* aarch64_simd_dupv2df */
                  break;

                case E_V4BFmode:
                  if (register_operand (operands[0], E_V4BFmode)
                      && GET_MODE (x3) == E_V4BFmode
                      && register_operand (operands[1], E_BFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1242; /* aarch64_simd_dupv4bf */
                  break;

                case E_V8BFmode:
                  if (register_operand (operands[0], E_V8BFmode)
                      && GET_MODE (x3) == E_V8BFmode
                      && register_operand (operands[1], E_BFmode)
                      && 
#line 108 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1243; /* aarch64_simd_dupv8bf */
                  break;

                default:
                  break;
                }
              break;

            case MEM:
              switch (GET_MODE (operands[0]))
                {
                case E_V2SImode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2SImode)
                      && GET_MODE (x3) == E_V2SImode
                      && register_operand (operands[1], E_SImode)
                      && 
#line 237 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1296; /* aarch64_simd_stpv2si */
                  break;

                case E_V2SFmode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2SFmode)
                      && GET_MODE (x3) == E_V2SFmode
                      && register_operand (operands[1], E_SFmode)
                      && 
#line 237 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1297; /* aarch64_simd_stpv2sf */
                  break;

                case E_V2DImode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2DImode)
                      && GET_MODE (x3) == E_V2DImode
                      && register_operand (operands[1], E_DImode)
                      && 
#line 237 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1298; /* aarch64_simd_stpv2di */
                  break;

                case E_V2DFmode:
                  if (aarch64_mem_pair_lanes_operand (operands[0], E_V2DFmode)
                      && GET_MODE (x3) == E_V2DFmode
                      && register_operand (operands[1], E_DFmode)
                      && 
#line 237 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                    return 1299; /* aarch64_simd_stpv2df */
                  break;

                default:
                  break;
                }
              break;

            default:
              break;
            }
          break;

        case MEM:
          switch (GET_MODE (operands[0]))
            {
            case E_V8QImode:
              if (register_operand (operands[0], E_V8QImode)
                  && GET_MODE (x3) == E_V8QImode
                  && aarch64_simd_struct_operand (operands[1], E_QImode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5109; /* *aarch64_simd_ld1rv8qi */
              break;

            case E_V16QImode:
              if (register_operand (operands[0], E_V16QImode)
                  && GET_MODE (x3) == E_V16QImode
                  && aarch64_simd_struct_operand (operands[1], E_QImode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5110; /* *aarch64_simd_ld1rv16qi */
              break;

            case E_V4HImode:
              if (register_operand (operands[0], E_V4HImode)
                  && GET_MODE (x3) == E_V4HImode
                  && aarch64_simd_struct_operand (operands[1], E_HImode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5111; /* *aarch64_simd_ld1rv4hi */
              break;

            case E_V8HImode:
              if (register_operand (operands[0], E_V8HImode)
                  && GET_MODE (x3) == E_V8HImode
                  && aarch64_simd_struct_operand (operands[1], E_HImode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5112; /* *aarch64_simd_ld1rv8hi */
              break;

            case E_V2SImode:
              if (register_operand (operands[0], E_V2SImode)
                  && GET_MODE (x3) == E_V2SImode
                  && aarch64_simd_struct_operand (operands[1], E_SImode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5113; /* *aarch64_simd_ld1rv2si */
              break;

            case E_V4SImode:
              if (register_operand (operands[0], E_V4SImode)
                  && GET_MODE (x3) == E_V4SImode
                  && aarch64_simd_struct_operand (operands[1], E_SImode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5114; /* *aarch64_simd_ld1rv4si */
              break;

            case E_V2DImode:
              if (register_operand (operands[0], E_V2DImode)
                  && GET_MODE (x3) == E_V2DImode
                  && aarch64_simd_struct_operand (operands[1], E_DImode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5115; /* *aarch64_simd_ld1rv2di */
              break;

            case E_V4HFmode:
              if (register_operand (operands[0], E_V4HFmode)
                  && GET_MODE (x3) == E_V4HFmode
                  && aarch64_simd_struct_operand (operands[1], E_HFmode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5116; /* *aarch64_simd_ld1rv4hf */
              break;

            case E_V8HFmode:
              if (register_operand (operands[0], E_V8HFmode)
                  && GET_MODE (x3) == E_V8HFmode
                  && aarch64_simd_struct_operand (operands[1], E_HFmode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5117; /* *aarch64_simd_ld1rv8hf */
              break;

            case E_V4BFmode:
              if (register_operand (operands[0], E_V4BFmode)
                  && GET_MODE (x3) == E_V4BFmode
                  && aarch64_simd_struct_operand (operands[1], E_BFmode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5118; /* *aarch64_simd_ld1rv4bf */
              break;

            case E_V8BFmode:
              if (register_operand (operands[0], E_V8BFmode)
                  && GET_MODE (x3) == E_V8BFmode
                  && aarch64_simd_struct_operand (operands[1], E_BFmode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5119; /* *aarch64_simd_ld1rv8bf */
              break;

            case E_V2SFmode:
              if (register_operand (operands[0], E_V2SFmode)
                  && GET_MODE (x3) == E_V2SFmode
                  && aarch64_simd_struct_operand (operands[1], E_SFmode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5120; /* *aarch64_simd_ld1rv2sf */
              break;

            case E_V4SFmode:
              if (register_operand (operands[0], E_V4SFmode)
                  && GET_MODE (x3) == E_V4SFmode
                  && aarch64_simd_struct_operand (operands[1], E_SFmode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5121; /* *aarch64_simd_ld1rv4sf */
              break;

            case E_V2DFmode:
              if (register_operand (operands[0], E_V2DFmode)
                  && GET_MODE (x3) == E_V2DFmode
                  && aarch64_simd_struct_operand (operands[1], E_DFmode)
                  && 
#line 8817 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
                return 5122; /* *aarch64_simd_ld1rv2df */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL)
        return -1;
      return recog_479 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 int
recog_521 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern12 (x1))
    {
    case 0:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 907; /* lbtruncuhfsi2 */

    case 1:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 927; /* lbtruncusfsi2 */

    case 2:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 947; /* lbtruncudfsi2 */

    case 3:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 917; /* lbtruncuhfdi2 */

    case 4:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 937; /* lbtruncusfdi2 */

    case 5:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 957; /* lbtruncudfdi2 */

    case 6:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2540; /* lbtruncuv4hfv4hi2 */

    case 7:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2550; /* lbtruncuv8hfv8hi2 */

    case 8:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2560; /* lbtruncuv2sfv2si2 */

    case 9:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2570; /* lbtruncuv4sfv4si2 */

    case 10:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2580; /* lbtruncuv2dfv2di2 */

    case 11:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2590; /* lbtruncuhfhi2 */

    case 12:
      if (!
#line 3055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V2SFmode)))))
        return -1;
      return 2600; /* *aarch64_fcvtuv2sfv2si2_mult */

    case 13:
      if (!
#line 3055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V4SFmode)))))
        return -1;
      return 2602; /* *aarch64_fcvtuv4sfv4si2_mult */

    case 14:
      if (!
#line 3055 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD
   && IN_RANGE (aarch64_vec_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (GET_MODE_INNER (V2DFmode)))))
        return -1;
      return 2604; /* *aarch64_fcvtuv2dfv2di2_mult */

    case 15:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 908; /* lceiluhfsi2 */

    case 16:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 928; /* lceilusfsi2 */

    case 17:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 948; /* lceiludfsi2 */

    case 18:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 918; /* lceiluhfdi2 */

    case 19:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 938; /* lceilusfdi2 */

    case 20:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 958; /* lceiludfdi2 */

    case 21:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2541; /* lceiluv4hfv4hi2 */

    case 22:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2551; /* lceiluv8hfv8hi2 */

    case 23:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2561; /* lceiluv2sfv2si2 */

    case 24:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2571; /* lceiluv4sfv4si2 */

    case 25:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2581; /* lceiluv2dfv2di2 */

    case 26:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2591; /* lceiluhfhi2 */

    case 27:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 909; /* lflooruhfsi2 */

    case 28:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 929; /* lfloorusfsi2 */

    case 29:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 949; /* lfloorudfsi2 */

    case 30:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 919; /* lflooruhfdi2 */

    case 31:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 939; /* lfloorusfdi2 */

    case 32:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 959; /* lfloorudfdi2 */

    case 33:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2542; /* lflooruv4hfv4hi2 */

    case 34:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2552; /* lflooruv8hfv8hi2 */

    case 35:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2562; /* lflooruv2sfv2si2 */

    case 36:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2572; /* lflooruv4sfv4si2 */

    case 37:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2582; /* lflooruv2dfv2di2 */

    case 38:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2592; /* lflooruhfhi2 */

    case 39:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 910; /* lrounduhfsi2 */

    case 40:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 930; /* lroundusfsi2 */

    case 41:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 950; /* lroundudfsi2 */

    case 42:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 920; /* lrounduhfdi2 */

    case 43:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 940; /* lroundusfdi2 */

    case 44:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 960; /* lroundudfdi2 */

    case 45:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2543; /* lrounduv4hfv4hi2 */

    case 46:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2553; /* lrounduv8hfv8hi2 */

    case 47:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2563; /* lrounduv2sfv2si2 */

    case 48:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2573; /* lrounduv4sfv4si2 */

    case 49:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2583; /* lrounduv2dfv2di2 */

    case 50:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2593; /* lrounduhfhi2 */

    case 51:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 911; /* lfrintnuhfsi2 */

    case 52:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 931; /* lfrintnusfsi2 */

    case 53:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 951; /* lfrintnudfsi2 */

    case 54:
      if (!(
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
        return -1;
      return 921; /* lfrintnuhfdi2 */

    case 55:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 941; /* lfrintnusfdi2 */

    case 56:
      if (!
#line 6810 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 961; /* lfrintnudfdi2 */

    case 57:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2544; /* lfrintnuv4hfv4hi2 */

    case 58:
      if (!(
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
        return -1;
      return 2554; /* lfrintnuv8hfv8hi2 */

    case 59:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2564; /* lfrintnuv2sfv2si2 */

    case 60:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2574; /* lfrintnuv4sfv4si2 */

    case 61:
      if (!
#line 3017 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 2584; /* lfrintnuv2dfv2di2 */

    case 62:
      if (!
#line 3027 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2594; /* lfrintnuhfhi2 */

    case 63:
      if (!
#line 6821 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (SImode))))
        return -1;
      return 963; /* *aarch64_fcvtusfsi2_mult */

    case 64:
      if (!
#line 6821 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (SImode))))
        return -1;
      return 967; /* *aarch64_fcvtudfsi2_mult */

    case 65:
      if (!
#line 6821 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (DImode))))
        return -1;
      return 965; /* *aarch64_fcvtusfdi2_mult */

    case 66:
      if (!
#line 6821 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT
   && IN_RANGE (aarch64_fpconst_pow_of_2 (operands[2]), 1,
		GET_MODE_BITSIZE (DImode))))
        return -1;
      return 969; /* *aarch64_fcvtudfdi2_mult */

    case 67:
      if (!
#line 6983 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 989; /* fixuns_truncsfsi2 */

    case 68:
      if (!
#line 6995 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 993; /* fixuns_trunchfsi2 */

    case 69:
      if (!
#line 7006 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 997; /* fixuns_truncdfsi2 */

    case 70:
      if (!
#line 6983 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 991; /* fixuns_truncdfdi2 */

    case 71:
      if (!
#line 6995 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FP_F16INST))
        return -1;
      return 995; /* fixuns_trunchfdi2 */

    case 72:
      if (!
#line 7006 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
        return -1;
      return 999; /* fixuns_truncsfdi2 */

    case 73:
      if (!
#line 3035 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD_F16INST))
        return -1;
      return 2596; /* fixuns_trunchfhi2 */

    case 74:
      if (!
#line 3439 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12583; /* fixunsvnx8sfvnx8si2 */

    case 75:
      if (!
#line 3439 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_STREAMING_SME2))
        return -1;
      return 12585; /* fixunsvnx16sfvnx16si2 */

    default:
      return -1;
    }
}

 int
recog_531 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case TRUNCATE:
      operands[1] = x4;
      switch (pattern384 (x3))
        {
        case 0:
          return 351; /* negsi2 */

        case 1:
          return 352; /* negdi2 */

        case 2:
          if ((
#line 7284 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT) && 
#line 60 "../../gcc/config/aarch64/iterators.md"
(TARGET_FP_F16INST)))
            return 1058; /* neghf2 */
          break;

        case 3:
          if (
#line 7284 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return 1059; /* negsf2 */
          break;

        case 4:
          if (
#line 7284 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return 1060; /* negdf2 */
          break;

        case 5:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1584; /* negv8qi2 */
          break;

        case 6:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1587; /* negv16qi2 */
          break;

        case 7:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1588; /* negv4hi2 */
          break;

        case 8:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1591; /* negv8hi2 */
          break;

        case 9:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1592; /* negv2si2 */
          break;

        case 10:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1595; /* negv4si2 */
          break;

        case 11:
          if (
#line 782 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 1596; /* negv2di2 */
          break;

        case 12:
          if ((
#line 2682 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 176 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return 2381; /* negv4hf2 */
          break;

        case 13:
          if ((
#line 2682 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD) && 
#line 177 "../../gcc/config/aarch64/iterators.md"
(TARGET_SIMD_F16INST)))
            return 2384; /* negv8hf2 */
          break;

        case 14:
          if (
#line 2682 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2385; /* negv2sf2 */
          break;

        case 15:
          if (
#line 2682 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2388; /* negv4sf2 */
          break;

        case 16:
          if (
#line 2682 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
            return 2389; /* negv2df2 */
          break;

        default:
          break;
        }
      if (!subreg_lowpart_operator (x4, E_SImode))
        return -1;
      operands[4] = x4;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SIGN_EXTRACT
          || GET_MODE (x5) != E_DImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x7 = XEXP (x5, 1);
      operands[3] = x7;
      if (!aarch64_simd_shift_imm_offset_si (operands[3], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 2);
      operands[2] = x8;
      if (!aarch64_simd_shift_imm_offset_si (operands[2], E_VOIDmode)
          || !
#line 4074 "../../gcc/config/aarch64/aarch64.md"
(INTVAL (operands[2]) + INTVAL (operands[3]) == 32))
        return -1;
      return 375; /* *neg_asr_si2_extr */

    case ASHIFT:
      switch (pattern293 (x3))
        {
        case 0:
          return 366; /* *neg_lsl_si2 */

        case 1:
          return 369; /* *neg_lsl_di2 */

        default:
          return -1;
        }

    case ASHIFTRT:
      switch (pattern293 (x3))
        {
        case 0:
          return 367; /* *neg_asr_si2 */

        case 1:
          return 370; /* *neg_asr_di2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern293 (x3))
        {
        case 0:
          return 368; /* *neg_lsr_si2 */

        case 1:
          return 371; /* *neg_lsr_di2 */

        default:
          return -1;
        }

    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      return recog_466 (x1, insn, pnum_clobbers);

    case FMA:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x9 = XEXP (x4, 1);
      operands[3] = x9;
      x10 = XEXP (x4, 2);
      operands[1] = x10;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern739 (x3, 
E_SFmode) != 0
              || !
#line 6920 "../../gcc/config/aarch64/aarch64.md"
(!HONOR_SIGNED_ZEROS (SFmode) && TARGET_FLOAT))
            return -1;
          return 980; /* *aarch64_fnmaddsf4 */

        case E_DFmode:
          if (pattern739 (x3, 
E_DFmode) != 0
              || !
#line 6920 "../../gcc/config/aarch64/aarch64.md"
(!HONOR_SIGNED_ZEROS (DFmode) && TARGET_FLOAT))
            return -1;
          return 981; /* *aarch64_fnmadddf4 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x9 = XEXP (x4, 1);
      operands[2] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_SFmode:
          if (pattern362 (x3, 
E_SFmode) != 0
              || !
#line 7255 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1053; /* *fnmulsf3 */

        case E_DFmode:
          if (pattern362 (x3, 
E_DFmode) != 0
              || !
#line 7255 "../../gcc/config/aarch64/aarch64.md"
(TARGET_FLOAT))
            return -1;
          return 1054; /* *fnmuldf3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_537 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 869; /* bswapsi2 */

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 870; /* bswapdi2 */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 871; /* bswaphi2 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode)
          || !
#line 372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1376; /* bswapv4hi2 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1377; /* bswapv8hi2 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode)
          || !
#line 372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1378; /* bswapv2si2 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1379; /* bswapv4si2 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 372 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD))
        return -1;
      return 1380; /* bswapv2di2 */

    default:
      return -1;
    }
}

 int
recog_546 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10123; /* while_wrsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10133; /* while_wrdivnx8bi_ptest */
}

 int
recog_550 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10043; /* *while_wrsivnx8bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3441 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10053; /* *while_wrdivnx8bi_cc */
}

 int
recog_554 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10122; /* while_rwsivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10132; /* while_rwdivnx8bi_ptest */
}

 int
recog_558 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10042; /* *while_rwsivnx8bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3440 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10052; /* *while_rwdivnx8bi_cc */
}

 int
recog_566 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3439 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10041; /* *while_ugesivnx8bi_cc */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8438 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3439 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10051; /* *while_ugedivnx8bi_cc */
}

 int
recog_576 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10159; /* while_gtsivnx2bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3437 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10169; /* while_gtdivnx2bi_ptest */
}

 int
recog_586 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (aarch64_reg_or_zero (operands[1], E_SImode)
      && aarch64_reg_or_zero (operands[2], E_SImode)
      && (
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return 10118; /* while_gesivnx8bi_ptest */
  if (!aarch64_reg_or_zero (operands[1], E_DImode)
      || !aarch64_reg_or_zero (operands[2], E_DImode)
      || !(
#line 8463 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3436 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2)))
    return -1;
  return 10128; /* while_gedivnx8bi_ptest */
}

 int
recog_596 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 1);
  operands[4] = x4;
  x5 = XVECEXP (x3, 0, 2);
  operands[5] = x5;
  x6 = XVECEXP (x3, 0, 3);
  x7 = XVECEXP (x6, 0, 0);
  operands[6] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[7] = x8;
  if (!aarch64_sve_ptrue_flag (operands[7], E_SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  switch (GET_CODE (x9))
    {
    case LT:
      switch (pattern1320 (x1, 
LT))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9544; /* *cmpltvnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9554; /* *cmpltvnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9584; /* *cmpltvnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9564; /* *cmpltvnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9594; /* *cmpltvnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9614; /* *cmpltvnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9574; /* *cmpltvnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9604; /* *cmpltvnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9624; /* *cmpltvnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9634; /* *cmpltvnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9644; /* *cmpltvnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9654; /* *cmpltvnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9684; /* *cmpltvnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9664; /* *cmpltvnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9694; /* *cmpltvnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9714; /* *cmpltvnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9674; /* *cmpltvnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9704; /* *cmpltvnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9724; /* *cmpltvnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9734; /* *cmpltvnx2di_ptest */

        default:
          return -1;
        }

    case LE:
      switch (pattern1320 (x1, 
LE))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9545; /* *cmplevnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9555; /* *cmplevnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9585; /* *cmplevnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9565; /* *cmplevnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9595; /* *cmplevnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9615; /* *cmplevnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9575; /* *cmplevnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9605; /* *cmplevnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9625; /* *cmplevnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9635; /* *cmplevnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9645; /* *cmplevnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9655; /* *cmplevnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9685; /* *cmplevnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9665; /* *cmplevnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9695; /* *cmplevnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9715; /* *cmplevnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9675; /* *cmplevnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9705; /* *cmplevnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9725; /* *cmplevnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9735; /* *cmplevnx2di_ptest */

        default:
          return -1;
        }

    case EQ:
      switch (pattern1320 (x1, 
EQ))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9546; /* *cmpeqvnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9556; /* *cmpeqvnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9586; /* *cmpeqvnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9566; /* *cmpeqvnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9596; /* *cmpeqvnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9616; /* *cmpeqvnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9576; /* *cmpeqvnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9606; /* *cmpeqvnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9626; /* *cmpeqvnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9636; /* *cmpeqvnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9646; /* *cmpeqvnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9656; /* *cmpeqvnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9686; /* *cmpeqvnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9666; /* *cmpeqvnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9696; /* *cmpeqvnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9716; /* *cmpeqvnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9676; /* *cmpeqvnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9706; /* *cmpeqvnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9726; /* *cmpeqvnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9736; /* *cmpeqvnx2di_ptest */

        default:
          return -1;
        }

    case NE:
      switch (pattern1320 (x1, 
NE))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9547; /* *cmpnevnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9557; /* *cmpnevnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9587; /* *cmpnevnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9567; /* *cmpnevnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9597; /* *cmpnevnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9617; /* *cmpnevnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9577; /* *cmpnevnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9607; /* *cmpnevnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9627; /* *cmpnevnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9637; /* *cmpnevnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9647; /* *cmpnevnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9657; /* *cmpnevnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9687; /* *cmpnevnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9667; /* *cmpnevnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9697; /* *cmpnevnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9717; /* *cmpnevnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9677; /* *cmpnevnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9707; /* *cmpnevnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9727; /* *cmpnevnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9737; /* *cmpnevnx2di_ptest */

        default:
          return -1;
        }

    case GE:
      switch (pattern1320 (x1, 
GE))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9548; /* *cmpgevnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9558; /* *cmpgevnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9588; /* *cmpgevnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9568; /* *cmpgevnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9598; /* *cmpgevnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9618; /* *cmpgevnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9578; /* *cmpgevnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9608; /* *cmpgevnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9628; /* *cmpgevnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9638; /* *cmpgevnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9648; /* *cmpgevnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9658; /* *cmpgevnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9688; /* *cmpgevnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9668; /* *cmpgevnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9698; /* *cmpgevnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9718; /* *cmpgevnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9678; /* *cmpgevnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9708; /* *cmpgevnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9728; /* *cmpgevnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9738; /* *cmpgevnx2di_ptest */

        default:
          return -1;
        }

    case GT:
      switch (pattern1320 (x1, 
GT))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9549; /* *cmpgtvnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9559; /* *cmpgtvnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9589; /* *cmpgtvnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9569; /* *cmpgtvnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9599; /* *cmpgtvnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9619; /* *cmpgtvnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9579; /* *cmpgtvnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9609; /* *cmpgtvnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9629; /* *cmpgtvnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9639; /* *cmpgtvnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9649; /* *cmpgtvnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9659; /* *cmpgtvnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9689; /* *cmpgtvnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9669; /* *cmpgtvnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9699; /* *cmpgtvnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9719; /* *cmpgtvnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9679; /* *cmpgtvnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9709; /* *cmpgtvnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9729; /* *cmpgtvnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9739; /* *cmpgtvnx2di_ptest */

        default:
          return -1;
        }

    case LTU:
      switch (pattern1324 (x1, 
LTU))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9550; /* *cmplovnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9560; /* *cmplovnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9590; /* *cmplovnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9570; /* *cmplovnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9600; /* *cmplovnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9620; /* *cmplovnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9580; /* *cmplovnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9610; /* *cmplovnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9630; /* *cmplovnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9640; /* *cmplovnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9650; /* *cmplovnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9660; /* *cmplovnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9690; /* *cmplovnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9670; /* *cmplovnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9700; /* *cmplovnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9720; /* *cmplovnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9680; /* *cmplovnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9710; /* *cmplovnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9730; /* *cmplovnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9740; /* *cmplovnx2di_ptest */

        default:
          return -1;
        }

    case LEU:
      switch (pattern1324 (x1, 
LEU))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9551; /* *cmplsvnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9561; /* *cmplsvnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9591; /* *cmplsvnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9571; /* *cmplsvnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9601; /* *cmplsvnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9621; /* *cmplsvnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9581; /* *cmplsvnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9611; /* *cmplsvnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9631; /* *cmplsvnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9641; /* *cmplsvnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9651; /* *cmplsvnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9661; /* *cmplsvnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9691; /* *cmplsvnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9671; /* *cmplsvnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9701; /* *cmplsvnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9721; /* *cmplsvnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9681; /* *cmplsvnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9711; /* *cmplsvnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9731; /* *cmplsvnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9741; /* *cmplsvnx2di_ptest */

        default:
          return -1;
        }

    case GEU:
      switch (pattern1324 (x1, 
GEU))
        {
        case 0:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9552; /* *cmphsvnx16qi_cc */

        case 1:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9562; /* *cmphsvnx8qi_cc */

        case 2:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9592; /* *cmphsvnx8hi_cc */

        case 3:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9572; /* *cmphsvnx4qi_cc */

        case 4:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9602; /* *cmphsvnx4hi_cc */

        case 5:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9622; /* *cmphsvnx4si_cc */

        case 6:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9582; /* *cmphsvnx2qi_cc */

        case 7:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9612; /* *cmphsvnx2hi_cc */

        case 8:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9632; /* *cmphsvnx2si_cc */

        case 9:
          if (!
#line 8219 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9642; /* *cmphsvnx2di_cc */

        case 10:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9652; /* *cmphsvnx16qi_ptest */

        case 11:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9662; /* *cmphsvnx8qi_ptest */

        case 12:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9692; /* *cmphsvnx8hi_ptest */

        case 13:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9672; /* *cmphsvnx4qi_ptest */

        case 14:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9702; /* *cmphsvnx4hi_ptest */

        case 15:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9722; /* *cmphsvnx4si_ptest */

        case 16:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9682; /* *cmphsvnx2qi_ptest */

        case 17:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9712; /* *cmphsvnx2hi_ptest */

        case 18:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9732; /* *cmphsvnx2si_ptest */

        case 19:
          if (!
#line 8253 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && aarch64_sve_same_pred_for_ptest_p (&operands[4], &operands[6])))
            return -1;
          return 9742; /* *cmphsvnx2di_ptest */

        default:
          return -1;
        }

    case GTU:
      return recog_595 (x1, insn, pnum_clobbers);

    case UNSPEC:
      return recog_594 (x1, insn, pnum_clobbers);

    default:
      return -1;
    }
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
    case MEM:
      switch (pattern458 (x2))
        {
        case 0:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16QImode)
       || register_operand (operands[2], VNx16QImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx16QImode)
   && register_operand (operands[2], VNx16QImode))))
            return NULL;
          return gen_split_428 (insn, operands);

        case 1:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8QImode)
       || register_operand (operands[2], VNx8QImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8QImode)
   && register_operand (operands[2], VNx8QImode))))
            return NULL;
          return gen_split_429 (insn, operands);

        case 2:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4QImode)
       || register_operand (operands[2], VNx4QImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4QImode)
   && register_operand (operands[2], VNx4QImode))))
            return NULL;
          return gen_split_430 (insn, operands);

        case 3:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2QImode)
       || register_operand (operands[2], VNx2QImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2QImode)
   && register_operand (operands[2], VNx2QImode))))
            return NULL;
          return gen_split_431 (insn, operands);

        case 4:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8HImode)
       || register_operand (operands[2], VNx8HImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8HImode)
   && register_operand (operands[2], VNx8HImode))))
            return NULL;
          return gen_split_432 (insn, operands);

        case 5:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4HImode)
       || register_operand (operands[2], VNx4HImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4HImode)
   && register_operand (operands[2], VNx4HImode))))
            return NULL;
          return gen_split_433 (insn, operands);

        case 6:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2HImode)
       || register_operand (operands[2], VNx2HImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2HImode)
   && register_operand (operands[2], VNx2HImode))))
            return NULL;
          return gen_split_434 (insn, operands);

        case 7:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4SImode)
       || register_operand (operands[2], VNx4SImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4SImode)
   && register_operand (operands[2], VNx4SImode))))
            return NULL;
          return gen_split_435 (insn, operands);

        case 8:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2SImode)
       || register_operand (operands[2], VNx2SImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2SImode)
   && register_operand (operands[2], VNx2SImode))))
            return NULL;
          return gen_split_436 (insn, operands);

        case 9:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2DImode)
       || register_operand (operands[2], VNx2DImode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2DImode)
   && register_operand (operands[2], VNx2DImode))))
            return NULL;
          return gen_split_437 (insn, operands);

        case 10:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8HFmode)
       || register_operand (operands[2], VNx8HFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8HFmode)
   && register_operand (operands[2], VNx8HFmode))))
            return NULL;
          return gen_split_438 (insn, operands);

        case 11:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4HFmode)
       || register_operand (operands[2], VNx4HFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4HFmode)
   && register_operand (operands[2], VNx4HFmode))))
            return NULL;
          return gen_split_439 (insn, operands);

        case 12:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2HFmode)
       || register_operand (operands[2], VNx2HFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2HFmode)
   && register_operand (operands[2], VNx2HFmode))))
            return NULL;
          return gen_split_440 (insn, operands);

        case 13:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8BFmode)
       || register_operand (operands[2], VNx8BFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx8BFmode)
   && register_operand (operands[2], VNx8BFmode))))
            return NULL;
          return gen_split_441 (insn, operands);

        case 14:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4BFmode)
       || register_operand (operands[2], VNx4BFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4BFmode)
   && register_operand (operands[2], VNx4BFmode))))
            return NULL;
          return gen_split_442 (insn, operands);

        case 15:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2BFmode)
       || register_operand (operands[2], VNx2BFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2BFmode)
   && register_operand (operands[2], VNx2BFmode))))
            return NULL;
          return gen_split_443 (insn, operands);

        case 16:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4SFmode)
       || register_operand (operands[2], VNx4SFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx4SFmode)
   && register_operand (operands[2], VNx4SFmode))))
            return NULL;
          return gen_split_444 (insn, operands);

        case 17:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2SFmode)
       || register_operand (operands[2], VNx2SFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2SFmode)
   && register_operand (operands[2], VNx2SFmode))))
            return NULL;
          return gen_split_445 (insn, operands);

        case 18:
          if (!(
#line 753 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx2DFmode)
       || register_operand (operands[2], VNx2DFmode))) && 
#line 761 "../../gcc/config/aarch64/aarch64-sve.md"
( register_operand (operands[0], VNx2DFmode)
   && register_operand (operands[2], VNx2DFmode))))
            return NULL;
          return gen_split_446 (insn, operands);

        case 19:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32QImode)
       || register_operand (operands[2], VNx32QImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_533 (insn, operands);

        case 20:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16HImode)
       || register_operand (operands[2], VNx16HImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_534 (insn, operands);

        case 21:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8SImode)
       || register_operand (operands[2], VNx8SImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_535 (insn, operands);

        case 22:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4DImode)
       || register_operand (operands[2], VNx4DImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_536 (insn, operands);

        case 23:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16BFmode)
       || register_operand (operands[2], VNx16BFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_537 (insn, operands);

        case 24:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16HFmode)
       || register_operand (operands[2], VNx16HFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_538 (insn, operands);

        case 25:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8SFmode)
       || register_operand (operands[2], VNx8SFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_539 (insn, operands);

        case 26:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx4DFmode)
       || register_operand (operands[2], VNx4DFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_540 (insn, operands);

        case 27:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx48QImode)
       || register_operand (operands[2], VNx48QImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_541 (insn, operands);

        case 28:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24HImode)
       || register_operand (operands[2], VNx24HImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_542 (insn, operands);

        case 29:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx12SImode)
       || register_operand (operands[2], VNx12SImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_543 (insn, operands);

        case 30:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx6DImode)
       || register_operand (operands[2], VNx6DImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_544 (insn, operands);

        case 31:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24BFmode)
       || register_operand (operands[2], VNx24BFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_545 (insn, operands);

        case 32:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx24HFmode)
       || register_operand (operands[2], VNx24HFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_546 (insn, operands);

        case 33:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx12SFmode)
       || register_operand (operands[2], VNx12SFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_547 (insn, operands);

        case 34:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx6DFmode)
       || register_operand (operands[2], VNx6DFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_548 (insn, operands);

        case 35:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx64QImode)
       || register_operand (operands[2], VNx64QImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_549 (insn, operands);

        case 36:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32HImode)
       || register_operand (operands[2], VNx32HImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_550 (insn, operands);

        case 37:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16SImode)
       || register_operand (operands[2], VNx16SImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_551 (insn, operands);

        case 38:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8DImode)
       || register_operand (operands[2], VNx8DImode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_552 (insn, operands);

        case 39:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32BFmode)
       || register_operand (operands[2], VNx32BFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_553 (insn, operands);

        case 40:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx32HFmode)
       || register_operand (operands[2], VNx32HFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_554 (insn, operands);

        case 41:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx16SFmode)
       || register_operand (operands[2], VNx16SFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_555 (insn, operands);

        case 42:
          if (!(
#line 904 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && (register_operand (operands[0], VNx8DFmode)
       || register_operand (operands[2], VNx8DFmode))) && 
#line 908 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
            return NULL;
          return gen_split_556 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC)
        return NULL;
      return split_3 (x1, insn);

    case ZERO_EXTEND:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != UNSPEC)
        return NULL;
      return split_4 (x1, insn);

    case MULT:
      switch (pattern462 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1189 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1194 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1199 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1204 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1209 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1214 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1219 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1224 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1229 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1234 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1239 (insn, operands);

        default:
          return NULL;
        }

    case SMAX:
      switch (pattern462 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1190 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1195 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1200 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1205 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1210 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1215 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1220 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1225 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1230 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1235 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1240 (insn, operands);

        default:
          return NULL;
        }

    case SMIN:
      switch (pattern465 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1191 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1196 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1201 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1206 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1211 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1216 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1221 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1226 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1231 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1236 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1241 (insn, operands);

        case 11:
          if (!(
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 810 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2794 (insn, operands);

        case 12:
          if (!(
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 810 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2796 (insn, operands);

        case 13:
          if (!(
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 810 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2798 (insn, operands);

        case 14:
          if (!(
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 810 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2800 (insn, operands);

        default:
          return NULL;
        }

    case UMAX:
      switch (pattern467 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1192 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1197 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1202 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1207 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1212 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1217 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1222 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1227 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1232 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1237 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1242 (insn, operands);

        default:
          return NULL;
        }

    case UMIN:
      switch (pattern468 (x2))
        {
        case 0:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1193 (insn, operands);

        case 1:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1198 (insn, operands);

        case 2:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1203 (insn, operands);

        case 3:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1208 (insn, operands);

        case 4:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1213 (insn, operands);

        case 5:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1218 (insn, operands);

        case 6:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1223 (insn, operands);

        case 7:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1228 (insn, operands);

        case 8:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1233 (insn, operands);

        case 9:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1238 (insn, operands);

        case 10:
          if (!(
#line 3951 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 3960 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], V2DImode))))
            return NULL;
          return gen_split_1243 (insn, operands);

        case 11:
          if (!(
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 810 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2795 (insn, operands);

        case 12:
          if (!(
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 810 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2797 (insn, operands);

        case 13:
          if (!(
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 810 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2799 (insn, operands);

        case 14:
          if (!(
#line 805 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2p1_OR_SME) && 
#line 810 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
            return NULL;
          return gen_split_2801 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFT:
      switch (pattern472 (x2))
        {
        case 0:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1508 (insn, operands);

        case 1:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1511 (insn, operands);

        case 2:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1514 (insn, operands);

        case 3:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1517 (insn, operands);

        case 4:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1520 (insn, operands);

        case 5:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1523 (insn, operands);

        case 6:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1526 (insn, operands);

        case 7:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1529 (insn, operands);

        case 8:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1532 (insn, operands);

        case 9:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1535 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      switch (pattern594 (x2))
        {
        case 0:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1509 (insn, operands);

        case 1:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1512 (insn, operands);

        case 2:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1515 (insn, operands);

        case 3:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1518 (insn, operands);

        case 4:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1521 (insn, operands);

        case 5:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1524 (insn, operands);

        case 6:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1527 (insn, operands);

        case 7:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1530 (insn, operands);

        case 8:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1533 (insn, operands);

        case 9:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1536 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XVECEXP (x2, 0, 0);
      operands[1] = x5;
      switch (pattern594 (x2))
        {
        case 0:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx16QImode))))
            return NULL;
          return gen_split_1510 (insn, operands);

        case 1:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8QImode))))
            return NULL;
          return gen_split_1513 (insn, operands);

        case 2:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4QImode))))
            return NULL;
          return gen_split_1516 (insn, operands);

        case 3:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2QImode))))
            return NULL;
          return gen_split_1519 (insn, operands);

        case 4:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx8HImode))))
            return NULL;
          return gen_split_1522 (insn, operands);

        case 5:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4HImode))))
            return NULL;
          return gen_split_1525 (insn, operands);

        case 6:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2HImode))))
            return NULL;
          return gen_split_1528 (insn, operands);

        case 7:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx4SImode))))
            return NULL;
          return gen_split_1531 (insn, operands);

        case 8:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2SImode))))
            return NULL;
          return gen_split_1534 (insn, operands);

        case 9:
          if (!(
#line 4890 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 4897 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && !register_operand (operands[3], VNx2DImode))))
            return NULL;
          return gen_split_1537 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      switch (pattern474 (x2))
        {
        case 0:
          if (!(
#line 1627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1632 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2970 (insn, operands);

        case 1:
          if (!(
#line 1627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1632 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2971 (insn, operands);

        case 2:
          if (!(
#line 1627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1632 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2972 (insn, operands);

        case 3:
          if (!(
#line 1627 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1632 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2973 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern474 (x2))
        {
        case 0:
          if (!(
#line 1649 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1654 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2974 (insn, operands);

        case 1:
          if (!(
#line 1649 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1654 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2975 (insn, operands);

        case 2:
          if (!(
#line 1649 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1654 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2976 (insn, operands);

        case 3:
          if (!(
#line 1649 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1654 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[3]))))
            return NULL;
          return gen_split_2977 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != XOR)
        return NULL;
      switch (pattern592 (x2))
        {
        case 0:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 1724 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1729 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return gen_split_2978 (insn, operands);
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 1724 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1729 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2979 (insn, operands);

        case 1:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 1724 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1729 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return gen_split_2980 (insn, operands);
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 1724 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1729 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2981 (insn, operands);

        case 2:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 1724 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1729 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return gen_split_2982 (insn, operands);
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 1724 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1729 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2983 (insn, operands);

        case 3:
          x6 = XEXP (x4, 1);
          if (rtx_equal_p (x6, operands[1])
              && (
#line 1724 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1729 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return gen_split_2984 (insn, operands);
          if (!rtx_equal_p (x6, operands[2])
              || !(
#line 1724 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE2) && 
#line 1729 "../../gcc/config/aarch64/aarch64-sve2.md"
( !CONSTANT_P (operands[4]))))
            return NULL;
          return gen_split_2985 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_73 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      switch (pattern700 (x2))
        {
        case 0:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1244 (insn, operands);

        case 1:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1261 (insn, operands);

        case 2:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1278 (insn, operands);

        case 3:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1295 (insn, operands);

        case 4:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1312 (insn, operands);

        case 5:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1329 (insn, operands);

        case 6:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1346 (insn, operands);

        case 7:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1363 (insn, operands);

        case 8:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1380 (insn, operands);

        case 9:
          if (!(
#line 4039 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[4])
   && !rtx_equal_p (operands[3], operands[4])) && 
#line 4049 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[4], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[4]))))
            return NULL;
          return gen_split_1397 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[3] = x6;
      x7 = XEXP (x3, 1);
      operands[4] = x7;
      x8 = XVECEXP (x2, 0, 2);
      operands[5] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_VNx16QImode:
          if (pattern1100 (x2, 
E_VNx16QImode, 
E_VNx16BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx16QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1991 (insn, operands);

        case E_VNx8QImode:
          if (pattern1100 (x2, 
E_VNx8QImode, 
E_VNx8BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1992 (insn, operands);

        case E_VNx4QImode:
          if (pattern1100 (x2, 
E_VNx4QImode, 
E_VNx4BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1993 (insn, operands);

        case E_VNx2QImode:
          if (pattern1100 (x2, 
E_VNx2QImode, 
E_VNx2BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2QImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1994 (insn, operands);

        case E_VNx8HImode:
          if (pattern1100 (x2, 
E_VNx8HImode, 
E_VNx8BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx8HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1995 (insn, operands);

        case E_VNx4HImode:
          if (pattern1100 (x2, 
E_VNx4HImode, 
E_VNx4BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1996 (insn, operands);

        case E_VNx2HImode:
          if (pattern1100 (x2, 
E_VNx2HImode, 
E_VNx2BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2HImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1997 (insn, operands);

        case E_VNx4SImode:
          if (pattern1100 (x2, 
E_VNx4SImode, 
E_VNx4BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx4SImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1998 (insn, operands);

        case E_VNx2SImode:
          if (pattern1100 (x2, 
E_VNx2SImode, 
E_VNx2BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2SImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_1999 (insn, operands);

        case E_VNx2DImode:
          if (pattern1100 (x2, 
E_VNx2DImode, 
E_VNx2BImode) != 0
              || !(
#line 7118 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && !rtx_equal_p (operands[2], operands[5])
   && !rtx_equal_p (operands[3], operands[5])
   && !rtx_equal_p (operands[4], operands[5])) && 
#line 7130 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed
   && register_operand (operands[5], VNx2DImode)
   && !rtx_equal_p (operands[0], operands[5]))))
            return NULL;
          return gen_split_2000 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_77 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 204:
          x4 = XVECEXP (x2, 0, 0);
          switch (GET_CODE (x4))
            {
            case PLUS:
              switch (pattern478 (x2))
                {
                case 0:
                  if (!(
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_159 (insn, operands);

                case 1:
                  if (!(
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_161 (insn, operands);

                case 2:
                  if (!(
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_163 (insn, operands);

                case 3:
                  if (!(
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_165 (insn, operands);

                case 4:
                  if (!(
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_167 (insn, operands);

                case 5:
                  if (!(
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_169 (insn, operands);

                case 6:
                  if (!(
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_160 (insn, operands);

                case 7:
                  if (!(
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_162 (insn, operands);

                case 8:
                  if (!(
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_164 (insn, operands);

                case 9:
                  if (!(
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_166 (insn, operands);

                case 10:
                  if (!(
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_168 (insn, operands);

                case 11:
                  if (!(
#line 3458 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3460 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_170 (insn, operands);

                default:
                  return NULL;
                }

            case ZERO_EXTEND:
              x5 = XEXP (x4, 0);
              if (GET_CODE (x5) != PLUS)
                return NULL;
              switch (pattern597 (x2))
                {
                case 0:
                  if (!(
#line 3485 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3487 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_171 (insn, operands);

                case 1:
                  if (!(
#line 3485 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3487 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_172 (insn, operands);

                case 2:
                  if (!(
#line 3485 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3487 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_173 (insn, operands);

                case 3:
                  if (!(
#line 3485 "../../gcc/config/aarch64/aarch64-simd.md"
(TARGET_SIMD && !aarch64_pars_overlap_p (operands[2], operands[3])) && 
#line 3487 "../../gcc/config/aarch64/aarch64-simd.md"
( 1)))
                    return NULL;
                  return gen_split_174 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 153:
          switch (pattern372 (x2))
            {
            case 0:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_466 (insn, operands);

            case 1:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_467 (insn, operands);

            case 2:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_468 (insn, operands);

            case 3:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_469 (insn, operands);

            case 4:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_470 (insn, operands);

            case 5:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_471 (insn, operands);

            case 6:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_472 (insn, operands);

            case 7:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_473 (insn, operands);

            case 8:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_474 (insn, operands);

            case 9:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_475 (insn, operands);

            case 10:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_476 (insn, operands);

            case 11:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_477 (insn, operands);

            case 12:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_478 (insn, operands);

            case 13:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_479 (insn, operands);

            case 14:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_480 (insn, operands);

            case 15:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_481 (insn, operands);

            case 16:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_482 (insn, operands);

            case 17:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_483 (insn, operands);

            case 18:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_484 (insn, operands);

            case 19:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_485 (insn, operands);

            case 20:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_486 (insn, operands);

            case 21:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_487 (insn, operands);

            case 22:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_488 (insn, operands);

            case 23:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_489 (insn, operands);

            case 24:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_490 (insn, operands);

            case 25:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_491 (insn, operands);

            case 26:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_492 (insn, operands);

            case 27:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_493 (insn, operands);

            case 28:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_494 (insn, operands);

            case 29:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_495 (insn, operands);

            case 30:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_496 (insn, operands);

            case 31:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_497 (insn, operands);

            case 32:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_498 (insn, operands);

            case 33:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_499 (insn, operands);

            case 34:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_500 (insn, operands);

            case 35:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_501 (insn, operands);

            case 36:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_502 (insn, operands);

            case 37:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_503 (insn, operands);

            case 38:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_504 (insn, operands);

            case 39:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_505 (insn, operands);

            case 40:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_506 (insn, operands);

            case 41:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_507 (insn, operands);

            case 42:
              if (!(
#line 812 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 814 "../../gcc/config/aarch64/aarch64-sve.md"
( reload_completed)))
                return NULL;
              return gen_split_508 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 2:
      return split_76 (x1, insn);

    case 7:
      x6 = XVECEXP (x2, 0, 2);
      if (GET_CODE (x6) != UNSPEC
          || XVECLEN (x6, 0) != 2
          || XINT (x6, 1) != 125
          || GET_MODE (x6) != E_VNx2DImode)
        return NULL;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      x4 = XVECEXP (x2, 0, 0);
      operands[5] = x4;
      if (!register_operand (operands[5], E_VNx2BImode))
        return NULL;
      x7 = XVECEXP (x2, 0, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode))
        return NULL;
      x8 = XVECEXP (x6, 0, 0);
      operands[6] = x8;
      x9 = XVECEXP (x6, 0, 1);
      if (GET_MODE (x9) != E_VNx2DImode)
        return NULL;
      x10 = XVECEXP (x2, 0, 3);
      operands[3] = x10;
      if (!const_int_operand (operands[3], E_DImode))
        return NULL;
      x11 = XVECEXP (x2, 0, 4);
      operands[4] = x11;
      switch (XINT (x2, 1))
        {
        case 120:
          x12 = XVECEXP (x2, 0, 6);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return NULL;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != SCRATCH)
            return NULL;
          switch (pattern1299 (x2))
            {
            case 0:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_855 (insn, operands);

            case 1:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_857 (insn, operands);

            case 2:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_859 (insn, operands);

            case 3:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_861 (insn, operands);

            case 4:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_863 (insn, operands);

            case 5:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_865 (insn, operands);

            case 6:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_867 (insn, operands);

            case 7:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_869 (insn, operands);

            case 8:
              if (!(
#line 1597 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_871 (insn, operands);

            case 9:
              if (!(
#line 1597 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_872 (insn, operands);

            case 10:
              if (!(
#line 1597 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_873 (insn, operands);

            case 11:
              if (!(
#line 1597 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_874 (insn, operands);

            case 12:
              if (!(
#line 1597 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_875 (insn, operands);

            case 13:
              if (!(
#line 1597 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_876 (insn, operands);

            case 14:
              if (!(
#line 1597 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_877 (insn, operands);

            case 15:
              if (!(
#line 1597 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1604 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_878 (insn, operands);

            case 16:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_856 (insn, operands);

            case 17:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_858 (insn, operands);

            case 18:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_860 (insn, operands);

            case 19:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_862 (insn, operands);

            case 20:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_864 (insn, operands);

            case 21:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_866 (insn, operands);

            case 22:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_868 (insn, operands);

            case 23:
              if (!(
#line 1566 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1573 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_870 (insn, operands);

            default:
              return NULL;
            }

        case 121:
          if (GET_CODE (x9) != SIGN_EXTEND)
            return NULL;
          x14 = XEXP (x9, 0);
          if (GET_CODE (x14) != TRUNCATE
              || GET_MODE (x14) != E_VNx2SImode
              || pattern255 (x2) != 0)
            return NULL;
          switch (pattern1346 (x2))
            {
            case 0:
              if (!(
#line 1911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1918 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_977 (insn, operands);

            case 1:
              if (!(
#line 1911 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE && TARGET_NON_STREAMING) && 
#line 1918 "../../gcc/config/aarch64/aarch64-sve.md"
( !CONSTANT_P (operands[6]))))
                return NULL;
              return gen_split_978 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 6:
      return split_75 (x1, insn);

    case 3:
      return split_74 (x1, insn);

    case 4:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (XINT (x2, 1))
        {
        case 351:
          switch (pattern452 (x2))
            {
            case 0:
              if (!(
#line 5358 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return NULL;
              return gen_split_1657 (insn, operands);

            case 1:
              if (!
#line 5358 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1660 (insn, operands);

            case 2:
              if (!
#line 5358 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1663 (insn, operands);

            case 3:
              if (!
#line 5358 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1666 (insn, operands);

            default:
              return NULL;
            }

        case 392:
          switch (pattern452 (x2))
            {
            case 0:
              if (!(
#line 5358 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return NULL;
              return gen_split_1658 (insn, operands);

            case 1:
              if (!
#line 5358 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1661 (insn, operands);

            case 2:
              if (!
#line 5358 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1664 (insn, operands);

            case 3:
              if (!
#line 5358 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1667 (insn, operands);

            default:
              return NULL;
            }

        case 377:
          switch (pattern452 (x2))
            {
            case 0:
              if (!(
#line 5358 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP) && 
#line 488 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16)))
                return NULL;
              return gen_split_1659 (insn, operands);

            case 1:
              if (!
#line 5358 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1662 (insn, operands);

            case 2:
              if (!
#line 5358 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1665 (insn, operands);

            case 3:
              if (!
#line 5358 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE
   && reload_completed
   && INTVAL (operands[4]) == SVE_RELAXED_GP))
                return NULL;
              return gen_split_1668 (insn, operands);

            default:
              return NULL;
            }

        case 357:
          switch (pattern454 (x2))
            {
            case 0:
              if (!(
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2630 (insn, operands);

            case 1:
              if (!(
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2634 (insn, operands);

            case 2:
              if (!(
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2638 (insn, operands);

            default:
              return NULL;
            }

        case 358:
          switch (pattern454 (x2))
            {
            case 0:
              if (!(
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2631 (insn, operands);

            case 1:
              if (!(
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2635 (insn, operands);

            case 2:
              if (!(
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2639 (insn, operands);

            default:
              return NULL;
            }

        case 363:
          switch (pattern454 (x2))
            {
            case 0:
              if (!(
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2632 (insn, operands);

            case 1:
              if (!(
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2636 (insn, operands);

            case 2:
              if (!(
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2640 (insn, operands);

            default:
              return NULL;
            }

        case 364:
          switch (pattern454 (x2))
            {
            case 0:
              if (!(
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2633 (insn, operands);

            case 1:
              if (!(
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2637 (insn, operands);

            case 2:
              if (!(
#line 8785 "../../gcc/config/aarch64/aarch64-sve.md"
(TARGET_SVE) && 
#line 8787 "../../gcc/config/aarch64/aarch64-sve.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_2641 (insn, operands);

            default:
              return NULL;
            }

        case 374:
          x7 = XVECEXP (x2, 0, 1);
          if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x6 = XVECEXP (x2, 0, 2);
          if (pattern479 (x6, 
372) != 0)
            return NULL;
          switch (pattern918 (x2))
            {
            case 0:
              if (!(
#line 491 "../../gcc/config/aarch64/iterators.md"
(TARGET_SSVE_B16B16) && 
#line 1399 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
                return NULL;
              return gen_split_2962 (insn, operands);

            case 1:
              if (!(
#line 492 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2) && 
#line 1399 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
                return NULL;
              return gen_split_2963 (insn, operands);

            case 2:
              if (!(
#line 493 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2) && 
#line 1399 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
                return NULL;
              return gen_split_2964 (insn, operands);

            case 3:
              if (!(
#line 494 "../../gcc/config/aarch64/iterators.md"
(TARGET_SVE2p1_OR_SME2) && 
#line 1399 "../../gcc/config/aarch64/aarch64-sve2.md"
( true)))
                return NULL;
              return gen_split_2965 (insn, operands);

            default:
              return NULL;
            }

        case 394:
          switch (pattern455 (x2))
            {
            case 0:
              if (!(
#line 2952 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX) && 
#line 2957 "../../gcc/config/aarch64/aarch64-sve2.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_3030 (insn, operands);

            case 1:
              if (!(
#line 2952 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX) && 
#line 2957 "../../gcc/config/aarch64/aarch64-sve2.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_3032 (insn, operands);

            case 2:
              if (!(
#line 2952 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX) && 
#line 2957 "../../gcc/config/aarch64/aarch64-sve2.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_3034 (insn, operands);

            default:
              return NULL;
            }

        case 395:
          switch (pattern455 (x2))
            {
            case 0:
              if (!(
#line 2952 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX) && 
#line 2957 "../../gcc/config/aarch64/aarch64-sve2.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_3031 (insn, operands);

            case 1:
              if (!(
#line 2952 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX) && 
#line 2957 "../../gcc/config/aarch64/aarch64-sve2.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_3033 (insn, operands);

            case 2:
              if (!(
#line 2952 "../../gcc/config/aarch64/aarch64-sve2.md"
(TARGET_SVE_FAMINMAX) && 
#line 2957 "../../gcc/config/aarch64/aarch64-sve2.md"
( (!rtx_equal_p (operands[1], operands[5])
       || !rtx_equal_p (operands[1], operands[6])))))
                return NULL;
              return gen_split_3035 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V2DImode))
    {
      switch (pattern924 (
E_V2DImode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_116 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_117 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_118 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_119 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_120 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_121 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_122 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_123 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (memory_operand (operands[0], E_V2DImode))
    {
      if (register_operand (operands[1], E_V2DImode))
        {
          switch (pattern979 ())
            {
            case 0:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_180 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_181 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_182 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_183 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_184 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_185 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 6:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_186 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 7:
              if (
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_187 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (peep2_current_count >= 3)
        {
          x2 = PATTERN (peep2_next_insn (2));
          if (pattern978 (x2, 
E_V2DImode) == 0
              && 
#line 304 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, false, V2DImode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_238 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (peep2_current_count < 3)
    return NULL;
  x2 = PATTERN (peep2_next_insn (2));
  if (pattern923 (x2, 
E_V2DImode) != 0
      || !
#line 325 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, true, V2DImode)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_242 (insn, operands);
}

 rtx_insn *
peephole2_6 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V8HFmode))
    {
      switch (pattern924 (
E_V8HFmode))
        {
        case 0:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_124 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_125 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_126 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_127 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_128 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_129 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 6:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_130 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 7:
          if (
#line 98 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_131 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (!memory_operand (operands[0], E_V8HFmode)
      || !register_operand (operands[1], E_V8HFmode))
    return NULL;
  switch (pattern979 ())
    {
    case 0:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_188 (insn, operands);

    case 1:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_189 (insn, operands);

    case 2:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_190 (insn, operands);

    case 3:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_191 (insn, operands);

    case 4:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_192 (insn, operands);

    case 5:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_193 (insn, operands);

    case 6:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_194 (insn, operands);

    case 7:
      if (!
#line 111 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_ok_for_ldpstp (operands, false)))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_195 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (register_operand (operands[0], E_V2SFmode))
    {
      switch (pattern921 (
E_V2SFmode))
        {
        case 0:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_24 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 1:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_30 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 2:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_36 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 3:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_42 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 4:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_48 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        case 5:
          if (
#line 74 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, true)))
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_54 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          break;

        default:
          break;
        }
    }
  if (memory_operand (operands[0], E_V2SFmode))
    {
      if (register_operand (operands[1], E_V2SFmode))
        {
          switch (pattern976 ())
            {
            case 0:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_60 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 1:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_66 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 2:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_72 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 3:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_78 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 4:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_84 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            case 5:
              if (
#line 86 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(aarch64_operands_ok_for_ldpstp (operands, false)))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_90 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
              break;

            default:
              break;
            }
        }
      if (peep2_current_count >= 3)
        {
          x2 = PATTERN (peep2_next_insn (2));
          if (pattern978 (x2, 
E_V2SFmode) == 0
              && 
#line 304 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, false, V2SFmode)))
            {
              *pmatch_len_ = 3;
              res = gen_peephole2_237 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
        }
    }
  if (peep2_current_count < 3)
    return NULL;
  x2 = PATTERN (peep2_next_insn (2));
  if (pattern923 (x2, 
E_V2SFmode) != 0
      || !
#line 325 "../../gcc/config/aarch64/aarch64-ldpstp.md"
(TARGET_FLOAT
   && aarch64_operands_adjust_ok_for_ldpstp (operands, true, V2SFmode)))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_241 (insn, operands);
}
